/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 3.0.
 *
 */
#include <Xm/Xm.h>

/*
 * Standard includes for builtins.
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "hsplicer-creation-c.h"
#include "splicer_defs.h"
#include <Xm/Form.h>
#include <Xm/Text.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>


/*
 * Macros to make code look nicer between ANSI and K&R.
 */
#ifndef ARGLIST
#if (NeedFunctionPrototypes == 0)
#define PROTOTYPE(p)	()
#define ARGLIST(p)	p
#define ARG(a, b)	a b;
#define GRA(a, b)	a b;
#define UARG(a, b)      a b;
#define GRAU(a, b)      a b;
#else
#define PROTOTYPE(p)	p
#define ARGLIST(p)	(
#define ARG(a, b)	a b,
#define GRA(a, b)	a b)
#ifdef __cplusplus
#define UARG(a, b)      a,
#define GRAU(a, b)      a)
#else
#define UARG(a, b)      a b,
#define GRAU(a, b)      a b)
#endif
#endif
#endif

Widget		BxFindTopShell PROTOTYPE((Widget));
WidgetList	BxWidgetIdsFromNames PROTOTYPE((Widget, char*, char*));

#define	MAXBUFFER	(100)
char	filename[200];
char	*printstring,*getenv();
void SpManageWarningBox(),free(),*calloc(),*realloc();



/*      Function Name:	BxExitCB
 *
 *      Description:   	This functions expects an integer to be passed in
 *		       	client data.  It calls the exit() system call with
 *			the integer value as the argument to the function.
 *
 *      Arguments:      Widget		w: 	the activating widget.
 *			XtPointer	client:	the integer exit value.
 *			XtPointer	call:	the call data (unused).
 */

/* ARGSUSED */
void
BxExitCB ARGLIST((w, client, call))
UARG( Widget, w)
ARG( XtPointer, client)
GRAU( XtPointer, call)
{
    int		exitValue = (int)client;
	void	exit();
    
	if(printstring) free(printstring);
    exit(exitValue);
}

/* ARGSUSED */
void
HssaveCB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	FILE	*fptr_out;
	char	outfile[200],buffer[500];

	/*SUPPRESS 594*/
	XmFileSelectionBoxCallbackStruct *filebox=(XmFileSelectionBoxCallbackStruct*)call;
	(void)strcpy(outfile,XmCvtXmStringToCT(filebox->value));
	if((fptr_out=fopen(outfile,"w"))==NULL)
	{
		(void)sprintf("Error opening help output file %s.",outfile);
		SpManageWarningBox(buffer);
	}
	else
	{
		(void)fputs((char*)XmTextGetString(textHelp),fptr_out);
		fclose(fptr_out);
	}
}

/* ARGSUSED */
void
HsprintCB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	void	XmTextFieldSetString();

	if(!printstring)
	{
		printstring=(char*)calloc(500,sizeof(char));
		(void)sprintf(printstring,"lpr -rP%s",getenv("PRINTER"));
	}
	XmTextFieldSetString(textFieldPrint,printstring);
	XtManageChild(formPrint);
}
/*      Function Name: 	BxUnmanageCB
 *
 *      Description:   	Given a string of the form:
 *		       	"(WL)[widgetName, widgetName, ...]"
 *			BxUnmanageCB attempts to convert the name to a Widget
 *			ID and unmanage the widget.
 *
 *      Arguments:     	Widget	    w:      the widget activating the callback.
 *		       	XtPointer   client: the list of widget names to attempt
 *					    to find and unmanage.
 *		       	XtPointer   call:   the call data (unused).
 *
 *      Notes:        *	This function expects that there is an application
 *		       	shell from which all other widgets are descended.
 */

/* ARGSUSED */
void
BxUnmanageCB ARGLIST((w, client, call))
ARG( Widget, w)
ARG( XtPointer, client)
GRAU( XtPointer, call)
{
    WidgetList		widgets;
    int			i;

    /*
     * This function returns a NULL terminated WidgetList.  The memory for
     * the list needs to be freed when it is no longer needed.
     */
    widgets = BxWidgetIdsFromNames(w, "BxUnmanageCB", (String)client);

    i = 0;
    while( widgets && widgets[i] != NULL )
    {
	XtUnmanageChild(widgets[i]);
	i++;
    }
    XtFree((char *)widgets);
}
/*      Function Name: 	BxManageCB
 *
 *      Description:   	Given a string of the form:
 *		       	"(WL)[widgetName, widgetName, ...]"
 *			BxManageCB attempts to convert the name to a Widget
 *			ID and manage the widget.
 *
 *      Arguments:     	Widget	    w:      the widget activating the callback.
 *		       	XtPointer   client: the list of widget names to attempt
 *					    to find and manage.
 *		       	XtPointer   call:   the call data (unused).
 *
 *      Notes:        *	This function expects that there is an application
 *		       	shell from which all other widgets are descended.
 */

/* ARGSUSED */
void
BxManageCB ARGLIST((w, client, call))
ARG( Widget, w)
ARG( XtPointer, client)
GRAU( XtPointer, call)
{
    WidgetList		widgets;
    int			i;

    /*
     * This function returns a NULL terminated WidgetList.  The memory for
     * the list needs to be freed when it is no longer needed.
     */
    widgets = BxWidgetIdsFromNames(w, "BxManageCB", (String)client);

    i = 0;
    while( widgets && widgets[i] != NULL )
    {
	XtManageChild(widgets[i]);
	i++;
    }
    XtFree((char *)widgets);
}

/*      Function Name:  DestroyWidget
 *
 *      Description:    When called, destroys the widget passed to it
 *              as client data.  This is used by the BXHelpCB function.
 *
 *      Arguments:      Widget      w:  the activating widget.
 *          XtPointer   client: the widget to destroy
 *          XtPointer   call:   the call data (unused).
 */

/* ARGSUSED */
static void
DestroyWidget ARGLIST((w, client, call))
UARG( Widget, w)
ARG( XtPointer, client)
GRAU( XtPointer, call)
{
    XtDestroyWidget((Widget)client);
}

/*      Function Name:  BxHelpCB
 *
 *      Description:    This functions expects a string to be passed as
 *              client data.  It creates and manages a dialog with a Text
 *          widget to display the string and a Dismiss button. The dialog
 *          is destroyed when it is dismissed.
 *
 *      Arguments:      Widget      w:  the activating widget.
 *          XtPointer   client: the string to display
 *          XtPointer   call:   the call data (unused).
 */

/* ARGSUSED */
void
BxHelpCB ARGLIST((w, client, call))
ARG( Widget, w)
ARG( XtPointer, client)
GRAU( XtPointer, call)
{
    String text = (String) client;
    Widget formDialog = XmCreateFormDialog(w, "formDialog", NULL, 0);
    Widget textWidget = XmCreateText(formDialog, "textWidget",  NULL, 0);
    Widget separator = XmCreateSeparator(formDialog, "separator", NULL, 0);
    Widget dismiss = XmCreatePushButton(formDialog, "dismiss", NULL, 0);
    String dismiss_label = "Dismiss";

    XtVaSetValues(XtParent(formDialog), XmNtitle, "HelpText", NULL);

    XtVaSetValues(textWidget,
        XmNvalue, text,
        XmNeditable, False,
        XmNtopAttachment, XmATTACH_FORM,
        XmNbottomAttachment, XmATTACH_WIDGET,
        XmNbottomWidget, separator,
        XmNleftAttachment, XmATTACH_FORM,
        XmNrightAttachment, XmATTACH_FORM,
        XmNwordWrap, True,
        XmNeditMode, XmMULTI_LINE_EDIT,
        XmNwidth, 250,
        XmNheight, 100,
        NULL);

    XtVaSetValues(separator,
        XmNbottomAttachment, XmATTACH_WIDGET,
        XmNbottomWidget, dismiss,
        XmNbottomOffset, 10,
        XmNleftAttachment, XmATTACH_FORM,
        XmNrightAttachment, XmATTACH_FORM,
        NULL);

    XtVaSetValues(dismiss,
        XtVaTypedArg, XmNlabelString, XmRString,
                dismiss_label, strlen(dismiss_label)+1,
        XmNbottomAttachment, XmATTACH_FORM,
        XmNbottomOffset, 10,
        XmNleftAttachment, XmATTACH_POSITION,
        XmNleftPosition, 25,
        XmNrightAttachment, XmATTACH_POSITION,
        XmNrightPosition, 75,
        NULL);

    XtAddCallback(dismiss, XmNactivateCallback, DestroyWidget,
            (XtPointer)XtParent(formDialog));

    XtManageChild(textWidget);
    XtManageChild(separator);
    XtManageChild(dismiss);
    XtManageChild(formDialog);
}

/* ARGSUSED */
void
HsHelpTopicCB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	FILE	*fptr;
	char	buffer[MAXBUFFER],*helptext;
	int	len_allocated;

	/*SUPPRESS 594*/
    	String name = (String) client;
	(void)sprintf(filename,"%s/%s",getenv("SPLICER_HELPFILES_PATH"),name);

	if((fptr=fopen(filename,"r"))==NULL)
	{
		(void)sprintf(buffer,"Error opening help topic file %s",filename);
		SpManageWarningBox(buffer);
	}
	else
	{
		helptext=(char*)calloc(len_allocated=ALLOC_INT,sizeof(char));
		helptext[0]='\0';
		while(fgets(buffer,MAXBUFFER,fptr)!=NULL)
		{
			if((int)strlen(buffer)+(int)strlen(helptext)>=len_allocated)
			{
				helptext=(char*)realloc(helptext,(len_allocated+ALLOC_INT)*sizeof(char));
				len_allocated+=ALLOC_INT;
			}
			(void)strcat(helptext,buffer);
		}
		fclose(fptr);
		XtVaSetValues(textHelp,XmNvalue,helptext,NULL);
		free(helptext);
	}
}

void SpManageWarningBox(message)
char    *message;
{
    	XtVaSetValues(messageBoxError,XmNmessageString,XmStringCreateLocalized(message),NULL);
        XtManageChild(messageBoxError);
}



/* ARGSUSED */
void
HsPrintOKCB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	FILE	*fptr;
	char	buffer[500],tmpfile[500];
	int	system();

	/*SUPPRESS 594*/

	/* make temporary file of help text */
	if((fptr=fopen(tmpnam(tmpfile),"w"))==NULL)
	{
		(void)sprintf("Error opening temporary file for printing %s.",tmpfile);
		SpManageWarningBox(buffer);
	}
	else
	{
		(void)fputs((char*)XmTextGetString(textHelp),fptr);
		fclose(fptr);
	}
	
	/* get printer name from environment and send command */
	printstring=XmTextGetString(textFieldPrint);
	(void)strcpy(buffer,printstring);
	(void)strcat(buffer," ");
	(void)strcat(buffer,tmpfile);
	system(buffer);
}

/* ARGSUSED */
void
HsTextHelpCer(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	/*SUPPRESS 594*/
}

/* ARGSUSED */
void
HsTextHelpCreateCB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	/*SUPPRESS 594*/
	char	buffer[MAXBUFFER],*helptext;
	int	len_allocated;

	/*SUPPRESS 594*/
	helptext=(char*)calloc(len_allocated=ALLOC_INT,sizeof(char));
	helptext[0]='\0';
	while(fgets(buffer,MAXBUFFER,stdin)!=NULL)
	{
		if((int)strlen(buffer)+(int)strlen(helptext)>=len_allocated)
		{
			helptext=(char*)realloc(helptext,(len_allocated+ALLOC_INT)*sizeof(char));
			len_allocated+=ALLOC_INT;
		}
		(void)strcat(helptext,buffer);
	}
	XtVaSetValues(textHelp,XmNvalue,helptext,NULL);
	free(helptext);
}
