/*
	splicer_data.c

	data i/o and manipulation functions
*/
#include <stdlib.h>
#include <stdio.h>
#include <search.h>
#include <malloc.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <X11/cursorfont.h>
#include <sys/types.h>
/*#include <sys/uil.h>*/
#include <unistd.h>
#include "splicer-creation-c.h"
#include "splicer_vars.h"


#define	ODPKEYLEN	(20)
HashInfo	**hashinfo;
extern	int	hash_num;

int	SpRead(fptr,dataptr)
FILE	*fptr;
DataFile	*dataptr;
{
	int	value;
	switch (dataptr->in_format)
	{
		case MST95REPORT:
			value=SpReadMST95report(fptr,dataptr);
			break;
		case TKREPORT:
			value=SpReadTKreport(fptr,dataptr);
			break;
		case ODPOTHER:
                case ODPOTHER1:
                case ODPOTHER2:
                case ODPOTHER3:
                case ODPOTHER4:
                case ODPOTHER5:
			value=SpReadOtherOdp(fptr,dataptr);
			break;
                case JANUSCLEAN:
                case JANUSORIG:
                        value=SpReadJanus(fptr,dataptr);
                        break;
		default:
			value=True;
	}
	return(value);
}

void	SpAffine(ptr,affineinfo,flag)
Hole	*ptr;
AffineFile	affineinfo;
int	flag;
{
	int	i;
	float	last_offset;
	Core	*coreptr;
	char		*odpkey;
	char		*odpptr=odpkey,key_to_find[ODPKEYLEN+1];
	HashInfo	*hashptr;
	ENTRY		*found_item,item,*hsearch();
	char	*name;
	int	fd,close();


/* if no hash table, read stored file */
	if(flag==CREATE_HASH)
	{
		if((hashinfo=SpReadAffineTable(affineinfo.filename,&hash_num))== NULL || message.error==True)
		{
			message.error=True;
			return;
		}
		else
		{
                        if((charptr=(char*)calloc((int)strlen(affineinfo.filename)+50,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpAffine 1c");
			(void)sprintf(charptr,"\nAffine Table %s read",affineinfo.filename);
                        have_affine = DO;
			SpUpdateReport(charptr);
			free(charptr);

                        XtSetSensitive(pushButtonOpenAffine,False);
		}
	
	}
        else
        {
        } 
}

int	SpEvalEquation(data_val,cull_equ)
float		data_val;
Equation	cull_equ;
{
	int	qual1,qual2,qual;

	qual1=qual2=qual=GOOD;
	if(cull_equ.sign1 == LESS_THAN && data_val<cull_equ.value1)
		qual1 =BAD_CULL1;
	else if(cull_equ.sign1 == LESS_THAN_OR_EQUAL_TO &&
				data_val <= cull_equ.value1)
		qual1 =BAD_CULL1;
	else if(cull_equ.sign1 == GREATER_THAN && data_val>cull_equ.value1)
		qual1 =BAD_CULL1;
	else if(cull_equ.sign1 == GREATER_THAN_OR_EQUAL_TO &&
			data_val>=cull_equ.value1)
		qual1 =BAD_CULL1;
	else if(cull_equ.sign1 == EQUAL_TO && data_val == cull_equ.value1)
		qual1 =BAD_CULL1;

	if(cull_equ.join == ONLY)
		qual=qual1;
	else
	{
		if(cull_equ.sign2 == LESS_THAN && data_val<cull_equ.value2)
			qual2 =BAD_CULL2;
		else if(cull_equ.sign2 == LESS_THAN_OR_EQUAL_TO &&
					data_val <= cull_equ.value2)
			qual2 =BAD_CULL2;
		else if(cull_equ.sign2 == GREATER_THAN && data_val>cull_equ.value2)
			qual2 =BAD_CULL2;
		else if(cull_equ.sign2 == GREATER_THAN_OR_EQUAL_TO &&
					data_val>=cull_equ.value2)
			qual2 =BAD_CULL2;
		else if(cull_equ.sign2 == EQUAL_TO && data_val == cull_equ.value2)
			qual2 =BAD_CULL2;

		if(cull_equ.join == OR)
			qual=qual1|qual2;
	}

	return(qual);
}


void SpCullTable(dataptr,name,flag)
DataFile        *dataptr;
char	*name;
int	flag;
{
	int		i,j,k,l;
	char		*odpkey;
	char		*odpptr=odpkey,key_to_find[ODPKEYLEN+1];
        XmString        xmstring;
        XEvent          event;
	HashInfo	*hashptr;
	Core		*coreptr;
	ENTRY		*found_item,item,*hsearch();

/* if no hash table, read stored file */
	if(flag==CREATE_HASH)
	{

		if((hashinfo=SpReadCullTable(name,&hash_num))== NULL)
		{
			message.error=True;
                        message.fatal=False;
                        message.caller=NONE;
                        message.type=XmDIALOG_WARNING;
                        message.default_button=XmDIALOG_OK_BUTTON;
			if((message.label=(char*)calloc((int)strlen(name)+100,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpCullTable 1");
		 	(void)sprintf(message.label,"Error reading Cull Table %s", name);
			SpManageMessage(message);
			return;
		}
		else
		{
			if((charptr=(char*)calloc((int)strlen(name)+100,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpCullTable 1b");
			(void)sprintf(charptr,"\nCull Table %s read",name);
			SpUpdateReport(charptr);
			free(charptr);
		}
	
	}

	/* search hash table for values */
        for(k=0; k<dataptr->numholes; ++k)
        {
		for(i=0;i<dataptr->holes[k]->numcores;i++)
		{

                        if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpCullTable 1");
                        (void)sprintf(charptr,"\nData : Culling using cull table; hole %c.", dataptr->holes[k]->name);
                        if(i == 0) {
                          SpUpdateReport(charptr);
                        }
                        (void)sprintf(charptr,"\nData : Culling using cull table; hole %c core %d", 
                                          dataptr->holes[k]->name, dataptr->holes[k]->core[i]->num);
                        xmstring=XmStringCreateLocalized(&charptr[1]);
                        XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
                        XmStringFree(xmstring);
                        free(charptr);
                        XmUpdateDisplay(messageBoxWorking);
                        /* check to see if the stop read button was pushed
                        */
                        while(XCheckMaskEvent(XtDisplay(messageBoxWorking), ButtonPressMask, &event)) {
                          if(event.xany.window == XtWindow(messageBoxWorking)) {
                            XtDispatchEvent(&event);
                            message.error = True;
                            message.fatal=False;
                            message.default_button=XmDIALOG_OK_BUTTON;
                            message.type=XmDIALOG_WARNING;
                            message.caller=NONE;
                            if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpCullTable");
                            (void)sprintf(message.label,"Data input has been stopped.\n");
                            (void)strcat(message.label, "An attempt to clear has been made but program may be unstable.");
                            return;
                          }
                          else {
                          }
                        }

			for(j=0;j<dataptr->holes[k]->core[i]->numvalues;j++)
			{
                          coreptr=dataptr->holes[k]->core[i];
                          for(l=0; l<hash_num; ++l)
                          {
                            if(dataptr->leg == hashinfo[l]->leg &&
                               dataptr->site == hashinfo[l]->site &&
                               dataptr->holes[k]->name == hashinfo[l]->hole &&
                               coreptr->num == hashinfo[l]->core &&
                               strcmp(coreptr->value[j]->section, hashinfo[l]->section) == 0)
                            {
                              if(fabs(coreptr->value[j]->top_int - hashinfo[l]->top_int) <= CULLTABLEDEPTHCHECK) 
                              {
                                coreptr->value[j]->quality=coreptr->value[j]->quality|BAD_CULLTABLE;
                              }
                            }
                          }
			}
		}
	}
	if(flag==DESTROY_HASH>0)
	{
		for(i=0;i<hash_num;i++)
		{
			if(hashinfo[i])
			{
				free(hashinfo[i]);
				hashinfo[i]=NULL;
			}
		}
		hash_num=0;
		if(hashinfo)
		{
			free(hashinfo);
			hashinfo=NULL;
		}
		hdestroy();
	}
}

void	SpCull(dataptr,type,cullinfo,flag)
DataFile  *dataptr;
int  	type;
Cull	cullinfo;
int	flag;
{
	int	i,j,k;
	Core	*coreptr;
	Value	*valueptr;
        XmString  xmstring;
        XEvent    event;

	if(cullinfo.top> 0)	/* remove top portion of core */
	{
            if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpCull");
            (void)sprintf(charptr,"\nData : Culling core tops.");
            SpUpdateReport(charptr);
            xmstring=XmStringCreateLocalized(&charptr[1]);
            XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
            XmStringFree(xmstring);
            free(charptr);
            XmUpdateDisplay(messageBoxWorking);

            for(k=0; k<dataptr->numholes; ++k) 
            {
		for(i=0;i<dataptr->holes[k]->numcores; i++)
		{
			coreptr=dataptr->holes[k]->core[i];
                        if(coreptr->numvalues > 0) 
                        {
                            j = 0;
		            while(strcmp(coreptr->value[j]->section, "1")==0 &&
						coreptr->value[j]->top_int < cullinfo.top)
                            {
					coreptr->value[j]->quality=coreptr->value[j]->quality|BAD_TOP;
                                        ++j;
                                        if(j >= coreptr->numvalues) {
                                          break;
                                        }
                            }
			}
		}
             }
	}
 
        /* check to see if the stop read button was pushed
        */
        while(XCheckMaskEvent(XtDisplay(messageBoxWorking), ButtonPressMask, &event)) {
          if(event.xany.window == XtWindow(messageBoxWorking)) {
            XtDispatchEvent(&event);
            message.error = True;
            message.fatal=False;
            message.default_button=XmDIALOG_OK_BUTTON;
            message.type=XmDIALOG_WARNING;
            message.caller=NONE;
            if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpCull");
            (void)sprintf(message.label,"Data input has been stopped.\n");
            (void)strcat(message.label, "An attempt to clear has been made but program may be unstable.");
            return;
          }
          else {
          }
        }

	if(cullinfo.by_core_num)	/* remove cores > given number */
	{
             if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpCull");
            (void)sprintf(charptr,"\nData : Culling cores.");
            SpUpdateReport(charptr);
            xmstring=XmStringCreateLocalized(&charptr[1]);
            XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
            XmStringFree(xmstring);
            free(charptr);
            XmUpdateDisplay(messageBoxWorking);

             for(k=0; k<dataptr->numholes; ++k)
             {
		for(i=0;i<dataptr->holes[k]->numcores;i++)
		{
			if(dataptr->holes[k]->core[i]->num > cullinfo.max_core)
			{
				coreptr=dataptr->holes[k]->core[i];
				for(j=0;j<coreptr->numvalues;j++)
					coreptr->value[j]->quality=coreptr->value[j]->quality|BAD_CORE_NUM;
			}
		}
       	      }
	}

	if(cullinfo.method==CULL_PARAMETERS || cullinfo.method == CULL_PARAMETER_AND_TABLE)
	{
            for(k=0; k<dataptr->numholes; ++k) 
            {
                if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpCull");
                (void)sprintf(charptr,"\nData : Culling using parameters; hole %c.", dataptr->holes[k]->name);
                SpUpdateReport(charptr);
                xmstring=XmStringCreateLocalized(&charptr[1]);
                XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
                XmStringFree(xmstring);
                free(charptr);
                XmUpdateDisplay(messageBoxWorking);

                /* check to see if the stop read button was pushed
                */
                while(XCheckMaskEvent(XtDisplay(messageBoxWorking), ButtonPressMask, &event)) {
                  if(event.xany.window == XtWindow(messageBoxWorking)) {
                    XtDispatchEvent(&event);
                    message.error = True;
                    message.fatal=False;
                    message.default_button=XmDIALOG_OK_BUTTON;
                    message.type=XmDIALOG_WARNING;
                    message.caller=NONE;
                    if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpCull");
                    (void)sprintf(message.label,"Data input has been stopped.\n");
                    (void)strcat(message.label, "An attempt to clear has been made but program may be unstable.");
                    return;
                  }
                  else {
                  }
                }

		for(i=0;i<dataptr->holes[k]->numcores;i++)
		{
			coreptr=dataptr->holes[k]->core[i];
			for(j=0;j<coreptr->numvalues;j++)	/* loop through data */
			{
				valueptr=coreptr->value[j];
				if(type==GRAPE)
					valueptr->quality= valueptr->quality|SpEvalEquation(*valueptr->data,cullinfo.grape);
				else if(type==PWAVE)
				{
					valueptr->quality= valueptr->quality|SpEvalEquation(*valueptr->data,cullinfo.pwave);
                                        if(dataptr->in_format == MST95REPORT) 
                                        {
					  if(valueptr->pwave->sig_strength < cullinfo.pwave_signal_max)
							valueptr->quality=valueptr->quality|BAD_PWAVE_SIGNAL;
                                        }
				}
				else if(type==SUSCEPTIBILITY)
					valueptr->quality=valueptr->quality| SpEvalEquation(*valueptr->data,cullinfo.susceptibility);
				else if(type==NATURALGAMMA)
					valueptr->quality=valueptr->quality|SpEvalEquation(*valueptr->data,cullinfo.naturalgamma);
				else if(type==REFLECTANCEMST)
					valueptr->quality= valueptr->quality|SpEvalEquation(*valueptr->data,cullinfo.reflectance);
                                else if(type==OTHERTYPE)
                                        valueptr->quality=valueptr->quality|SpEvalEquation(*valueptr->data,cullinfo.otherodp);
				else
					valueptr->quality=valueptr->quality|SpEvalEquation(*valueptr->data,cullinfo.otherodp);
			}
		}
             }
	}
	if(cullinfo.method==CULL_TABLE || cullinfo.method == CULL_PARAMETER_AND_TABLE)

		SpCullTable(dataptr,cullinfo.filename,flag);
}

void	SpSmooth(ptr)
Hole	*ptr;
{
	int	i,j,k,l,m,n,num_interp=0,inc,datptr_cnt,max_depths=0,num_depths=0,this_num=0,end_cnt,highfound,lowfound;
	float	halfwidth,*weight,target,end_depth;
	float	*datptr,*sm_datptr,start_depth;
	double	rint();
	Core	*coreptr;
	void	gauss_weights();

  /* use gaussian filter */
  if(smooth.method==GAUSSIAN)
  {
    /* must use an odd number of weights */
    if(smooth.width%2==0)
      smooth.width+=1;
    halfwidth=(int)((smooth.width-1)/2);
    /* get filter weights */
    if((weight=(float*)calloc(smooth.width+1,sizeof(float)))==NULL)
      SpBadMemAlloc("SpSmooth");
    gauss_weights(smooth.width,weight);
    /* allocate storage arrays */
    if(smooth.width_units==POINTS)
    {
      sm_datptr=NULL;
      if((datptr=(float*)calloc(smooth.width+1,sizeof(float)))==NULL)
                                SpBadMemAlloc("SpSmooth");
    }
    else
    {
      max_depths=0;
      for(i=0;i<ptr->numcores;i++)
      {
        coreptr=ptr->core[i];
        this_num=(coreptr->value[coreptr->numvalues-1]->sb_depth-coreptr->value[0]->sb_depth)*100;
        if(this_num> max_depths) max_depths=this_num;
      }
      max_depths+=2;
      if((sm_datptr=(float*)calloc(max_depths,sizeof(float)))==NULL)
                                SpBadMemAlloc("SpSmooth");
      if((datptr=(float*)calloc(max_depths,sizeof(float)))==NULL)
                                SpBadMemAlloc("SpSmooth");
    }

    /* loop through cores */
    for(i=0;i<ptr->numcores;i++)
    {
      coreptr=ptr->core[i];
      coreptr->smooth_status = NONE;
      if(smooth.width_units==POINTS)
      {
        /* loop through data (first and last "halfwidth" values are same as raw data if good! */
        for(j=0;j<halfwidth && j<coreptr->numvalues;j++)
        {
          if(coreptr->value[j]->quality == GOOD)
          {
            coreptr->value[j]->sm_data=*coreptr->value[j]->data;
            coreptr->value[j]->smooth_ok = SMTAIL;
          }
          else
          {
            coreptr->value[j]->smooth_ok = SMBADDATA;
          }
        }

        if(j>= coreptr->numvalues)
        {
          coreptr->smooth_status = SMTOOFEWPTS;
        }
        else
        {
          /* loop through data until at last half width */
          for(;j<coreptr->numvalues-halfwidth;j++)
          {
            /* let smooth be ok until proven otherwise */
            coreptr->value[j]->smooth_ok = SMOK;
            inc=j-halfwidth;    /* first value in smoothing */
            /* raw value at this point must be good */
            if(coreptr->value[j]->quality!=GOOD)
            {
              coreptr->value[j]->smooth_ok = SMBADDATA;
            }
            /* fill data arrays */
            for(k=inc,num_interp=0,datptr_cnt=0;datptr_cnt<smooth.width && k<coreptr->numvalues &&
                                                        !(coreptr->value[j]->quality);k++,datptr_cnt++)
            {
              if(coreptr->value[k]->quality==GOOD)
              {
                datptr[datptr_cnt]=*coreptr->value[k]->data;
              }
              else      /* interpolate data point */
              {
                /* find next lower point in width range */
                for(l=k-1;l>=inc && coreptr->value[l]->quality!=GOOD;l--);
                if(l<inc)       /* no lower point in range */
                {
                  coreptr->value[j]->smooth_ok = SMTOOFEWPTS;
                }
                else
                {
                  /* find next higher point in width range */
                  for(m=k+1;m<=j+halfwidth && coreptr->value[m]->quality!=GOOD;m++);
                  if(m>j+halfwidth)     /* no higher point in range */
                  {
                    coreptr->value[j]->smooth_ok = SMTOOFEWPTS;
                  }
                  else
                  {
                    datptr[datptr_cnt]=*coreptr->value[l]->data+(*coreptr->value[m]->data -
                                                                *coreptr->value[l]->data)*
                                (coreptr->value[m]->sb_depth-coreptr->value[l]->sb_depth)/
                                                        coreptr->value[k]->sb_depth;
                    num_interp++;
                  }
                }
              }
            }
            if(num_interp>halfwidth)
            {
              coreptr->value[j]->smooth_ok = SMBADCALC;
            }
            /* compute smoothed value */
            if(coreptr->value[j]->smooth_ok < SMOK)
            {
            }
            else if(!coreptr->value[j]->quality)
            {
              coreptr->value[j]->sm_data=0.0;
              for(k=0;k<smooth.width;k++)
                coreptr->value[j]->sm_data+=datptr[k]*weight[k+1];
            }
            else
            {
              coreptr->value[j]->smooth_ok = SMBADCALC;
            }
          }

          if(j<coreptr->numvalues)
          {
            /* loop through last half width values */
            for(;j<coreptr->numvalues;j++)
            {
              if(coreptr->value[j]->quality == GOOD)
              {
                coreptr->value[j]->sm_data=*coreptr->value[j]->data;
                coreptr->value[j]->smooth_ok = SMTAIL;
              }
              else
              {
                coreptr->value[j]->smooth_ok = SMBADDATA;
              }
            }
          }

          /* check if have some smoothed points
          */
          n = 0;
          for(j=0; j<coreptr->numvalues; ++j)
          {
            if(coreptr->value[j]->smooth_ok == SMOK || coreptr->value[j]->smooth_ok == SMTAIL)
            {
              ++n;
            }
          }
          if(n < TOOFEWSMOOTHED)
          {
            coreptr->smooth_status = SMTOOFEWPTS;
          }
          if(coreptr->smooth_status == NONE) {
            coreptr->smooth_status = SMOK;
          }
        }
      }

      else if(smooth.width_units==DEPTH)
      {
        /* find first & last good points */
        for(j=0;j<coreptr->numvalues && coreptr->value[j]->quality!=GOOD ;j++);
        for(k=coreptr->numvalues-1;k>=0 && coreptr->value[k]->quality!=GOOD;k--);
        end_cnt=k;
        if(end_cnt<0 || j>=coreptr->numvalues)
        {
          coreptr->smooth_status = SMTOOFEWPTS;
        }
        else
        {
          start_depth=coreptr->value[j]->sb_depth*100.0;
          end_depth=coreptr->value[end_cnt]->sb_depth*100.0;
          num_depths=1+end_depth-start_depth;
          if(num_depths<=halfwidth)
          {
            coreptr->smooth_status = SMTOOFEWPTS;
          }
          else if(num_depths>max_depths)
          {
            coreptr->smooth_status = SMTOOFEWPTS;
          }
          else
          {
            /* interpolate 1 cm array of entire core */
            datptr[l=0]=*coreptr->value[j]->data;
            for(m=j,l++,target=start_depth+1;target<end_depth && l<max_depths;target++,l++)
            {
              /* find value >= to target value */
              highfound=lowfound=False;
              while(m<coreptr->numvalues - 1 && k>=0 && !(lowfound&highfound))
              {
                if(!highfound && !(target<=rint((double)(coreptr->value[m]->sb_depth*100))
                                                        && coreptr->value[m]->quality==GOOD))
                  m++;
                else if(!highfound)
                {
                  highfound=True;
                  k=m;
                }
                else
                {
                  if(!(target>rint((double)(coreptr->value[k]->sb_depth*100))&&
                                        coreptr->value[k]->quality==GOOD))
                    k--;
                  else
                    lowfound=True;
                }
              }
              if(m>=coreptr->numvalues || k<0)
              {
                coreptr->smooth_status = SMTOOFEWPTS;
              }
              else {
                if(target==rint((double)(coreptr->value[m]->sb_depth*100)))       /* exact match */
                                        datptr[l]=*coreptr->value[m]->data;
                else /* interpolate */
                  datptr[l]=*coreptr->value[k]->data+(*coreptr->value[m]->data -*coreptr->value[k]->data)*
                                                        (target/100.0-coreptr->value[k]->sb_depth)/
                                        (coreptr->value[m]->sb_depth-coreptr->value[k]->sb_depth);
              }
            }
            if(l>max_depths)
            {
              coreptr->smooth_status = SMTOOFEWPTS;
            }
            if(coreptr->smooth_status == NONE)
            {
              datptr[l]=*coreptr->value[end_cnt]->data;
              /* smooth data array */
              /* loop through data (first and last "halfwidth" values are same as raw data */
              for(j=0;j<halfwidth;j++)
                sm_datptr[j]=datptr[j];
              /* compute smoothed value */
              for(;j<num_depths-halfwidth;j++)
              {
                sm_datptr[j]=0.0;
                for(k=0,l=j-halfwidth+1;k<smooth.width;k++,l++)
                  sm_datptr[j]+=datptr[l]*weight[k+1];
              }
              /* loop through last half width values */
              for(;j<num_depths;j++)
                sm_datptr[j]=datptr[j];
              /* fill in real smoothed array */
              for(j=0;j<coreptr->numvalues;j++)
              {
                if(coreptr->value[j]->quality != GOOD)
                {
                  coreptr->value[j]->smooth_ok = SMBADDATA;
                }
                else
                {
                  if(rint((double)(coreptr->value[j]->sb_depth*100.0))<(start_depth+halfwidth))
                  {
                    coreptr->value[j]->sm_data=*coreptr->value[j]->data;
                                               coreptr->value[j]->smooth_ok = SMTAIL;
                  }
                  else if(rint((double)(coreptr->value[j]->sb_depth*100.0))>(end_depth-halfwidth))
                  {
                    coreptr->value[j]->sm_data=*coreptr->value[j]->data;
                                              coreptr->value[j]->smooth_ok = SMTAIL;
                  }
                  else
                  {
                    k=(int)(rint((double)(coreptr->value[j]->sb_depth*100.0))-start_depth);
                    coreptr->value[j]->sm_data=sm_datptr[k];
                    coreptr->value[j]->smooth_ok = SMOK;
                  }
                }
              }
              coreptr->smooth_status = SMOK;
            }
          }
        }
      }
    }


    if(sm_datptr) 
    {
      free(sm_datptr);
      sm_datptr=NULL;
    }
    if(datptr)
    {
      free(datptr);
      weight=NULL;
    }
    if(weight)
    {
      free(weight);
      weight=NULL;
    }
  }

  /* if smooth method other */
  else
  {
  }

}
	
void	SpDecimate(ptr,deci_num)
Hole	*ptr;
int	deci_num;
{
	int	i,j;
	Core	*coreptr;

	for(i=0;i<ptr->numcores; i++)
	{
		coreptr=ptr->core[i];
		for(j=0;j<coreptr->numvalues;j++)
		{
			if(j%deci_num!=0)
				coreptr->value[j]->quality=coreptr->value[j]->quality|DECIMATED;
		}
	}
}

int	current_file=0,lineno=0,current_hole_num=0;
char	*nameptr;
FILE	*fptr;

int SpOutputData(client_data)
XtPointer client_data;
{
	char		*filename,*out_prefix,*out_suffix;
	XmString	xmstring;
	FILE		*outptr;
	int	SpWriteData();
	
/* open file if necessary */
	if(current_hole_num<data[dset]->numholes)
	{
	/* find current file name */
		out_prefix=XmTextFieldGetString(textFieldOutputPrefix);
		out_suffix=XmTextFieldGetString(textFieldOutputSuffix);
                if((filename=(char*)calloc((int)strlen(out_prefix) + (int)strlen(out_suffix) + (int)strlen(outdata_dirname) + 20,CHAR_SIZE))==NULL)
                                  SpBadMemAlloc("SpOutputData");
		(void)sprintf(filename,"%s%s%d%c.%s",outdata_dirname,out_prefix,data[dset]->site,data[dset]->holes[current_hole_num]->name,
				out_suffix);
		XtFree(out_prefix);
		XtFree(out_suffix);
	/* open file */
		if((outptr=fopen(filename,"w"))==NULL)
		{
			message.error=True;
			message.fatal=False;
			message.caller=OUTPUTDATA;
                        message.type=XmDIALOG_WARNING;
                        message.default_button=XmDIALOG_OK_BUTTON;
			if((message.label=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpOutputData 1");
			(void)sprintf(message.label,"Cannot write to output file %s.",filename);
			message.default_button=XmDIALOG_OK_BUTTON;
			message.type=XmDIALOG_ERROR;
			SpManageMessage(message);
		}
		else
		{
	/* update message in working dialog */
			
			if((charptr=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpOutputData 2");
			(void)sprintf(charptr,"Output : Writing to file %s ",filename);
			xmstring=XmStringCreateLocalized(charptr);
			XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring,NULL);
			XmStringFree(xmstring);
			free(charptr);
		}
	/* write this hole */
		(void)SpWriteData(outptr,data[dset]->holes[current_hole_num]);
		current_hole_num++;
		fclose(outptr);
                free(filename);
	}
	else
	{
	/* all holes written */
		current_hole_num=0;
		XtUnmanageChild(messageBoxWorking);
		return(True);
	}
	return(False);
}
int SpInputData(client_data)
XtPointer client_data;
{
	int	i,j,hashflag, len, err, col, skip;
	Boolean	switched=False;
	Hole	*tmphole;
        String str;
	XmString	xmstring;
        int FindMinMax(), 
            CheckDepthInDescendingOrder(),
            CheckCoreAndDepthOrder(), 
            MakeSplice(), 
            CheckHowManyCulled();
        void SetMinMax(),
             MakeNewAffineTable(),
             MapHoleToAffineTable(),
             MapCoreToAffineTable(),
             CheckAffineTableMissingHole(),
             DrawDrawingAreaEdit(),
             DrawDrawingAreaView(),
             PlotSpliceVsAge();

	if(current_file==0 && !done_reading)
	{
                reason_for_redraw = NONE;
		done_reading=False;
		if(smooth.method!=NONE)
			done_smooth=False;
		else
			done_smooth=True;
		if(decimate_value>1)
			done_decimate=False;
		else
			done_decimate=True;
		if(cull.method!=NONE)
			done_cull=False;
		else
			done_cull=True;
		if(affine.usetable)
			done_affine=False;
		else
			done_affine=True;

                /* if data format is ODP Other get the column number for data value
                */
                if(openfileinfo.in_data_format == ODPOTHER || openfileinfo.in_data_format == ODPOTHER1 ||
                   openfileinfo.in_data_format == ODPOTHER2 || openfileinfo.in_data_format == ODPOTHER3 ||
                   openfileinfo.in_data_format == ODPOTHER4 || openfileinfo.in_data_format == ODPOTHER5)
                {
                  str = XmTextGetString(textFieldOpenFormatOtherValueColumn);
                  openfileinfo.other_format_value_col = atoi(str);
                  XtFree(str);

                  /* make the format
                  */
                  (void)sprintf(openfileinfo.other_format, "");
                  switch (openfileinfo.in_data_format)
                  {
                       case    ODPOTHER:
                       case    ODPOTHER1:
                               (void)strcpy(openfileinfo.other_format, "%d %d %c %d %c %s %f %f %f");
                               col = 9;
                               break;
                       case    ODPOTHER2:
                               (void)strcpy(openfileinfo.other_format, "%d %c %d %c %s %f %f %f");
                               col = 8;
                               break;
                       case    ODPOTHER3:
                               (void)strcpy(openfileinfo.other_format, "%d %c %d %s %f %f %f");
                               col = 7;
                               break;
                       case    ODPOTHER4:
                               (void)strcpy(openfileinfo.other_format, "%d %c %d %s %f %f");
                               col = 6;
                               break;
                       case    ODPOTHER5:
                               (void)strcpy(openfileinfo.other_format, "%d %d %c %d %c %s %f %f");
                               col = 8;
                               break;
                       default:
                               message.error=True;
                               message.fatal=False;
                               if((message.label=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData");
                               (void)sprintf(message.label,"Could not make the format for ODP other; no match for format type.\n");
                               message.type=XmDIALOG_ERROR;
                               message.caller=NONE;
                               message.default_button=XmDIALOG_OK_BUTTON;
                               current_file=lineno=current_hole_num=0;
                               XtUnmanageChild(messageBoxWorking);
                               SpManageMessage(message);
                               return(True);
                  }
                  if((skip = openfileinfo.other_format_value_col - col - 1) <= 0) {
                  }
                  else {
                    for(i=1; i<=skip; ++i) {
                      (void)strcat(openfileinfo.other_format, " %*s");
                    }
                  }
                  (void)strcat(openfileinfo.other_format, " %f");
                }

                /* allocate space for data set 
                */
                ++dataset_cnt;
                dset = dataset_cnt - 1;
                if(dataset_cnt > 1) {
                   if((charptr= (char*)realloc((char*)data,(dataset_cnt*sizeof(DataFile*))))==NULL) {
                                SpBadMemAlloc("SpInputData");
                   }
                   else {
                                data=(DataFile**)charptr; 
                   }
                }
                else if(dataset_cnt == 1) {
                  if((data = (DataFile**)calloc(dataset_cnt, sizeof(DataFile*)))==NULL) {
                    SpBadMemAlloc("SpInputData");
                  }
                }
                if((data[dset] = (DataFile*)calloc(1, sizeof(DataFile)))==NULL) {
                  SpBadMemAlloc("SpInputData");
                }

                data[dset]->in_format = openfileinfo.in_data_format;
                data[dset]->type = openfileinfo.in_data_type;
                data[dset]->numfiles = openfileinfo.num_in_files;
		data[dset]->readerrors=0;
                data[dset]->decimate_value = decimate_value;
                if((data[dset]->name=(char**)calloc(openfileinfo.num_in_files,sizeof(char*)))==NULL) {
                  SpBadMemAlloc("SpInputData");
                }
                for(i=0; i<openfileinfo.num_in_files; ++i) {
                  if((data[dset]->name[i]=(char*)calloc(strlen(openfileinfo.in_file_names[i])+5,CHAR_SIZE))==NULL) {
                    SpBadMemAlloc("SpInputData");
                  }
                  (void)sprintf(data[dset]->name[i], "%s", openfileinfo.in_file_names[i]);
                  free(openfileinfo.in_file_names[i]);
                  openfileinfo.in_file_names[i] = NULL;
                }

		current_hole_num=0;
		data[dset]->holes=NULL;

	}
/* if done reading, process data */
	else if(done_reading && !message.error)
	{
		if(current_hole_num<data[dset]->numholes)
		{
                        if(err=CheckDepthInDescendingOrder(dset) == YES) {
                          current_file=lineno=current_hole_num=0;
                          done_decimate=done_cull=done_reading=False;
                          if(dataset_cnt == 1) {
                            SpCleanUp(INPUTDATA);
                          }
                          else if(dataset_cnt > 1) {
                            SpFreeData(data[dset]);
                            if(data[dset])
                            {
                              free(data[dset]);
                              data[dset]=NULL;
                            }
                            --dataset_cnt;
                            dset = dataset_cnt - 1;
                            if(have_splice == DO) {
                              if(XtIsManaged(XtParent(drawingAreaView))) {
                                reason_for_redraw = DRAW_EVERYTHING;
                                DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
                              }
                            }
                            if(XtIsManaged(XtParent(drawingAreaEdit))) {
                              reason_for_redraw = DRAW_EVERYTHING;
                              DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
                            }
                          }
                          XtUnmanageChild(messageBoxWorking);
                          return(True);
                        }

			i=current_hole_num;
			if(!done_cull)
			{
                                if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData 1");
                                (void)sprintf(charptr,"\nData : Culling.");
                                xmstring=XmStringCreateLocalized(&charptr[1]);
                                XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
                                XmStringFree(xmstring);
                                free(charptr);
                                XmUpdateDisplay(messageBoxWorking);
                               
				hashflag=CREATE_HASH;
				SpCull(data[dset],data[dset]->type,cull,hashflag);
                                err = CheckHowManyCulled(dset);
				done_cull=True;
				current_hole_num=-1;
				if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
					SpBadMemAlloc("SpInputData 1");
				(void)sprintf(charptr,"\nData : Done culling.");
				xmstring=XmStringCreateLocalized(&charptr[1]);
				XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
				XmStringFree(xmstring);
				free(charptr);
			}
			else if(!done_smooth)
			{
				if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
					SpBadMemAlloc("SpInputData 2");
				(void)sprintf(charptr,"\nData : Smoothing data hole %c.",data[dset]->holes[i]->name);
				SpUpdateReport(charptr);
				xmstring=XmStringCreateLocalized(&charptr[1]);
				XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
				XmStringFree(xmstring);
				free(charptr);
                                if(i == 0) {
                                  if(smooth.width_units == DEPTH && smooth.width < MINSMOOTHWIDTH * average_depth_step) {
                                    if((charptr=(char*)calloc(150,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SmoothData 2");
                                    (void)sprintf(charptr, "The width of the filter is too small. Please create a filter as wide or wider than %dcm.",
                                                   MINSMOOTHWIDTH * average_depth_step);
                                    SpManageWarningBox(charptr);
                                    free(charptr);
                                    smooth.method = NONE;
                                  }
                                  else if(smooth.width_units == POINTS && smooth.width < MINSMOOTHWIDTH) {
                                    if((charptr=(char*)calloc(150,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SmoothData 3");
                                    (void)sprintf(charptr, "The width of the filter is too small. Please create a filter as wide or wider than %d pts.",
                                                     MINSMOOTHWIDTH);
                                    SpManageWarningBox(charptr);
                                    free(charptr);
                                    smooth.method = NONE;
                                  }
                                }

				if(smooth.method!=NONE)
					SpSmooth(data[dset]->holes[i]);
				if(i+1==data[dset]->numholes || smooth.method==NONE)
				{
					current_hole_num=-1;
					done_smooth=True;
				}
			}
			else if(!done_decimate)
			{
                                if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData 3");
				(void)sprintf(charptr,"\nData : Decimating data hole %c.",data[dset]->holes[i]->name);
				SpUpdateReport(charptr);
				xmstring=XmStringCreateLocalized(&charptr[1]);
				XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
				XmStringFree(xmstring);
				free(charptr);
				if(decimate_value>1)
					SpDecimate(data[dset]->holes[i],decimate_value);
				if(i+1==data[dset]->numholes || decimate_value<=1)
				{
					current_hole_num=-1;
					done_decimate=True;
				}
			}
			else if(done_affine == False)
			{
                                if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData 4");
				(void)sprintf(charptr,"\nData : Applying affine table for hole %c.",data[dset]->holes[i]->name);
				SpUpdateReport(charptr);
				xmstring=XmStringCreateLocalized(&charptr[1]);
				XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
				XmStringFree(xmstring);
				free(charptr);
				if(i==0)
					hashflag=CREATE_HASH;
				else if(i+1==data[dset]->numholes)
					 hashflag=DESTROY_HASH;
				else
					hashflag=0;
				if(affine.usetable)
					SpAffine(data[dset]->holes[i],affine,hashflag);
				if(i+1==data[dset]->numholes || !affine.usetable)
				{
					current_hole_num=-1;
					done_affine=True;
				}
			}
                        else if(affine.usetable == True && dataset_cnt > 1)
                        {
                          done_affine=True;
                          if(i+1==data[dset]->numholes)
                          {
                                  current_hole_num=-1;
                          }
                        }
	
			
		current_hole_num++;
		}
		/* done reading and processing data */
		if(!message.error)
		{
			if(done_affine&&done_decimate&&done_smooth&&done_cull&&done_reading)
			{
                                if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData 4");
                                (void)sprintf(charptr,"\n");
                                SpUpdateReport(charptr);
                                free(charptr);

				XtSetSensitive(pushButtonDataBase,FALSE);
                                if(dataset_cnt == 1) {
				  XtSetSensitive(pushButtonOpenSplicerTable,True);
                                }
				XtSetSensitive(pushButtonOpenStrat,True);

                           /*check to see if all holes could be smoothed. here??
                                
                                if(smooth.method == GAUSSIAN || smooth.method == OTHER) {
                                  for(i=0; i<data[dset]->numholes; ++i) {
                                    for(j=0; j<data[dset]->holes[i]->numcores; ++j) {
                                    }
                                  }
                                }
                           */
	                        have_data = DO; 

                                /* set the default open data directory */
                                XtFree(open_data_directory);
                                len = (int)strlen(current_path);
                                if((open_data_directory=(char*)calloc(len+10,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData 4a");
                                if(len == 0) {
                                }
                                else if(strcmp(&current_path[len-1], "/") != 0) {
                                  (void)sprintf(open_data_directory, "%s/", current_path);
                                }
                                else {
                                  (void)sprintf(open_data_directory, "%s", current_path);
                                }

                                if(data[dset]->numholes > 1) {
                                  XtSetSensitive(pushButtonComposite,True);
                                  XtSetSensitive(cascadeButtonSplice,True);
                                  XtSetSensitive(pushButtonSaveData,True);
                                }
                              /*  XtSetSensitive(pushButtonDisplay,True); */
                                XtSetSensitive(cascadeButtonSave,True);
                                XtSetSensitive(pushButtonSaveCull,True);
                                XtSetSensitive(pushButtonViewOffsets,True);
                                XtSetSensitive(cascadeButtonClear,True);
                                XtSetSensitive(pushButtonClearAll,True);
                              /* XtSetSensitive(pushButtonClearComposite,True); */
                                XtSetSensitive(cascadeButtonDataManip, True);
                                XmListDeleteAllItems(listOpenSelected);

                                if(smooth.method == NONE) {
                                  XmToggleButtonSetState(toggleButtonPlotUnsmooth, True, NULL);
                                  XmToggleButtonSetState(toggleButtonPlotSmooth, False, NULL);
                                  XmToggleButtonSetState(toggleButtonPlotBoth, False, NULL);
                                  XtSetSensitive(toggleButtonPlotSmooth,FALSE);
                                  XtSetSensitive(toggleButtonPlotUnsmooth,FALSE);
                                  XtSetSensitive(toggleButtonPlotBoth,FALSE); 
                                }
                                else if(smooth.method == GAUSSIAN || smooth.method == OTHER) {
                                  XtSetSensitive(toggleButtonPlotSmooth,True);
                                  XtSetSensitive(toggleButtonPlotUnsmooth,True);
                                  XtSetSensitive(toggleButtonPlotBoth,True);
                                  if(smooth.plot == UNSMOOTHED) {
                                    XmToggleButtonSetState(toggleButtonPlotUnsmooth, True, NULL); 
                                    XmToggleButtonSetState(toggleButtonPlotSmooth, False, NULL);
                                    XmToggleButtonSetState(toggleButtonPlotBoth, False, NULL);
                                  }
                                  else if(smooth.plot == SMOOTHED) {
                                    XmToggleButtonSetState(toggleButtonPlotUnsmooth, False, NULL); 
                                    XmToggleButtonSetState(toggleButtonPlotSmooth, True, NULL);
                                    XmToggleButtonSetState(toggleButtonPlotBoth, False, NULL);
                                  }
                                  else if(smooth.plot == SMOOTHEDBOTH) {
                                    XmToggleButtonSetState(toggleButtonPlotUnsmooth, False, NULL); 
                                    XmToggleButtonSetState(toggleButtonPlotSmooth, False, NULL);
                                    XmToggleButtonSetState(toggleButtonPlotBoth, True, NULL);
                                  }
                                }

                                if((err = FindMinMax(dset)) > 0) {
                                  SpManageWarningBox("Error; Could not find the min and max values of this data set");
                                  if(data[dset]->type == GRAPE) {
                                    data[dset]->min = GRAPEMIN;
                                    data[dset]->max = GRAPEMAX;
                                  }
                                  else if(data[dset]->type == PWAVE) {
                                    data[dset]->min = PWAVEMIN;
                                    data[dset]->max = PWAVEMAX;
                                  }
                                  else if(data[dset]->type == SUSCEPTIBILITY) {
                                    data[dset]->min = SUSCMIN;
                                    data[dset]->max = SUSCMAX;
                                  }
                                  else if(data[dset]->type == NATURALGAMMA) {
                                    data[dset]->min = NGAMMAMIN;
                                    data[dset]->max = NGAMMAMAX;
                                  }
                                  else if(data[dset]->type == REFLECTANCEMST) { 
                                    data[dset]->min = REFLECTMIN;
                                    data[dset]->max = REFLECTMAX;
                                  }
                                  else if(data[dset]->type == OTHERTYPE) {
                                    data[dset]->min = OTHERMIN;
                                    data[dset]->max = OTHERMAX;
                                  }
                                  else {
                                  }
                                }
                                else {
                                  data[dset]->min = minvar;
                                  data[dset]->max = maxvar;
                                }
                                SetMinMax(dset);
                                if(affine.usetable == False && dataset_cnt == 1) {
                                  (void)MakeNewAffineTable(&affinetable);
                                  (void)MapHoleToAffineTable(&affinetable, dset);
                                  (void)MapCoreToAffineTable(&affinetable, dset);
                                }
                                /* note that after read one data set there is always
                                   an affine table whether read or created new
                                */
                                else if(dataset_cnt > 1) {
                                  CheckAffineTableMissingHole(&affinetable, dset);
                                  MapHoleToAffineTable(&affinetable, dset);
                                  CheckAffineTableMissingCore(&affinetable, dset);
                                  MapCoreToAffineTable(&affinetable, dset);
                                  for(i=0; i<dset; ++i) {
                                    MapHoleToAffineTable(&affinetable, i);
                                    MapCoreToAffineTable(&affinetable, i);
                                  }
                                }
 
                                if(data[dset]->type == GRAPE) {
                                  xmstring=XmCvtCTToXmString("Grape");
                                }
                                else if(data[dset]->type == PWAVE) {
                                  xmstring=XmCvtCTToXmString("Pwave");
                                }
                                else if(data[dset]->type == SUSCEPTIBILITY) {
                                  xmstring=XmCvtCTToXmString("Susceptibility");
                                }
                                else if(data[dset]->type == NATURALGAMMA) {
                                  xmstring=XmCvtCTToXmString("Natural Gamma");
                                }
                                else if(data[dset]->type == REFLECTANCEMST) {
                                  xmstring=XmCvtCTToXmString("Reflectance");
                                }
                                else if(data[dset]->type == OTHERTYPE) {
                                  xmstring=XmCvtCTToXmString("Other");
                                }
                                else {
                                  xmstring=XmCvtCTToXmString("Other");
                                }
                                if(dataset_cnt == 1) {
                                  XtManageChild(optionMenuDataSet);
                                  XtManageChild(pushButtonDataSet1);
                                  XtVaSetValues(pushButtonDataSet1,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet1, NULL);
                                }
                                else if(dataset_cnt == 2) {
                                  XtManageChild(pushButtonDataSet2);
                                  XtVaSetValues(pushButtonDataSet2,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet2, NULL);
                                }
                                else if(dataset_cnt == 3) {
                                  XtManageChild(pushButtonDataSet3);
                                  XtVaSetValues(pushButtonDataSet3,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet3, NULL);
                                }
                                else if(dataset_cnt == 4) {
                                  XtManageChild(pushButtonDataSet4);
                                  XtVaSetValues(pushButtonDataSet4,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet4, NULL);
                                }
                                else if(dataset_cnt == 5) {
                                  XtManageChild(pushButtonDataSet5);
                                  XtVaSetValues(pushButtonDataSet5,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet5, NULL);
                                }
                                else if(dataset_cnt == 6) {
                                  XtManageChild(pushButtonDataSet6);
                                  XtVaSetValues(pushButtonDataSet6,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet6, NULL);
                                }
                                else if(dataset_cnt == 7) {
                                  XtManageChild(pushButtonDataSet7);
                                  XtVaSetValues(pushButtonDataSet7,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet7, NULL);
                                }
                                else if(dataset_cnt == 8) {
                                  XtManageChild(pushButtonDataSet8);
                                  XtVaSetValues(pushButtonDataSet8,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet8, NULL);
                                }
                                else if(dataset_cnt == 9) {
                                  XtManageChild(pushButtonDataSet9);
                                  XtVaSetValues(pushButtonDataSet9,XmNlabelString,xmstring,NULL);
                                  XtVaSetValues(optionMenuDataSet, XmNmenuHistory, pushButtonDataSet9, NULL);
                                }
                                else {
                                }
                                XmStringFree(xmstring);

                                XtUnmanageChild(messageBoxWorking);

                                /* if this is first data set create a report output filename using site name
                                   this assumes that any additional data sets are from same site
                                   figure out that path for this when know what the affine path is
                                */
                                if(dataset_cnt == 1) {
                                  if(report_filename) {
                                    XtFree(report_filename);
                                    report_filename = NULL;
                                  }
                                  if((report_filename=(char*)calloc(50,CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInputData 7"); 
                                  (void)sprintf(report_filename, "%d.rpt", data[dset]->site);
                                }

                                if(have_splice == DO) {
                                  MakeSplice(dset, &spcomp);
                                  if(XtIsManaged(XtParent(drawingAreaView))) {
                                    reason_for_redraw = DRAW_EVERYTHING;
                                    DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
                                  }
                                }
                                if(XtIsManaged(XtParent(drawingAreaEdit))) {
                                  reason_for_redraw = DRAW_EVERYTHING;
                                  DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
                                }
                                if(are_agemodelling == YES) {
                                  if(have_time_series == DO) {
                                    have_splicetoage_tie = DONT;
                                    have_timeseries_tie = DONT;
                                  }
                                  PlotSpliceVsAge();
                                }
			}
			return(done_affine&&done_decimate&&done_smooth&&done_cull&&done_reading); 
		}
	}
/* if all data read, set holes and start processing next time */
	if(!message.error && current_file >= data[dset]->numfiles && !datafileopen)	/* all data read */
	{
		current_file=0;

		/* sort holes alpha/numerically */
		for(i=0;i<data[dset]->numholes-1;i++)
		{
			switched=False;
			for(j=i+1;!switched && j<data[dset]->numholes;j++)
			{
				if(data[dset]->holes[j]->name < data[dset]->holes[i]->name)
				{
					tmphole=data[dset]->holes[i];
					data[dset]->holes[i]=data[dset]->holes[j];
					data[dset]->holes[j]=tmphole;
					switched=True;
					i--;
				}
			}
		}
		if(!message.error)
		{
                        SiteAveDepth();
                      
			done_reading=True;
			if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpInputData 7");
			(void)sprintf(charptr,"\nData : Done reading files. Preparing to process...");
			SpUpdateReport(charptr);
			xmstring=XmStringCreateLocalized(&charptr[1]);
			XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring,NULL);
			XmStringFree(xmstring);
			free(charptr);
			return(False);
		}
	}
/* find current filename */
	else if(!message.error && !datafileopen)
	{
		nameptr=data[dset]->name[current_file++];
		if((fptr=fopen(nameptr,"r"))==NULL)
		{
			message.error=True;
			message.fatal=False;
			message.default_button=XmDIALOG_OK_BUTTON;
			message.type=XmDIALOG_ERROR;
			message.caller=SPINPUTDATA;
			if((message.label=(char*)calloc(100+(int)strlen(nameptr),CHAR_SIZE))==NULL)
					SpBadMemAlloc("SpInputData 8");
			(void)sprintf(message.label,"Error opening input file %s\n",nameptr);
		}
		else
		{
			lineno=0;
			datafileopen=True;
			if((charptr=(char*)calloc(100+(int)strlen(nameptr),CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpInputData 9");
			(void)sprintf(charptr,"Data : Reading file %s (line=%d, total errors=%d)     ",
                                      nameptr,lineno,data[dset]->readerrors);
			xmstring=XmStringCreateLocalized(charptr);
			XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring,NULL);
			XmStringFree(xmstring);
			free(charptr);

                        /* if have header get num of lines and read that many from current file
                        */
                        if(data[dset]->in_format != JANUSORIG && XmToggleButtonGetState(toggleButtonHeaderYes) == True) {
                          str = XmTextGetString(textFieldNHeader);
                          skip = atoi(str);
                          XtFree(str);
                          for(i=1; i<=skip; ++i) {
                            if(fgets(buffer,999,fptr)==NULL) {
                              /* error; reached end of file
                              */
                            }
                          }
                        }

                        /* if format type is Janus Orig then read current file until record
                           reads <PRE><!--START OF OUTPUT--> then read one more to skip header
                           if don't reach this record then error
                           note that if there was an error getting data then the nest line will
                           have some message stating this. fine out what that is.
                        */
                        if(data[dset]->in_format == JANUSORIG) {
                          while(fgets(buffer,999,fptr)!=NULL) {
                            if(strcmp(buffer, "<PRE><!--START OF OUTPUT-->\n") == 0) {
                              if(fgets(buffer,999,fptr)==NULL) {
                                /* error
                                */     
                              }
                              break;
                            } 
                          }
                        }
		}
	}
/* read some data */
	if(!message.error && datafileopen)
	{
		if(SpRead(fptr, data[dset]))
		{
		/* end of file found */
			fclose(fptr);
			datafileopen=False;
			if((charptr=(char*)calloc(200+(int)strlen(nameptr),CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpInputData 10");
                        if(data[dset]->numholes == 0) {
                          (void)sprintf(charptr,"\nUnable to read input file  %s",nameptr);
                          message.error = TRUE;
                          if((message.label=(char*)calloc(50+(int)strlen(nameptr),CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData 8");
                            (void)sprintf(message.label,"Unable to read input file %s\n",nameptr);
                        }
                        else {
			  (void)sprintf(charptr,"\nRead file %s (total lines =%d, total errors=%d)",nameptr,lineno,data[dset]->readerrors);
                        }
			SpUpdateReport(charptr);
			free(charptr);
		}
		else
		/* not end of file */
		{
			if(++lineno % 500 == 0)
			{
                        	if((charptr=(char*)calloc(200+(int)strlen(nameptr),CHAR_SIZE))==NULL) 
                               		SpBadMemAlloc("SpInputData 11");
				(void)sprintf(charptr,"Data : Reading file %s (line=%d, total errors=%d)",nameptr,lineno,data[dset]->readerrors);
				xmstring=XmStringCreateLocalized(charptr);
				XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring,NULL);
				XmStringFree(xmstring);
				free(charptr);
			}

                        if(data[dset]->readerrors > TOOMANYREADERRORS) {
                          message.error=True;
                          message.fatal=False;
                          if((message.label=(char*)calloc(500 + (int)strlen(nameptr),CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpInputData");
                          (void)sprintf(message.label,"%d read errors have occured. \nAre in file %s at line %d\n", 
                                            data[dset]->readerrors, nameptr, lineno);
                          message.type=XmDIALOG_ERROR;
                          message.caller=NONE;
                          message.default_button=XmDIALOG_OK_BUTTON;
                          current_file=lineno=current_hole_num=0;
                          fclose(fptr);
                          datafileopen=False;
                          if(dataset_cnt == 1) {
                            SpCleanUp(INPUTDATA);
                          }
                          else if(dataset_cnt > 1) {
                            SpFreeData(data[dset]);
                            if(data[dset])
                            {
                              free(data[dset]);
                              data[dset]=NULL;
                            }
                            --dataset_cnt;
                            dset = dataset_cnt - 1;
                            if(have_splice == DO) {
                              if(XtIsManaged(XtParent(drawingAreaView))) {
                                reason_for_redraw = DRAW_EVERYTHING;
                                DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
                              }
                            }
                            if(XtIsManaged(XtParent(drawingAreaEdit))) {
                              reason_for_redraw = DRAW_EVERYTHING;
                              DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
                            }
                          }
                          XtUnmanageChild(messageBoxWorking);
                          SpManageMessage(message);
                          return(True);
                        }
		}
	}
/* an error occurred somewhere... Close working box and clean up */
	if(message.error)
	{
		current_file=lineno=current_hole_num=0;
                datafileopen=False;
                if(dataset_cnt == 1) {
		  SpCleanUp(INPUTDATA);
                }
                else if(dataset_cnt > 1) {
                  SpFreeData(data[dset]);
                  if(data[dset])
                  {
                    free(data[dset]);
                    data[dset]=NULL;
                  }
                  --dataset_cnt;
                  dset = dataset_cnt - 1;
                  if(have_splice == DO) {
                    if(XtIsManaged(XtParent(drawingAreaView))) {
                      reason_for_redraw = DRAW_EVERYTHING;
                      DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
                    }
                  }
                  if(XtIsManaged(XtParent(drawingAreaEdit))) {
                    reason_for_redraw = DRAW_EVERYTHING;
                    DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
                  }
                }
		XtUnmanageChild(messageBoxWorking);
                message.fatal=False;
                message.caller=NONE;
                message.type=XmDIALOG_ERROR;
                message.default_button=XmDIALOG_OK_BUTTON;
		SpManageMessage(message); 
		return(True);
	}
	else
		return(False);
}

int	SpInputSplicerTable(client_data)
XtPointer	client_data;
{
	XmString	xmstring;
	int	i,j,k,status, sm, dum1, dum2, SpReadSplicerTable(), FindValueInCoreToSplice();
	Core	*coreptr;
	Value	*valueptr;
	char	*ptr;
        void DrawDrawingAreaView(), CheckSpliceTableOffsets(), PlotSpliceVsAge();

	if(!splicer_read_done)
	{
		if ((fptr=fopen(splicertable.filename,"r"))==NULL)
		{
			message.error=True;
                        message.fatal=False;
                        message.caller=NONE;
                        message.type=XmDIALOG_WARNING;
                        message.default_button=XmDIALOG_OK_BUTTON;
                        if((message.label=(char*)calloc((int)strlen(splicertable.filename)+50,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpInputSplicerTable 1");
			(void)sprintf(message.label,"Error opening input file %s\n",splicertable.filename);
			SpManageMessage(message);
			return(True);
		}
		else
		{
                        if((charptr=(char*)calloc((int)strlen(splicertable.filename)+50,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpInputSplicerTable 1");
			(void)sprintf(charptr,"\nSplicer table file %s used.\n",splicertable.filename);
			SpUpdateReport(charptr);
			free(charptr);
                        XmUpdateDisplay(messageBoxWorking);
		/* set up splicer table */
			splicertable.alloc_cnt=ALLOC_INT;
			splicertable.data_cnt=1; /* first value isn't read from table */
			sptable_cnt=0;
			if((splicertable.data=(SplicerTableInfo*)calloc(splicertable.alloc_cnt,sizeof(SplicerTableInfo)))==NULL)
				SpBadMemAlloc("SpInputSplicerTable");
		/* read splicer table */
			while(!splicer_read_done)
			{
				if(splicertable.data_cnt+1>=splicertable.alloc_cnt)
				{
					if((ptr=(char*)realloc((char*)splicertable.data,(splicertable.alloc_cnt+=ALLOC_INT)*sizeof(SplicerTableInfo)))==NULL)
						SpBadMemAlloc("SpInputSplicerTable");
					else
						splicertable.data=(SplicerTableInfo*)ptr;
				}
				if((status=SpReadSplicerTable(fptr,splicertable.data,&splicertable.data_cnt))==EOF)
						splicer_read_done=True;
				else if(!(status==9 || status==19))	/* error reading */
				{
					fclose(fptr);
					free(splicertable.data);
					XtUnmanageChild(messageBoxWorking);
					message.error=True;
                                        message.fatal=False;
					if((message.label=(char*)calloc((int)strlen(splicertable.filename)+100,CHAR_SIZE))==NULL)
						SpBadMemAlloc("SpInputSplicerTable");
					(void)sprintf(message.label,"Error reading splicer table %s.",splicertable.filename);
                                        message.caller=NONE;
                                        message.type=XmDIALOG_ERROR;
                                        message.default_button=XmDIALOG_OK_BUTTON;
					SpManageMessage(message);
					return(True);
				}
			}
			fclose(fptr);

                        if((charptr=(char*)calloc((int)strlen(splicertable.filename)+200,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpInputSplicerTable 3");
			(void)sprintf(charptr,"Splicer : Read splicer table file %s (total ties %d)",splicertable.filename,
					(int)splicertable.data_cnt/2);
			SpUpdateReport(charptr);
                        XmUpdateDisplay(messageBoxWorking);
			xmstring=XmStringCreateLocalized(charptr);
			XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
			XmStringFree(xmstring);
			free(charptr);
		}
	}
	else if(!splicer_table_done)	/* fill in splicer table values */
	{
	/* get first data value */
		if(sptable_cnt==0)
		{
			for(i=0;i<data[dset]->numholes && data[dset]->holes[i]->name != splicertable.data[1].hole;i++);


			if(i<data[dset]->numholes)
			{
				for(j=0;j<data[dset]->holes[i]->numcores && splicertable.data[1].core!=data[dset]->holes[i]->core[j]->num;j++);
				if(j<data[dset]->holes[i]->numcores)
				{
				/* find first "good" value */
					coreptr=data[dset]->holes[i]->core[j];
					for(k=0;k<coreptr->numvalues && coreptr->value[k]->quality!=GOOD;k++);
				/* set splicertable values for top of cores */
					if(k<coreptr->numvalues)
					{
						spcomp.numcores=0;
						valueptr=coreptr->value[k];
						splicertable.data[0].hole=splicertable.data[1].hole;
						splicertable.data[0].core=splicertable.data[1].core;
						splicertable.data[0].core_type=valueptr->type;
						(void)strcpy(splicertable.data[0].section,valueptr->section);
						splicertable.data[0].top_int=valueptr->top_int;
						splicertable.data[0].bot_int=valueptr->bot_int;
						splicertable.data[0].mbsf=valueptr->sb_depth;
						splicertable.data[0].mcd=valueptr->sb_depth +(splicertable.data[1].mcd-splicertable.data[1].mbsf);
					}
					else
						message.error=SPL_NO_CORE_VALUES;
				}
				else
					message.error=SPL_MISSING_CORE;
			}
			else
				message.error=SPL_MISSING_CORE;

                        if(message.error == SPL_NO_CORE_VALUES || message.error == SPL_MISSING_CORE)
                        {
                          spcomp.numcores=0;
                          splicertable.data[0].hole=splicertable.data[1].hole;
                          splicertable.data[0].core=splicertable.data[1].core;
                          splicertable.data[0].core_type=splicertable.data[1].core_type;
                          (void)strcpy(splicertable.data[0].section,"1");
                          splicertable.data[0].top_int=0.0;
                          splicertable.data[0].bot_int=0.0;
                          splicertable.data[0].mbsf=0.0;
                          splicertable.data[0].mcd=splicertable.data[0].mbsf +(splicertable.data[1].mcd-splicertable.data[1].mbsf);
                        }
			else if(message.error)
			{
				XtUnmanageChild(messageBoxWorking);
                        	if((message.label=(char*)calloc(100,CHAR_SIZE))==NULL)
                                	SpBadMemAlloc("SpInputSplicerTable 3");
				(void)sprintf(message.label,"Error finding match for top of first core!");
				if(splicertable.data)
				{
					free(splicertable.data);
					splicertable.data=NULL;
				}
                                message.fatal=False;
                                message.caller=NONE;
                                message.type=XmDIALOG_WARNING;
                                message.default_button=XmDIALOG_OK_BUTTON;
				SpManageMessage(message);
				return(message.error);
			}
		}
/* write  data for a tie */
/* loop through all good data between sptable_cnt & sptablecnt+1, then add 2 to sptablecnt */	
		if(sptable_cnt<splicertable.data_cnt)
		{
		/* find correct hole */
			for(i=0;i<data[dset]->numholes && splicertable.data[sptable_cnt].hole!=data[dset]->holes[i]->name;i++);
			if(i<data[dset]->numholes)
			{
			/* find correct core */
				for(j=0;j<data[dset]->holes[i]->numcores && splicertable.data[sptable_cnt].core!=data[dset]->holes[i]->core[j]->num;j++);
				if(j<data[dset]->holes[i]->numcores)
				{
				/* find first value for this core*/
					coreptr=data[dset]->holes[i]->core[j];
					for(k=0;k<coreptr->numvalues && coreptr->value[k]->sb_depth < splicertable.data[sptable_cnt].mbsf; k++);
                     
				/* get "good" values until bottom of tied core*/
					if(k<coreptr->numvalues)
					{
						spcomp.hole[spcomp.numcores]=i;
						spcomp.core[spcomp.numcores]=j;
						spcomp.Depthoffset[spcomp.numcores]=splicertable.data[sptable_cnt].mcd-splicertable.data[sptable_cnt].mbsf;
						spcomp.numpercore[spcomp.numcores]=0;
                                                spcomp.map_to_table[spcomp.numcores] = sptable_cnt;
                                                if(spcomp.numcores > 0) {
                                                  if(strcmp(splicertable.data[sptable_cnt].type_of_splice, "tie") == 0) {
                                                    spcomp.splice_how[spcomp.numcores] = REAL;
                                                  }
                                                  else if(strcmp(splicertable.data[sptable_cnt].type_of_splice, "interp") == 0) {
                                                    spcomp.splice_how[spcomp.numcores] = INTERPOLATED;
                                                    spcomp.interpolated_spl_depth[spcomp.numcores] = splicertable.data[sptable_cnt].mcd;

                                                    /* note that if find real value at 'depth' then splicearraynum comes back
                                                       with indicy of real point. but if interpolated a point then splicearraynum
                                                       is the indicy of next real point.
                                                    */
                                                    if(smooth.method == GAUSSIAN || smooth.method == OTHER) {
                                                      sm == YES;
                                                    }
                                                    else {
                                                      sm = NO;
                                                    }
                                                    (void)FindValueInCoreToSplice(dset, sm, spcomp.interpolated_spl_depth[spcomp.numcores], 
                                                            spcomp.hole[spcomp.numcores], spcomp.core[spcomp.numcores],
                                                            &dum1, &dum2, 
                                                            &spcomp.interpolated_value[spcomp.numcores], &spcomp.interpolated_sm_value[spcomp.numcores]);
                                                  }
                                                  else if(strcmp(splicertable.data[sptable_cnt].type_of_splice, "append") == 0) {
                                                    spcomp.splice_how[spcomp.numcores] = APPEND;
                                                  }
                                                  else {
                                                    spcomp.splice_how[spcomp.numcores] = NONE;
                                                  }
                                                }
                                                else {
                                                  spcomp.splice_how[spcomp.numcores] = NONE;
                                                }
						for(;k<coreptr->numvalues && coreptr->value[k]->sb_depth <= splicertable.data[sptable_cnt+1].mbsf; k++)
						{
							valueptr=coreptr->value[k];
							if(valueptr->quality == GOOD)
							{
								spcomp.MapToOrig[spcomp.numcores][spcomp.numpercore[spcomp.numcores]]=k;
								spcomp.sb_depth[spcomp.numcores][spcomp.numpercore[spcomp.numcores]]=valueptr->sb_depth+spcomp.Depthoffset[spcomp.numcores];
                                                                spcomp.var[spcomp.numcores][spcomp.numpercore[spcomp.numcores]]=*valueptr->data;
                                                                spcomp.numpercore[spcomp.numcores]++;
							}
						}
                                                ++spcomp.numcores;
					}
					else
						message.error=SPL_NO_CORE_VALUES;
				}
				else
					message.error=SPL_MISSING_CORE;
                        	if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL)
                                {
                                	SpBadMemAlloc("SpInputSplicerTable 4");
                                }
				SpUpdateReport(charptr);
				xmstring=XmStringCreateLocalized(&charptr[1]);
				XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
				XmStringFree(xmstring);
				free(charptr);
				sptable_cnt+=2;
			}
			else 
                        {
				message.error=SPL_MISSING_HOLE;
                                sptable_cnt+=2;
                        }
			if(message.error == True)
			{
                        	if((message.label=(char*)calloc(100,CHAR_SIZE))==NULL)
                                	SpBadMemAlloc("SpInputSplicerTable 4");
				(void)sprintf(message.label,"Error building splicer table!");
				XtUnmanageChild(messageBoxWorking);
				if(splicertable.data)
				{
					free(splicertable.data);
					splicertable.data=NULL;
				}
				sptable_cnt=0;
                                message.fatal=False;
                                message.caller=NONE;
                                message.type=XmDIALOG_WARNING;
                                message.default_button=XmDIALOG_OK_BUTTON;
				SpManageMessage(message);
				return(message.error);
			}
		}
		else
			splicer_table_done=True;
	}
	
/* check if work is done */
	if(splicer_read_done&&splicer_table_done)
	{
                if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                             SpBadMemAlloc("SpInputSplicerTable 4");
                (void)sprintf(charptr,"\n");
                SpUpdateReport(charptr);
                free(charptr);

		XtUnmanageChild(messageBoxWorking);
		have_splice=DO;
                XtSetSensitive(pushButtonSaveSplicerTable,True);
                XtSetSensitive(pushButtonSaveSplicerData,True);
                XtSetSensitive(pushButtonOpenSplicerTable,False);
                XtSetSensitive(pushButtonClearSplice,True);
                XtSetSensitive(cascadeButtonSplice,True);
                XtSetSensitive(pushButtonSpliceUndoLast, True);
                if(XtIsManaged(XtParent(drawingAreaView))) {
                  reason_for_redraw = DRAW_EVERYTHING;
                  DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
                }
                if(are_agemodelling == YES && ((agemodel_cnt == 1 && agemodel[0].aveage > 0.0) || agemodel_cnt > 1)) {
                  XtSetSensitive(pushButtonPlotSpliceVsAge, True);
                  XtSetSensitive(pushButtonSaveSpliceToAge, True);
                  XtSetSensitive(pushButtonOpenAgeSignal, True);
                  XtSetSensitive(pushButtonOpenTimeSeries, True);
                  PlotSpliceVsAge();
                }

                if(message.error == SPL_MISSING_HOLE || message.error == SPL_MISSING_CORE || message.error == SPL_NO_CORE_VALUES) { 
                  (void)sprintf(buffer,"Warning; the entire splice record could not be built.");
                  SpManageWarningBox(buffer);
                } 

                if(have_affine == DO) {
                  CheckSpliceTableOffsets();
                }
                else {
                  (void)sprintf(buffer, "Warning: You do not have an affine table.");
                  SpManageWarningBox(buffer);
                }


		return(True);

	}
	else
		return(False);
}

int SpInputStrat(client_data)
XtPointer client_data;
{
        char            string[100];
	XmString	xmstring;
	StratFile	*stratptr;
	StratData	*thisptr;
	int	i,j,found=0,SpReadStrat();
	Core	*coreptr;
        void DrawDrawingAreaEdit(), DrawDrawingAreaView(), DrawDrawingAreaAgeDepth(), 
             MapStratToAffine(), FindStratDepthOffset();

	stratptr=strat[strat_file_cnt-1];
	if(!stratfileopen)
	{
                io_wait_cursor = XCreateFontCursor(XtDisplay(formFileSelection), XC_watch);
                if(io_wait_cursor != BadAlloc && io_wait_cursor != BadFont && io_wait_cursor != BadValue) {
                  XDefineCursor(XtDisplay(formFileSelection), XtWindow(formFileSelection), io_wait_cursor);
                }
		if ((fptr=fopen(stratptr->filename,"r"))==NULL)
		{
			message.error=True;
                        if((message.label=(char*)calloc((int)strlen(stratptr->filename)+100,CHAR_SIZE))==NULL)
                               	SpBadMemAlloc("SpInputstrat 1");
			(void)sprintf(message.label,"Error opening input file %s\n",stratptr->filename);
                        message.fatal=False;
                        message.caller=NONE;
                        message.type=XmDIALOG_WARNING;
                        message.default_button=XmDIALOG_OK_BUTTON;
			SpManageMessage(message);
			return(True);
		}
		else
		{
                        if((charptr=(char*)calloc((int)strlen(stratptr->filename)+(int)strlen(strat_type[stratptr->type])+100,CHAR_SIZE))==NULL)
                               	SpBadMemAlloc("SpInputstrat 2");
			(void)sprintf(charptr,"\nStrat file %s read.(%s)",stratptr->filename,
				strat_type[stratptr->type]);
			SpUpdateReport(charptr);
			free(charptr);
			stratfileopen=True;
			if((stratptr->data= (StratData*)calloc((stratptr->alloc_cnt=ALLOC_INT),sizeof(StratData)))==NULL)
				SpBadMemAlloc("SpInputstrat");
			stratptr->data_cnt=0;
		}
	}
	if(stratptr->data_cnt+1 >= stratptr->alloc_cnt)
	{
			if((charptr= (char*)realloc(stratptr->data,(stratptr->alloc_cnt+=ALLOC_INT)*sizeof(StratData)))==NULL)
				SpBadMemAlloc("SpInputstrat");
			else
				stratptr->data=(StratData*)charptr;
	}
	stratfileopen=SpReadStrat(fptr,&stratptr->data[stratptr->data_cnt]);
	if(stratfileopen)
	{
		if(stratptr->data_cnt % 500 == 0)
		{
                        if((charptr=(char*)calloc((int)strlen(stratptr->filename)+100,CHAR_SIZE))==NULL)
                               	SpBadMemAlloc("SpInputstrat 2");
			(void)sprintf(charptr,"Strat : Reading Strat file %s (line number %d)",stratptr->filename,
					stratptr->data_cnt);
			xmstring=XmStringCreateLocalized(charptr);
			XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
			XmStringFree(xmstring);
			free(charptr);
		}
		stratptr->data_cnt++;
		return(False);
	}
	else
	{
                if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                              SpBadMemAlloc("SpInputStrat");
                (void)sprintf(charptr,"\n");
                SpUpdateReport(charptr);
                free(charptr);

		if(fptr) fclose(fptr);
		XtUnmanageChild(messageBoxWorking);
		have_strat=DO;
                MapStratToAffine();
                FindStratDepthOffset();
                AgeDepthMinMax();
                XtSetSensitive(pushButtonViewAgeDepth,True);
                XtSetSensitive(pushButtonSaveStrat,True);
                /* XtSetSensitive(pushButtonClearStrat,True); */
             
                XmListDeleteAllItems(listAgeDepthStrat);
                for(i=0; i<strat_file_cnt; ++i) {
                  if(strat[i]->type == DIATOMS) {
                    (void)sprintf(string, "Diatom");
                    for(j=0; j<strat[i]->data_cnt; ++j) {
                      strat[i]->data[j].type = DIATOMS;
                    }
                  }
                  else if(strat[i]->type == RADIOLARIA) {
                    (void)sprintf(string, "Radiolaria");
                    for(j=0; j<strat[i]->data_cnt; ++j) {
                      strat[i]->data[j].type = RADIOLARIA;
                    }
                  }
                  else if(strat[i]->type == FORAMINIFERA) {
                    (void)sprintf(string, "Foraminifera");
                    for(j=0; j<strat[i]->data_cnt; ++j) {
                      strat[i]->data[j].type = FORAMINIFERA;
                    }
                  }
                  else if(strat[i]->type == NANNOFOSSILS) {
                    (void)sprintf(string, "Nannofossils");
                    for(j=0; j<strat[i]->data_cnt; ++j) {
                      strat[i]->data[j].type = NANNOFOSSILS;
                    }
                  }
                  else if(strat[i]->type == PALEOMAG) {
                    (void)sprintf(string, "Paleomag");
                    for(j=0; j<strat[i]->data_cnt; ++j) {
                      strat[i]->data[j].type = PALEOMAG;
                    }
                  }
                  else {
                    (void)sprintf(string, "unknown");
                  }
                  xmstring = XmStringCreateSimple(string);
                  XmListAddItem(listAgeDepthStrat, xmstring, 0);
                  XmListSelectPos(listAgeDepthStrat, 0, False);
                  XmStringFree(xmstring);
                }
                (void)sprintf(string, "");

                for(i=0; i<strat_file_cnt; ++i) {
                  agedepth_use_type[i] = YES;
                }
                XtSetSensitive(formAgeDepthControls, True);
                if(XtIsManaged(XtParent(drawingAreaAgeDepth))) {
                  DrawDrawingAreaAgeDepth(drawingAreaAgeDepth, (XtPointer)NULL, (XtPointer)NULL);
                }
                if(have_data == DO) {
                  if(XtIsManaged(XtParent(drawingAreaEdit))) {
                    reason_for_redraw = DRAW_EVERYTHING;
                    DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
                  }
                  if(are_splicing == YES) {
                    if(XtIsManaged(XtParent(drawingAreaView))) {
                      reason_for_redraw = DRAW_EVERYTHING;
                      DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
                    }
                  }
                }
                if(io_wait_cursor) {
                  XUndefineCursor(XtDisplay(formFileSelection), XtWindow(formFileSelection));
                  XFreeCursor(XtDisplay(formFileSelection), io_wait_cursor);
                }
		return(True);
	}
}

int	currentstrat_file=0;
int	strat_out_open=False;
SpOutputStrat()
{
	int		i,SpWriteStrat();
	XmString	xmstring;
	if(!strat_out_open)
	{
		if((fptr=fopen(outstrat.filename,"w"))==NULL)
		{
			message.error=True;
                        if((message.label=(char*)calloc((int)strlen(outstrat.filename)+100,CHAR_SIZE))==NULL)
                               	SpBadMemAlloc("SpOutputStrat 1");
			(void)sprintf(message.label,"Error Opening output strat file %s.",outstrat.filename);
                        message.fatal=False;
                        message.caller=NONE;
                        message.type=XmDIALOG_WARNING;
                        message.default_button=XmDIALOG_OK_BUTTON;
			SpManageMessage(message);
			return(True);
		}
		else
		{
			strat_out_open=True;
                        if((charptr=(char*)calloc((int)strlen(outstrat.filename)+100,CHAR_SIZE))==NULL)
                               	SpBadMemAlloc("SpOutputStrat 2");
			(void)sprintf(charptr,"\nOutput strat file %s.",outstrat.filename);
			SpUpdateReport(charptr);
			free(charptr);
		}
	}
	if(currentstrat_file<strat_file_cnt)
	{
		for(i=0;i<strat[currentstrat_file]->data_cnt;i++)
			(void)SpWriteStrat(fptr,&strat[currentstrat_file]->data[i]);	
                if((charptr=(char*)calloc((int)strlen(strat[currentstrat_file]->filename)+100,CHAR_SIZE))==NULL)
                               	SpBadMemAlloc("SpOutputStrat 3");
		(void)sprintf(charptr,"Strat: Output data from input file %s.",strat[currentstrat_file]->filename);
		xmstring=XmStringCreateLocalized(&charptr[1]);
		XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
		XmStringFree(xmstring);
		free(charptr);
		currentstrat_file++;
		return(False);
	}
	else
	{
		fclose(fptr);
		strat_out_open=False;
		currentstrat_file=0;
		XtUnmanageChild(messageBoxWorking);
		return(True);
	}
}

void SpFreeData(dataptr)
DataFile	*dataptr;
{
	int	i,j,k;

	for(i=0;i<dataptr->numfiles;i++)
	{
		if(dataptr->name[i] && (int)strlen(dataptr->name[i])>0)
		{
			XtFree(dataptr->name[i]);
			dataptr->name[i]=NULL;
		}
	}
	for(i=0;dataptr->holes && dataptr->holes[i] && i<dataptr->numholes;i++)
	{
		for(j=0;dataptr->holes[i]->core && j<dataptr->holes[i]->numcores;j++)
		{
			for(k=0;dataptr->holes[i]->core[j]->value && k< dataptr->holes[i]->core[j]->allocvalues;k++)
			{
				if(dataptr->type==GRAPE && dataptr->holes[i]->core[j]->value[k]->grape)
					free(dataptr->holes[i]->core[j]->value[k]->grape);
				else if(dataptr->type==PWAVE && dataptr->holes[i]->core[j]->value[k]->pwave)
					free(dataptr->holes[i]->core[j]->value[k]->pwave);
				else if(dataptr->type==NATURALGAMMA && dataptr->holes[i]->core[j]->value[k]->naturalgamma)
					free(dataptr->holes[i]->core[j]->value[k]->naturalgamma);
				else if(dataptr->type==SUSCEPTIBILITY && dataptr->holes[i]->core[j]->value[k]->susceptibility)
					free(dataptr->holes[i]->core[j]->value[k]->susceptibility);
				else if(dataptr->type==REFLECTANCEMST && dataptr->holes[i]->core[j]->value[k]->reflectanceMST)
					free(dataptr->holes[i]->core[j]->value[k]->reflectanceMST);
				free(dataptr->holes[i]->core[j]->value[k]);
			}
			free(dataptr->holes[i]->core[j]->value);
			free(dataptr->holes[i]->core[j]);
		}
		free(dataptr->holes[i]);
	}
	if(dataptr->holes)
	{
		free(dataptr->holes);
		dataptr->holes=NULL;
	}
	if(dataptr->name && (int)strlen((char*)dataptr->name)>0)
	{
		free(dataptr->name);
		dataptr->name=NULL;
	}
	if(dataptr->holes_used && (int)strlen(dataptr->holes_used)>0)
	{
		free(dataptr->holes_used);
		dataptr->holes_used=NULL;
	}
	dataptr->readerrors=0;
	dataptr->numholes=0;
	dataptr->numfiles=0;
	return;
}

SpOutputAgeModel()
{
        int             i, SpWriteAgeModel();
        XmString        xmstring;

        if((fptr=fopen(outagemodel_filename,"w"))==NULL)
        {
              message.error=True;
              if((message.label=(char*)calloc((int)strlen(outagemodel_filename)+100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpOutputAgeModel 1");
              (void)sprintf(message.label,"Error Opening output age model file %s.",outagemodel_filename);
              message.fatal=False;
              message.caller=NONE;
              message.type=XmDIALOG_WARNING;
              message.default_button=XmDIALOG_OK_BUTTON;
              SpManageMessage(message);
              return(True);
        }
        else
        {
              if((charptr=(char*)calloc((int)strlen(outagemodel_filename)+100,CHAR_SIZE))==NULL)
                               SpBadMemAlloc("SpOutputAgeModel 2");
              (void)sprintf(charptr,"\nOutput age model file %s.\n",outagemodel_filename);
              SpUpdateReport(charptr);
              free(charptr);

              /* write the agemodel table to report
              */
              sprintf(buffer, "\nAge Model Table\n");
              SpUpdateReport(buffer);
              for(i=0; i<agemodel_cnt; ++i) {
                sprintf(buffer,"%10.2f%10.2f%10.3f     %s %s\n",
                      agemodel[i].avembsf, agemodel[i].avemcd, agemodel[i].aveage, agemodel[i].name, agemodel[i].code);
                SpUpdateReport(buffer);
              }
              SpUpdateReport("\n");
        }

        if((charptr=(char*)calloc((int)strlen(outagemodel_filename)+100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpOutputAgeModel 3");
        (void)sprintf(charptr,"Age Model: Saving age model to file %s.", outagemodel_filename);
        xmstring=XmStringCreateLocalized(&charptr[1]);
        XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
        XmStringFree(xmstring);
        free(charptr);
        XmUpdateDisplay(messageBoxWorking);

        (void)SpWriteAgeModel(fptr);
        if((charptr=(char*)calloc((int)strlen(outagemodel_filename)+100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpOutputAgeModel 3");
        (void)sprintf(charptr,"Age model save done.");
        xmstring=XmStringCreateLocalized(&charptr[1]);
        XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
        XmStringFree(xmstring);
        free(charptr);
        fclose(fptr);
        XtUnmanageChild(messageBoxWorking);
        return(True);
}


SpInputAgeModel()
{
        int             i, j, k, found, unfound, mbsferr, mcderr, SpReadAgeModel();
        char            string[500];
        XmString        xmstring;
        void DrawDrawingAreaAgeDepth(), PlotSpliceVsAge();

        if((fptr=fopen(inagemodel_filename,"r"))==NULL)
        {
              message.error=True;
              if((message.label=(char*)calloc((int)strlen(inagemodel_filename)+100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpInputAgeModel 1");
              (void)sprintf(message.label,"Error Opening input age model file %s.",inagemodel_filename);
              message.fatal=False;
              message.caller=NONE;
              message.type=XmDIALOG_WARNING;
              message.default_button=XmDIALOG_OK_BUTTON;
              SpManageMessage(message);
              return(True);
        }
        else
        {
              if((charptr=(char*)calloc((int)strlen(inagemodel_filename)+100,CHAR_SIZE))==NULL)
                               SpBadMemAlloc("SpInputAgeModel 2");
              (void)sprintf(charptr,"\nInput age model file %s.\n",inagemodel_filename);
              SpUpdateReport(charptr);
              free(charptr);
        }

        if((charptr=(char*)calloc((int)strlen(inagemodel_filename)+100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpInputAgeModel 3");
        (void)sprintf(charptr,"Age Model: Openning age model file %s.", inagemodel_filename);
        xmstring=XmStringCreateLocalized(&charptr[1]);
        XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
        XmStringFree(xmstring);
        free(charptr);
        XmUpdateDisplay(messageBoxWorking);

        SpReadAgeModel(fptr);
        if(agemodel_cnt > 0) {

          /* map the age model to the strat dataums
          */
          if(have_strat == DO) {
            unfound = 0;
            for(i=0; i<agemodel_cnt; ++i) {
              if(agemodel[i].type == TIME || agemodel[i].type == HANDPICK) {
                agemodel[i].agemodel_maptostratfile = -1;
                agemodel[i].agemodel_maptodatum = -1;
              }
              else {
                found = NO;
                for(j=0; j<strat_file_cnt; ++j) {
                  if(agemodel[i].type == strat[j]->type) {
                    for(k=0; k<strat[j]->data_cnt; ++k) {
                      if((strcmp(strat[j]->data[k].name, agemodel[i].name) == 0) &&
                         (strcmp(strat[j]->data[k].code, agemodel[i].code) == 0)) {
                        found = YES;
                        agemodel[i].agemodel_maptostratfile = j;
                        agemodel[i].agemodel_maptodatum = k;
                        strat[j]->data[k].agemodel_maptostratfile = j;
                        strat[j]->data[k].agemodel_maptodatum = k;
                      }
                    }
                  }
                }             
                if(found == NO) {
                  agemodel[i].agemodel_maptostratfile = -1;
                  agemodel[i].agemodel_maptodatum = -1;
                  ++unfound;
                }
              }
            }
            if(unfound > 0) {
              (void)sprintf(buffer,"Warning; could not map %d age model datums to the strat datums.", unfound);
              SpManageWarningBox(buffer);
            }

            /* check that mcd's agree
            */
            mcderr = 0;
            mbsferr = 0;
            (void)sprintf(string, "They occur at: ");
            for(i=0; i<agemodel_cnt; ++i) {
              if(agemodel[i].agemodel_maptostratfile != -1 && agemodel[i].agemodel_maptodatum != -1) {
                if(fabs(agemodel[i].avemcd - strat[agemodel[i].agemodel_maptostratfile]->data[agemodel[i].agemodel_maptodatum].avemcd) > 0.001) {
                  ++mcderr;
                  (void)strcat(string, agemodel[i].code);
                }
                if(fabs(agemodel[i].avembsf - strat[agemodel[i].agemodel_maptostratfile]->data[agemodel[i].agemodel_maptodatum].avembsf) > 0.001) {
                  ++mbsferr;
                  (void)strcat(string,  agemodel[i].code);
                }
              }
            }
            if(mcderr > 0 && mbsferr > 0) {
              (void)sprintf(buffer,"Warning; comparing strat datums to age model; %d mbfs's and %d mcd's dissagree.\n", mbsferr, mcderr);
              (void)strcat(buffer, string);
              SpManageWarningBox(buffer);
            }
            else if(mcderr > 0) {
              (void)sprintf(buffer,"Warning; comparing strat datums to age model: %d mcd's dissagree.\n", mcderr);
              (void)strcat(buffer, string);
              SpManageWarningBox(buffer);
            }
            else if(mbsferr > 0) {
              (void)sprintf(buffer,"Warning; comparing strat datums to age model; %d mbfs's dissagree.\n", mbsferr);
              (void)strcat(buffer, string);
              SpManageWarningBox(buffer);
            }
          }
          else {
            (void)sprintf(buffer,"Warning; there are no strat datums to map the age model datums to.");
            SpManageWarningBox(buffer);
          }

          XmListDeleteAllItems(listConstructAgeModel);
          for(i=0; i<agemodel_cnt; ++i) {
            (void)sprintf(string, "%7.2f  %7.2f   %7.3f    %s %s", agemodel[i].avembsf, agemodel[i].avemcd,
                  agemodel[i].aveage, agemodel[i].name, agemodel[i].code);
            xmstring = XmStringCreateSimple(string);
            XmListAddItemUnselected(listConstructAgeModel, xmstring, 0);
            XmStringFree(xmstring);
          }

          if(XtIsManaged(XtParent(drawingAreaAgeDepth))) {
            DrawDrawingAreaAgeDepth(drawingAreaAgeDepth, (XtPointer)NULL, (XtPointer)NULL);
          }
          if(have_splice == DO) {
            PlotSpliceVsAge();
          }

          if(agemodel_cnt > 1 || (agemodel_cnt == 1 && agemodel[0].aveage != 0.0)) {
            XtSetSensitive(pushButtonSaveAgeMode, True);
            XtSetSensitive(pushButtonRemoveSelectDatum, True);
            XtSetSensitive(pushButtonAgeDepthClearAgeMododelList, True);
            if(have_splice == DO) {
              XtSetSensitive(pushButtonPlotSpliceVsAge, True);
              XtSetSensitive(pushButtonSaveSpliceToAge, True);
            }
            else {
              XtSetSensitive(pushButtonPlotSpliceVsAge, False);
              XtSetSensitive(pushButtonSaveSpliceToAge, False);
            }
          }
          else {
            XtSetSensitive(pushButtonPlotSpliceVsAge, False);
            XtSetSensitive(pushButtonSaveAgeMode, False);
            XtSetSensitive(pushButtonSaveSpliceToAge, False);
          }
          if(agemodel_cnt > 0) {
            XtSetSensitive(pushButtonRemoveSelectDatum, True);
            XtSetSensitive(pushButtonAgeDepthClearAgeMododelList, True);
          }
          else {
            XtSetSensitive(pushButtonRemoveSelectDatum, False);
            XtSetSensitive(pushButtonAgeDepthClearAgeMododelList, False);
          }
       
        
          /* write the agemodel table to report
          */
          sprintf(buffer, "\nAge Model Table\n");
          SpUpdateReport(buffer);
          for(i=0; i<agemodel_cnt; ++i) {
            sprintf(buffer,"%10.2f%10.2f%10.3f     %s %s\n",
                  agemodel[i].avembsf, agemodel[i].avemcd, agemodel[i].aveage, agemodel[i].name, agemodel[i].code);
            SpUpdateReport(buffer);
          }
          SpUpdateReport("\n");
        }

        if((charptr=(char*)calloc((int)strlen(inagemodel_filename)+100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpInputAgeModel 3");
        (void)sprintf(charptr,"Age model read done.");
        xmstring=XmStringCreateLocalized(&charptr[1]);
        XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
        XmStringFree(xmstring);
        free(charptr);
        fclose(fptr);
        XtUnmanageChild(messageBoxWorking);
        return(True);
}

void SpWriteReport()
{
  int  len;
  FILE *fptr;
  char *reportbuffer, *filename;

  if((filename=(char*)calloc((int)strlen(open_data_directory)+(int)strlen(report_filename)+5,CHAR_SIZE))==NULL)
                       SpBadMemAlloc("SpWriteReport 1");
  len = (int)strlen(open_data_directory);
  if(strcmp(&open_data_directory[len-1], "/") != 0) {
    (void)sprintf(filename, "%s/%s", open_data_directory, report_filename);
  }
  else {
    (void)sprintf(filename, "%s%s", open_data_directory, report_filename);
  }

  /* does a file of this name already exist
  */
  if((fptr=fopen(filename,"r"))==NULL) {

    /* no file, write to a new file
    */
    if((fptr=fopen(filename,"w"))==NULL) {
    }
    else {

      if((charptr=(char*)calloc(50+(int)strlen(filename),CHAR_SIZE))==NULL) {
        SpBadMemAlloc("SpWriteReport 2");
      }
      (void)sprintf(charptr,"\nThe report file %s has been created.",filename);
      SpUpdateReport(charptr);
      free(charptr);

      reportbuffer=XmTextGetString(textReport);
      (void) fputs(reportbuffer,fptr);
      XtFree(reportbuffer);
      fclose(fptr);
    }
  
  }
  else
  {

    /* yes file exists, append to it
    */
    fclose(fptr);
    if((fptr=fopen(filename,"a"))==NULL) {
    }
    else {

      if((charptr=(char*)calloc(50+(int)strlen(filename),CHAR_SIZE))==NULL) {
        SpBadMemAlloc("SpWriteReport 3");
      }
      (void)sprintf(charptr,"\nThe report has been appended to file %s.",filename);
      SpUpdateReport(charptr);
      free(charptr);

      (void)fputs("\n\n", fptr);
      reportbuffer=XmTextGetString(textReport);
      (void) fputs(reportbuffer,fptr);
      XtFree(reportbuffer);
      fclose(fptr);
    }
  }
  free(filename);
}
