/*
	splicer_io.c
*/
#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include "splicer-creation-c.h"
#include "splicer_vars.h"

#define	MAXLINE		(1001)
#define MAXPREVIEW      (20)
long	atol();
int	close();
char	line[MAXLINE];


int	SpReadSplicerTable(fptr,splicerptr,cnt)
FILE	*fptr;
SplicerTableInfo	*splicerptr;
int	*cnt;
{
	int	status,i;

	status=fscanf(fptr,"%d %c %d %c %s %f %f %f %f %s %d %c %d %c %s %f %f %f %f",
			&splicerptr[*cnt].site,&splicerptr[*cnt].hole,&splicerptr[*cnt].core,&splicerptr[*cnt].core_type,
			splicerptr[*cnt].section,&splicerptr[*cnt].top_int,&splicerptr[*cnt].bot_int,
			&splicerptr[*cnt].mbsf,&splicerptr[*cnt].mcd, splicerptr[*cnt+1].type_of_splice,
			&splicerptr[*cnt+1].site,&splicerptr[*cnt+1].hole,&splicerptr[*cnt+1].core,&splicerptr[*cnt+1].core_type,
			splicerptr[*cnt+1].section,&splicerptr[*cnt+1].top_int,&splicerptr[*cnt+1].bot_int,
			&splicerptr[*cnt+1].mbsf,&splicerptr[*cnt+1].mcd);
	if(status==9 || status==19)	/* more data to read */
	{
		*cnt=*cnt+status/9;
		splicerptr[*cnt].hole=toupper(splicerptr[*cnt].hole);
		splicerptr[*cnt].core_type=toupper(splicerptr[*cnt].core_type);
		for(i=0;i<(int)strlen(splicerptr[*cnt].section);i++)
		{
			if(isalpha(splicerptr[*cnt].section[i]))
				splicerptr[*cnt].section[i]=toupper(splicerptr[*cnt].section[i]);
		}
		splicerptr[*cnt+1].hole=toupper(splicerptr[*cnt+1].hole);
		splicerptr[*cnt+1].core_type=toupper(splicerptr[*cnt+1].core_type);
		for(i=0;i<(int)strlen(splicerptr[*cnt+1].section);i++)
		{
			if(isalpha(splicerptr[*cnt+1].section[i]))
				splicerptr[*cnt+1].section[i]=toupper(splicerptr[*cnt+1].section[i]);
		}
	}
	return(status);
}

int	SpWriteSplicerTable(splfile)
char *splfile;
{
	int	i;
	Hole	*holeptr1,*holeptr2;
	Core	*coreptr1,*coreptr2;
	Value	*valueptr1,*valueptr2;
        FILE    *fptr;
        SplicerTableInfo  *spl1, *spl2;

  if((fptr=fopen(splfile, "w")) == NULL){
    return;
  }

  i = 1;
  while(i<splicertable.data_cnt-1) {
    spl1 = &splicertable.data[i];
    spl2 = &splicertable.data[i+1];
    if((int)strcmp(spl2->type_of_splice, "interp") == 0) {
      (void)sprintf(spl2->type_of_splice, "tie");
    }
    (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f\t%s\t%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f\n",
      spl1->site, spl1->hole, spl1->core, spl1->core_type, spl1->section, spl1->top_int, spl1->bot_int, spl1->mbsf, spl1->mcd,
      spl2->type_of_splice,
      spl2->site, spl2->hole, spl2->core, spl2->core_type, spl2->section, spl2->top_int, spl2->bot_int, spl2->mbsf, spl2->mcd);
    i = i + 2;
  } 
  
  i = splicertable.data_cnt-1;
  spl1 = &splicertable.data[i];
  (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f\n", 
    spl1->site, spl1->hole, spl1->core, spl1->core_type, spl1->section, spl1->top_int, spl1->bot_int, spl1->mbsf, spl1->mcd);

  fclose(fptr);

	return(True);
}

int	SpReadStrat(fptr,stratptr)
FILE	*fptr;
StratData	*stratptr;
{
	int	status,i;

	status=fscanf(fptr,"%s %s %f %f %d %d %c %d %c %s %f %f %d %d %c %d %c %s %f %f",
		stratptr->name,stratptr->code,&stratptr->top_age,&stratptr->bot_age,&stratptr->top.leg,
		&stratptr->top.site,&stratptr->top.hole,&stratptr->top.core,
		&stratptr->top.coretype,stratptr->top.section,&stratptr->top.interval,
		&stratptr->top.sb_depth,&stratptr->bot.leg,&stratptr->bot.site,&stratptr->bot.hole,&stratptr->bot.core,
		&stratptr->bot.coretype,stratptr->bot.section,&stratptr->bot.interval,&stratptr->bot.sb_depth);
	stratptr->top.hole=toupper(stratptr->top.hole);
	stratptr->top.coretype=toupper(stratptr->top.coretype);
	for(i=0;i<(int)strlen(stratptr->top.section);i++)
	{
		if(isalpha(stratptr->top.section[i]))
			stratptr->top.section[i]=toupper(stratptr->top.section[i]);
	}
	stratptr->bot.hole=toupper(stratptr->bot.hole);
	stratptr->bot.coretype=toupper(stratptr->bot.coretype);
	for(i=0;i<(int)strlen(stratptr->bot.section);i++)
	{
		if(isalpha(stratptr->bot.section[i]))
			stratptr->bot.section[i]=toupper(stratptr->bot.section[i]);
	}
	if(status==20)
		return(True);
	else if(status!=EOF)
	{
		message.error=True;
                if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL) {
                  SpBadMemAlloc("SpReadSTrat");
                }
                else {
                  (void)sprintf(charptr,"Error reading stat file. This happened at datum name %s", stratptr->name);
                }
		SpManageWarningBox(charptr);
                free(charptr);
		return(False);
	}
	else
		return(False);

} 

int	SpWriteStrat(fptr,stratptr)
FILE	*fptr;
StratData	*stratptr;
{
	char	topoffset[6],botoffset[6],
		topmsd[9],botmsd[9];
	
	if(stratptr->top.in_affine == NO)
	{
		(void)sprintf(topmsd,"N/A");
		(void)sprintf(topoffset,"N/A");
	}
	else
	{
		(void)sprintf(topmsd,"%.2f",stratptr->top.sb_depth+stratptr->top.offset);
		(void)sprintf(topoffset,"%.2f",stratptr->top.offset);
	}
	if(stratptr->bot.in_affine == NO)
	{
		(void)sprintf(topmsd,"N/A");
		(void)sprintf(botoffset,"N/A");
	}
	else
	{
		(void)sprintf(botmsd,"%.2f",stratptr->bot.sb_depth+stratptr->bot.offset);
		(void)sprintf(botoffset,"%.2f",stratptr->bot.offset);
	}
	fprintf(fptr,"%s\t%s\t%.2f\t%.2f\t%d\t%d\t%c\t%d\t%c\t%s\t%.2f\t%.2f\t%s\t%s\t%d\t%d\t%c\t%d\t%c\t%s\t%.2f\t%.2f\t%s\t%s\n",
		stratptr->name,stratptr->code,stratptr->top_age,stratptr->bot_age,stratptr->top.leg,
		stratptr->top.site,stratptr->top.hole,stratptr->top.core,
		stratptr->top.coretype,stratptr->top.section,stratptr->top.interval,
		stratptr->top.sb_depth, topoffset, topmsd,
		stratptr->bot.leg,stratptr->bot.site,stratptr->bot.hole,stratptr->bot.core,
		stratptr->bot.coretype,stratptr->bot.section,stratptr->bot.interval,stratptr->bot.sb_depth,
		botoffset,botmsd);
	return(True);
}
int SpWriteData(fptr,holeptr)
FILE	*fptr;
Hole	*holeptr;
{
	int	i,j;
	Core	*coreptr;
	Value	*valueptr;

	for(i=0;i<holeptr->numcores;i++)
	{
		coreptr=holeptr->core[i];
		for(j=0;j<coreptr->numvalues;j++)
		{
			valueptr=coreptr->value[j];
				valueptr=coreptr->value[j];
			if(valueptr->quality==GOOD)
			{
                                switch (data[dset]->in_format) {
                
                                  case MST95REPORT:
                                  case TKREPORT:
				    (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.3f",
				       		data[dset]->site,holeptr->name,coreptr->num,valueptr->type,
						valueptr->section,valueptr->top_int,
						valueptr->bot_int, valueptr->sb_depth, *valueptr->data);
				    if(smooth.method!=NONE)
					(void)fprintf(fptr,"\t%.3f",valueptr->sm_data);
                                    break;
                                  case ODPOTHER1:
                                    (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f",
                                                data[dset]->site,holeptr->name,coreptr->num,valueptr->type,
                                                valueptr->section,valueptr->top_int,
                                                valueptr->bot_int, valueptr->sb_depth, *valueptr->data);
                                    if(smooth.method!=NONE)
                                        (void)fprintf(fptr,"\t%.2f",valueptr->sm_data);
                                    break;
                                  case ODPOTHER2:
                                    (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f",
                                                data[dset]->site, holeptr->name,coreptr->num,valueptr->type,
                                                valueptr->section,valueptr->top_int,
                                                valueptr->bot_int, valueptr->sb_depth, *valueptr->data);
                                    if(smooth.method!=NONE)
                                        (void)fprintf(fptr,"\t%.2f",valueptr->sm_data);
                                    break;
                                  case ODPOTHER3:
                                    (void)fprintf(fptr,"%d\t%c\t%d\t%s\t%.1f\t%.1f\t%.2f\t%.2f",
                                                data[dset]->site, holeptr->name,coreptr->num,
                                                valueptr->section,valueptr->top_int,
                                                valueptr->bot_int, valueptr->sb_depth, *valueptr->data);
                                    if(smooth.method!=NONE)
                                        (void)fprintf(fptr,"\t%.2f",valueptr->sm_data);
                                    break;
                                  case ODPOTHER4:
                                    (void)fprintf(fptr,"%d\t%c\t%d\t%s\t%.1f\t%.2f\t%.2f",
                                                data[dset]->site, holeptr->name,coreptr->num,
                                                valueptr->section,valueptr->top_int,
                                                valueptr->sb_depth, *valueptr->data);
                                    if(smooth.method!=NONE)
                                        (void)fprintf(fptr,"\t%.2f",valueptr->sm_data);
                                    break;
                                  case JANUSCLEAN:
                                  case JANUSORIG:
                                  case ODPOTHER5:
                                    (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.2f\t%.3f",
                                                data[dset]->site,holeptr->name,coreptr->num,valueptr->type,
                                                valueptr->section,valueptr->top_int,
                                                valueptr->sb_depth, *valueptr->data);
                                    if(smooth.method!=NONE)
                                        (void)fprintf(fptr,"\t%.3f",valueptr->sm_data);
                                    break;
                                }
				(void)fprintf(fptr,"\t%.2f\t%.2f\n", coreptr->cum_dep_offset,
						(valueptr->sb_depth+coreptr->cum_dep_offset));
			}
		}
	}
	return(True);
}

int SpWriteSplicerData(filename, writeage)
char    *filename;
int     writeage;
{
	int	i,j;
        float   smvar;
	Hole	*holeptr;
	Core	*coreptr;
	Value	*valueptr;
        FILE    *fptr;

        if((fptr=fopen(filename,"w"))==NULL)
        {
          (void)sprintf(buffer, "Could not write file %s.", filename);
          SpManageWarningBox(buffer);
          return;
        }

        io_wait_cursor = XCreateFontCursor(XtDisplay(formFileSelection), XC_watch);
        if(io_wait_cursor != BadAlloc && io_wait_cursor != BadFont && io_wait_cursor != BadValue) {
          XDefineCursor(XtDisplay(formFileSelection), XtWindow(formFileSelection), io_wait_cursor);
        }

	for(i=0;i<spcomp.numcores;i++)
	{
		holeptr=data[dset]->holes[spcomp.hole[i]];
		coreptr=holeptr->core[spcomp.core[i]];
                if(smooth.method == NONE){
		  for(j=0;j<spcomp.numpercore[i];j++)
		  {
                    /* if the first point in core is at the same depth as last point of last
                       core don't write it
                    */ 
                    if(!(i > 0 && j == 0 && fabs(spcomp.sb_depth[i][j] - spcomp.sb_depth[i-1][spcomp.numpercore[i-1]-1]) < 0.005))
                    {
			valueptr=coreptr->value[spcomp.MapToOrig[i][j]];
                        switch (data[dset]->in_format) {

                          case MST95REPORT:
                          case TKREPORT:
			    (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.3f\t%.2f\t%.2f",
					data[dset]->site, holeptr->name, coreptr->num, valueptr->type, valueptr->section, valueptr->top_int,
					valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], spcomp.Depthoffset[i],
					spcomp.sb_depth[i][j]);
                             break;
                          case ODPOTHER1:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->type, valueptr->section, valueptr->top_int,
                                        valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case ODPOTHER2:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->type, valueptr->section, valueptr->top_int,
                                        valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case ODPOTHER3:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%s\t%.1f\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->section, valueptr->top_int,
                                        valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case ODPOTHER4:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%s\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->section, valueptr->top_int,
                                        valueptr->sb_depth, spcomp.var[i][j], spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case JANUSCLEAN:
                          case JANUSORIG:
                          case ODPOTHER5:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.2f\t%.3f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->type, valueptr->section, valueptr->top_int,
                                        valueptr->sb_depth, spcomp.var[i][j], spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                             break;
                        }
                        if(writeage == YES) 
                        {
                             (void)fprintf(fptr,"\t%.3f\n", spcomp.age[i][j]);
                        }
                        else
                        {
                             (void)fprintf(fptr,"\n");
                        }
                    }
                    else
                    {
                    }
                  }
                }
                else if(smooth.method == GAUSSIAN || smooth.method == OTHER){
                  for(j=0;j<spcomp.numpercore[i];j++)
                  {  
                    if(!(i > 0 && j == 0 && fabs(spcomp.sb_depth[i][j] - spcomp.sb_depth[i-1][spcomp.numpercore[i-1]-1]) < 0.005)){ 
                        valueptr=coreptr->value[spcomp.MapToOrig[i][j]];
                        if(valueptr->smooth_ok >= SMOK){
                          smvar = valueptr->sm_data;
                        }
                        else {
                          smvar = spcomp.var[i][j];
                        }

                        switch (data[dset]->in_format) {
 
                          case MST95REPORT:
                          case TKREPORT:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.3f\t%.3f\t%.2f\t%.2f",
                                        data[dset]->site,holeptr->name,coreptr->num,valueptr->type,valueptr->section,valueptr->top_int,
                                        valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], smvar,
                                        spcomp.Depthoffset[i], spcomp.sb_depth[i][j]);
                            break;
                          case ODPOTHER1:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->type, valueptr->section, valueptr->top_int,
                                        valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], smvar, spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case ODPOTHER2:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->type, valueptr->section, valueptr->top_int,
                                        valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], smvar, spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case ODPOTHER3:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%s\t%.1f\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->section, valueptr->top_int,
                                        valueptr->bot_int, valueptr->sb_depth, spcomp.var[i][j], smvar, spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case ODPOTHER4:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%s\t%.1f\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f",
                                        data[dset]->site, holeptr->name, coreptr->num, valueptr->section, valueptr->top_int,
                                        valueptr->sb_depth, spcomp.var[i][j], smvar, spcomp.Depthoffset[i],
                                        spcomp.sb_depth[i][j]);
                            break;
                          case JANUSCLEAN:
                          case JANUSORIG:
                          case ODPOTHER5:
                            (void)fprintf(fptr,"%d\t%c\t%d\t%c\t%s\t%.1f\t%.2f\t%.3f\t%.3f\t%.2f\t%.2f",
                                        data[dset]->site,holeptr->name,coreptr->num,valueptr->type,valueptr->section,valueptr->top_int,
                                        valueptr->sb_depth, spcomp.var[i][j], smvar,
                                        spcomp.Depthoffset[i], spcomp.sb_depth[i][j]);
                            break;
                        }
                        if(writeage == YES) 
                        {
                           (void)fprintf(fptr,"\t%.3f\t%.2f\n", spcomp.age[i][j], spcomp.sedrate[i][j]);
                        }
                        else
                        {
                           (void)fprintf(fptr,"\n");
                        }
                    }
                    else
                    {
                    }
                  }
                }
	}

        if(io_wait_cursor) {
          XUndefineCursor(XtDisplay(formFileSelection), XtWindow(formFileSelection));
          XFreeCursor(XtDisplay(formFileSelection), io_wait_cursor);
        }
        fclose(fptr);
	return(True);
}
		

int SpReadTKreport(fptr,dataptr)
FILE	*fptr;
DataFile	*dataptr;
{
	int	core_num,this_hole,this_core,max_alloc,i,status;
        float   dum;
	Hole	*holeptr;
	Core	*coreptr;
	Value	*valueptr;
	char	hole_name;

	/*return False=more data, true=done */
	dataptr->subleg=' ';
	if((status=fscanf(fptr,"%d %d %c %d",&dataptr->leg,&dataptr->site,&hole_name,&core_num))!=4)
	{
		if(status==EOF)
			return(True);
		else
		{
			dataptr->readerrors++;
			return(False);
		}
	}
	else
	{
         
	/* check if new hole */
		hole_name=toupper(hole_name);
		if(dataptr->holes_used==NULL || strchr(dataptr->holes_used,hole_name)==NULL)
		{
			dataptr->numholes++;
			if(dataptr->numholes >1)	/* not first hole */
			{
				if((charptr=(char*)realloc(dataptr->holes_used,(dataptr->numholes+1)*CHAR_SIZE))==NULL)
					SpBadMemAlloc("SpReadTKreport 2");
				else
					dataptr->holes_used = charptr;
				if((charptr=(char*)realloc((char*)dataptr->holes,dataptr->numholes*sizeof(Hole*)))==NULL)
					SpBadMemAlloc("SpReadTKreport 3");
				else
					dataptr->holes=(Hole**)charptr;
			}
			else		/* first hole */
			{
				if((dataptr->holes_used=(char*)calloc(2,sizeof(char)))==NULL)
					SpBadMemAlloc("SpReadTKreport 4");
				dataptr->holes_used[0]='\0';
				if((dataptr->holes=(Hole**)calloc(dataptr->numholes,sizeof(Hole*)))==NULL)
					SpBadMemAlloc("SpReadTKreport 5");
			}
			/* set hole values */
			if((dataptr->holes[dataptr->numholes-1]=(Hole*)calloc(1,sizeof(Hole)))==NULL)
				SpBadMemAlloc("SpReadTKreport 6");
			this_hole=dataptr->numholes-1;
			holeptr=dataptr->holes[this_hole];
			holeptr->name=hole_name;
			(void)sprintf(dataptr->holes_used,"%s%c",dataptr->holes_used,hole_name);
			holeptr->numcores=0;
		}
		else	/* hole already exists */
			for(this_hole=0;this_hole<dataptr->numholes && 
					dataptr->holes[this_hole]->name!=hole_name;this_hole++);
		holeptr=dataptr->holes[this_hole];
		/* check if new core*/
		for(this_core=0;this_core<holeptr->numcores && core_num != holeptr->core[this_core]->num;this_core++);
		if(this_core >= holeptr->numcores)
		{
			if(holeptr->numcores++>0)	/* not first core*/
			{
				if((charptr=(char*)realloc((char*)holeptr->core,holeptr->numcores*sizeof(Core*)))==NULL)
					SpBadMemAlloc("SpReadTKreport 7");
				else
					holeptr->core=(Core**)charptr;
			}
			else		/* firstcore */
			{
				if((holeptr->core=(Core**)calloc(holeptr->numcores,sizeof(Core*)))==NULL)
					SpBadMemAlloc("SpReadTKreport 8");
			}
			/* set core values */
			if((holeptr->core[this_core]=(Core*)calloc(1,sizeof(Core)))==NULL)
				SpBadMemAlloc("SpReadTKreport 9");
			coreptr=holeptr->core[this_core];
			coreptr->num=core_num;
			coreptr->numvalues=0;
			if((coreptr->value=(Value**)calloc(ALLOC_INT,sizeof(Value*)))==NULL)
				SpBadMemAlloc("SpReadTKreport 10");
			for(coreptr->allocvalues=0;coreptr->allocvalues<ALLOC_INT;coreptr->allocvalues++)
			{
				if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
					SpBadMemAlloc("SpReadTKreport 11");
			}
		}
		coreptr=holeptr->core[this_core];
		coreptr->cum_dep_offset=0.0;
		coreptr->did_offset=False;
		if(coreptr->numvalues++ >= coreptr->allocvalues)
		{
			max_alloc=coreptr->allocvalues+ALLOC_INT;
			if((charptr=(char*)realloc((char*)coreptr->value,max_alloc*sizeof(Value*)))==NULL)
				SpBadMemAlloc("SpReadTKreport 12");
			else
				coreptr->value=(Value**) charptr;
			for(;coreptr->allocvalues<max_alloc;coreptr->allocvalues++)
			{
				if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
					SpBadMemAlloc("SpReadTKreport 13");
			}
		}
		valueptr=coreptr->value[coreptr->numvalues-1];
	/* get standard core values */
		while((valueptr->type=fgetc(fptr))!=EOF && isspace(valueptr->type));
		if(valueptr->type==EOF)
			return(True);
		else
			valueptr->type=toupper(valueptr->type);
		while((valueptr->section[0]=fgetc(fptr))!=EOF && isspace(valueptr->section[0]));
		if(valueptr->section[0]==EOF)
			return(True);
		else
			valueptr->section[0]=toupper(valueptr->section[0]);
		valueptr->section[1]=fgetc(fptr);
		if(isspace(valueptr->section[1]))
			valueptr->section[1]='\0';
		else
			valueptr->section[1]=toupper(valueptr->section[1]);
		valueptr->section[1]='\0';
		if((status=fscanf(fptr,"%f %f %f",&valueptr->top_int,&valueptr->bot_int,&valueptr->sb_depth))!=3)
		{
			if(status==EOF)
				return(True);
			else
			{
				dataptr->readerrors++;
				return(False);
			}
		}
                if(fabs(valueptr->sb_depth - BAD_CODE) <= ROUNDCHECK) {
                  valueptr->quality=BAD_SB_DEPTH;
                }
                else {
	  	  valueptr->quality=GOOD;
                }
		valueptr->run_num=0;
	/* get type specific values */
		switch (dataptr->type)
		{
			case GRAPE:
				if((valueptr->grape=(Grapedata*)calloc(1,sizeof(Grapedata)))==NULL)
					SpBadMemAlloc("SpReadTKreport 15");
				if((status=fscanf(fptr,"%f",&valueptr->grape->density)) != 1)
				{
					if(status==EOF)
						return(True);
					else
					{
						dataptr->readerrors++;
						message.error=True;
					}
				}
				else
				{
                                        valueptr->data=&valueptr->grape->density;
					valueptr->grape->gamma_counts=0;
                                        valueptr->grape->b_corr_density = 0.0;
				}
				break;
			case SUSCEPTIBILITY:
				if((valueptr->susceptibility=(Susceptibility*)calloc(1,sizeof(Susceptibility)))==NULL)
					SpBadMemAlloc("SpReadTKreport 16");
				if((status=fscanf(fptr,"%f",&valueptr->susceptibility->corrected)) !=1)
				{
					if(status==EOF)
						return(True);
					else
					{
						dataptr->readerrors++;
						message.error=True;
					}
				}
				else
				{
					valueptr->susceptibility->observed=0.0;
					valueptr->data=&valueptr->susceptibility->corrected;
				}
				break;
			case PWAVE:
				if((valueptr->pwave=(Pwavedata*)calloc(1,sizeof(Pwavedata)))==NULL)
					SpBadMemAlloc("SpReadTKreport 17");
				if((status=fscanf(fptr,"%f",&valueptr->pwave->velocity)) !=1)
				{
					if(status==EOF)
						return(True);
					else
					{
						dataptr->readerrors++;
						message.error=True;
					}
				}
				else
				{
					valueptr->pwave->sig_strength=0;
					valueptr->pwave->travel_time=0;
					valueptr->pwave->displacement=0;
					valueptr->data=&valueptr->pwave->velocity;
				}
				break;
			case NATURALGAMMA:
                                if((valueptr->naturalgamma=(Natgammadata*)calloc(1,sizeof(Natgammadata)))==NULL)
                                        SpBadMemAlloc("SpReadTKreport 18");
                                if((status=fscanf(fptr,"%f %d %f %f %f %f %f %d",&valueptr->naturalgamma->total_cnt,
						&valueptr->naturalgamma->sample_time,
						&valueptr->naturalgamma->seg1_cnt,&valueptr->naturalgamma->seg2_cnt,
						&valueptr->naturalgamma->seg3_cnt,&valueptr->naturalgamma->seg4_cnt,
						&valueptr->naturalgamma->seg5_cnt,&valueptr->run_num))!=8)
                                {
					if(status==EOF)
						return(True);
					else
					{
                                        	dataptr->readerrors++;
                                        	message.error=True;
					}
                                }
                                else
                                {
                                        valueptr->data=&valueptr->naturalgamma->total_cnt;
                                }
                                break;
			case REFLECTANCEMST:
				if((valueptr->reflectanceMST=(ReflectanceMST*)calloc(1,sizeof(ReflectanceMST)))==NULL)
					SpBadMemAlloc("SpReadTKreport 19");
				for(i=0;i<31;i++)
					valueptr->reflectanceMST->nm_value[i]=0.0;
				if((status=fscanf(fptr,"%f",&valueptr->reflectanceMST->nm_value[15]))!=1)
				{
					if(status==EOF)
						return(True);
					else
					{
						dataptr->readerrors++;
						message.error=True;
					}
				}
				else
				{
					valueptr->reflectanceMST->L=0.0;
					valueptr->reflectanceMST->a=0.0;
					valueptr->reflectanceMST->b=0.0;
					valueptr->reflectanceMST->munsell_hue[0]='\0';
					valueptr->reflectanceMST->munsell_value[0]='\0';
					valueptr->data=&valueptr->reflectanceMST->nm_value[15];
				}
				break;
                        case OTHERTYPE:
                                break;
			default:
				dataptr->readerrors++;
				message.error=True;
		}
		if(message.error==True)
		{
			message.fatal=False;
			message.default_button=XmDIALOG_OK_BUTTON;
			message.type=XmDIALOG_ERROR;
			message.caller=SPREADTKREPORT;
			if((message.label=(char*)calloc(500+(int)strlen(format[dataptr->in_format])+
                                          (int)strlen(type[dataptr->type]),CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpReadTKreport 15");
			(void)sprintf(message.label,"Invalid TK format and/or %s type at %c  %d  %s  %6.1f %6.1f %8.2f",
                                              type[dataptr->type], holeptr->name, coreptr->num, valueptr->section,
                                              valueptr->top_int, valueptr->bot_int, valueptr->sb_depth);
			SpManageMessage(message);
		}
		else
			valueptr->sm_data=*valueptr->data;
	}
	return(False);
}
int SpReadOtherOdp(fptr,dataptr)
FILE	*fptr;
DataFile	*dataptr;
{
	char	hole_name;
	int	core_num,status,this_hole,this_core,max_alloc;
	Value	tmp_value,*valueptr;
	Core	*coreptr;
	Hole	*holeptr;

	/*return False=more data, true=done */
/* read data line */
	if(fgets(line,1000,fptr)==NULL)
		return(True);
/* get variables */
	dataptr->subleg=' ';
	switch (dataptr->in_format)
	{
		case	ODPOTHER1:
			if((status=sscanf(line,openfileinfo.other_format,&dataptr->leg,
					&dataptr->site,&hole_name,&core_num,&tmp_value.type,
					tmp_value.section,&tmp_value.top_int,&tmp_value.bot_int,
					&tmp_value.sb_depth,&tmp_value.otherodp))!=10)
			{
				if(status==EOF)
					return(True);
				else
					message.error=True;
			}
			break;
		case	ODPOTHER2:
			dataptr->leg=0;
			if((status=sscanf(line,openfileinfo.other_format,
					&dataptr->site,&hole_name,&core_num,&tmp_value.type,
					tmp_value.section,&tmp_value.top_int,&tmp_value.bot_int,
					&tmp_value.sb_depth,&tmp_value.otherodp))!=9)
			{
				if(status==EOF)
					return(True);
				else
					message.error=True;
			}
			break;
		case	ODPOTHER3:
			dataptr->leg=0;
                        tmp_value.type = '?';
			if((status=sscanf(line,openfileinfo.other_format, &dataptr->site,&hole_name,&core_num,
					tmp_value.section,&tmp_value.top_int,&tmp_value.bot_int,
					&tmp_value.sb_depth,&tmp_value.otherodp))!=8)
			{
				if(status==EOF)
					return(True);
				else
					message.error=True;
			}
			break;
		case	ODPOTHER4:
			dataptr->leg=0;
                        tmp_value.type = '?';
			if((status=sscanf(line,openfileinfo.other_format, &dataptr->site,&hole_name,&core_num,
					tmp_value.section,&tmp_value.top_int,
					&tmp_value.sb_depth,&tmp_value.otherodp))!=7)
			{
				if(status==EOF)
					return(True);
				else
					message.error=True;
			}
			tmp_value.bot_int=tmp_value.top_int;
			break;
                case    ODPOTHER5:
                        if((status=sscanf(line,openfileinfo.other_format,&dataptr->leg,
                                        &dataptr->site,&hole_name,&core_num,&tmp_value.type,
                                        tmp_value.section,&tmp_value.top_int,
                                        &tmp_value.sb_depth,&tmp_value.otherodp))!=9)
                        {
                                if(status==EOF)
                                        return(True);
                                else
                                        message.error=True;
                        }
                        tmp_value.bot_int=tmp_value.top_int;
                        break;
		default:
			message.fatal=False;
			message.default_button=XmDIALOG_OK_BUTTON;
			message.type=XmDIALOG_ERROR;
			message.caller=SPREADOTHERODP;
			if((message.label=(char*)calloc(100,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 1");
			(void)sprintf(message.label,"Invalid other odp data type %d",dataptr->type);
			SpManageMessage(message);
			return(False);
	}
	if(message.error)
	{
		message.fatal=False;
		message.default_button=XmDIALOG_OK_BUTTON;
		message.type=XmDIALOG_ERROR;
		message.caller=SPREADOTHERODP;
		if((message.label=(char*)calloc(50+(int)strlen(type[dataptr->type])+
					(int)strlen(format[dataptr->in_format]) + (int)strlen(line),CHAR_SIZE))==NULL)
			SpBadMemAlloc("SpReadOtherOdp 2");
		(void)sprintf(message.label,"Bad %s %s at line\n %s",format[dataptr->in_format],type[dataptr->type], line);
		SpManageMessage(message);
		return(False);
	}

	/* check if new hole */
	hole_name=toupper(hole_name);
	if(dataptr->holes_used==NULL || strchr(dataptr->holes_used,hole_name)==NULL)
	{
		dataptr->numholes++;
		if(dataptr->numholes >1)	/* not first hole */
		{
			if((charptr=(char*)realloc(dataptr->holes_used,(dataptr->numholes+1)*CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 3");
			else
				dataptr->holes_used = charptr;
			if((charptr=(char*)realloc((char*)dataptr->holes,dataptr->numholes*sizeof(Hole*)))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 4");
			else
				dataptr->holes=(Hole**)charptr;
		}
		else		/* first hole */
		{
			if((dataptr->holes_used=(char*)calloc(2,sizeof(char)))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 5");
			dataptr->holes_used[0]='\0';
			if((dataptr->holes=(Hole**)calloc(dataptr->numholes,sizeof(Hole*)))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 6");
		}
		/* set hole values */
		if((dataptr->holes[dataptr->numholes-1]=(Hole*)calloc(1,sizeof(Hole)))==NULL)
			SpBadMemAlloc("SpReadOtherOdp 7");
		this_hole=dataptr->numholes-1;
		holeptr=dataptr->holes[this_hole];
		holeptr->name=hole_name;
		(void)sprintf(dataptr->holes_used,"%s%c",dataptr->holes_used,hole_name);
		holeptr->numcores=0;
	}
	else	/* hole already exists */
	{
		for(this_hole=0;this_hole<dataptr->numholes && 
				dataptr->holes[this_hole]->name!=hole_name;this_hole++);
	}
	holeptr=dataptr->holes[this_hole];
	/* check if new core*/
	for(this_core=0;this_core<holeptr->numcores && core_num != holeptr->core[this_core]->num;this_core++);
	if(this_core >= holeptr->numcores)
	{
		if(holeptr->numcores++>0)	/* not first core*/
		{
			if((charptr=(char*)realloc((char*)holeptr->core,holeptr->numcores*sizeof(Core*)))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 8");
			else
				holeptr->core=(Core**)charptr;
		}
		else		/* firstcore */
		{
			if((holeptr->core=(Core**)calloc(holeptr->numcores,sizeof(Core*)))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 9");
		}
		/* set core values */
		if((holeptr->core[this_core]=(Core*)calloc(1,sizeof(Core)))==NULL)
			SpBadMemAlloc("SpReadOtherOdp 10");
		coreptr=holeptr->core[this_core];
		coreptr->num=core_num;
		coreptr->numvalues=0;
		if((coreptr->value=(Value**)calloc(ALLOC_INT,sizeof(Value*)))==NULL)
			SpBadMemAlloc("SpReadOtherOdp 11");
		for(coreptr->allocvalues=0;coreptr->allocvalues<ALLOC_INT;coreptr->allocvalues++)
		{
			if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 12");
		}
	}
	coreptr=holeptr->core[this_core];
	coreptr->cum_dep_offset=0.0;
	coreptr->did_offset=False;
	if(coreptr->numvalues++ >= coreptr->allocvalues)
	{
		max_alloc=coreptr->allocvalues+ALLOC_INT;
		if((charptr=(char*)realloc((char*)coreptr->value,max_alloc*sizeof(Value*)))==NULL)
			SpBadMemAlloc("SpReadOtherOdp 13");
		else
			coreptr->value=(Value**) charptr;
		for(;coreptr->allocvalues<max_alloc;coreptr->allocvalues++)
		{
			if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
				SpBadMemAlloc("SpReadOtherOdp 14");
		}
	}
	valueptr=coreptr->value[coreptr->numvalues-1];
/* get standard core values */
	valueptr->type=tmp_value.type;
	(void)strcpy(valueptr->section,tmp_value.section);
	valueptr->top_int=tmp_value.top_int;
	valueptr->bot_int=tmp_value.bot_int;
	valueptr->sb_depth=tmp_value.sb_depth;
	valueptr->otherodp=tmp_value.otherodp;
        if(fabs(valueptr->sb_depth - BAD_CODE) <= ROUNDCHECK) {
          valueptr->quality=BAD_SB_DEPTH;
        }
        else {
	  valueptr->quality=GOOD;
        }
	valueptr->run_num=0;
	valueptr->data=&valueptr->otherodp;
	valueptr->sm_data=*valueptr->data;
	return(False);

}

int SpReadMST95report(fptr,dataptr)
FILE	*fptr;
DataFile	*dataptr;
{
/* return False=more data, true=done */
	char	c_value[20];
	int	core,this_hole,this_core,max_alloc,nm_num,pos;
	Hole	*holeptr;
	Core	*coreptr;
	Value	*valueptr;
	int	i,len;

/* read one data line */
	if(fgets(line,MAXLINE,fptr)!=NULL)
	{
	/* get rid of ending blanks */
		len=(int)strlen(line);
		for(i=len-1;i>0 && isspace(line[i]);i--)
			line[i]='\0';
		len=(int)strlen(line);
	/* get	standard header information */
		(void)strncpy(c_value,&line[1],3); c_value[3]='\0';
		dataptr->leg=atol(c_value);
		dataptr->subleg = line[5];
		(void)strncpy(c_value,&line[7],4); c_value[4]='\0';
		dataptr->site= atol(c_value);

		/* check if new hole */
		if(dataptr->holes_used==NULL || strchr(dataptr->holes_used,line[12])==NULL)
		{
			dataptr->numholes++;
			if(line[12]==' ') /* no hole given, ignore line */
			{
				dataptr->readerrors++;
				return(False);
			}
			if(dataptr->numholes >1)	/* not first hole */
			{
				if((charptr=(char*)realloc(dataptr->holes_used,(dataptr->numholes+1)*CHAR_SIZE))==NULL)
					SpBadMemAlloc("SpReadMST95report 1");
				else
					dataptr->holes_used = charptr;
				if((charptr=(char*)realloc((char*)dataptr->holes,dataptr->numholes*sizeof(Hole*)))==NULL)
					SpBadMemAlloc("SpReadMST95report 2");
				else
					dataptr->holes=(Hole**)charptr;
			}
			else		/* first hole */
			{
				if((dataptr->holes_used=(char*)calloc(2,sizeof(char)))==NULL)
					SpBadMemAlloc("SpReadMST95report 3");
				dataptr->holes_used[0]='\0';
				if((dataptr->holes=(Hole**)calloc(dataptr->numholes,sizeof(Hole*)))==NULL)
					SpBadMemAlloc("SpReadMST95report 4");
			}
			/* set hole values */
			if((dataptr->holes[dataptr->numholes-1]=(Hole*)calloc(1,sizeof(Hole)))==NULL)
				SpBadMemAlloc("SpReadMST95report 5");
			this_hole=dataptr->numholes-1;
			holeptr=dataptr->holes[this_hole];
			holeptr->name=toupper(line[12]);
			(void)sprintf(dataptr->holes_used,"%s%c",dataptr->holes_used,line[12]);
			holeptr->numcores=0;
		}
		else	/* hole already exists */
			for(this_hole=0;this_hole<dataptr->numholes && 
					dataptr->holes[this_hole]->name!=line[12];this_hole++);
		holeptr=dataptr->holes[this_hole];
		/* get core value */
		(void)strncpy(c_value,&line[14],3); c_value[3]='\0';
		core=atol(c_value);
		/* check if new core*/
		for(this_core=0;this_core<holeptr->numcores && core != holeptr->core[this_core]->num;this_core++);
		if(this_core >= holeptr->numcores)
		{
			if(holeptr->numcores++>0)	/* not first core*/
			{
				if((charptr=(char*)realloc((char*)holeptr->core,holeptr->numcores*sizeof(Core*)))==NULL)
					SpBadMemAlloc("SpReadMST95report 6");
				else
					holeptr->core=(Core**)charptr;
			}
			else		/* firstcore */
			{
				if((holeptr->core=(Core**)malloc(holeptr->numcores*sizeof(Core*)))==NULL)
					SpBadMemAlloc("SpReadMST95report 7");
			}
			/* set core values */
			if((holeptr->core[this_core]=(Core*)calloc(1,sizeof(Core)))==NULL)
				SpBadMemAlloc("SpReadMST95report 8");
			coreptr=holeptr->core[this_core];
			coreptr->num=core;
			coreptr->numvalues=0;
			if((coreptr->value=(Value**)calloc(ALLOC_INT,sizeof(Value*)))==NULL)
				SpBadMemAlloc("SpReadMST95report 9");
			for(coreptr->allocvalues=0;coreptr->allocvalues<ALLOC_INT;coreptr->allocvalues++)
			{
				if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
					SpBadMemAlloc("SpReadMST95report 10");
			}
		}
		coreptr=holeptr->core[this_core];
		coreptr->cum_dep_offset=0.0;
		coreptr->did_offset=False;
		if(coreptr->numvalues++ >= coreptr->allocvalues)
		{
			max_alloc=coreptr->allocvalues+ALLOC_INT;
			if((charptr=(char*)realloc((char*)coreptr->value,max_alloc*sizeof(Value*)))==NULL)
				SpBadMemAlloc("SpReadMST95report 11");
			else
				coreptr->value=(Value**) charptr;
			for(;coreptr->allocvalues<max_alloc;coreptr->allocvalues++)
			{
				if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
					SpBadMemAlloc("SpReadMST95report 12");
			}
		}
		valueptr=coreptr->value[coreptr->numvalues-1];
	/* get standard core values */
		valueptr->type=line[18];
		valueptr->type=toupper(valueptr->type);
		if(isspace(line[20]))
		{
			(void)strncpy(valueptr->section,&line[21],1);
			valueptr->section[1]='\0';
		}
		else
			(void)strncpy(valueptr->section,&line[20],2);
		valueptr->section[2]='\0';
		for(i=0;i<(int)strlen(valueptr->section);i++)
		{
			if(isalpha(valueptr->section[i]))
				valueptr->section[i]=toupper(valueptr->section[i]);
		}
		(void)strncpy(c_value,&line[23],5); c_value[5]='\0';
		valueptr->top_int=(float)atof(c_value);
		(void)strncpy(c_value,&line[29],5); c_value[5]='\0';
		valueptr->bot_int=(float)atof(c_value);
		(void)strncpy(c_value,&line[35],7); c_value[7]='\0';
		valueptr->sb_depth=(float)atof(c_value);
                if(fabs(valueptr->sb_depth - BAD_CODE) <= ROUNDCHECK) {
                  valueptr->quality=BAD_SB_DEPTH;
                }
                else {
		  valueptr->quality=GOOD;
                }
	/* get data type specific values */
		if(dataptr->type==GRAPE)
		{
			if(len!=72)
			{
				coreptr->numvalues--;
				message.error=True;
				message.fatal=False;
				message.caller=SPREADMST95REPORT;
				message.type=XmDIALOG_WARNING;
				message.default_button=XmDIALOG_OK_BUTTON;
				if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)
					SpBadMemAlloc("SpReadMST95report 13");
				(void)sprintf(message.label,"Invalid Grape and/or MST95 format at. %c  %d  %s  %6.1f %6.1f %8.2f",
                                              holeptr->name, coreptr->num, valueptr->section, 
                                              valueptr->top_int, valueptr->bot_int, valueptr->sb_depth);
				return(False);
			}
			if((valueptr->grape=(Grapedata*)calloc(1,sizeof(Grapedata)))==NULL)
				SpBadMemAlloc("SpReadMST95report 14");
			(void)strncpy(c_value,&line[46],5);c_value[5]='\0';
			valueptr->grape->density=(float)atof(c_value);
			valueptr->data=&valueptr->grape->density;
			valueptr->sm_data=valueptr->grape->density;
			(void)strncpy(c_value,&line[54],5);c_value[5]='\0';
			valueptr->grape->b_corr_density=(float)atof(c_value);
			(void)strncpy(c_value,&line[62],5);c_value[5]='\0';
			valueptr->grape->gamma_counts=atol(c_value);
			(void)strncpy(c_value,&line[68],4);c_value[4]='\0';
			valueptr->run_num=atol(c_value);
		}	
		else if (dataptr->type==PWAVE)
		{
			if(len!=82)
			{
                                coreptr->numvalues--;
                                message.error=True;
                                message.fatal=False; 
                                message.caller=SPREADMST95REPORT;
                                message.type=XmDIALOG_WARNING; 
                                message.default_button=XmDIALOG_OK_BUTTON; 
                                if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpReadMST95report 15");
				(void)sprintf(message.label,"Invalid Pwave and/or MST95 format at. %c  %d  %s  %6.1f %6.1f %8.2f",
                                               holeptr->name, coreptr->num, valueptr->section, valueptr->top_int, valueptr->bot_int,
                                               valueptr->sb_depth);
				return(False);
			}
			if((valueptr->pwave=(Pwavedata*)calloc(1,sizeof(Pwavedata)))==NULL)
				SpBadMemAlloc("SpReadMST95report 16");
			(void)strncpy(c_value,&line[44],7); c_value[7]='\0';
			valueptr->pwave->velocity=(float)atof(c_value);
			valueptr->data=&valueptr->pwave->velocity;
			valueptr->sm_data=valueptr->pwave->velocity;
			(void)strncpy(c_value,&line[51],4); c_value[4]='\0';
			valueptr->pwave->sig_strength=atol(c_value);
			(void)strncpy(c_value,&line[56],4); c_value[4]='\0';
			valueptr->pwave->travel_time=atol(c_value);
			(void)strncpy(c_value,&line[71],5); c_value[5]='\0';
			valueptr->pwave->displacement=atol(c_value);
			(void)strncpy(c_value,&line[78],4); c_value[4]='\0';
			valueptr->run_num=atol(c_value);
		}
		else if (dataptr->type==NATURALGAMMA)
		{
			if(len!=92)
			{
                                coreptr->numvalues--;
                                message.error=True; 
                                message.fatal=False;  
                                message.caller=SPREADMST95REPORT; 
                                message.type=XmDIALOG_WARNING;  
                                message.default_button=XmDIALOG_OK_BUTTON;  
                                if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpReadMST95report 17");
				(void)sprintf(message.label,"Invalid Natural Gamma and/or MST95 format at. %c  %d  %s  %6.1f %6.1f %8.2f",
                                               holeptr->name, coreptr->num, valueptr->section, valueptr->top_int, valueptr->bot_int,
                                               valueptr->sb_depth);
				return(False);
			}
			if((valueptr->naturalgamma=(Natgammadata*)calloc(1,sizeof(Natgammadata)))==NULL)
                                SpBadMemAlloc("SpReadMST95report 18");
			(void)strncpy(c_value,&line[44],8); c_value[8]='\0';
			valueptr->naturalgamma->total_cnt=(float)atol(c_value);
			valueptr->data=&valueptr->naturalgamma->total_cnt;
			valueptr->sm_data=valueptr->naturalgamma->total_cnt;
			(void)strncpy(c_value,&line[52],5); c_value[5]='\0';
			valueptr->naturalgamma->sample_time=atol(c_value);
			(void)strncpy(c_value,&line[58],5); c_value[5]='\0';
			valueptr->naturalgamma->seg1_cnt=atof(c_value);
			(void)strncpy(c_value,&line[64],5); c_value[5]='\0';
			valueptr->naturalgamma->seg2_cnt=atof(c_value);
			(void)strncpy(c_value,&line[70],5); c_value[5]='\0';
			valueptr->naturalgamma->seg3_cnt=atof(c_value);
			(void)strncpy(c_value,&line[76],5); c_value[5]='\0';
			valueptr->naturalgamma->seg4_cnt=atof(c_value);
			(void)strncpy(c_value,&line[82],5); c_value[5]='\0';
			valueptr->naturalgamma->seg5_cnt=atof(c_value);
			(void)strncpy(c_value,&line[88],4); c_value[4]='\0';
			valueptr->run_num=atol(c_value);
		}
		else if (dataptr->type==SUSCEPTIBILITY)
		{
			if(len!=63)
			{
                                coreptr->numvalues--;
                                message.error=True;  
                                message.fatal=False;   
                                message.caller=SPREADMST95REPORT;  
                                message.type=XmDIALOG_WARNING;   
                                message.default_button=XmDIALOG_OK_BUTTON;   
                                if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL) 
                                        SpBadMemAlloc("SpReadMST95report 19");
				(void)sprintf(message.label,"Invalid Magnetic Susceptibility and/or MST95 format at. %c  %d  %s  %6.1f %6.1f %8.2f",
                                               holeptr->name, coreptr->num, valueptr->section, valueptr->top_int, valueptr->bot_int,
                                               valueptr->sb_depth);
				return(False);
			}
			if((valueptr->susceptibility=(Susceptibility*)calloc(1,sizeof(Susceptibility)))==NULL)
                                SpBadMemAlloc("SpReadMST95report 20");
			(void)strncpy(c_value,&line[44],6); c_value[7]='\0';
			valueptr->susceptibility->observed=(float)atof(c_value);
			(void)strncpy(c_value,&line[50],8); c_value[7]='\0';
			valueptr->susceptibility->corrected=(float)atof(c_value);
			valueptr->data=&valueptr->susceptibility->corrected;
			valueptr->sm_data=valueptr->susceptibility->corrected;
			(void)strncpy(c_value,&line[59],4); c_value[4]='\0';
			valueptr->run_num=atol(c_value);
		}
		else if(dataptr->type==REFLECTANCEMST)
		{
			if(len!=267)
			{
                                coreptr->numvalues--;
                                message.error=True;   
                                message.fatal=False;    
                                message.caller=SPREADMST95REPORT;   
                                message.type=XmDIALOG_WARNING;    
                                message.default_button=XmDIALOG_OK_BUTTON;    
                                if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)  
                                        SpBadMemAlloc("SpReadMST95report 21");
				(void)sprintf(message.label,"Invalid Reflectance and/or MST95 format at. %c  %d  %s  %6.1f %6.1f %8.2f",
                                               holeptr->name, coreptr->num, valueptr->section, valueptr->top_int, valueptr->bot_int,
                                               valueptr->sb_depth);
				return(False);
			}
			if((valueptr->reflectanceMST=(ReflectanceMST*)calloc(1,sizeof(ReflectanceMST)))==NULL)
				SpBadMemAlloc("SpReadMST95report 22");
			(void)strncpy(c_value,&line[45],6); c_value[7]='\0';
			valueptr->reflectanceMST->L=(float)atof(c_value);
			(void)strncpy(c_value,&line[52],6); c_value[7]='\0';
			valueptr->reflectanceMST->a=(float)atof(c_value);
			(void)strncpy(c_value,&line[59],6); c_value[7]='\0';
			valueptr->reflectanceMST->b=(float)atof(c_value);
			(void)strncpy(valueptr->reflectanceMST->munsell_hue,&line[66],6);
			(void)strncpy(valueptr->reflectanceMST->munsell_value,&line[73],9);
			pos=81;
			for(nm_num=0;nm_num<31;nm_num++)
			{
				(void)strncpy(c_value,&line[pos],6); c_value[7]='\0';
				valueptr->reflectanceMST->nm_value[nm_num]=(float)atof(c_value);
				pos+=6;
			}
			valueptr->data=&valueptr->reflectanceMST->nm_value[15];
			valueptr->sm_data=valueptr->reflectanceMST->nm_value[15];
			valueptr->run_num=0;
		}
                else if(dataptr->type==OTHERTYPE) 
                {

                }
		else
		{       message.error=True;    
                        message.fatal=False;     
                        message.caller=SPREADMST95REPORT;    
                        message.type=XmDIALOG_WARNING;     
                        message.default_button=XmDIALOG_OK_BUTTON;     
                        if((message.label=(char*)calloc(500,CHAR_SIZE))==NULL)   
                        	SpBadMemAlloc("SpReadMST95report 21");
			(void)sprintf(message.label,"Invalid data type %d.\n",dataptr->type);
			return(False);
		}
		/* return not end of file */
		return(False);
	}
	else	/* end of file found */
		return(True);
}

HashInfo **SpReadAffineTable(filename,num)
char	*filename;
int	*num;
{
	FILE	*fptr;
	int	i,alloc_num,j, nh, nc,
		hashsize,status;
	HashInfo	**affineinfo;
	float		xvalue,dummy1,dummy2;
	char	did_it;
        void CheckAffineTableOrder(),
             CheckAffineTableMissingHole(),
             MapHoleToAffineTable(),
             CheckAffineTableMissingCore(),
             MapCoreToAffineTable();

/* open input affine table */
	if((fptr=fopen(filename,"r"))==NULL)
	{
		message.error=True;
		message.fatal=False;
		message.default_button=XmDIALOG_OK_BUTTON;
		message.type=XmDIALOG_ERROR;
		message.caller=SPREADAFFINETABLE;
		if((message.label=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
			SpBadMemAlloc("SpReadAffineTable 1");
		(void)sprintf(message.label,"error opening affine table %s.",filename);
		SpManageMessage(message);
	}
	else
	{
		message.error=False;
	/* allocate initial array */
		alloc_num=ALLOC_INT;
		if((affineinfo=(HashInfo**)calloc(alloc_num,sizeof(HashInfo*)))==NULL)
			SpBadMemAlloc("SpReadAffineTable 2");
		hashsize=sizeof(HashInfo);
		for(i=0;i<alloc_num;i++)
		{
			if((affineinfo[i]=(HashInfo*)calloc(1,hashsize))==NULL)
				SpBadMemAlloc("SpReadAffineTable 3");
		}
	/* read affine table */
		for(j=0;(status=fscanf(fptr,"%d %d %c %d %c %f %c",&affineinfo[j]->leg,
				&affineinfo[j]->site,&affineinfo[j]->hole,&affineinfo[j]->core,
				&affineinfo[j]->coretype,&xvalue,&did_it))==7;
				j++)
		{
		/* convert data values as needed */
			affineinfo[j]->hole=toupper(affineinfo[j]->hole);
			affineinfo[j]->coretype=toupper(affineinfo[j]->coretype);
			did_it=toupper(did_it);
			affineinfo[j]->value= rint(xvalue*100.0);
			affineinfo[j]->subleg=' ';
			if(did_it=='N')
				affineinfo[j]->value2=False;
			else
				affineinfo[j]->value2=True;
                /* put values in affine table */ 
                        if(j == 0) {
                          strcpy(affinetable.hole[0].name, &affineinfo[0]->hole);
                          nh = 0;
                          nc = 0;
                          affinetable.numhole = 1;
                          affinetable.hole[0].numcore = 0;
                        }
                        else if(j > 0 && affineinfo[j]->hole != affineinfo[j-1]->hole) {
                          ++nh;
                          ++affinetable.numhole;
                          strcpy(affinetable.hole[nh].name, &affineinfo[j]->hole);
                          nc = 0;
                          affinetable.hole[nh].numcore = 0;
                        }
                        affinetable.hole[nh].core[nc].leg = affineinfo[j]->leg;
                        affinetable.hole[nh].core[nc].site = affineinfo[j]->site;
                        affinetable.hole[nh].core[nc].name = affineinfo[j]->core;
                        strncpy(affinetable.hole[nh].core[nc].type, &affineinfo[j]->coretype, 1);
                        affinetable.hole[nh].core[nc].cum_depth_offset = xvalue;
                        affinetable.hole[nh].core[nc].did_offset = affineinfo[j]->value2;
                        ++nc;
                        ++affinetable.hole[nh].numcore;

		/* allocate more memory if necessary */
			if(j+1>=alloc_num)
			{
				alloc_num+=ALLOC_INT;
				if((charptr=(char*)realloc((char*)affineinfo,alloc_num*sizeof(HashInfo*)))==NULL)
					SpBadMemAlloc("SpReadAffineTable 4");
				else
					affineinfo=(HashInfo**)charptr;
				for(i=j+1;i<alloc_num;i++)
				{
					if((affineinfo[i]=(HashInfo*)calloc(1,hashsize))==NULL)
						SpBadMemAlloc("SpReadAffineTable 5");
				}
			}
		}

		if(status!=EOF)
		{
			message.error=True;
			message.fatal=False;
			message.default_button=XmDIALOG_OK_BUTTON;
			message.caller=SPREADAFFINETABLE;
			message.type=XmDIALOG_ERROR;
			if((message.label=(char*)calloc((int)strlen(filename)+100,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpReadAffineTable 6");
			(void)sprintf(message.label,"Error reading affine table %s line %d.",filename,j);
			for(i=0;i<alloc_num;i++)
			{
				if(affineinfo[i])
				{
					free(affineinfo[i]);
					affineinfo[i]=NULL;
				}
			}
			if(affineinfo)
			{
				free(affineinfo);
				affineinfo=NULL;
			}
		}
                else 
                {
                  for(i=0; i<dataset_cnt; ++i) {
                    (void)CheckAffineTableOrder(&affinetable);
                    (void)CheckAffineTableMissingHole(&affinetable, i);
                    (void)MapHoleToAffineTable(&affinetable, i);
                    (void)CheckAffineTableMissingCore(&affinetable, i);
                    (void)MapCoreToAffineTable(&affinetable, i);
                  }
                }

		*num=j;
		fclose(fptr);
	}
	return(affineinfo);
}

HashInfo **SpReadCullTable(filename,num)
char	*filename;
int	*num;
{
	int	fdcull,i,alloc_num,j,
		hashsize,status;
	HashInfo	**cullinfo;

/* open input cull table */
	if((fdcull=open(filename,O_RDONLY|O_CREAT,0))== -1)
		return((HashInfo**)NULL);
	else
	{
	/* allocate initial array */
		alloc_num=ALLOC_INT;
		if((cullinfo=(HashInfo**)calloc(alloc_num,sizeof(HashInfo*)))==NULL)
			SpBadMemAlloc("SpCullTable 2");
		hashsize=sizeof(HashInfo);
		for(i=0;i<alloc_num;i++)
		{
			if((cullinfo[i]=(HashInfo*)calloc(1,hashsize))==NULL)
				SpBadMemAlloc("SpCullTable 3");
		}
	/* read cull table */
		status=hashsize;
		for(j=0;status==hashsize;j++)
		{
		/* allocate more memory if necessary */
			if(j>=alloc_num)
			{
				alloc_num+=ALLOC_INT;
				if((charptr=(char*)realloc((char*)cullinfo,alloc_num*sizeof(HashInfo*)))==NULL)
					SpBadMemAlloc("SpCullTable 4");
				else
					cullinfo=(HashInfo**)charptr;
				for(i=j;i<alloc_num;i++)
				{
					if((cullinfo[i]=(HashInfo*)calloc(1,hashsize))==NULL)
						SpBadMemAlloc("SpCullTable 5");
				}
			}
			status=read(fdcull,(char *) cullinfo[j],hashsize);
		}
		*num=j-1;
		close(fdcull);
	}
	if(status!=0 || *num == 0)
		return((HashInfo**)NULL);
	else
		return(cullinfo);
}

int	SpWriteAffineTable(affineptr,filename)
AffineTable     *affineptr;
char		*filename;
{
	FILE	*fptr;
	int	i,j;
	char	did_it;


/* open output affinetable */
	if((fptr=fopen(filename,"w"))==NULL)
	{
		message.error=True;
		message.fatal=False;
		message.caller=SPWRITEAFFINETABLE;
		message.default_button=XmDIALOG_OK_BUTTON;
		message.type=XmDIALOG_ERROR;
		if((message.label=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
			SpBadMemAlloc("SpWriteAffineTable 1");
		(void)sprintf(message.label,"Error opening affine table %s.",filename);
		SpManageMessage(message);
	}
	else
	{
		message.error=False;
	/* write out file */
		for(i=0;i<affineptr->numhole;i++)
		{
			for(j=0;j<affineptr->hole[i].numcore;j++)
			{
				if(affineptr->hole[i].core[j].did_offset)
					did_it='Y';
				else
					did_it='N';

				(void)fprintf(fptr,"%d\t%d\t%s\t%d\t%s\t%.2f\t%c\n", affineptr->hole[i].core[j].leg,
					affineptr->hole[i].core[j].site, affineptr->hole[i].name, affineptr->hole[i].core[j].name,
					affineptr->hole[i].core[j].type, 
                                        affineptr->hole[i].core[j].cum_depth_offset, did_it);
			}
		}
		fclose(fptr);
	}
	return(!message.error);
}

int	SpWriteCullTable(dataptr,filename)
DataFile	*dataptr;
char		*filename;
{
	int	fdcull,flag;
	int	i,j,k;
	HashInfo	info;
	Core	*coreptr;
#if OS == SUNOS
	int	write();
#elif OS == SOLARIS
	ssize_t	write();
#endif


/* open output cull table */
	if((fdcull=open(filename,O_WRONLY|O_CREAT,0744))== -1)
	{
		message.error=True;
		if((charptr=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
			SpBadMemAlloc("SpWriteCullTable 1");
		else
			(void)sprintf(charptr,"Error opening cull table %s.",filename);
		SpManageWarningBox(charptr);
		free(charptr);
	}
	else
	{
		message.error=False;
	/* write out file */
		info.leg=dataptr->leg;
		info.subleg=dataptr->subleg;
		info.site=dataptr->site;
		flag=BAD_CULL1 | BAD_CULL2 | BAD_TOP;
		for(i=0;i<dataptr->numholes;i++)
		{
			info.hole=dataptr->holes[i]->name;
			{
				for(j=0;j<dataptr->holes[i]->numcores;j++)
				{
					coreptr=dataptr->holes[i]->core[j];
					info.core=coreptr->num;
					for(k=0;k<coreptr->numvalues;k++)
					{
						info.coretype=coreptr->value[k]->type;
						(void)strcpy(info.section,coreptr->value[k]->section);
						info.top_int=coreptr->value[k]->top_int;
					/* write flagged values to file */
						if((info.value=coreptr->value[k]->quality) & flag)
							(void)write(fdcull,(char*)&info,sizeof(HashInfo));
					}
				}
			}
		}
		close(fdcull);
	}
	return(!message.error);
}

int     SpWriteAgeModel(fptr)
FILE    *fptr;
{
        int i;
        char    topoffset[6],botoffset[6],
                topmsd[9],botmsd[9];

        if(agemodel_cnt < 1) 
        {
          return;
        }
        else 
        {
          for(i=0; i<agemodel_cnt; ++i) 
          {
            if(agemodel[i].top.in_affine == NO)
            {
                (void)sprintf(topmsd,"N/A");
                (void)sprintf(topoffset,"N/A");
            }
            else
            {
                (void)sprintf(topmsd,"%.2f",agemodel[i].top.sb_depth+agemodel[i].top.offset);
                (void)sprintf(topoffset,"%.2f",agemodel[i].top.offset);
            }
            if(agemodel[i].bot.in_affine == NO)
            {
                (void)sprintf(topmsd,"N/A");
                (void)sprintf(botoffset,"N/A");
            }
            else
            {
                (void)sprintf(botmsd,"%.2f",agemodel[i].bot.sb_depth+agemodel[i].bot.offset);
                (void)sprintf(botoffset,"%.2f",agemodel[i].bot.offset);
            }

            fprintf(fptr,"%8.3f\t%8.3f\t%8.4f\t%8.3f\t%s\t%s", 
                      agemodel[i].avembsf, agemodel[i].avemcd, agemodel[i].aveage, agemodel[i].sedrate, 
                      agemodel[i].name, agemodel[i].code);
            if(agemodel[i].type == PALEOMAG) {
              fprintf(fptr, "\tPaleomag\n");
            }
            else if(agemodel[i].type == DIATOMS) {
              fprintf(fptr, "\tDiatom\n");
            }
            else if(agemodel[i].type == RADIOLARIA) {
              fprintf(fptr, "\tRadiolaria\n");
            }
            else if(agemodel[i].type == FORAMINIFERA) {
              fprintf(fptr, "\tForaminifera\n");
            }
            else if(agemodel[i].type == NANNOFOSSILS) {
              fprintf(fptr, "\tNannofossil\n");
            }
            else if(agemodel[i].type == HANDPICK) {
              fprintf(fptr, "\tHandpick\n");
            }
            else if(agemodel[i].type == TIME) {
              fprintf(fptr, "\tTimeSeries\n");
            }
            else {
              fprintf(fptr, "\n");
            }
          }
        }
        return(True);
}

int     SpReadAgeModel(fptr)
FILE    *fptr;
{
        int i, status;
        char s[201], strattype[50];

        agemodel_cnt = 0;
        status = 1;

        for(i=0; i<MAXAGE; ++i) 
        {
          if(fgets(s, 200, fptr) == NULL) {
            return;
          }
          sscanf(s, "%f %f %f %f %s %s %s",
                   &agemodel[i].avembsf, &agemodel[i].avemcd, &agemodel[i].aveage, &agemodel[i].sedrate,
                   &agemodel[i].name, &agemodel[i].code, strattype);
          if(strcmp(strattype, "Paleomag") == 0) {
            agemodel[i].type = PALEOMAG;
          }
          else if(strcmp(strattype, "Diatom") == 0) {
            agemodel[i].type = DIATOMS;
          }
          else if(strcmp(strattype, "Radiolaria") == 0) {
            agemodel[i].type = RADIOLARIA;
          }
          else if(strcmp(strattype, "Foraminifera") == 0) {
            agemodel[i].type = FORAMINIFERA;
          }
          else if(strcmp(strattype, "Nannofossil") == 0) {
            agemodel[i].type = NANNOFOSSILS;
          }
          else if(strcmp(strattype, "Handpick") == 0) {
            agemodel[i].type = HANDPICK;
          }
          else if(strcmp(strattype, "TimeSeries") == 0) {
            agemodel[i].type = TIME;
          }
          else {
            agemodel[i].type = -1;
          }
          sprintf(strattype,"");

          ++agemodel_cnt;
        }
        sprintf(s,"");
        return(True);
}

void ReadPreviewInput(file)
char *file;
{
  int l, len;
  char *text;
  FILE *fd;
  XmTextPosition  pos;

  if((fd = fopen(file, "r"))==NULL) {
    message.error=True;
    message.fatal=False;
    message.default_button=XmDIALOG_OK_BUTTON;
    message.type=XmDIALOG_ERROR;
    message.caller=NONE;
    if((message.label=(char*)calloc((int)strlen(file)+100,CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpReadPreviewInput 1");
    (void)sprintf(message.label,"Error: could not open preview input file  %s.",file);
    SpManageMessage(message);
  }
  else {
    l = 0;
    len = 500;
    if((text=(char*)calloc(len * MAXPREVIEW + 1000, CHAR_SIZE))==NULL)
                SpBadMemAlloc("ReadPreviewInput 2");
    (void)sprintf(text, "");
    (void)sprintf(text, "%s\n\n", file);
    while((fgets(line,500,fd) != NULL) && l<MAXPREVIEW) {
      ++l;
      (void)strcat(text, line);
    }
  } 
  fclose(fd);

  pos=XmTextGetLastPosition(textPreviewInput);

  XmTextInsert(textPreviewInput,pos,text);

  free(text);
}

int ReadTimeSeries(file)
char *file;
{
  void ViewSpliceVsAge();
  int i, n, ndiv, all, moreall, sumall, valcol, agecol, nline;
  char *fmt, *str;
  float minval, maxval, startage, endage, age, val, sumval;
  FILE *fd;

  /* get the time series read info
  */
  str = XmTextGetString(textFieldTimeSeriesAgeCol);
  agecol = atoi(str);
  free(str);
  str = XmTextGetString(textFieldTimeSeriesValCol);
  valcol = atoi(str);
  free(str);
  str = XmTextGetString(textFieldTimeSeriesFromAge);
  startage = atof(str);
  free(str);
  str = XmTextGetString(textFieldTimeSeriesToAge);
  endage = atof(str);
  free(str);
  if(fabs(endage - 0.0) < 0.0001) {
    endage = 999.9;
  }

  if(XmToggleButtonGetState(toggleButtonTimeSeriesAgeMa) == True) {
    timeseries.MaConvert = 1.0;
  }
  else if(XmToggleButtonGetState(toggleButtonTimeSeriesAgeKyr) == True) {
    timeseries.MaConvert = 0.001;
  }
  else if(XmToggleButtonGetState(toggleButtonTimeSeriesAgeYrs) == True) {
    timeseries.MaConvert = 0.000001;
  }
  else {
  }

  /* make the read format
  */
  if((fmt=(char*)calloc(100,CHAR_SIZE)) == NULL)
                 SpBadMemAlloc("ReadTimeSeries");
  (void)sprintf(fmt,"");
  i = 1;
  if(agecol > valcol) {
    if(valcol == 1) {

    }
    else {
      while(i<valcol) {
        ++i;
        strcat(fmt,"%*s ");
      }
    }
    strcat(fmt,"%f ");
    ++i;
    if(i == agecol) {
    }
    else {
      while(i<agecol) {
        ++i;
        strcat(fmt,"%*s ");
      }
    }
    strcat(fmt,"%f");
  }
  else if(valcol > agecol) {
    if(agecol == 1) {

    }
    else {
      while(i<agecol) {
        ++i;
        strcat(fmt,"%*s ");
      }
    }
    strcat(fmt,"%f ");
    ++i;
    if(i == valcol) {
    }
    else {
      while(i<valcol) {
        ++i;
        strcat(fmt,"%*s ");
      }
    }
    strcat(fmt,"%f");
  }
  else {
  }

  all = 500;
  moreall = 100;
  if((fd = fopen(file, "r"))==NULL) {
    message.error=True;
    message.fatal=False;
    message.default_button=XmDIALOG_OK_BUTTON;
    message.type=XmDIALOG_ERROR;
    message.caller=NONE;
    if((message.label=(char*)calloc((int)strlen(file)+100,CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpReadTimeSeries");
    (void)sprintf(message.label,"Error: could not open time series file  %s.",file);
    SpManageMessage(message);
  }
  else {
    timeseries.age=(float*)calloc(all, sizeof(float));
    timeseries.val=(float*)calloc(all, sizeof(float));
    i=0;
    nline = 0;
    sumall = all;
    while(fgets(line,1000,fd) != NULL) {
      ++nline;
      if(valcol > agecol) {
        if((sscanf(line,fmt, &age, &val)) != 2) {
           if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL) {
              SpBadMemAlloc("ReadTimeSeries");
            }
            else {
              (void)sprintf(charptr,"There is a format problem in time series file. This happened on line %d", nline);
            }
            SpManageWarningBox(charptr);
            free(charptr);
            SpCleanUp(TIMESERIES);
            return 1;
        }
      }
      else if(agecol > valcol) {
        if((sscanf(line,fmt, &val, &age)) != 2) {
          if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL) {
              SpBadMemAlloc("ReadTimeSeries");
            }
            else {
              (void)sprintf(charptr,"There is a format problem in time series file. This happened on line %d", nline);
            }
            SpManageWarningBox(charptr);
            free(charptr);
            SpCleanUp(TIMESERIES);
            return 1;
        }
      }
      age = age * timeseries.MaConvert;

      if(age <= endage && age >= startage) {

        /* check that the age is in descending order
        */
        if(i>0) {
          if(age < timeseries.age[i-1]) {
            if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL) {
              SpBadMemAlloc("ReadTimeSeries");
            }
            else {
              (void)sprintf(charptr,"The time series is not in descending order.\nThis happened on line %d at %.3f Ma", nline, timeseries.age[i-1]);
              
            }
            SpManageWarningBox(charptr);
            free(charptr);           
            SpCleanUp(TIMESERIES);
            return 1;
          }
        } 
        timeseries.age[i] = age;
        timeseries.val[i] = val;

        if(i == 0) {
          minval = timeseries.val[i];
          maxval = timeseries.val[i];
        }
        else if(timeseries.val[i] > maxval) {
          maxval = timeseries.val[i];
        }
        else if(timeseries.val[i] < minval) {
          minval = timeseries.val[i];
        } 

        ++i;

        if(i >= sumall) {
          sumall = sumall + moreall;
          if((timeseries.age=(float*)realloc((float*)timeseries.age, sumall*sizeof(float)))==NULL)
          {
                        SpBadMemAlloc("ReadTimeSeries");
          }
          else 
          {
          }
          if((timeseries.val=(float*)realloc((float*)timeseries.val, sumall*sizeof(float)))==NULL)
          {
                        SpBadMemAlloc("ReadTimeSeries");
          }
          else
          {
          }
        }
      }
    }
    timeseries.n=i;
    timeseries.minval = minval;
    timeseries.maxval = maxval;
  }
  fclose(fd);
  free(fmt);

  if(timeseries.n < 2) {
    if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL) {
              SpBadMemAlloc("ReadTimeSeries");
    }
    else {
      (void)sprintf(charptr,"The time series has less than two points.");
    }
    SpManageWarningBox(charptr);
    free(charptr);
    SpCleanUp(TIMESERIES);
    return 1;
  }

  /* check for mult samples per level
  */
  sumval = timeseries.val[0];
  n = 0;
  ndiv = 1;
  for(i=1; i<timeseries.n; ++i) {
    if(timeseries.age[i] == timeseries.age[i-1] && i < timeseries.n - 1) {
      sumval = sumval + timeseries.val[i];
      ++ndiv;
    }
    else if(timeseries.age[i] == timeseries.age[i-1] && i == timeseries.n - 1) {
      sumval = sumval + timeseries.val[i];
      ++ndiv;
      timeseries.age[n] = timeseries.age[i-1];
      timeseries.val[n] = sumval/ndiv;
      ++n;
    }
    else if(timeseries.age[i] > timeseries.age[i-1] && i < timeseries.n - 1) {
      timeseries.age[n] = timeseries.age[i-1];
      timeseries.val[n] = sumval/ndiv;
      sumval = timeseries.val[i];
      ndiv = 1;
      ++n;
    }
    else if(timeseries.age[i] > timeseries.age[i-1] && i == timeseries.n - 1) {
      timeseries.age[n] = timeseries.age[i-1];
      timeseries.val[n] = sumval/ndiv;
      ++n;
      timeseries.age[n] = timeseries.age[i];
      timeseries.val[n] = timeseries.val[i];
      ++n;
    }
    else {
    }
  }
  timeseries.n = n;

  if(timeseries.n < 2) {
    if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL) {
              SpBadMemAlloc("ReadTimeSeries");
    }
    else {
      (void)sprintf(charptr,"The time series has less than two points.");
    }
    SpManageWarningBox(charptr);
    free(charptr);
    SpCleanUp(TIMESERIES);
    return 1;
  }

  have_time_series = DO;
  XtSetSensitive(pushButtonOpenAgeSignal, False);
  XtSetSensitive(pushButtonOpenTimeSeries, False);
  XtSetSensitive(radioBoxInvertTimeSeries, True);
  ViewSpliceVsAge((Widget)NULL, (XtPointer)NULL, (XtPointer)NULL);

  return 0;
}

int SpReadJanus(fptr,dataptr)
FILE    *fptr;
DataFile        *dataptr;
{
        char    hole_name, munsell[2][20];
        int     core_num,status,this_hole,this_core,max_alloc;
        float   val[6];
        Value   tmp_value,*valueptr;
        Core    *coreptr;
        Hole    *holeptr;

        /*return False=more data, true=done */

/* read data line */
        dataptr->subleg=' ';
        if(fgets(buffer,1000,fptr)==NULL)
                return(True);

        if(dataptr->in_format == JANUSORIG) {
          if(strcmp(buffer, "Sql statement executed OK!\n") == 0) {
            return(True);
          }
        }

/* get variables */
        switch (dataptr->type)
        {
                case    GRAPE:
                case    PWAVE:
                case    NATURALGAMMA:
                        if((status=sscanf(buffer, "%d %d %c %d %c %s %f %f %f",
                                   &dataptr->leg, &dataptr->site, &hole_name, &core_num, &tmp_value.type,
                                   tmp_value.section, &tmp_value.top_int, &tmp_value.sb_depth,
                                   &val[0]))!=9)
                        {
                                if(status==EOF)
                                        return(True);
                                else
                                        message.error=True;
                        }
                        break;
                case    SUSCEPTIBILITY:
                        if((status=sscanf(buffer, "%d %d %c %d %c %s %f %f %f %f",
                                   &dataptr->leg, &dataptr->site, &hole_name, &core_num, &tmp_value.type,
                                   tmp_value.section, &tmp_value.top_int, &tmp_value.sb_depth,
                                   &val[0], &val[1]))!=10)
                        {
                                if(status==EOF)
                                        return(True);
                                else
                                        message.error=True;
                        }
                        break;
                case    REFLECTANCEMST:
                        if((status=sscanf(buffer, "%d %d %c %d %c %s %f %f %f %f %f %s, %s, %f %f %f",
                                   &dataptr->leg, &dataptr->site, &hole_name, &core_num, &tmp_value.type,
                                   tmp_value.section, &tmp_value.top_int, &tmp_value.sb_depth,
                                   &val[0], val[1], &val[2], munsell[0], munsell[1], &val[3], &val[4], &val[5]))!=16)
                        {
                                if(status == 13) {
                                }
                                else if(status==EOF) {
                                        return(True);
                                }
                                else {
                                        message.error=True;
                                }
                        }
                        break;
                default:
                        message.fatal=False;
                        message.default_button=XmDIALOG_OK_BUTTON;
                        message.type=XmDIALOG_ERROR;
                        message.caller=SPREADJANUS;
                        if((message.label=(char*)calloc(100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpReadJanus 1");
                        (void)sprintf(message.label,"Invalid other odp data type %d",dataptr->type);
                        SpManageMessage(message);
                        return(True);
        }
        tmp_value.bot_int=tmp_value.top_int;
        if(message.error)
        {
                message.fatal=False;
                message.default_button=XmDIALOG_OK_BUTTON;
                message.type=XmDIALOG_ERROR;
                message.caller=SPREADJANUS;
                if((message.label=(char*)calloc(50+(int)strlen(type[dataptr->type])+
                                        (int)strlen(format[dataptr->in_format]),CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpReadJanus 2");
                (void)sprintf(message.label,"Bad %s %s line",format[dataptr->in_format],type[dataptr->type]);
                SpManageMessage(message);
                return(False);
        }
        /* check if new hole */
        hole_name=toupper(hole_name);
        if(dataptr->holes_used==NULL || strchr(dataptr->holes_used,hole_name)==NULL)
        {
                dataptr->numholes++;
                if(dataptr->numholes >1)        /* not first hole */
                {
                        if((charptr=(char*)realloc(dataptr->holes_used,(dataptr->numholes+1)*CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpReadJanus 3");
                        else
                                dataptr->holes_used = charptr;
                        if((charptr=(char*)realloc((char*)dataptr->holes,dataptr->numholes*sizeof(Hole*)))==NULL)
                                SpBadMemAlloc("SpReadJanus 4");
                        else
                                dataptr->holes=(Hole**)charptr;
                }
                else            /* first hole */
                {
                        if((dataptr->holes_used=(char*)calloc(2,sizeof(char)))==NULL)
                                SpBadMemAlloc("SpReadJanus 5");
                        dataptr->holes_used[0]='\0';
                        if((dataptr->holes=(Hole**)calloc(dataptr->numholes,sizeof(Hole*)))==NULL)
                                SpBadMemAlloc("SpReadJanus 6");
                }
                /* set hole values */
                if((dataptr->holes[dataptr->numholes-1]=(Hole*)calloc(1,sizeof(Hole)))==NULL)
                        SpBadMemAlloc("SpReadJanus 7");
                this_hole=dataptr->numholes-1;
                holeptr=dataptr->holes[this_hole];
                holeptr->name=hole_name;
                (void)sprintf(dataptr->holes_used,"%s%c",dataptr->holes_used,hole_name);
                holeptr->numcores=0;
        }
        else    /* hole already exists */
        {
                for(this_hole=0;this_hole<dataptr->numholes && dataptr->holes[this_hole]->name!=hole_name;this_hole++);
        }
        holeptr=dataptr->holes[this_hole];
        /* check if new core*/
        for(this_core=0;this_core<holeptr->numcores && core_num != holeptr->core[this_core]->num;this_core++);
        if(this_core >= holeptr->numcores)
        {
                if(holeptr->numcores++>0)       /* not first core*/
                {
                        if((charptr=(char*)realloc((char*)holeptr->core,holeptr->numcores*sizeof(Core*)))==NULL)
                                SpBadMemAlloc("SpReadJanus 8");
                        else
                                data[dset]->holes[this_hole]->core=(Core**)charptr;
                }
                else            /* firstcore */
                {
                        if((holeptr->core=(Core**)calloc(holeptr->numcores,sizeof(Core*)))==NULL)
                                SpBadMemAlloc("SpReadJanus 9");
                }
                /* set core values */
                if((holeptr->core[this_core]=(Core*)calloc(1,sizeof(Core)))==NULL)
                        SpBadMemAlloc("SpReadJanus 10");
                coreptr=holeptr->core[this_core];
                coreptr->num=core_num;
                coreptr->numvalues=0;
                if((coreptr->value=(Value**)calloc(ALLOC_INT,sizeof(Value*)))==NULL)
                        SpBadMemAlloc("SpReadJanus 11");
                for(coreptr->allocvalues=0;coreptr->allocvalues<ALLOC_INT;coreptr->allocvalues++)
                {
                        if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
                                SpBadMemAlloc("SpReadJanus 12");
                }
        }
        coreptr=holeptr->core[this_core];
        if(coreptr->numvalues++ >= coreptr->allocvalues)
        {
                max_alloc=coreptr->allocvalues+ALLOC_INT;
                if((charptr=(char*)realloc((char*)coreptr->value,max_alloc*sizeof(Value*)))==NULL)
                        SpBadMemAlloc("SpReadJanus 13");
                else
                        coreptr->value=(Value**) charptr;
                for(;coreptr->allocvalues<max_alloc;coreptr->allocvalues++)
                {
                        if((coreptr->value[coreptr->allocvalues]=(Value*)calloc(1,sizeof(Value)))==NULL)
                                SpBadMemAlloc("SpReadJanus 14");
                }
        }
        valueptr=coreptr->value[coreptr->numvalues-1];
/* get standard core values */
        valueptr->type=tmp_value.type;
        (void)strcpy(valueptr->section,tmp_value.section);
        valueptr->top_int=tmp_value.top_int;
        valueptr->bot_int=tmp_value.bot_int;
        valueptr->sb_depth=tmp_value.sb_depth;
        if(fabs(valueptr->sb_depth - BAD_CODE) <= ROUNDCHECK)
                valueptr->quality=BAD_SB_DEPTH;
        else
                valueptr->quality=GOOD;
        valueptr->run_num=0;
        switch (dataptr->type)
        {
          case GRAPE:
          case PWAVE:
          case NATURALGAMMA:
            valueptr->otherodp = val[0];
            valueptr->data = &valueptr->otherodp;
            break;
          case SUSCEPTIBILITY:
            if((valueptr->susceptibility=(Susceptibility*)calloc(1,sizeof(Susceptibility)))==NULL)
                                        SpBadMemAlloc("SpReadJanus 15");
            valueptr->susceptibility->observed = val[0];
            valueptr->susceptibility->corrected = val[1];
            valueptr->data = &valueptr->susceptibility->corrected;
            break;
          case REFLECTANCEMST:
            if((valueptr->reflectanceMST=(ReflectanceMST*)calloc(1,sizeof(ReflectanceMST)))==NULL)
                                        SpBadMemAlloc("SpReadJanus 16");
            valueptr->reflectanceMST->L = val[0];
            valueptr->reflectanceMST->a = val[1];
            valueptr->reflectanceMST->b = val[2];
            strcpy(valueptr->reflectanceMST->munsell_hue, munsell[0]);
            strcpy(valueptr->reflectanceMST->munsell_value, munsell[1]);
            valueptr->data = &valueptr->reflectanceMST->L;
            break;
          default:
            dataptr->readerrors++;
            message.error=True;
        }

        if(message.error==True)
        {
          message.fatal=False;
          message.default_button=XmDIALOG_OK_BUTTON;
          message.type=XmDIALOG_ERROR;
          message.caller=SPREADJANUS;
          if((message.label=(char*)calloc(50+(int)strlen(format[dataptr->in_format])+(int)strlen(type[dataptr->type]),sizeof(char)))==NULL)
                                SpBadMemAlloc("SpReadJanus 17");
          (void)sprintf(message.label,"Bad %s %s line",format[dataptr->in_format],type[dataptr->type]);
          SpManageMessage(message);
        }
        else
          valueptr->sm_data=*valueptr->data;

        return(False);
}
