/*
splicer_vars.h

This file contains general global variables and definitions
used by the splicer program.

*/
#include "splicer_defs.h"

HashInfo	**SpReadCullTable(),**SpReadAffineTable();
void	SpCleanUp(),SpManageMessage(),SpBadMemAlloc(),SpFreeData(),
	SpExit(),SpUpdateReport(),SpManageWarningBox(),SpUpdateOpen(),
	SpGetEquationValues(),SpSetEquationValues(),XmListDeselectAllItems(),
	XmScaleGetValue(),AxisDep(),DisplaySliderControl(),AxisCorr(),
	AxisDepthOffset(),XmToggleButtonSetState(),DrawDrawingAreaEdit(),
	DrawDrawingAreaView(),Spwrite_defaults();
int	atoi(),SpReadMST95report(),SpReadTKreport(),SpReadOtherOdp(),
	SpWriteCullTable(),SpWriteAffineTable(),SpWriteSplicerTable(),
	SpWriteSplicerData(),system(),abs(),FindAveDepth(),
	FindValueInCoreToSplice(),CleanUpCore(),StdDev(),CleanUpSpliceCore(),
	RepickDepth(),Correlate(),GetDisplayValues(),Spread_defaults();
double	fabs();
Boolean	XmToggleButtonGetState();
Widget	XmMessageBoxGetChild();

#define SOLARIS	5
#define	SUNOS	4

#if OS == SUNOS
	int	free(),read();
#elif OS == SOLARIS
	void	free();
	ssize_t	read();
#endif

extern	char color[NCOLOR][50];
extern  char cust_color[NCOLOR][50];
extern  char tempcolor[NCOLOR][50];

extern	ReportFile 	report;
extern	DataFile	**data;
extern	AffineFile	affine;
extern	Smooth		smooth;
extern	Cull		cull;
extern	StratFile	**strat,outstrat;
extern  AffineTable     affinetable;
extern	SplicerTableFile	splicertable;
extern  OpenFileInfo            openfileinfo;
extern  ErrRecord       errrecord;
extern  TimeSeries      timeseries;
extern  char            *open_data_directory;
extern  char		*outdata_filename;
extern	char		*outdata_dirname;
extern  char		*outspdata_filename;
extern	char		*outspdata_dirname;
extern  char            *default_strat_dirname;
extern  char            *outagemodel_filename;
extern  char            *outagemodel_dirname;
extern  char            *inagemodel_filename;
extern  char            *inagemodel_dirname;
extern  char            *outsplicetoage_filename;
extern  char            *outsplicetoage_dirname;
extern  char            *outsplicetoage_filename;
extern  char            *outsplicetoage_dirname;
extern  char            *report_filename;
extern  char            *report_dirname;

extern  CorrelationTable corr;
extern  SpliceComp       spcomp;
extern  StratData        agemodel[MAXAGE];

extern	int	strat_file_cnt;
extern	char	*current_path;
extern  char    *preview_input_path;
extern	char	*defaults_filename;
extern	int	decimate_value;
extern	char	*type[];
extern	XtWorkProcId	work_id;
extern	XtAppContext	app;
extern	MessageInfo	message;
extern  Cursor          io_wait_cursor;

extern	int	splicer_read_done, splicer_table_done,sptable_cnt;
extern	int	done_reading,done_cull,done_smooth,done_decimate,done_affine;
extern	int	datafileopen;
extern	int	stratfileopen;

extern	char	*charptr;
extern	char	buffer[1000];
