/*
	file: splicer_defaults.c

	These functions are used for reading and writing the
	default files for splicer programs.

*/
#include <stdio.h>
#include <stdlib.h>
#include <Xm/Xm.h>
#include <malloc.h>
#include <math.h>
#include <string.h>
#include "splicer-creation-c.h"
#include "splicer_vars.h"

#define	MAXLINE	(1000)

void Spcheck_defaults()
{
	/* this function will eventually check for valid defaults */
}

/*      Function Name: Spread_defaults
 *
 *      Description:   	This function reads the set defaults from the
 *		       	supplied input file.
 *			
 *
 *      Arguments:      char	*filename:	name of defaults file
 */
int Spread_defaults(filename)
char	*filename;
{
	FILE	*fptr;
	char	line[MAXLINE],flag[MAXLINE],equal[2],value[MAXLINE];
/* set automatic defaults */
	if((outdata_filename= (char*)calloc(25,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0");
	(void)strcpy(outdata_filename,"out.dat");
	if((outdata_dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0a");
	(void)strcpy(outdata_dirname,current_path);
	if((outspdata_filename= (char*)calloc(50,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0b");
	(void)strcpy(outspdata_filename,"splice.dat");
	if((outspdata_dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0c");
	(void)strcpy(outspdata_dirname,current_path);
	if((outstrat.filename= (char*)calloc(50,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0d");
	(void)strcpy(outstrat.filename,"strat.dat");
	if((outstrat.dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0e");
	(void)strcpy(outstrat.dirname,current_path);
        if((report_filename= (char*)calloc((int)strlen(current_path)+20,CHAR_SIZE))==NULL)
                SpBadMemAlloc("Spread_defaults 0d");
        (void)sprintf(report_filename,"%s/splicer.rpt", current_path);
        if((report_dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
                SpBadMemAlloc("Spread_defaults 0e");
        (void)strcpy(report_dirname,current_path);
	
/* smooth values */
	smooth.method=NONE;
	smooth.plot=UNSMOOTHED;
	smooth.width=9;
	smooth.width_units=POINTS;
/* decimate_value */
	decimate_value=1;
/* affine table values */
	if((affine.filename= (char*)calloc(50,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 1");
	(void)strcpy(affine.filename,"aff.out");
	if((affine.dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpInitialize 2");
	(void)strcpy(affine.dirname,current_path);
	affine.usetable=FALSE;
/* cull values */
	cull.method=CULL_PARAMETERS;
	cull.top=5.0;
	cull.max_core=999;
	cull.by_core_num=False;
	if((cull.filename= (char*)calloc(50,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0b");
	(void)strcpy(cull.filename,"culltable.dat");
	if((cull.dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
		SpBadMemAlloc("Spread_defaults 0c");
	(void)strcpy(cull.dirname,current_path);
	cull.grape.sign1=LESS_THAN_OR_EQUAL_TO;
	cull.grape.sign2=GREATER_THAN_OR_EQUAL_TO;
	cull.grape.join=OR;
	cull.grape.value1=1.03;
	cull.grape.value2=2.8;
	cull.pwave.sign1=LESS_THAN;
	cull.pwave.sign2=GREATER_THAN_OR_EQUAL_TO;
	cull.pwave.join=ONLY;
	cull.pwave.value1=1500.0;
	cull.pwave.value2=99999.0;
	cull.pwave_signal_max=167.0;
	cull.susceptibility.sign1=LESS_THAN;
	cull.susceptibility.sign2=GREATER_THAN;
	cull.susceptibility.join=ONLY;
	cull.susceptibility.value1=-10.0;
	cull.susceptibility.value2=99999.0;
	cull.naturalgamma.sign1=LESS_THAN;
	cull.naturalgamma.sign2=GREATER_THAN_OR_EQUAL_TO;
	cull.naturalgamma.join=ONLY;
	cull.naturalgamma.value1=0.0;
	cull.naturalgamma.value2=99999.0;
	cull.reflectance.sign1=LESS_THAN_OR_EQUAL_TO;
	cull.reflectance.sign2=GREATER_THAN_OR_EQUAL_TO;
	cull.reflectance.join=OR;
	cull.reflectance.value1=0.0;
	cull.reflectance.value2=100.0;
	cull.otherodp.sign1=LESS_THAN;
	cull.otherodp.sign2=GREATER_THAN;
	cull.otherodp.join=OR;
	cull.otherodp.value1=-99999.0;
	cull.otherodp.value2=99999.0;
/* data type */
	openfileinfo.in_data_type=GRAPE;
/* data format */
	openfileinfo.in_data_format=MST95REPORT;
/* open data directory */
        if((open_data_directory= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6a");
        (void)strcpy(open_data_directory,current_path);
/* splicer table file */
	if((splicertable.filename= (char*)calloc(50,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpInitialize 5");
	(void)strcpy(splicertable.filename,"splicertable.dat");
	if((splicertable.dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpInitialize 6");
	(void)strcpy(splicertable.dirname,current_path);
/* strat directory */
        if((default_strat_dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(default_strat_dirname,current_path);
/*age model file and directory */
        if((inagemodel_dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(inagemodel_dirname,current_path);
        if((inagemodel_filename= (char*)calloc((int)strlen(current_path)+20,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(inagemodel_filename,current_path);
        (void)strcat(inagemodel_filename, "/age.out");
        if((outagemodel_dirname= (char*)calloc((int)strlen(inagemodel_dirname)+5,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(outagemodel_dirname,inagemodel_dirname);
        if((outagemodel_filename= (char*)calloc((int)strlen(inagemodel_filename)+2,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(outagemodel_filename,inagemodel_filename);
/*time series filename and directory */
        if((timeseries.dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(timeseries.dirname,current_path);
        if((timeseries.filename= (char*)calloc((int)strlen(current_path)+20,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(timeseries.filename,current_path);
        (void)strcat(timeseries.filename, "/berger.orb");
/* splice vs age filename and directory */
        if((outsplicetoage_dirname= (char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(outsplicetoage_dirname,current_path);
        if((outsplicetoage_filename= (char*)calloc((int)strlen(current_path)+20,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 6");
        (void)strcpy(outsplicetoage_filename,current_path);
        (void)strcat(outsplicetoage_filename, "/splice.age");
/* text report*/
	if((report.name = (char*)calloc(25,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpInitialize 6b");
	(void)strcpy(report.name,"splicer.rpt");
/* color stuff */
        colorset = CUSTOME_COLORSET;
        (void)strcpy(cust_color[BG_COLOR],"black");
        (void)strcpy(cust_color[LABEL_COLOR],"white");
	(void)strcpy(cust_color[MBSF_COLOR],"yellow");
	(void)strcpy(cust_color[MCD_COLOR],"green");
	(void)strcpy(cust_color[SMOOTH_COLOR],"pink");
	(void)strcpy(cust_color[SPLICE_COLOR],"turquoise");
	(void)strcpy(cust_color[SPLICELOCATION_COLOR],"white");
	(void)strcpy(cust_color[TIEPTFIXED_COLOR],"red");
	(void)strcpy(cust_color[TIEPTSHIFT_COLOR],"green");
	(void)strcpy(cust_color[TIELINE_COLOR],"orange");
	(void)strcpy(cust_color[OVERLAYINCORR_COLOR],"turquoise");
	(void)strcpy(cust_color[OVERLAYOUTCORR_COLOR],"green");
	(void)strcpy(cust_color[PALEOMAG_COLOR],"red");
	(void)strcpy(cust_color[DIATOM_COLOR],"limegreen");
	(void)strcpy(cust_color[RAD_COLOR],"white");
	(void)strcpy(cust_color[FORAM_COLOR],"pink");
	(void)strcpy(cust_color[NANNO_COLOR],"lightblue");
        (void)strcpy(cust_color[CORRCOEF_COLOR],"lightblue");
	(void)strcpy(cust_color[BESTCORR_COLOR],"yellow");
	(void)strcpy(cust_color[DEPOFFLINE_COLOR],"white");
	(void)strcpy(cust_color[DEPOFFHOLE1_COLOR],"pink");
	(void)strcpy(cust_color[DEPOFFHOLE2_COLOR],"green");
	(void)strcpy(cust_color[DEPOFFHOLE3_COLOR],"yellow");
	(void)strcpy(cust_color[DEPOFFHOLE4_COLOR],"blue");
	(void)strcpy(cust_color[DEPOFFHOLE5_COLOR],"orange");
        (void)strcpy(cust_color[DEPOFFHOLE6_COLOR],"violet");
        (void)strcpy(cust_color[DEPOFFHOLE7_COLOR],"red");
        (void)strcpy(cust_color[DEPOFFHOLE8_COLOR],"brown");
        (void)strcpy(cust_color[DEPOFFHOLE9_COLOR],"turquoise");
        (void)strcpy(cust_color[DEPOFFHOLE10_COLOR],"darkgreen");
        (void)strcpy(cust_color[DEPOFFHOLE11_COLOR],"lightblue");
        (void)strcpy(cust_color[AGEDEPHANDPICK_COLOR], "yellow");
        (void)strcpy(cust_color[AGEDEPLINE_COLOR], "red");
        (void)strcpy(cust_color[SEDRATE_COLOR], "green");
        (void)strcpy(cust_color[DATUMLOC_COLOR], "yellow");
        (void)strcpy(cust_color[TIMESERIES_COLOR], "red");
        clip = CLIP;       
	
/* open defaults file */
        if((fptr=fopen(filename,"r"))==NULL)
		return(FALSE);

/* loop through defaults file */
	while(fgets(line,MAXLINE,fptr)!=NULL)
	{
	/* check if valid defaults file */
		if(line[0]!= '#' && (int)strlen(line)>0)
		{
			if(sscanf(line,"%s %s %s",flag,equal,value)==3 && !strcmp(equal,"="))
			{
			/* set default values */
			/* smoothing defaults */
				if(!strcmp(flag,"SMOOTH_METHOD"))
					smooth.method= atoi(value);
				else if(!strcmp(flag,"SMOOTH_PLOT"))
					smooth.plot= atoi(value);
				else if(!strcmp(flag,"SMOOTH_WIDTH"))
					smooth.width=atoi(value);
				else if(!strcmp(flag,"SMOOTH_WIDTH_UNITS"))
					smooth.width_units=atoi(value);
			/* decimate_values */
				else if(!strcmp(flag,"DECIMATE_VALUE"))
					decimate_value=atoi(value);
			/* affine table values */
				else if(!strcmp(flag,"USE_AFFINE_TABLE"))
					affine.usetable=atoi(value);
				else if(!strcmp(flag,"AFFINE_TABLE"))
				{
					if((charptr=(char*)realloc((char*)affine.filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
						SpBadMemAlloc("SpInitialize 7");
					else
					{
						affine.filename=charptr;
						(void)strcpy(affine.filename,value);
					}
				}
				else if(!strcmp(flag,"AFFINE_DIRECTORY"))
				{
					if((charptr=(char*)realloc((char*)affine.dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
						SpBadMemAlloc("SpInitialize 8");
					else
					{
						affine.dirname=charptr;
						(void)strcpy(affine.dirname,value);
					}
				}
			/* cull values */
				else if(!strcmp(flag,"CULL_METHOD"))
					cull.method=atoi(value);
				else if(!strcmp(flag,"CULL_TOP"))
					(void)sscanf(value,"%f",&cull.top);
				else if(!strcmp(flag,"CULL_BY_CORE_NUM"))
					(void)sscanf(value,"%d",&cull.by_core_num);
				else if(!strcmp(flag,"CULL_CORE_MAX"))
					(void)sscanf(value,"%d",&cull.max_core);
				else if(!strcmp(flag,"CULL_TABLE"))
				{
					if((charptr=(char*)realloc((char*)cull.filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
						SpBadMemAlloc("SpInitialize 9");
					else
					{
						cull.filename=charptr;
						(void)strcpy(cull.filename,value);
					}
				}
				else if(!strcmp(flag,"CULL_DIRECTORY"))
				{
					if((charptr=(char*)realloc((char*)cull.dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
						SpBadMemAlloc("SpInitialize 10");
					else
					{
						cull.dirname=charptr;
						(void)strcpy(cull.dirname,value);
					}
				}
				else if(!strcmp(flag,"PWAVE_SIGNAL_MAX"))
					cull.pwave_signal_max=(float)atof(value);
				else if(!strcmp(flag,"GRAPE_EQUATION_1"))
					cull.grape.sign1=atoi(value);
				else if(!strcmp(flag,"GRAPE_EQUATION_2"))
					cull.grape.sign2=atoi(value);
				else if(!strcmp(flag,"GRAPE_JOIN"))
					cull.grape.join=atoi(value);
				else if(!strcmp(flag,"GRAPE_VALUE_1"))
					cull.grape.value1=(float)atof(value);
				else if(!strcmp(flag,"GRAPE_VALUE_2"))
					cull.grape.value2=(float)atof(value);
				else if(!strcmp(flag,"PWAVE_EQUATION_1"))
					cull.pwave.sign1=atoi(value);
				else if(!strcmp(flag,"PWAVE_EQUATION_2"))
					cull.pwave.sign2=atoi(value);
				else if(!strcmp(flag,"PWAVE_JOIN"))
					cull.pwave.join=atoi(value);
				else if(!strcmp(flag,"PWAVE_VALUE_1"))
					cull.pwave.value1=(float)atof(value);
				else if(!strcmp(flag,"PWAVE_VALUE_2"))
					cull.pwave.value2=(float)atof(value);
				else if(!strcmp(flag,"SUSCEPTIBILITY_EQUATION_1"))
					cull.susceptibility.sign1=atoi(value);
				else if(!strcmp(flag,"SUSCEPTIBILITY_EQUATION_2"))
					cull.susceptibility.sign2=atoi(value);
				else if(!strcmp(flag,"SUSCEPTIBILITY_JOIN"))
					cull.susceptibility.join=atoi(value);
				else if(!strcmp(flag,"SUSCEPTIBILITY_VALUE_1"))
					cull.susceptibility.value1=(float)atof(value);
				else if(!strcmp(flag,"SUSCEPTIBILITY_VALUE_2"))
					cull.susceptibility.value2=(float)atof(value);
				else if(!strcmp(flag,"NATURALGAMMA_EQUATION_1"))
					cull.naturalgamma.sign1=atoi(value);
				else if(!strcmp(flag,"NATURALGAMMA_EQUATION_2"))
					cull.naturalgamma.sign2=atoi(value);
				else if(!strcmp(flag,"NATURALGAMMA_JOIN"))
					cull.naturalgamma.join=atoi(value);
				else if(!strcmp(flag,"NATURALGAMMA_VALUE_1"))
					cull.naturalgamma.value1=(float)atof(value);
				else if(!strcmp(flag,"NATURALGAMMA_VALUE_2"))
					cull.naturalgamma.value2=(float)atof(value);
				else if(!strcmp(flag,"REFLECTANCE_EQUATION_1"))
					cull.reflectance.sign1=atoi(value);
				else if(!strcmp(flag,"REFLECTANCE_EQUATION_2"))
					cull.reflectance.sign2=atoi(value);
				else if(!strcmp(flag,"REFLECTANCE_JOIN"))
					cull.reflectance.join=atoi(value);
				else if(!strcmp(flag,"REFLECTANCE_VALUE_1"))
					cull.reflectance.value1=(float)atof(value);
				else if(!strcmp(flag,"REFLECTANCE_VALUE_2"))
					cull.reflectance.value2=(float)atof(value);
				else if(!strcmp(flag,"OTHERODP_EQUATION_1"))
					cull.otherodp.sign1=atoi(value);
				else if(!strcmp(flag,"OTHERODP_EQUATION_2"))
					cull.otherodp.sign2=atoi(value);
				else if(!strcmp(flag,"OTHERODP_JOIN"))
					cull.otherodp.join=atoi(value);
				else if(!strcmp(flag,"OTHERODP_VALUE_1"))
					cull.otherodp.value1=(float)atof(value);
				else if(!strcmp(flag,"OTHERODP_VALUE_2"))
					cull.otherodp.value2=(float)atof(value);
			/* data type */
				else if(!strcmp(flag,"DATA_TYPE"))
					openfileinfo.in_data_type=atoi(value);
			/* data format */
				else if(!strcmp(flag,"IN_DATA_FORMAT"))
					openfileinfo.in_data_format=atoi(value);
                        /* open data directory */
                                else if(!strcmp(flag,"OPEN_DATA_DIRECTORY"))
                                {
                                        if((charptr=(char*)realloc((char*)open_data_directory,((int)strlen(value)+2)*CHAR_SIZE
))==NULL)
                                                SpBadMemAlloc("SpInitialize 11a");
                                        else
                                        {
                                                open_data_directory=charptr;
                                                (void)strcpy(open_data_directory,value);
                                        }
                                }
			/* splicer table */
				else if(!strcmp(flag,"SPLICER_TABLE"))
				{
					if((charptr=(char*)realloc((char*)splicertable.filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
						SpBadMemAlloc("SpInitialize 11");
					else
					{
						splicertable.filename=charptr;
						(void)strcpy(splicertable.filename,value);
					}
				}
				else if(!strcmp(flag,"SPLICER_DIRECTORY"))
				{
					if((charptr=(char*)realloc((char*)splicertable.dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
						SpBadMemAlloc("SpInitialize 12");
					else
					{
						splicertable.dirname=charptr;
						(void)strcpy(splicertable.dirname,value);
					}
				}
                                else if(!strcmp(flag,"STRAT_DIRECTORY"))
                                {
                                        if((charptr=(char*)realloc((char*)default_strat_dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                default_strat_dirname=charptr;
                                                (void)strcpy(default_strat_dirname,value);
                                        }
                                }
                                else if(!strcmp(flag,"AGEMODEL_FILE"))
                                {
                                        if((charptr=(char*)realloc((char*)inagemodel_filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                inagemodel_filename=charptr;
                                                (void)strcpy(inagemodel_filename,value);
                                                if((charptr=(char*)realloc((char*)outagemodel_filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                             SpBadMemAlloc("SpInitialize 12");
                                                else
                                                {
                                                        outagemodel_filename=charptr;
                                                        (void)strcpy(outagemodel_filename,value);
                                                }
                                        }
                                }
                                else if(!strcmp(flag,"AGEMODEL_DIRECTORY"))
                                {
                                        if((charptr=(char*)realloc((char*)inagemodel_dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                inagemodel_dirname=charptr;
                                                (void)strcpy(inagemodel_dirname,value);
                                                if((charptr=(char*)realloc((char*)outagemodel_dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                             SpBadMemAlloc("SpInitialize 12");
                                                else
                                                {
                                                        outagemodel_dirname=charptr;
                                                        (void)strcpy(outagemodel_dirname,value);
                                                }
                                        }
                                }
                                else if(!strcmp(flag,"TIMESERIES_FILE"))
                                {
                                        if((charptr=(char*)realloc((char*)timeseries.filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                timeseries.filename=charptr;
                                                (void)strcpy(timeseries.filename,value);
                                        }
                                }
                                else if(!strcmp(flag,"TIMESERIES_DIRECTORY"))
                                {
                                        if((charptr=(char*)realloc((char*)timeseries.dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                timeseries.dirname=charptr;
                                                (void)strcpy(timeseries.dirname,value);
                                        }
                                }
                                else if(!strcmp(flag,"COMPOSITE_DATA_FILE"))
                                {
                                        if((charptr=(char*)realloc((char*)outdata_filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                outdata_filename=charptr;
                                                (void)strcpy(outdata_filename,value);
                                        }
                                }
                                else if(!strcmp(flag,"COMPOSITE_DATA_DIRECTORY"))
                                {
                                        if((charptr=(char*)realloc((char*)outdata_dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                outdata_dirname=charptr;
                                                (void)strcpy(outdata_dirname,value);
                                        }
                                }
                                else if(!strcmp(flag,"SPLICE_FILE"))
                                {
                                        if((charptr=(char*)realloc((char*)outspdata_filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                outspdata_filename=charptr;
                                                (void)strcpy(outspdata_filename,value);
                                        }
                                }
                                else if(!strcmp(flag,"SPLICE_DIRECTORY"))
                                {
                                        if((charptr=(char*)realloc((char*)outspdata_dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                outspdata_dirname=charptr;
                                                (void)strcpy(outspdata_dirname,value);
                                        }
                                }
                                else if(!strcmp(flag,"SPLICEVSAGE_FILE"))
                                {
                                        if((charptr=(char*)realloc((char*)outsplicetoage_filename,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                outsplicetoage_filename=charptr;
                                                (void)strcpy(outsplicetoage_filename,value);
                                        }
                                }
                                else if(!strcmp(flag,"SPLICEVSAGE_DIRECTORY"))
                                {
                                        if((charptr=(char*)realloc((char*)outsplicetoage_dirname,((int)strlen(value)+2)*CHAR_SIZE))==NULL)
                                                SpBadMemAlloc("SpInitialize 12");
                                        else
                                        {
                                                outsplicetoage_dirname=charptr;
                                                (void)strcpy(outsplicetoage_dirname,value);
                                        }
                                }
                                
			/* color defaults */
                                else if(!strcmp(flag,"COLORSET"))
                                        colorset = atoi(value);
                                else if(!strcmp(flag,"BG_COLOR"))
                                        (void)strcpy(cust_color[BG_COLOR],value);
                                else if(!strcmp(flag,"LABEL_COLOR"))
                                        (void)strcpy(cust_color[LABEL_COLOR],value);
				else if(!strcmp(flag,"MBSF_COLOR"))
					(void)strcpy(cust_color[MBSF_COLOR],value);
				else if(!strcmp(flag,"MCD_COLOR"))
					(void)strcpy(cust_color[MCD_COLOR],value);
				else if(!strcmp(flag,"SMOOTH_COLOR"))
					(void)strcpy(cust_color[SMOOTH_COLOR],value);
				else if(!strcmp(flag,"SPLICE_COLOR"))
					 (void)strcpy(cust_color[SPLICE_COLOR],value);
				else if(!strcmp(flag,"SPLICELOCATION_COLOR"))
					(void)strcpy(cust_color[SPLICELOCATION_COLOR],value);
				else if(!strcmp(flag,"TIEPTFIXED_COLOR"))
					(void)strcpy(cust_color[TIEPTFIXED_COLOR],value);
				else if(!strcmp(flag,"TIEPTSHIFT_COLOR"))
					(void)strcpy(cust_color[TIEPTSHIFT_COLOR],value);
				else if(!strcmp(flag,"TIELINE_COLOR"))
					(void)strcpy(cust_color[TIELINE_COLOR],value);
				else if(!strcmp(flag,"OVERLAYINCORR_COLOR"))
					(void)strcpy(cust_color[OVERLAYINCORR_COLOR],value);
				else if(!strcmp(flag,"OVERLAYOUTCORR_COLOR"))
					(void)strcpy(cust_color[OVERLAYOUTCORR_COLOR],value);
				else if(!strcmp(flag,"PALEOMAG_COLOR"))
					(void)strcpy(cust_color[PALEOMAG_COLOR],value);
				else if(!strcmp(flag,"DIATOM_COLOR"))
					(void)strcpy(cust_color[DIATOM_COLOR],value);
				else if(!strcmp(flag,"RAD_COLOR"))
					(void)strcpy(cust_color[RAD_COLOR],value);
				else if(!strcmp(flag,"FORAM_COLOR"))
					(void)strcpy(cust_color[FORAM_COLOR],value);
				else if(!strcmp(flag,"NANNO_COLOR"))
					(void)strcpy(cust_color[NANNO_COLOR],value);
                                else if(!strcmp(flag,"CORRCOEF_COLOR"))
                                        (void)strcpy(cust_color[CORRCOEF_COLOR],value);
				else if(!strcmp(flag,"BESTCORR_COLOR"))
					(void)strcpy(cust_color[BESTCORR_COLOR],value);
				else if(!strcmp(flag,"DEPOFFLINE_COLOR"))
					(void)strcpy(cust_color[DEPOFFLINE_COLOR],value);
				else if(!strcmp(flag,"DEPOFFHOLE1_COLOR"))
					(void)strcpy(cust_color[DEPOFFHOLE1_COLOR],value);
				else if(!strcmp(flag,"DEPOFFHOLE2_COLOR"))
					(void)strcpy(cust_color[DEPOFFHOLE2_COLOR],value);
				else if(!strcmp(flag,"DEPOFFHOLE3_COLOR"))
					(void)strcpy(cust_color[DEPOFFHOLE3_COLOR],value);
				else if(!strcmp(flag,"DEPOFFHOLE4_COLOR"))
					(void)strcpy(cust_color[DEPOFFHOLE4_COLOR],value);
				else if(!strcmp(flag,"DEPOFFHOLE5_COLOR"))
					(void)strcpy(cust_color[DEPOFFHOLE5_COLOR],value);
                                else if(!strcmp(flag,"DEPOFFHOLE6_COLOR"))
                                        (void)strcpy(cust_color[DEPOFFHOLE6_COLOR],value);
                                else if(!strcmp(flag,"DEPOFFHOLE7_COLOR"))
                                        (void)strcpy(cust_color[DEPOFFHOLE7_COLOR],value);
                                else if(!strcmp(flag,"DEPOFFHOLE8_COLOR"))
                                        (void)strcpy(cust_color[DEPOFFHOLE8_COLOR],value);
                                else if(!strcmp(flag,"DEPOFFHOLE9_COLOR"))
                                        (void)strcpy(cust_color[DEPOFFHOLE9_COLOR],value);
                                else if(!strcmp(flag,"DEPOFFHOLE10_COLOR"))
                                        (void)strcpy(cust_color[DEPOFFHOLE10_COLOR],value);         
                                else if(!strcmp(flag,"DEPOFFHOLE11_COLOR"))
                                        (void)strcpy(cust_color[DEPOFFHOLE11_COLOR],value);
                                else if(!strcmp(flag,"AGEDEPHANDPICK_COLOR"))
                                        (void)strcpy(cust_color[AGEDEPHANDPICK_COLOR],value);
                                else if(!strcmp(flag,"AGEDEPLINE_COLOR"))
                                        (void)strcpy(cust_color[AGEDEPLINE_COLOR],value);
                                else if(!strcmp(flag,"SEDRATE_COLOR"))
                                        (void)strcpy(cust_color[SEDRATE_COLOR],value);
                                else if(!strcmp(flag,"DATUMLOC_COLOR"))
                                        (void)strcpy(cust_color[DATUMLOC_COLOR],value);
                                else if(!strcmp(flag,"TIMESERIES_COLOR"))
                                        (void)strcpy(cust_color[TIMESERIES_COLOR],value);
                                else if(!strcmp(flag,"CLIP"))
                                        clip=atoi(value);
			/* unknown flag */
				else
					(void)fprintf(stderr,"splicer: ERROR: Unknown defaults flag %s.\n",flag);
			}
			else
			{
				(void)fprintf(stderr,"splicer: ERROR: Unknown defaults file line type: ");
				(void)fputs(line,stderr);
			}
		}
	}
	if(fptr!=NULL) fclose(fptr);
	Spcheck_defaults();
	return(TRUE);
}


/*      Function Name:	Spwrite_defaults
 *
 *      Description:   	This function writes the defaults values to the
 *		       	specified file.
 *			
 *
 *      Arguments:      FILE		*fptr:	defaults file pointer
 */

void Spwrite_defaults(fptr)
FILE	*fptr;
{
   int len;

/* information header */
	(void)fprintf(fptr,"#\n# %s\n#\n",SPLICER_VERSION);

/* smoothing information */
	(void)fprintf(fptr,"SMOOTH_METHOD\t\t\t=\t%d\n",smooth.method);
        if(smooth.method == NONE) {
          smooth.plot = UNSMOOTHED;
        }
        else if(smooth.method == GAUSSIAN || smooth.method == OTHER) {
          smooth.plot = SMOOTHEDBOTH;
        }
	(void)fprintf(fptr,"SMOOTH_PLOT\t\t\t=\t%d\n",smooth.plot);
	(void)fprintf(fptr,"SMOOTH_WIDTH\t\t\t=\t%d\n",smooth.width);
	(void)fprintf(fptr,"SMOOTH_WIDTH_UNITS\t\t=\t%d\n",smooth.width_units);
/* decimation information */
	(void)fprintf(fptr,"DECIMATE_VALUE\t\t\t=\t%d\n",decimate_value);
/* affine table information */
	(void)fprintf(fptr,"USE_AFFINE_TABLE\t\t=\t%d\n",affine.usetable);
	(void)fprintf(fptr,"AFFINE_TABLE\t\t\t=\t%s\n",affine.filename);
        len = (int)strlen(affine.dirname);
        if(strcmp(&affine.dirname[len-1], "/") != 0) {
          strcat(affine.dirname, "/");
        }
	(void)fprintf(fptr,"AFFINE_DIRECTORY\t\t=\t%s\n",affine.dirname);
/* cull information */
	(void)fprintf(fptr,"CULL_METHOD\t\t\t=\t%d\n",cull.method);
	(void)fprintf(fptr,"CULL_TOP\t\t\t=\t%.1f\n",cull.top);
	(void)fprintf(fptr,"CULL_BY_CORE_NUM\t\t=\t%d\n",cull.by_core_num);
	(void)fprintf(fptr,"CULL_CORE_MAX\t\t\t=\t%d\n",cull.max_core);
	(void)fprintf(fptr,"CULL_TABLE\t\t\t=\t%s\n",cull.filename);
        len = (int)strlen(cull.dirname);
        if(strcmp(&cull.dirname[len-1], "/") != 0) {
          strcat(cull.dirname, "/");
        }
	(void)fprintf(fptr,"CULL_DIRECTORY\t\t\t=\t%s\n",cull.dirname);
	(void)fprintf(fptr,"PWAVE_SIGNAL_MAX\t\t=\t%.1f\n",cull.pwave_signal_max);
	(void)fprintf(fptr,"GRAPE_EQUATION_1\t\t=\t%d\n",cull.grape.sign1);
	(void)fprintf(fptr,"GRAPE_VALUE_1\t\t\t=\t%.3f\n",cull.grape.value1);
	(void)fprintf(fptr,"GRAPE_JOIN\t\t\t=\t%d\n",cull.grape.join);
	(void)fprintf(fptr,"GRAPE_EQUATION_2\t\t=\t%d\n",cull.grape.sign2);
	(void)fprintf(fptr,"GRAPE_VALUE_2\t\t\t=\t%.3f\n",cull.grape.value2);
	(void)fprintf(fptr,"PWAVE_EQUATION_1\t\t=\t%d\n",cull.pwave.sign1);
	(void)fprintf(fptr,"PWAVE_VALUE_1\t\t\t=\t%.3f\n",cull.pwave.value1);
	(void)fprintf(fptr,"PWAVE_JOIN\t\t\t=\t%d\n",cull.pwave.join);
	(void)fprintf(fptr,"PWAVE_EQUATION_2\t\t=\t%d\n",cull.pwave.sign2);
	(void)fprintf(fptr,"PWAVE_VALUE_2\t\t\t=\t%.3f\n",cull.pwave.value2);
	(void)fprintf(fptr,"SUSCEPTIBILITY_EQUATION_1\t=\t%d\n",cull.susceptibility.sign1);
	(void)fprintf(fptr,"SUSCEPTIBILITY_VALUE_1\t\t=\t%.3f\n",cull.susceptibility.value1);
	(void)fprintf(fptr,"SUSCEPTIBILITY_JOIN\t\t=\t%d\n",cull.susceptibility.join);
	(void)fprintf(fptr,"SUSCEPTIBILITY_EQUATION_2\t=\t%d\n",cull.susceptibility.sign2);
	(void)fprintf(fptr,"SUSCEPTIBILITY_VALUE_2\t\t=\t%.3f\n",cull.susceptibility.value2);
	(void)fprintf(fptr,"NATURALGAMMA_EQUATION_1\t\t=\t%d\n",cull.naturalgamma.sign1);
	(void)fprintf(fptr,"NATURALGAMMA_VALUE_1\t\t=\t%.3f\n",cull.naturalgamma.value1);
	(void)fprintf(fptr,"NATURALGAMMA_JOIN\t\t=\t%d\n",cull.naturalgamma.join);
	(void)fprintf(fptr,"NATURALGAMMA_EQUATION_2\t\t=\t%d\n",cull.naturalgamma.sign2);
	(void)fprintf(fptr,"NATURALGAMMA_VALUE_2\t\t=\t%.3f\n",cull.naturalgamma.value2);
	(void)fprintf(fptr,"REFLECTANCE_EQUATION_1\t\t=\t%d\n",cull.reflectance.sign1);
	(void)fprintf(fptr,"REFLECTANCE_VALUE_1\t\t=\t%.3f\n",cull.reflectance.value1);
	(void)fprintf(fptr,"REFLECTANCE_JOIN\t\t=\t%d\n",cull.reflectance.join);
	(void)fprintf(fptr,"REFLECTANCE_EQUATION_2\t\t=\t%d\n",cull.reflectance.sign2);
	(void)fprintf(fptr,"REFLECTANCE_VALUE_2\t\t=\t%.3f\n",cull.reflectance.value2);
	(void)fprintf(fptr,"OTHERODP_EQUATION_1\t\t=\t%d\n",cull.otherodp.sign1);
	(void)fprintf(fptr,"OTHERODP_VALUE_1\t\t=\t%.3f\n",cull.otherodp.value1);
	(void)fprintf(fptr,"OTHERODP_JOIN\t\t\t=\t%d\n",cull.otherodp.join);
	(void)fprintf(fptr,"OTHERODP_EQUATION_2\t\t=\t%d\n",cull.otherodp.sign2);
	(void)fprintf(fptr,"OTHERODP_VALUE_2\t\t=\t%.3f\n",cull.otherodp.value2);
/* data type */
	(void)fprintf(fptr,"DATA_TYPE\t\t\t=\t%d\n",openfileinfo.in_data_type);
/* data format*/
	(void)fprintf(fptr,"IN_DATA_FORMAT\t\t\t=\t%d\n",openfileinfo.in_data_format);
/* open data directory */
        len = (int)strlen(open_data_directory);
        if(strcmp(&open_data_directory[len-1], "/") != 0) {
          strcat(open_data_directory, "/");
        }
        (void)fprintf(fptr,"OPEN_DATA_DIRECTORY\t\t=\t%s\n",open_data_directory);
/* splicer table */
	(void)fprintf(fptr,"SPLICER_TABLE\t\t\t=\t%s\n",splicertable.filename);
        len = (int)strlen(splicertable.dirname);
        if(strcmp(&splicertable.dirname[len-1], "/") != 0) {
          strcat(splicertable.dirname, "/");
        }
	(void)fprintf(fptr,"SPLICER_DIRECTORY\t\t=\t%s\n",splicertable.dirname);
/* strat directory */ 
        len = (int)strlen(default_strat_dirname);
        if(strcmp(&default_strat_dirname[len-1], "/") != 0) {
          strcat(default_strat_dirname, "/");
        }
        (void)fprintf(fptr,"STRAT_DIRECTORY\t\t\t=\t%s\n",default_strat_dirname);
/* agemodel file and directory */
        (void)fprintf(fptr,"AGEMODEL_FILE\t\t\t=\t%s\n",outagemodel_filename);
        len = (int)strlen(outagemodel_dirname);
        if(strcmp(&outagemodel_dirname[len-1], "/") != 0) {
          strcat(outagemodel_dirname, "/");
        }
        (void)fprintf(fptr,"AGEMODEL_DIRECTORY\t\t=\t%s\n",outagemodel_dirname);
/* time series file and directory */
         (void)fprintf(fptr,"TIMESERIES_FILE\t\t\t=\t%s\n",timeseries.filename);
        len = (int)strlen(timeseries.dirname);
        if(strcmp(&timeseries.dirname[len-1], "/") != 0) {
          strcat(timeseries.dirname, "/");
        }
        (void)fprintf(fptr,"TIMESERIES_DIRECTORY\t\t=\t%s\n",timeseries.dirname);
/* composite data file and directory */
        (void)fprintf(fptr,"COMPOSITE_DATA_FILE\t\t=\t%s\n",outdata_filename);
        len = (int)strlen(outdata_dirname);
        if(strcmp(&outdata_dirname[len-1], "/") != 0) {
          strcat(outdata_dirname, "/");
        }
        (void)fprintf(fptr,"COMPOSITE_DATA_DIRECTORY\t=\t%s\n",outdata_dirname);
/* splice file and directory */
        (void)fprintf(fptr,"SPLICE_FILE\t\t\t=\t%s\n",outspdata_filename);
        len = (int)strlen(outspdata_dirname);
        if(strcmp(&outspdata_dirname[len-1], "/") != 0) {
          strcat(outspdata_dirname, "/");
        }
        (void)fprintf(fptr,"SPLICE_DIRECTORY\t\t=\t%s\n",outspdata_dirname);
/* splice vs age file and directory */
        (void)fprintf(fptr,"SPLICEVSAGE_FILE\t\t=\t%s\n",outsplicetoage_filename);
        len = (int)strlen(outsplicetoage_dirname);
        if(strcmp(&outsplicetoage_dirname[len-1], "/") != 0) {
          strcat(outsplicetoage_dirname, "/");
        }
        (void)fprintf(fptr,"SPLICEVSAGE_DIRECTORY\t\t=\t%s\n",outsplicetoage_dirname);
/* color defaults */
        (void)fprintf(fptr,"COLORSET\t\t\t=\t%d\n",colorset);
        (void)fprintf(fptr,"BG_COLOR\t\t\t=\t%s\n",cust_color[BG_COLOR]);
        (void)fprintf(fptr,"LABEL_COLOR\t\t\t=\t%s\n",cust_color[LABEL_COLOR]);
	(void)fprintf(fptr,"MBSF_COLOR\t\t\t=\t%s\n",cust_color[MBSF_COLOR]);
	(void)fprintf(fptr,"MCD_COLOR\t\t\t=\t%s\n",cust_color[MCD_COLOR]);
	(void)fprintf(fptr,"SMOOTH_COLOR\t\t\t=\t%s\n",cust_color[SMOOTH_COLOR]);
	(void)fprintf(fptr,"SPLICE_COLOR\t\t\t=\t%s\n",cust_color[SPLICE_COLOR]);
	(void)fprintf(fptr,"SPLICELOCATION_COLOR\t\t=\t%s\n",cust_color[SPLICELOCATION_COLOR]);
	(void)fprintf(fptr,"TIEPTFIXED_COLOR\t\t=\t%s\n",cust_color[TIEPTFIXED_COLOR]);
	(void)fprintf(fptr,"TIEPTSHIFT_COLOR\t\t=\t%s\n",cust_color[TIEPTSHIFT_COLOR]);
	(void)fprintf(fptr,"TIELINE_COLOR\t\t\t=\t%s\n",cust_color[TIELINE_COLOR]);
	(void)fprintf(fptr,"OVERLAYINCORR_COLOR\t\t=\t%s\n",cust_color[OVERLAYINCORR_COLOR]);
	(void)fprintf(fptr,"OVERLAYOUTCORR_COLOR\t\t=\t%s\n",cust_color[OVERLAYOUTCORR_COLOR]);
	(void)fprintf(fptr,"PALEOMAG_COLOR\t\t\t=\t%s\n",cust_color[PALEOMAG_COLOR]);
	(void)fprintf(fptr,"DIATOM_COLOR\t\t\t=\t%s\n",cust_color[DIATOM_COLOR]);
	(void)fprintf(fptr,"RAD_COLOR\t\t\t=\t%s\n",cust_color[RAD_COLOR]);
	(void)fprintf(fptr,"FORAM_COLOR\t\t\t=\t%s\n",cust_color[FORAM_COLOR]);
	(void)fprintf(fptr,"NANNO_COLOR\t\t\t=\t%s\n",cust_color[NANNO_COLOR]);
        (void)fprintf(fptr,"CORRCOEF_COLOR\t\t\t=\t%s\n",cust_color[CORRCOEF_COLOR]);
	(void)fprintf(fptr,"BESTCORR_COLOR\t\t\t=\t%s\n",cust_color[BESTCORR_COLOR]);
	(void)fprintf(fptr,"DEPOFFLINE_COLOR\t\t=\t%s\n",cust_color[DEPOFFLINE_COLOR]);
	(void)fprintf(fptr,"DEPOFFHOLE1_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE1_COLOR]);
	(void)fprintf(fptr,"DEPOFFHOLE2_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE2_COLOR]);
	(void)fprintf(fptr,"DEPOFFHOLE3_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE3_COLOR]);
	(void)fprintf(fptr,"DEPOFFHOLE4_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE4_COLOR]);
	(void)fprintf(fptr,"DEPOFFHOLE5_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE5_COLOR]);
        (void)fprintf(fptr,"DEPOFFHOLE6_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE6_COLOR]);
        (void)fprintf(fptr,"DEPOFFHOLE7_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE7_COLOR]);
        (void)fprintf(fptr,"DEPOFFHOLE8_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE8_COLOR]);
        (void)fprintf(fptr,"DEPOFFHOLE9_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE9_COLOR]);
        (void)fprintf(fptr,"DEPOFFHOLE10_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE10_COLOR]);
        (void)fprintf(fptr,"DEPOFFHOLE11_COLOR\t\t=\t%s\n",cust_color[DEPOFFHOLE11_COLOR]);
        (void)fprintf(fptr,"AGEDEPHANDPICK_COLOR\t\t=\t%s\n",cust_color[AGEDEPHANDPICK_COLOR]);
        (void)fprintf(fptr,"AGEDEPLINE_COLOR\t\t=\t%s\n",cust_color[AGEDEPLINE_COLOR]);
        (void)fprintf(fptr,"SEDRATE_COLOR\t\t\t=\t%s\n",cust_color[SEDRATE_COLOR]);
        (void)fprintf(fptr,"DATUMLOC_COLOR\t\t\t=\t%s\n",cust_color[DATUMLOC_COLOR]);
        (void)fprintf(fptr,"TIMESERIES_COLOR\t\t=\t%s\n",cust_color[TIMESERIES_COLOR]);
        (void)fprintf(fptr,"CLIP\t\t\t\t=\t%d\n",clip);
}
