/*
function: gauss-weights
*/
#include <stdio.h>

void gauss_weights(width,weight)
int	width;
float	*weight;
{
	double	exp (), foldwidth, halfwidth, power, sum = 0.0;
	int	ia;

	foldwidth = ((double) width - 1.0) / 3.0;
	halfwidth = ((double) width - 1.0) / 2.0;

	/*  compute unscaled weights  */
	for (ia = 1;  ia <= width;  ia++)
	{
		power = (halfwidth - (double) ia + 1.0) / foldwidth;
		power = -1.0 * power * power;
		weight[ia] = exp (power);
		sum += weight[ia];

		/*  set pointers  */
	}

	/*  scale weights to add to 1.0  */
	for (ia = 1;  ia <= width;  ia++)
		weight[ia] /= sum;

}  /*  end gauss_weights  */
