/*
    contains the following functions:
*/
         void SplicerInitialSettings();
         void SetMinMax();
         void SetDisplayDefaults();
         int  GetDisplayValues();
         void AxisDep();
         void AxisVar();
         void AxisCorr();
         void AxisDepthOffset();
         void AxisAge();
         void MakeTheGCs();
         void SetInitialColors();
         int  FindAveDepth();
         int  Correlate();
         int  RepickDepth();
         int  FindMinMax();
         int  CleanUpCore();
         int  CleanUpSpliceCore();
         void DisplaySliderControl();
         int  StdDev();
         int  SiteAveDepth();
         void MakeClipMask();
         void FindClipRegion();
         int  FindMinMaxOneCore();
         void ReadColorList();
         int  GetColorPixelValue();
         void SetCustomeColorButtonColors();
         void SetCustomeColorWidgetBGColors();
         void SetCustomeColorWidgetFGColors();
         void PlaceDialog();
         void MapStratToAffine();
         void FindStratDepthOffset();
         void AgeDepthMinMax();
         void AgeDepthPlotValues();
         int  CalcAge();
         int  GetColorSet();
         void SetColorSetBGandFG();
         int FindSpliceAveAge();

#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "splicer-creation-c.h"
#include "splicer_vars.h"

void SplicerInitialSettings(dpy)
Display *dpy;
{
  int i;
  char *string;
  time_t tp;

/*
  if((string=(char*)calloc(1000, CHAR_SIZE))==NULL)
                 SpBadMemAlloc("");
  (void)strcpy(string,(char*)getenv("WHERE_AM_I"));
  for(i=0; i<strlen(string); ++i) {
    string[i] = toupper(string[i]);
  }
  if(strcmp(string, "SHIP") == 0) {
    whereami = SHIP;
  }
  else if(strcmp(string, "SHORE") == 0) {
    whereami = SHORE;
  }
  else {
    whereami = SHORE;
  }
  free(string);
*/
  dataset_cnt = 0;
  dset = 0;
  XtUnmanageChild(optionMenuDataSet);
  XtUnmanageChild(pushButtonDataSet1);
  XtUnmanageChild(pushButtonDataSet2);
  XtUnmanageChild(pushButtonDataSet3);
  XtUnmanageChild(pushButtonDataSet4);
  XtUnmanageChild(pushButtonDataSet5);
  XtUnmanageChild(pushButtonDataSet6);
  XtUnmanageChild(pushButtonDataSet7);
  XtUnmanageChild(pushButtonDataSet8);
  XtUnmanageChild(pushButtonDataSet9);
  have_data = DONT;
  have_affine = DONT;
  have_tie = DONT;
  last_tie = NONE;
  have_tie1 = NO;
  have_tie2 = NO;
  have_shift = DONT;
  have_corr = DONT;
  have_splice = DONT;
  have_core_to_splice = DONT;
  have_splice_tie = DONT;
  last_sp_tie = NONE;
  have_sp_tie1 = NO;
  have_sp_tie2 = NO;
  have_strat = DONT;
  have_splicetoage = DONT;
  have_time_series = DONT;
  have_splicetoage_tie = DONT;
  have_timeseries_tie = DONT;
  last_splicetoage_tie = NONE;
  have_splicetoage_corr = DONT;
  lastaffinehole = -1;
  lastaffinecore = -1;
  draw_offsets = NO;
  are_compositing = NO;
  did_affine = NO;
  saved_affine = NO;
  are_splicing = NO;
  did_splicing = NO;
  saved_splice = NO;
  are_dragging = NO;
  are_agemodelling = NO;
  did_agemodel = NO;
  saved_agemodel = NO;
  agemodel_cnt = 0;
  reason_for_redraw = DRAW_EVERYTHING;
  last_scale_val_edit = 0;
  last_scale_val_view = 0;
  splicertable.data_cnt = 0;
  agemodel_cnt = 0;
  are_agemodelling = NO;
  agemodelling_depth_type = MBSF;
  write_report = NO;
  open_dataform_is_up = NO;
  MakeTheGCs(dpy);
  SetInitialColors(dpy);
  SetDisplayDefaults();
  ReadColorList(dpy);
  XtSetSensitive(pushButtonDataBase, FALSE);
  XtSetSensitive(cascadeButtonSave,FALSE);
  XtSetSensitive(pushButtonSaveCull,FALSE);
  XtSetSensitive(pushButtonSaveAffine,FALSE);
  XtSetSensitive(pushButtonSaveSplicerTable,FALSE);
  XtSetSensitive(pushButtonSaveStrat,FALSE);
  XtSetSensitive(pushButtonSaveData,FALSE);
  XtSetSensitive(pushButtonSaveSplicerData,FALSE);
  XtSetSensitive(cascadeButtonClear,FALSE);
  XtSetSensitive(pushButtonClearAll,FALSE);
  XtSetSensitive(pushButtonClearComposite,FALSE);
  XtSetSensitive(pushButtonClearSplice,FALSE);
  XtSetSensitive(pushButtonClearStrat,FALSE);
  XtSetSensitive(pushButtonComposite,FALSE);
  XtSetSensitive(cascadeButtonSplice,FALSE);
  XtSetSensitive(pushButtonDisplay,TRUE);
  XtSetSensitive(pushButtonViewOffsets,FALSE);
  XtSetSensitive(pushButtonViewAgeDepth,FALSE);
  XtSetSensitive(cascadeButtonDataManip, False);
  XmToggleButtonSetState(toggleButtonLockSlider, True, NULL);
  XmToggleButtonSetState(toggleButtonAgeDepthmbsf, True, NULL);
  XmToggleButtonSetState(toggleButtonPlotUnsmooth, True, NULL); 
  XmToggleButtonSetState(toggleButtonPlotSmooth, False, NULL);
  XmToggleButtonSetState(toggleButtonPlotBoth, False, NULL);
  XmToggleButtonSetState(toggleButtonOpenFormatsOther1, True, NULL);
  XtSetSensitive(toggleButtonPlotSmooth,FALSE);
  XtSetSensitive(toggleButtonPlotUnsmooth,FALSE);
  XtSetSensitive(toggleButtonPlotBoth,FALSE);
  XmToggleButtonSetState(toggleButtonHeaderNo, True, NULL);
  XmToggleButtonSetState(toggleButtonHeaderYes, False, NULL);

  XtUnmanageChild(formFileSelectionTimeSeries);
  XtUnmanageChild(optionMenuStratType1);
  XtUnmanageChild(labelStratType1);
  XtVaSetValues(XtParent(formFileSelection), XmNheight, 640, NULL);

  /* write to report
  */
  XtManageChild(formTextReport);
  if((string=(char*)calloc(1000, CHAR_SIZE))==NULL)
                 SpBadMemAlloc("");
  if(time(&tp)) {
    (void)sprintf(string,"Start of Session.  %s",ctime(&tp));
  }
  else {
    (void)sprintf(string, "Start of Session. No date available.\n");
  }
  SpUpdateReport(string);
  free(string);
  XtPopdown(XtParent(formTextReport));
}

void SetMinMax(ds)
int ds;
{
  int scalemax;
  char string[50];

  (void)sprintf(string, "%.2f", data[ds]->min); 
  XtVaSetValues(textVarMin, XmNvalue, string, NULL); 
  (void)sprintf(string, "%.2f", data[ds]->max); 
  XtVaSetValues(textVarMax, XmNvalue, string, NULL); 

  scalemax = maxdep + (0.2 * maxdep); 
  XtVaSetValues(drawingAreaEditScale, XmNmaximum, scalemax, NULL); 
  XtVaSetValues(drawingAreaViewScale, XmNmaximum, scalemax, NULL);

  (void)sprintf(string, "");
}

void SetDisplayDefaults()
{
  int scalemax;
  char string[50];

  depmeterdisplayed = DEPMETERDISPLAYED;
  (void)sprintf(string, "%.3f", depmeterdisplayed);
  XtVaSetValues(textDepthScale, XmNvalue, string, NULL);

  deptic = DEPTIC;
  (void)sprintf(string, "%.1f", deptic); 
  XtVaSetValues(textDepthTic, XmNvalue, string, NULL); 

  varaxislen = VAR_AXIS_LEN;
  (void)sprintf(string, "%d", varaxislen); 
  XtVaSetValues(textVarAxisLen, XmNvalue, string, NULL); 

  minvar = 0.0;
  (void)sprintf(string, "%.2f", minvar); 
  XtVaSetValues(textVarMin, XmNvalue, string, NULL); 

  maxvar = 0.0;
  (void)sprintf(string, "%.2f", maxvar);
  XtVaSetValues(textVarMax, XmNvalue, string, NULL); 

  scale_mult = SCALE_MULT;
  (void)sprintf(string, "%d", scale_mult); 
  XtVaSetValues(textScaleMult, XmNvalue, string, NULL); 

  XtVaSetValues(drawingAreaEditScale, XmNscaleMultiple, scale_mult, NULL);
  XtVaSetValues(drawingAreaViewScale, XmNscaleMultiple, scale_mult, NULL);
  XmToggleButtonSetState(toggleButtonScaleDragYes, True, NULL);
  XmToggleButtonSetState(toggleButtonScaleDragNo, False, NULL);

  maxdep = MAXDEP;
  scalemax = maxdep;
  XtVaSetValues(drawingAreaEditScale, XmNmaximum, scalemax, NULL);
  XtVaSetValues(drawingAreaViewScale, XmNmaximum, scalemax, NULL);

  XmToggleButtonSetState(toggleButtonPlotUnsmooth, False, NULL);
  XmToggleButtonSetState(toggleButtonPlotSmooth, False, NULL);
  XmToggleButtonSetState(toggleButtonPlotBoth, False, NULL);
/*
  if(smooth.method == NONE) {
  }
  else if(smooth.plot == UNSMOOTHED) {
  }
  else if(smooth.plot == SMOOTHED) {
    XmToggleButtonSetState(toggleButtonPlotSmooth, True, NULL);
    XmToggleButtonSetState(toggleButtonPlotUnsmooth, False, NULL);
  }
  else if(smooth.plot == SMOOTHEDBOTH) {
    XmToggleButtonSetState(toggleButtonPlotBoth, True, NULL);
    XmToggleButtonSetState(toggleButtonPlotUnsmooth, False, NULL);
  }
*/  
  (void)sprintf(string, "%.2f", DEPTHCHANGE);
  XtVaSetValues(textDepthChange, XmNvalue, string, NULL);

  (void)sprintf(string, "");
}


int GetDisplayValues(ds)
int ds;
{
  double check, fract, ip;
  String  str;

  str = XmTextGetString(textDepthScale);
  depmeterdisplayed = atof(str);
  XtFree(str);

  /* check that meters display is a whole number >= 1
  */
  check = depmeterdisplayed;
  fract = modf(check, &ip);
  if(fract != 0.0){
    depmeterdisplayed = DEPMETERDISPLAYED;
    (void)sprintf(buffer,"meters displayed must be a whole number.");
    SpManageWarningBox(buffer);
    return 1;
  }
  if(depmeterdisplayed < 1.0){
    depmeterdisplayed = DEPMETERDISPLAYED;
    (void)sprintf(buffer,"meters displayed must be greater than or equal to 1.0."); 
    SpManageWarningBox(buffer); 
    return 1;
  }

  str = XmTextGetString(textDepthTic); 
  deptic = atof(str);
  XtFree(str);


  /* check that the depth tic is a whole number and divides evenly into number
     of meters displayed
  */
  check = deptic;
  fract = modf(check, &ip);
  if(fract != 0.0){
    deptic = DEPTIC;
    (void)sprintf(buffer,"the depth tic must be a whole number.");
    SpManageWarningBox(buffer);
    return 1;
  }
  check = depmeterdisplayed/deptic;
  fract = modf(check, &ip);
  if(fract != 0.0){
    deptic = DEPTIC;
    (void)sprintf(buffer,"the depth tic interval must divide evenly into number of meters displyed");
    SpManageWarningBox(buffer);
    return 1;
  }

  str = XmTextGetString(textVarAxisLen); 
  varaxislen = atoi(str);
  XtFree(str);

  /* check that the var axis length has some length
  */
  if(varaxislen < 10){
    varaxislen = VAR_AXIS_LEN;
    (void)sprintf(buffer,"the variable axis pixel length is unreasonably small.");
    SpManageWarningBox(buffer);
    return 1;
  }

  str = XmTextGetString(textVarMin); 
  minvar = atof(str);
  XtFree(str);

  str = XmTextGetString(textVarMax); 
  maxvar = atof(str);
  XtFree(str);

  /* check that the max is greater than the min and the range is not 
     approaching zero
  */
  if(maxvar < minvar){
    (void)sprintf(buffer,"the variable axis maximum is less than its minimum."); 
    SpManageWarningBox(buffer);
    return 1; 
  }
  if(have_data == DO){
    if(maxvar == minvar){
      (void)sprintf(buffer,"the variable axis minimum equals its maximum."); 
      SpManageWarningBox(buffer);
      return 1;  
    }
    if(fabs(maxvar - minvar) < 0.001){
      (void)sprintf(buffer,"the variable axis range is unreasonably small."); 
      SpManageWarningBox(buffer);
      return 1; 
    }
  }

  if(have_data == DO) {
    data[ds]->min = minvar;
    data[ds]->max = maxvar;
  }

     /* check that the var axis length and var display range relative to
        real var range is reasonable. just warn;  
  
     if((varaxislen/(maxvar - minvar) * (realmaxvar - realminvar) - varaxislen) > 200) {
       (void)sprintf(buffer,"the variable axis display range is much smaller than real range.");
       SpManageWarningBox(buffer);
     }
    */

  str = XmTextGetString(textScaleMult); 
  check = atof(str);
  XtFree(str);

  /* check that slider scale is a whole number greater than or equal to one
  */
  fract = modf(check, &ip);
  if(fract != 0.0){
    (void)sprintf(buffer,"the scroll increment must be a whole number.");
    SpManageWarningBox(buffer);
    return 1;
  }
  scale_mult = check;
  if(scale_mult < 1){
    (void)sprintf(buffer,"the scroll increment must be greater than or equal to 1.0."); 
    SpManageWarningBox(buffer); 
    return 1; 
  }

  XtVaSetValues(drawingAreaEditScale, XmNscaleMultiple, scale_mult, NULL);
  XtVaSetValues(drawingAreaViewScale, XmNscaleMultiple, scale_mult, NULL);

  if(XmToggleButtonGetState(toggleButtonPlotUnsmooth) == True){
    smooth.plot = UNSMOOTHED;
  }
  else if(XmToggleButtonGetState(toggleButtonPlotSmooth) == True){
    smooth.plot = SMOOTHED; 
  }
  else if(XmToggleButtonGetState(toggleButtonPlotBoth) == True){
    smooth.plot = SMOOTHEDBOTH; 
  }

  return 0;
}


void AxisDep(w, dpy, wid, gc, maxmeter, top_off, left, ticpixlen, depinc, unitinc, depscalepix, annot, label)
Widget w;
Display *dpy;
Window wid;
GC gc;
int top_off, left, ticpixlen, annot, label;
float unitinc, depscalepix, depinc, maxmeter;
{
  int yoff, laboff, chk;
  char s[50];
  Dimension win_height;

  /* get the height and width of the drawing area
  */
  XtVaGetValues(w, XmNheight, &win_height, NULL);

  /* label the axis
  */
  if(label > 0){
    if(label == MBSF) {
      (void)sprintf(s,"mbsf");
    }
    else if(label == MCD) {
      (void)sprintf(s,"mcd");
    }
    else {
      (void)sprintf(s,"m");
    }
    XDrawString(dpy, wid, gc, 8, OFF + 30, s, (int)strlen(s));
  }

  yoff = top_off;
  /* draw the depth axis and tic it
  */
  if(left > 0) {
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, yoff + left);
    yoff = yoff + left;
  }
  laboff=YAXIS_ANNOT_OFF;
  if(unitinc >= 10.0 && unitinc < 100.0) {
    laboff = YAXIS_ANNOT_OFF + 5;
  }
  else if(unitinc >= 100.0) {
    laboff=YAXIS_ANNOT_OFF + 9;
  }
  XDrawLine(dpy, wid, gc, OFF, yoff, OFF-4, yoff);
  (void)sprintf(s,"%.1f",unitinc);
  XDrawString(dpy, wid, gc, OFF-laboff, yoff+2, s, (int)strlen(s));
  chk = 1;
  
  while(yoff+ticpixlen <= (int)win_height && unitinc < maxmeter){
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, yoff+ticpixlen);
    yoff = yoff + ticpixlen;
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF-4, yoff);
    unitinc = unitinc + depinc;
    if(unitinc >= 10.0 && unitinc < 100.0) {
      laboff = YAXIS_ANNOT_OFF + 5;
    }
    else if(unitinc >= 100.0) {
      laboff=YAXIS_ANNOT_OFF + 9;
    }
    if(chk == annot){
      (void)sprintf(s,"%.1f",unitinc);
      XDrawString(dpy, wid, gc, OFF-laboff, yoff, s, (int)strlen(s));
      chk = 1;
    }
    else {
      ++chk;
    }
  }
  if(yoff < (int)win_height && unitinc < maxmeter) {
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, win_height);
  }

  (void)sprintf(s, "");
} 
 
void AxisVar()
{
}

int XAxisDepthCorrSetup(lead, dt, len, tic, ntic, perpix, max)
int    lead;
float  dt;
int    *len;
float  *tic;
int    *ntic;
float  *perpix;
float  *max;
{
  double fract, check, ip;

  check = *len;
  if(lead * dt  <= 1){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=0.2;
    *ntic=10;
    *perpix=1.0/(*len);
    *max=1.0;
  }
  else if(lead * dt <= 2){
    fract = modf((check/4.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 4.0;
    }
    else {
      *len = (ip * 4.0) + 4.0;
    }
    *tic=0.5;
    *ntic=8;
    *perpix=2.0/(*len);
    *max=2.0;
  }
  else if(lead * dt <= 3){
    fract = modf((check/6.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 6.0;
    }
    else {
      *len = (ip * 6.0) + 6.0;
    }
    *tic=0.5;
    *ntic=12;
    *perpix=3.0/(*len);
    *max=3.0;
  }
  else if(lead * dt <= 4){
    fract = modf((check/4.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 4.0;
    }
    else {
      *len = (ip * 4.0) + 4.0;
    }
    *tic=1.0;
    *ntic=8;
    *perpix=4.0/(*len);
    *max=4.0;
  }
  else if(lead *dt <= 5){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
  else if(lead * dt <= 6){
    fract = modf((check/6.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 6.0;
    }
    else {
      *len = (ip * 6.0) + 6.0;
    }
    *tic=1.0;
    *ntic=12;
    *perpix=6.0/(*len);
    *max=6.0;
  }
  else if(lead * dt <= 7){
    fract = modf((check/7.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 7.0;
    }
    else {
      *len = (ip * 7.0) + 7.0;
    }
    *tic=1.0;
    *ntic=14;
    *perpix=7.0/(*len);
    *max=7.0;
  }
  else if(lead * dt <= 8){
    fract = modf((check/4.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 4.0;
    }
    else {
      *len = (ip * 4.0) + 4.0;
    }
    *tic=2.0;
    *ntic=8;
    *perpix=8.0/(*len);
    *max=8.0;
  }
  else if(lead * dt <= 10){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=2.0;
    *ntic=10;
    *perpix=10.0/(*len);
    *max=10.0;
  }
  else if(lead * dt <= 15){
    fract = modf((check/3.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 3.0;
    }
    else {
      *len = (ip * 3.0) + 3.0;
    }
    *tic=5.0;
    *ntic=6;
    *perpix=10.0/(*len);
    *max=10.0;
  }
  else if(lead * dt <= 20){
    fract = modf((check/4.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 4.0;
    }
    else {
      *len = (ip * 4.0) + 4.0;
    }
    *tic=5.0;
    *ntic=8;
    *perpix=10.0/(*len);
    *max=10.0;
  }
  else if(lead * dt <= 25){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=5.0;
    *ntic=10;
    *perpix=10.0/(*len);
    *max=10.0;
  }
  else {
    return 1;
  }

  return 0;
}

void AxisCorr(dpy, xid, gc, lagtic, nlagtic, maxlag, ylen, xlen, place)
Display *dpy;
Window xid;
GC gc;
int nlagtic, ylen, xlen, place;
float lagtic, maxlag;
{
  int i, m, xoff, yoff, inc;
  char s[50];
  float corr;

  /* draw and label the lead,lag axis and tic it
  */
  XDrawString(dpy, xid, gc, SPACE, SPACE/2, "lag from tie", 12);
  XDrawString(dpy, xid, gc, xlen + SPACE - 5, SPACE/2, "tie", 3);
  XDrawString(dpy, xid, gc, (xlen * 2) + SPACE - 70, SPACE/2, "lead from tie", 13);

  m = SPACE;
  yoff = (ylen/2) + SPACE;
  XDrawLine(dpy, xid, gc, m, yoff, m + (xlen * 2), yoff);
  if(place == 2) {
    (void)sprintf(s,"%.2f",-1*maxlag);
  }
  else {
    (void)sprintf(s,"%.1f",-1*maxlag);
  }
  XDrawString(dpy, xid, gc, m-5, yoff+15, s, (int)strlen(s));
  inc = (xlen * 2)/nlagtic;
  for(i=0; i <= nlagtic; ++i){
    XDrawLine(dpy, xid, gc, m, yoff-3, m, yoff+3);
    m = m + inc;
  }  
  if(place == 2) {
    (void)sprintf(s,"%.2f", maxlag);
  }
  else {
    (void)sprintf(s,"%.1f", maxlag);
  }
  XDrawString(dpy, xid, gc, m-5-inc, yoff+15, s, (int)strlen(s));

  /* draw and label the corr coef axis
  */
  m = SPACE;
  corr = 1.0;
  xoff = SPACE + xlen;
  XDrawLine(dpy, xid, gc, xoff, m, xoff, ylen + SPACE);
  (void)sprintf(s,"%.1f",corr);
  XDrawString(dpy, xid, gc, xoff+10, m+3, s, (int)strlen(s));
  inc = ylen/10;
  for(i=0; i <= 10; ++i){
    XDrawLine(dpy, xid, gc, xoff-3, m, xoff+3, m);
    m = m + inc;
  }  
  (void)sprintf(s,"%.1f",-1*corr);
  XDrawString(dpy, xid, gc, xoff+10, m+3-inc, s, (int)strlen(s));

  (void)sprintf(s, "");
}

void AxisDepthOffset(w, dpy, wid, gc, maxmeter, top_off, left, ticpixlen, depinc, unitinc, depscalepix, annot)
Widget w;
Display *dpy;
Window wid;
GC gc;
int top_off, left, ticpixlen, annot;
float unitinc, depscalepix, depinc, maxmeter;
{
  int xoff, laboff, inc, dinc;
  char s[50];
  Dimension win_width;

  /* get the  width of the drawing area
  */ 
  XtVaGetValues(w, XmNwidth, &win_width, NULL);

  /*label the axis
  */
  (void)sprintf(s,"Depth offset (m)");
  XDrawString(dpy, wid, gc, OFF + 20, 20, s, (int)strlen(s));

  inc = unitinc + .1;
  dinc = depinc + .1;

  /* draw the depth offset axis(x axis) and tic it
  */
  xoff = OFF;
  laboff= 0;
  XDrawLine(dpy, wid, gc, xoff, OFF, xoff, OFF - 4);
  (void)sprintf(s,"%d",inc);
  XDrawString(dpy, wid, gc, xoff - laboff, OFF - 10, "0", 1);
     
  while(xoff + ticpixlen <= (int)win_width && unitinc < maxmeter){
    XDrawLine(dpy, wid, gc, xoff, OFF, xoff + ticpixlen, OFF);
    xoff = xoff + ticpixlen;
    XDrawLine(dpy, wid, gc, xoff, OFF, xoff, OFF - 4);
    inc = inc + dinc;
    if(inc >= 10 && inc < 100){
      laboff = 3;
    }
    else if(unitinc >= 100.0) {
      laboff= 5;
    }
    (void)sprintf(s,"%d",inc);
    XDrawString(dpy, wid, gc, xoff - laboff, OFF - 10, s, (int)strlen(s));
  }

  (void)sprintf(s, "");
}

void AxisAge(w, dpy, wid, gc, maxage, top_off, left, ticpixlen, ageinc, unitinc, ageperpix, annot)
Widget w;
Display *dpy;
Window wid;
GC gc;
int top_off, ticpixlen, annot, left;
float unitinc, ageperpix, ageinc, maxage;
{
  int xoff, laboff, inc, dinc, max;
  char s[50]; 
  Dimension win_width;
 
  /* get the  width of the drawing area
  */ 
  XtVaGetValues(w, XmNwidth, &win_width, NULL);
 
  /*label the axis
  */
  (void)sprintf(s,"Age(Ma)");
  XDrawString(dpy, wid, gc, OFF + 20, 20, s, (int)strlen(s));
 
  inc = unitinc + .1;
  dinc = ageinc + .1;
  max = maxage + .1;
 
  xoff = top_off;

  /* if axis does not start at first tic draw up to first tic
  */
  if(left > 0) {
    XDrawLine(dpy, wid, gc, xoff, top_off_agedepth_depth, xoff + left, top_off_agedepth_depth);
    xoff = xoff + left;
  }

  /* draw and label the first tic
  */
  laboff= 0;
  XDrawLine(dpy, wid, gc, xoff, OFF, xoff, OFF - 4);
  (void)sprintf(s,"%d",inc);
  XDrawString(dpy, wid, gc, xoff - laboff, top_off_agedepth_depth - 10, s, (int)strlen(s));
     
  while(inc < max){
    XDrawLine(dpy, wid, gc, xoff, top_off_agedepth_depth, xoff + ticpixlen, top_off_agedepth_depth);
    xoff = xoff + ticpixlen;
    XDrawLine(dpy, wid, gc, xoff, top_off_agedepth_depth, xoff, top_off_agedepth_depth - 4);
    inc = inc + dinc;
    if(inc >= 10 && inc < 100){
      laboff = 3;
    }
    else if(inc >= 100.0) {
      laboff= 5;
    }
    (void)sprintf(s,"%d",inc);
    XDrawString(dpy, wid, gc, xoff - laboff, top_off_agedepth_depth - 10, s, (int)strlen(s));
  }
  if(xoff < (int)win_width - top_off - SPACE - OFF && inc < max) {
    ticpixlen = (int)win_width - top_off - SPACE - xoff;
    XDrawLine(dpy, wid, gc, xoff, top_off_agedepth_depth, xoff + ticpixlen, top_off_agedepth_depth);
    xoff = xoff + ticpixlen;
    XDrawLine(dpy, wid, gc, xoff, top_off_agedepth_depth, xoff, top_off_agedepth_depth - 4);
    laboff = 25;
    unitinc = inc + (ticpixlen * ageperpix);
    (void)sprintf(s,"%8.4f",unitinc);
    XDrawString(dpy, wid, gc, xoff - laboff, top_off_agedepth_depth - 10, s, (int)strlen(s));
  }

  (void)sprintf(s, "");
}

AxisSpliceAge(w, dpy, wid, gc, maxmeter, top_off, left, ticpixlen, depinc, unitinc, depscalepix, annot, label)
Widget w;
Display *dpy;
Window wid;
GC gc;
int top_off, left, ticpixlen, annot, label;
float unitinc, depscalepix, depinc, maxmeter;
{
  int yoff, laboff, chk;
  char s[50];
  Dimension win_height;

  /* get the height and width of the drawing area
  */
  XtVaGetValues(w, XmNheight, &win_height, NULL);

  if(label > 0){
    (void)sprintf(s,"Ma");
    XDrawString(dpy, wid, gc, 8, OFF + 30, s, (int)strlen(s));
  }

  yoff = top_off;
  /* draw the depth axis and tic it
  */
  if(left > 0) {
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, yoff + left);
    yoff = yoff + left;
  }
  laboff=YAXIS_ANNOT_OFF + 10;
  if(unitinc >= 10.0) {
    laboff = YAXIS_ANNOT_OFF + 15;
  }
  XDrawLine(dpy, wid, gc, OFF, yoff, OFF-4, yoff);
  (void)sprintf(s,"%.3f",unitinc);
  XDrawString(dpy, wid, gc, OFF-laboff, yoff+2, s, (int)strlen(s));
  chk = 1;
 
  while(yoff+ticpixlen <= (int)win_height && unitinc < maxmeter){
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, yoff+ticpixlen);
    yoff = yoff + ticpixlen;
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF-4, yoff);
    unitinc = unitinc + depinc;
    if(unitinc >= 10.0 && unitinc < 100.0) {
      laboff = YAXIS_ANNOT_OFF + 5;
    }
    else if(unitinc >= 100.0) {
      laboff=YAXIS_ANNOT_OFF + 9;
    }
    if(chk == annot){
      (void)sprintf(s,"%.3f",unitinc);
      XDrawString(dpy, wid, gc, OFF-laboff, yoff, s, (int)strlen(s));
      chk = 1;
    }
    else {
      ++chk;
    }
  }
  if(yoff < (int)win_height && unitinc < maxmeter) {
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, win_height);
  }

  (void)sprintf(s, "");
}

void MakeTheGCs(display)
Display *display;
{
  int screen_num;
  XFontStruct *font;

  /* create the GC's for the drawing windows 
  */
  screen_num = DefaultScreen(display);
  gc_drawingAreaEdit = XCreateGC(display,
                       RootWindow(display, screen_num),
                       (unsigned long)NULL, NULL);
  gc_drawingAreaView = XCreateGC(display, 
                       RootWindow(display, screen_num), 
                       (unsigned long)NULL, NULL);
  gc_drawingAreaTieCorrelation = XCreateGC(display, 
                                 RootWindow(display, screen_num), 
                                 (unsigned long)NULL, NULL);
  gc_drawingAreaSpliceCorrelation = XCreateGC(display, 
                                    RootWindow(display, screen_num), 
                                    (unsigned long)NULL, NULL);
  gc_drawingAreaAgeDepth = XCreateGC(display,
                                    RootWindow(display, screen_num),
                                    (unsigned long)NULL, NULL);
  gc_drawingAreaDepthOffset = XCreateGC(display,
                                    RootWindow(display, screen_num),
                                    (unsigned long)NULL, NULL);
  gc_drawingAreaSpliceToAge = XCreateGC(display,
                                    RootWindow(display, screen_num),
                                    (unsigned long)NULL, NULL);
  gc_drawingAreaTieToTimeSeriesCorr = XCreateGC(display,
                                    RootWindow(display, screen_num),
                                    (unsigned long)NULL, NULL);
  
  /* and set their fonts
  */
  if(!(font = XLoadQueryFont(display, "-*-helvetica-*-r-*--12-*"))) {
    (void)sprintf(buffer, "Query for composite and splice drawing area fonts failed.");
    SpManageWarningBox(buffer);
  }  
  else {
    XSetFont(display, gc_drawingAreaEdit, font->fid);
    XSetFont(display, gc_drawingAreaView, font->fid);
  }
  if(!(font = XLoadQueryFont(display, "-*-helvetica-*-r-*--10-*"))) {
    (void)sprintf(buffer, "Query for correlation and depth offset drawing area fonts failed."); 
    SpManageWarningBox(buffer);
  }  
  else {
    XSetFont(display, gc_drawingAreaTieCorrelation, font->fid);
    XSetFont(display, gc_drawingAreaSpliceCorrelation, font->fid);
    XSetFont(display, gc_drawingAreaDepthOffset, font->fid);
    XSetFont(display, gc_drawingAreaAgeDepth, font->fid);
    XSetFont(display, gc_drawingAreaSpliceToAge, font->fid);
    XSetFont(display, gc_drawingAreaTieToTimeSeriesCorr, font->fid);
  }
  if(!(font = XLoadQueryFont(display, "-*-helvetica-*-r-*--8-*"))) {
  }  
  else {
  }
}

void SetInitialColors(dpy)
Display *dpy;
{
  XmString xmstring;
  XColor return_color, unused;
  Pixel pixwhite, pixblack;
  int GetColorSet();

  cmap = DefaultColormapOfScreen(XtScreen(drawingAreaEdit));

  /* get black and white pixel values for backup incase have a
     failed named color allocation
  */
  pixblack = BlackPixelOfScreen(XtScreen(drawingAreaEdit));
  pixwhite = WhitePixelOfScreen(XtScreen(drawingAreaEdit));

  /* get the colorset to use
  */
  GetColorSet();

  /* set the background color for the four drawing areas 
  */
  if(!XAllocNamedColor(dpy, cmap, color[BG_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[BG_COLOR]); 
    SpManageWarningBox(buffer);
    bgPixel = pixblack; 
    xmstring = XmStringCreateSimple("black");
    XtVaSetValues(pushButtonDrawingAreaColorBG, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    bgPixel = return_color.pixel;
    xmstring = XmStringCreateSimple(color[BG_COLOR]);
    XtVaSetValues(pushButtonDrawingAreaColorBG, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonDrawingAreaColorBG, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaEdit, XmNbackground, bgPixel, NULL); 
  XtVaSetValues(drawingAreaView, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaTieCorrelation, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaCompCorrelation, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaDepthOffset, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaAgeDepth, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaSpliceToAge, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaTieToTimeSeriesCorr, XmNbackground, bgPixel, NULL);

  /* set the border color of labels for cursor location and ties to 
     the drawing areas background color
  */
  XtVaSetValues(labelCursorLocation, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelDepthOffsetCursorLocation, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelSpliceCursorLocation, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelAgeDepthCursorLocation, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelSpliceToAgeCursorLocation, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelTie1ID, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelTie2ID, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelTie1var, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelTie2var, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelTie1sbd, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelTie2sbd, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelSpliceTie1ID, XmNborderColor, bgPixel, NULL); 
  XtVaSetValues(labelSpliceTie2ID, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelSpliceTie1var, XmNborderColor, bgPixel, NULL); 
  XtVaSetValues(labelSpliceTie2var, XmNborderColor, bgPixel, NULL); 
  XtVaSetValues(labelSpliceTie1sbd, XmNborderColor, bgPixel, NULL); 
  XtVaSetValues(labelSpliceTie2sbd, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelSpliceDifferenceInValue, XmNborderColor, bgPixel, NULL);


  /* set the row-column and label background color to drawing area color
  */
  XtVaSetValues(rowColumnColorCompositeAndSplice, XmNbackground, bgPixel, NULL);
  XtVaSetValues(rowColumnColorCorrelation, XmNbackground, bgPixel, NULL);
  XtVaSetValues(rowColumnColorDepthOffset, XmNbackground, bgPixel, NULL);
  XtVaSetValues(rowColumnColorDrawingAreas, XmNbackground, bgPixel, NULL);
  XtVaSetValues(rowColumnColorAgeDepth, XmNbackground, bgPixel, NULL);
  XtVaSetValues(rowColumnColorSpliceToAge, XmNbackground, bgPixel, NULL);
 
  XtVaSetValues(labelDrawingAreaColorBG, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelDrawingAreaColorLabels, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorCoreRelated, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorCorembsf, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorCoremcd, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorSmooth, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorSplice, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorSpliceLocation, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorTieRelated, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorTiePtFixed, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorTiePtShift, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorTieLine, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorOverlayInCorr, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorOverlayOutCorr, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorStrat, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorPaleomag, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDiatom, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorRad, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorForam, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorNanno, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorCorrCoef, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorBestCorr, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetLine, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole1, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole2, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole3, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole4, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole5, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole6, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole7, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole8, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole9, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole10, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDepthOffsetHole11, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorAgeDepthHandPick, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorAgeDepthLine, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorSedRate, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorTimeSeries, XmNbackground, bgPixel, NULL);
  XtVaSetValues(labelColorDatumLocation, XmNbackground, bgPixel, NULL);

  /* if no foreground and or background color were read on command line args
     set the colors for hsplicer foreground and background to the drawing
     args background and labels 
  */
  if(prgfg == NO || prgbg == NO) {
    (void)sprintf(prgfgcolor, "");
    (void)sprintf(prgfgcolor, color[LABEL_COLOR]);
    (void)sprintf(prgbgcolor, "");
    (void)sprintf(prgbgcolor, color[BG_COLOR]);
  }

  /* set all the foreground colors
  */

  /* the labels for all four drawing areas
  */
  if(!XAllocNamedColor(dpy, cmap, color[LABEL_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[LABEL_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[LABEL_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonDrawingAreaColorLabels, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[LABEL_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[LABEL_COLOR]);
    XtVaSetValues(pushButtonDrawingAreaColorLabels, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonDrawingAreaColorLabels, XmNbackground, fgPixel[LABEL_COLOR], NULL);
 
  /* set the row-column label foreground colors to the label color
  */
  XtVaSetValues(labelDrawingAreaColorBG, XmNforeground, fgPixel[LABEL_COLOR], NULL); 
  XtVaSetValues(labelDrawingAreaColorLabels, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorCoreRelated, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorCorembsf, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorCoremcd, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorSmooth, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorSplice, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorSpliceLocation, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorTieRelated, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorTiePtFixed, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorTiePtShift, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorTieLine, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorOverlayInCorr, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorOverlayOutCorr, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorStrat, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorPaleomag, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDiatom, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorRad, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorForam, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorNanno, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorCorrCoef, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorBestCorr, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetLine, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole1, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole2, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole3, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole4, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole5, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole6, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole7, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole8, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole9, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole10, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDepthOffsetHole11, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorAgeDepthHandPick, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorAgeDepthLine, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorSedRate, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorTimeSeries, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  XtVaSetValues(labelColorDatumLocation, XmNforeground, fgPixel[LABEL_COLOR], NULL);
 
  /* the original unadjusted ODP sb depth 
  */
  if(!XAllocNamedColor(dpy, cmap, color[MBSF_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[MBSF_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[MBSF_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorCorembsf, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[MBSF_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[MBSF_COLOR]);
    XtVaSetValues(pushButtonColorCorembsf, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCorembsf, XmNbackground, fgPixel[MBSF_COLOR], NULL);

  /* the smoothed data
  */
  if(!XAllocNamedColor(dpy, cmap, color[SMOOTH_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[SMOOTH_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[SMOOTH_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorSmooth, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[SMOOTH_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[SMOOTH_COLOR]); 
    XtVaSetValues(pushButtonColorSmooth, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorSmooth, XmNbackground, fgPixel[SMOOTH_COLOR], NULL);

  /* composite and splice tie lines
  */
  if(!XAllocNamedColor(dpy, cmap, color[TIELINE_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[TIELINE_COLOR]); 
    SpManageWarningBox(buffer);
    fgPixel[TIELINE_COLOR] = pixwhite; 
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorTieLine, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[TIELINE_COLOR] = return_color.pixel; 
    xmstring = XmStringCreateSimple(color[TIELINE_COLOR]); 
    XtVaSetValues(pushButtonColorTieLine, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTieLine, XmNbackground, fgPixel[TIELINE_COLOR], NULL);
  
  /* the middle button tie point 1 (fixed; it stays put)
     let this convention hold for splice as well
  */
  if(!XAllocNamedColor(dpy, cmap, color[TIEPTFIXED_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[TIEPTFIXED_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[TIEPTFIXED_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorTiePtFixed, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[TIEPTFIXED_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[TIEPTFIXED_COLOR]); 
    XtVaSetValues(pushButtonColorTiePtFixed, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTiePtFixed, XmNbackground, fgPixel[TIEPTFIXED_COLOR], NULL);

  /* the right button tie point 2 (shift; it moves)
     let this convention hold for splice as well
  */
  if(!XAllocNamedColor(dpy, cmap, color[TIEPTSHIFT_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[TIEPTSHIFT_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[TIEPTSHIFT_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorTiePtShift, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[TIEPTSHIFT_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[TIEPTSHIFT_COLOR]); 
    XtVaSetValues(pushButtonColorTiePtShift, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTiePtShift, XmNbackground, fgPixel[TIEPTSHIFT_COLOR], NULL);
  
  /* the composite and splice core overlays 
  */
  /* part of core used in correlation
  */
  if(!XAllocNamedColor(dpy, cmap, color[OVERLAYINCORR_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[OVERLAYINCORR_COLOR]); 
    SpManageWarningBox(buffer);
    fgPixel[OVERLAYINCORR_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorOverlayInCorr, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[OVERLAYINCORR_COLOR] = return_color.pixel; 
    xmstring = XmStringCreateSimple(color[OVERLAYINCORR_COLOR]); 
    XtVaSetValues(pushButtonColorOverlayInCorr, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorOverlayInCorr, XmNbackground, fgPixel[OVERLAYINCORR_COLOR], NULL);
  /* part of core not used in correlation
  */
  if(!XAllocNamedColor(dpy, cmap, color[OVERLAYOUTCORR_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[OVERLAYOUTCORR_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[OVERLAYOUTCORR_COLOR]  = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorOverlayOutCorr, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[OVERLAYOUTCORR_COLOR]  = return_color.pixel;
    xmstring = XmStringCreateSimple(color[OVERLAYOUTCORR_COLOR]); 
    XtVaSetValues(pushButtonColorOverlayOutCorr, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorOverlayOutCorr, XmNbackground, fgPixel[OVERLAYOUTCORR_COLOR], NULL);

  /* the depth adjusted(shifted) core 
  */
  if(!XAllocNamedColor(dpy, cmap, color[MCD_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[MCD_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[MCD_COLOR]  = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorCoremcd, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[MCD_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[MCD_COLOR]); 
    XtVaSetValues(pushButtonColorCoremcd, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCoremcd, XmNbackground, fgPixel[MCD_COLOR], NULL);


  /* the splice composite 
  */
  if(!XAllocNamedColor(dpy, cmap, color[SPLICE_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[SPLICE_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[SPLICE_COLOR]  = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorSplice, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[SPLICE_COLOR]  = return_color.pixel;
    xmstring = XmStringCreateSimple(color[SPLICE_COLOR]); 
    XtVaSetValues(pushButtonColorSplice, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorSplice, XmNbackground, fgPixel[SPLICE_COLOR], NULL);

  /* the lines between spliced cores
  */
  if(!XAllocNamedColor(dpy, cmap, color[SPLICELOCATION_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[SPLICELOCATION_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[SPLICELOCATION_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorSpliceLocation, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[SPLICELOCATION_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[SPLICELOCATION_COLOR]); 
    XtVaSetValues(pushButtonColorSpliceLocation, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorSpliceLocation, XmNbackground, fgPixel[SPLICELOCATION_COLOR], NULL);

  /* the composite and splice correlation coef
  */
  if(!XAllocNamedColor(dpy, cmap, color[CORRCOEF_COLOR], &return_color, &unused)) {  
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CORRCOEF_COLOR]); 
    SpManageWarningBox(buffer);
    fgPixel[CORRCOEF_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorCorrCoef, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CORRCOEF_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CORRCOEF_COLOR]); 
    XtVaSetValues(pushButtonColorCorrCoef, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCorrCoef, XmNbackground, fgPixel[CORRCOEF_COLOR], NULL);

  /* the line on axis indicating location of best corr. coef.
  */
  if(!XAllocNamedColor(dpy, cmap, color[BESTCORR_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[BESTCORR_COLOR]);   
    SpManageWarningBox(buffer);
    fgPixel[BESTCORR_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorBestCorr, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }  
  else { 
    fgPixel[BESTCORR_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[BESTCORR_COLOR]); 
    XtVaSetValues(pushButtonColorBestCorr, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  } 
  XtVaSetValues(pushButtonColorBestCorr, XmNbackground, fgPixel[BESTCORR_COLOR], NULL);

  /* stratigraphy colors;
  */
  if(!XAllocNamedColor(dpy, cmap, color[PALEOMAG_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[PALEOMAG_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[PALEOMAG_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorPaleomag, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[PALEOMAG_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[PALEOMAG_COLOR]); 
    XtVaSetValues(pushButtonColorPaleomag, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorPaleomag, XmNbackground, fgPixel[PALEOMAG_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DIATOM_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color %s.",  color[DIATOM_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DIATOM_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorDiatom, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[DIATOM_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DIATOM_COLOR]); 
    XtVaSetValues(pushButtonColorDiatom, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDiatom, XmNbackground, fgPixel[DIATOM_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[RAD_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[RAD_COLOR]); 
    SpManageWarningBox(buffer);
    fgPixel[RAD_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorRad, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[RAD_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[RAD_COLOR]); 
    XtVaSetValues(pushButtonColorRad, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorRad, XmNbackground, fgPixel[RAD_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[FORAM_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[FORAM_COLOR]); 
    SpManageWarningBox(buffer);
    fgPixel[FORAM_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorForam, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[FORAM_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[FORAM_COLOR]); 
    XtVaSetValues(pushButtonColorForam, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorForam, XmNbackground, fgPixel[FORAM_COLOR], NULL);
  
  if(!XAllocNamedColor(dpy, cmap, color[NANNO_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[NANNO_COLOR]); 
    SpManageWarningBox(buffer);
    fgPixel[NANNO_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorNanno, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[NANNO_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[NANNO_COLOR]); 
    XtVaSetValues(pushButtonColorNanno, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorNanno, XmNbackground, fgPixel[NANNO_COLOR], NULL);

  /* view depth offset colors
  */
  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFLINE_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFLINE_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFLINE_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorDepthOffsetLine, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[DEPOFFLINE_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFLINE_COLOR]); 
    XtVaSetValues(pushButtonColorDepthOffsetLine, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetLine, XmNbackground, fgPixel[DEPOFFLINE_COLOR], NULL);
  
  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE1_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE1_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFHOLE1_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorDepthOffsetHole1, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[DEPOFFHOLE1_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE1_COLOR]); 
    XtVaSetValues(pushButtonColorDepthOffsetHole1, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole1, XmNbackground, fgPixel[DEPOFFHOLE1_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE2_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE2_COLOR]); 
    SpManageWarningBox(buffer); 
    fgPixel[DEPOFFHOLE2_COLOR] = pixwhite; 
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole2, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {  
    fgPixel[DEPOFFHOLE2_COLOR] = return_color.pixel; 
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE2_COLOR]);  
    XtVaSetValues(pushButtonColorDepthOffsetHole2, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole2, XmNbackground, fgPixel[DEPOFFHOLE2_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE3_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE3_COLOR]); 
    SpManageWarningBox(buffer); 
    fgPixel[DEPOFFHOLE3_COLOR] = pixwhite; 
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole3, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {  
    fgPixel[DEPOFFHOLE3_COLOR] = return_color.pixel; 
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE3_COLOR]);  
    XtVaSetValues(pushButtonColorDepthOffsetHole3, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole3, XmNbackground, fgPixel[DEPOFFHOLE3_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE4_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE4_COLOR]); 
    SpManageWarningBox(buffer); 
    fgPixel[DEPOFFHOLE4_COLOR] = pixwhite; 
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole4, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {  
    fgPixel[DEPOFFHOLE4_COLOR] = return_color.pixel; 
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE4_COLOR]);  
    XtVaSetValues(pushButtonColorDepthOffsetHole4, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole4, XmNbackground, fgPixel[DEPOFFHOLE4_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE5_COLOR], &return_color, &unused)) { 
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE5_COLOR]); 
    SpManageWarningBox(buffer); 
    fgPixel[DEPOFFHOLE5_COLOR] = pixwhite; 
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole5, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else {  
    fgPixel[DEPOFFHOLE5_COLOR] = return_color.pixel; 
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE5_COLOR]);  
    XtVaSetValues(pushButtonColorDepthOffsetHole5, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole5, XmNbackground, fgPixel[DEPOFFHOLE5_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE6_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE6_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFHOLE6_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole6, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[DEPOFFHOLE6_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE6_COLOR]);  
    XtVaSetValues(pushButtonColorDepthOffsetHole6, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole6, XmNbackground, fgPixel[DEPOFFHOLE6_COLOR], NULL);
 
  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE7_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE7_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFHOLE7_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole7, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[DEPOFFHOLE7_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE7_COLOR]);  
    XtVaSetValues(pushButtonColorDepthOffsetHole7, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole7, XmNbackground, fgPixel[DEPOFFHOLE7_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE8_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE8_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFHOLE8_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole8, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[DEPOFFHOLE8_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE8_COLOR]);  
    XtVaSetValues(pushButtonColorDepthOffsetHole8, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole8, XmNbackground, fgPixel[DEPOFFHOLE8_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE9_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE9_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFHOLE9_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole9, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[DEPOFFHOLE9_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE9_COLOR]);   
    XtVaSetValues(pushButtonColorDepthOffsetHole9, XmNlabelString, xmstring, NULL);   
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole9, XmNbackground, fgPixel[DEPOFFHOLE9_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE10_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE10_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFHOLE10_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole10, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[DEPOFFHOLE10_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE10_COLOR]);   
    XtVaSetValues(pushButtonColorDepthOffsetHole10, XmNlabelString, xmstring, NULL);   
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole10, XmNbackground, fgPixel[DEPOFFHOLE10_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DEPOFFHOLE11_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DEPOFFHOLE11_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DEPOFFHOLE11_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorDepthOffsetHole11, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[DEPOFFHOLE11_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DEPOFFHOLE11_COLOR]);   
    XtVaSetValues(pushButtonColorDepthOffsetHole11, XmNlabelString, xmstring, NULL);   
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDepthOffsetHole11, XmNbackground, fgPixel[DEPOFFHOLE11_COLOR], NULL);

  /* colors for the age depth
  */
  if(!XAllocNamedColor(dpy, cmap, color[AGEDEPHANDPICK_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[AGEDEPHANDPICK_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[AGEDEPHANDPICK_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorAgeDepthHandPick, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[AGEDEPHANDPICK_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[AGEDEPHANDPICK_COLOR]);
    XtVaSetValues(pushButtonColorAgeDepthHandPick, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorAgeDepthHandPick, XmNbackground, fgPixel[AGEDEPHANDPICK_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[AGEDEPLINE_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[AGEDEPLINE_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[AGEDEPLINE_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorAgeDepthLine, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[AGEDEPLINE_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[AGEDEPLINE_COLOR]);
    XtVaSetValues(pushButtonColorAgeDepthLine, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorAgeDepthLine, XmNbackground, fgPixel[AGEDEPLINE_COLOR], NULL);

  /* set the colors for splice vs age
  */
  if(!XAllocNamedColor(dpy, cmap, color[SEDRATE_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[SEDRATE_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[SEDRATE_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorSedRate, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[SEDRATE_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[SEDRATE_COLOR]);
    XtVaSetValues(pushButtonColorSedRate, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorSedRate, XmNbackground, fgPixel[SEDRATE_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[TIMESERIES_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[TIMESERIES_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[TIMESERIES_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorTimeSeries, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[TIMESERIES_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[TIMESERIES_COLOR]);
    XtVaSetValues(pushButtonColorTimeSeries, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTimeSeries, XmNbackground, fgPixel[TIMESERIES_COLOR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[DATUMLOC_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[DATUMLOC_COLOR]);
    SpManageWarningBox(buffer);
    fgPixel[DATUMLOC_COLOR] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorDatumLocation, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[DATUMLOC_COLOR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[DATUMLOC_COLOR]);
    XtVaSetValues(pushButtonColorDatumLocation, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorDatumLocation, XmNbackground, fgPixel[DATUMLOC_COLOR], NULL);
}


int FindAveDepth(holenum, corenum, pavedt)
int holenum, corenum;
float *pavedt;
{
  int i, n, err, dum;
  float sbd[MAXPERCORE], dat[MAXPERCORE];

  /* calculate the average depth step for current
     'tied' cores.
     note that cum depth offset is irrelevant
     and whether using smooth or not unimportant
  */
  *pavedt = 0.0;
  n = 0;
  if(data[dset]->holes[holenum]->core[corenum]->numvalues > 1){

    /* clean core of bad values
    */
    dum = 0;
    err = CleanUpCore(dset, holenum, corenum, &n, sbd, dat, NO, &dum);

    if(n > 1) { 
      for(i=0; i<n-1; ++i){
        *pavedt = *pavedt + sbd[i+1] - sbd[i];
      }
      *pavedt = *pavedt/n;
    }   
    else {
      (void)sprintf(buffer, "Warning; can not calculate average depth in hole %c core %d. using 0.05m.",
                              data[dset]->holes[holenum]->name, data[dset]->holes[holenum]->core[corenum]->num);
      SpManageWarningBox(buffer);
      *pavedt = 0.05;
      return 1;
    }
  }
  else { 
    (void)sprintf(buffer, "Warning; hole %c core %d has less than 2 points!", 
                            data[dset]->holes[holenum]->name, data[dset]->holes[holenum]->core[corenum]->num);
    SpManageWarningBox(buffer);
    return 2;
  }

  return 0;
}


/* correlation function. note that in this function
   x is core 1 and y is core 2 
*/
int Correlate(nx,ny,offx,offy,x,y,pcoef,pn)
int nx, ny, offx, offy, *pn;
float x[MAXPERCORE], y[MAXPERCORE], *pcoef;
{
  int j;
  float sumx, sumy, sumxy, sumxsq, sumysq, stdevx, stdevy;
 
 
  *pn=0;
  sumx=0.0;
  sumy=0.0;
  sumxy=0.0;
  sumxsq=0.0;
  sumysq=0.0;
 
  /* sum up  
  */
  for(j=0; j<ny; ++j){
    if(j+offx+offy < 0 || j+offx+offy >= nx){
    }
    else if(x[j+offx+offy] == -9999.0 || y[j+offy] == -9999.0){
    }
    else {
      ++*pn;
      sumx=sumx+x[j+offx+offy];
      sumy=sumy+y[j+offy];
      sumxy=sumxy+x[j+offx+offy]*y[j+offy];
      sumxsq=sumxsq+x[j+offx+offy]*x[j+offx+offy];
      sumysq=sumysq+y[j+offy]*y[j+offy];
    }
  }

  /* calculate the standard deviation and
     the correlation coeficiant
  */
  if(*pn > 1){
    stdevx=((*pn)*sumxsq)-(sumx*sumx);
    stdevy=((*pn)*sumysq)-(sumy*sumy);
    if(stdevx <= 0 || stdevy <= 0){
      *pcoef=0.0;
      *pn=0;
    }
    else {
      stdevx=sqrt(stdevx);
      stdevy=sqrt(stdevy);
      *pcoef=(((*pn)*sumxy)-(sumx*sumy))/(stdevx*stdevy);
    }
  }
  else {
    *pcoef=0.0;
    *pn=0;
  }
  return 0;
}


/* repick depth at constant depth step
*/
int RepickDepth(pdep,pvar,pn,ptie,dt)
int *pn, *ptie;
float *pdep, *pvar, dt;
{
  int i, n, k, kt, lastk, lastn;
  float dep[MAXPERCORE], var[MAXPERCORE];

  /* repick from tie point backwards to first sample
  */
  n=(pdep[*ptie]-pdep[0])/dt+1;
  if(n > MAXPERCORE){
    return 1;
  }
  dep[n-1]=pdep[*ptie];
  for(i=n-2; i>=0;--i){
    dep[i]=dep[i+1]-dt;
  }
  k=*ptie;
  kt=n-1;
  while(kt >= 0){
    if((k-1) < 0 && dep[kt] <= pdep[0]){
      var[kt]=(pvar[1]-pvar[0])/
                (pdep[1]-pdep[0])*
                (dep[kt]-pdep[0])+pvar[0];
      --kt;
    }
    else if(dep[kt] <= pdep[k] && 
            dep[kt] >= pdep[k-1]){
      var[kt]=(pvar[k]-pvar[k-1])/
                (pdep[k]-pdep[k-1])*
                (dep[kt]-pdep[k-1])+pvar[k-1];
      --kt;
    }
    else if(dep[kt] < pdep[k] && (k-1) > 0){
      --k;
    }
    else if(dep[kt] < pdep[0]){
      var[kt]=(pvar[1]-pvar[0])/
                (pdep[1]-pdep[0])*
                (dep[kt]-pdep[0])+pvar[0];
      --kt;
    }
  }

  /* repick from tie point to last sample
  */
  lastk=*pn-1;
  lastn=(pdep[lastk]-pdep[*ptie])/dt+n;
  if(lastn > MAXPERCORE){   
    return 1;
  } 
  for(i=n;i<lastn;++i){
    dep[i]=dep[i-1]+dt;
  } 
  k=*ptie;
  kt=n;
  while(kt < lastn){ 
    if(k > lastk && dep[kt] >= pdep[lastk]){
      var[kt]=(pvar[lastk]-pvar[lastk-1])/
         (pdep[lastk]-pdep[lastk-1])*
         (dep[kt]-pdep[lastk])+pvar[lastk];
      ++kt;
    }
    else if(dep[kt] >= pdep[k-1] &&
            dep[kt] <= pdep[k]){
      var[kt]=(pvar[k]-pvar[k-1])/
                (pdep[k]-pdep[k-1])*
                (dep[kt]-pdep[k-1])+pvar[k-1];
      ++kt;
    } 
    else if(dep[kt] > pdep[k] && (k+1) <= lastk){
      ++k;
    }    
    else if(dep[kt] > pdep[lastk]){
      var[kt]=(pvar[lastk]-pvar[lastk-1])/
         (pdep[lastk]-pdep[lastk-1])*
         (dep[kt]-pdep[lastk])+pvar[lastk];
      ++kt;
    }
  }
  *ptie=n-1;
  *pn=lastn;
  for(i=0; i<lastn; ++i){
    pdep[i]=dep[i];
    pvar[i]=var[i];
  }

  /* check that have no duplicate depths
  */
  for(i=1; i<lastn; ++i){
    if(dep[i-1] == dep[i]){
      (void)sprintf(buffer, "Repick; depths not in descending order at %.2f", dep[i]); 
      SpManageWarningBox(buffer);
    }
    else if(dep[i-1] > dep[i]){
      (void)sprintf(buffer, "Repicking depth; depths not in descending order at %.2f", dep[i]);  
      SpManageWarningBox(buffer);
    }
  }

  return 0;
}


/* find min and max of current var for entire site.
   convert these to nearest reasonable whole numbers.
   and change them to +/- (PLUSMINUSSTD std from mean.
   use this range to calculate the initial drawing
   scale to use.
   this would be (max-min)/VAR_AXIS_LEN
   also find the maximum depth; minimum always 0.
*/
int FindMinMax(ds)
int ds;
{
  int i, j, k, sm, err, dum, coren, nstd;
  float *phold, coredep[MAXPERCORE], corevar[MAXPERCORE];
  double std, mean, sumstd, summean;

  if(data[ds]->numholes < 1) {
    return(0);
  }

  if(smooth.method == NONE) {
    sm = NO;
  }
  else if((smooth.method == GAUSSIAN || smooth.method == OTHER) &&
          (smooth.plot == UNSMOOTHED || smooth.plot == SMOOTHEDBOTH)){ 
    sm = NO;
  }  
  else if((smooth.method == GAUSSIAN || smooth.method == OTHER) &&
           smooth.plot == SMOOTHED){
    sm = YES;
  }

  minvar = 9999.0;
  maxvar = -9999.0;
  maxdep = -9999.0;
  summean = 0.0;
  mean = 0.0;
  sumstd = 0.0;
  std = 0.0;
  nstd = 0;

  for(i=0; i<data[ds]->numholes; ++i) {
    if(data[ds]->holes[i]->numcores < 1) {
    }
    else {
      for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
        if(data[ds]->holes[i]->core[j]->numvalues < 1) {
        }
        else {
          for(k=0; k<data[ds]->holes[i]->core[j]->numvalues; ++k) {

            if(sm == NO &&
               (data[ds]->holes[i]->core[j]->value[k]->quality) == GOOD){
              phold = data[ds]->holes[i]->core[j]->value[k]->data;
              if(*phold > maxvar) {
                maxvar = *phold;
              }  
              else if(*phold < minvar) {
                minvar = *phold;
              }
            }
            else if(sm == YES &&
                    data[ds]->holes[i]->core[j]->value[k]->smooth_ok >= SMOK){
              if(data[ds]->holes[i]->core[j]->value[k]->sm_data > maxvar) {
                maxvar = data[ds]->holes[i]->core[j]->value[k]->sm_data;  
              }  
              else if(data[ds]->holes[i]->core[j]->value[k]->sm_data < minvar) { 
                minvar = data[ds]->holes[i]->core[j]->value[k]->sm_data;
              }
            }
            else {
            }
          }

          dum = 0;
          err = CleanUpCore(ds, i, j, &coren, coredep, corevar, NO, &dum);
          err = StdDev(corevar, coren, 0, coren, &std, &mean);
          sumstd = sumstd + std;
          summean = summean + mean;
          ++nstd;
        }
      }  
    }  
    j = data[ds]->holes[i]->numcores - 1;
    k = data[ds]->holes[i]->core[j]->numvalues - 1;
    if(data[ds]->holes[i]->core[j]->value[k]->sb_depth > maxdep){
      maxdep = data[ds]->holes[i]->core[j]->value[k]->sb_depth;
    }
  }

  if(minvar == 9999.0 || maxvar == -9999.0) {
    return 1;
  }
  else {
    realminvar = minvar;
    realmaxvar = maxvar;

    if(nstd > 0 && err == 0) {
      std = sumstd/nstd;
      mean = summean/nstd;
      minvar = mean - (PLUSMINUSSTD * std);
      maxvar = mean + (PLUSMINUSSTD * std);
    }
    else {
      return 1;
    }
  }

  return 0;
}

/* clean up one cores depth and var
   for either plotting or correlation.
   find and average mult samples per level,
   remove bad values,
   chack that samples in desending order,
   Add the cummulative depth offset to sbd.
   (future) deal with gaps in data.
*/
int CleanUpCore(s, hnum, cnum, pn, psbd, pdata, sm, pt)
int s, hnum, cnum, *pn, sm, *pt;
float *pdata, *psbd;
{
  int j, k, n, ndiv, tie;
  float sum, savetiedep;

  /*look for and trash any bad data by not storing
    them in the pointers pdata and psbd
    if have sent a core for  correlation and remove
    a sample, change the tie(if needed).
  */
    
  n = 0;
  tie = *pt;
  for(j=0; j<data[s]->holes[hnum]->core[cnum]->numvalues; ++j) {
    if(sm == NO && data[s]->holes[hnum]->core[cnum]->value[j]->quality == GOOD){
      pdata[n] = *data[s]->holes[hnum]->core[cnum]->value[j]->data;
      psbd[n] = data[s]->holes[hnum]->core[cnum]->value[j]->sb_depth;
      ++n;
    }
    else if(sm == YES && data[s]->holes[hnum]->core[cnum]->value[j]->smooth_ok >= SMOK){
      pdata[n] = data[s]->holes[hnum]->core[cnum]->value[j]->sm_data;
      psbd[n] = data[s]->holes[hnum]->core[cnum]->value[j]->sb_depth;
      ++n;
    }
    else if(tie > 0 && n < tie){
      --tie;
    }
  }
  *pn = n;

  /* check that there are at least two data points in
     this core
  */
  if(n < 2) {
    return 1;
  }

  /* check that data is in order
  */
  for(j=1; j<n; ++j) {
    if(psbd[j] < psbd[j-1]) {
      return 2;
    }
  }

  /* look for mult samples per level and average any found
     can now use the pointers pdata and psbd rather than
     the global structs
     the var will either be unsmoothed or smoothed
     depending on value of sm = NO/YES.
     if are correlating and find mult samples, adjust
     tie(if needed)
  */
  sum = pdata[0];
  ndiv = 1;
  savetiedep = psbd[tie];
  k = 0;
  for(j=1; j<n; ++j){
    if(psbd[j] == psbd[j-1] &&
                   j < n-1){
      sum = sum + pdata[j];
      ++ndiv;
    }
    else if(psbd[j] == psbd[j-1] && j == n-1){
      sum = sum + pdata[j];
      ++ndiv;
      psbd[k] = psbd[j-1];
      pdata[k] =  sum/ndiv;
      ++k;
      --tie;
    }  
    else if(psbd[j] != psbd[j-1] && j < n-1){
      psbd[k] = psbd[j-1];
      pdata[k] = sum/ndiv;
      sum = pdata[j];
      ndiv=1;
      ++k;
    }  
    else if(psbd[j] != psbd[j-1] && j == n-1){
      psbd[k] = psbd[j-1];
      pdata[k] = sum/ndiv;
      ++k;
      psbd[k] = psbd[j];
      pdata[k] = pdata[j];
      ++k;
    }  
    else {
    }  
  }
  *pn = k;
  *pt = tie;

  for(j=0; j<k; ++j) {
    if(fabs(savetiedep - psbd[j]) < 0.0001) {
      tie = j;
    }
  }
  *pt = tie;

  /* check again that there are at least two data points in
     this core
  */
  if(k < 2) {
    return 1;
  }
  

  /* check if somehow screwed up the tie. HOW?
     but how do i know if i have tie 1 or 2?
        pdata[tie] should = textTie?sbd
  */

  /*add the cummulative depth offset to the sbd.
    note that the temp shift(overlay) offset will
    be done in the drawing functions
  */ 
  n = *pn;
  for(j=0; j<n; ++j) {
    psbd[j] = psbd[j] + data[s]->holes[hnum]->core[cnum]->cum_dep_offset;
  }

  /*check to see if there are any 'user defined' gaps in 
    this core.
    then do what??  code them somehow??
  */

  return 0;
}


/* clean up core being added to splice composite
   by; 
   finding and averaging mult samples per level,
   remove bad values,
   chack that samples in desending order,
   Add the Depthoffset to sbd.
   (future) deal with gaps in data.
*/
int CleanUpSpliceCore(hnum, cnum, pn, psbd, pdata, sm, spcornum, spstart, pmap)
int hnum, cnum, *pn, sm, spcornum, spstart, *pmap;
float *pdata, *psbd;
{
  int j, k, n, ndiv;
  float sum;

  /*look for and trash any bad data by not storing
    them in the pointers pdata and psbd
    start at the tie array location
  */
  n = 0;
  for(j=spstart; j<data[dset]->holes[hnum]->core[cnum]->numvalues; ++j) {
    if(sm == NO && data[dset]->holes[hnum]->core[cnum]->value[j]->quality == GOOD){
      pdata[n] = *data[dset]->holes[hnum]->core[cnum]->value[j]->data;
      pmap[n] = j;
      psbd[n] = data[dset]->holes[hnum]->core[cnum]->value[j]->sb_depth;
      ++n;
    }  
    else if(sm == YES && data[dset]->holes[hnum]->core[cnum]->value[j]->smooth_ok >= SMOK){
      pdata[n] = data[dset]->holes[hnum]->core[cnum]->value[j]->sm_data;
      pmap[n] = j;
      psbd[n] = data[dset]->holes[hnum]->core[cnum]->value[j]->sb_depth;
      ++n;
    }
  }
  *pn = n;
 
  /* check that there are at least two data points in
     this core
  */
  if(n < 2) {
    return 1;
  }
  /* check that data is in order
  */
  for(j=1; j<n; ++j) {
    if(psbd[j] < psbd[j-1]) {
      return 1;
    }
  }
 
  /* look for mult samples per level and average any found
     can now use the pointers pdata and psbd rather than
     the global structs
     the var will either be unsmoothed or smoothed
     depending on value of sm = NO/YES.
  */
  sum = pdata[0];
  ndiv = 1;
  k = 0;
  for(j=1; j<n; ++j){
    if(psbd[j] == psbd[j-1] && j < n-1){
      sum = sum + pdata[j];
      ++ndiv;
    }
    else if(psbd[j] == psbd[j-1] && j == n-1){
      sum = sum + pdata[j];
      ++ndiv;
      pmap[k] = pmap[j-1];
      psbd[k] = psbd[j-1];
      pdata[k] =  sum/ndiv;
      ++k;
    }
    else if(psbd[j] != psbd[j-1] && j < n-1){
      pmap[k] = pmap[j-1];
      psbd[k] = psbd[j-1];
      pdata[k] = sum/ndiv;
      sum = pdata[j];
      ndiv=1;
      ++k;
    }
    else if(psbd[j] != psbd[j-1] && j == n-1){
      pmap[k] = pmap[j-1];
      psbd[k] = psbd[j-1];
      pdata[k] = sum/ndiv;
      ++k;
      pmap[k] = pmap[j];
      psbd[k] = psbd[j];
      pdata[k] = pdata[j];
      ++k;
    }
    else {
    }
  }
  *pn = k;

  /* check again that there are at least two data points in
     this core
  */
  if(k < 2) {
    return 1;
  }
 
  /*add the splice depth offset to the sbd.
  */
  n = *pn;
  for(j=0; j<n; ++j) {
    psbd[j] = psbd[j] + spcomp.Depthoffset[spcornum];
  }
 
  return 0;
}

/*how=1;  the lock toggle has been activated.
          if it is on use the scale value of View slider
          and change Edit silder and redraw Edit.
  how=2;  the Edit slider has been changed. if the lock
          toggle is on get the Edit slider scale value
          and change the View slider scale value to Edit
          and redraw View
  how=3;  the View slider has been changed. if the lock
          toggle is on get the View slider scale value
          and change the Edit slider scale value to View
          and redraw Edit
*/
void DisplaySliderControl(how)
int how;
{
  int scale_edit, scale_view;

  /* if the scale lock option is on
  */
  if(XmToggleButtonGetState(toggleButtonLockSlider) == True) {

    XmScaleGetValue(drawingAreaViewScale, &scale_view);
    XmScaleGetValue(drawingAreaEditScale, &scale_edit);

    /* if the top values of the two scales differ
    */
    if(scale_view != scale_edit) {

      reason_for_redraw = DRAW_EVERYTHING;
 
      /* lock toggle hit; 
         make the top value of edit scale equal to view scale
      */
      if(how == 1){
        XtVaSetValues(drawingAreaEditScale, XmNvalue, scale_view, NULL);
        DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
      }

      /* edit scale has been changed or dragged; 
         make the top value of view scale equal to edit scale
      */
      else if(how == 2){
        XtVaSetValues(drawingAreaViewScale, XmNvalue, scale_edit, NULL);
        DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
      }

      /* view scale has been changed or dragged;  
         make the top value of edit scale equal to view scale 
      */
      else if(how == 3){
        XtVaSetValues(drawingAreaEditScale, XmNvalue, scale_view, NULL);
        DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
      }
    }
  }  
}

int FindValueInCoreToSplice(ds, sm, depth, hole, core, parr, phow, pval, psmval)
int ds, hole, core, *parr, *phow, sm;
float depth, *pval, *psmval;
{
  int i, j;
  float *pval1, *pval2, val1, val2, dep1,dep2;

  /* search for a sample in core to splice at the same depth as splice tie.
     if none is found, interpolate a value at splice tie depth
  */
  *parr = -1;
  for(i=0; i<data[ds]->holes[hole]->core[core]->numvalues; ++i) {
    if(data[ds]->holes[hole]->core[core]->value[i]->quality != GOOD){
    }
    else if(fabs(data[ds]->holes[hole]->core[core]->value[i]->sb_depth +
         data[ds]->holes[hole]->core[core]->cum_dep_offset - depth) < ROUNDCHECK) {
      *parr = i;
      *phow = REAL;
      pval1 = data[ds]->holes[hole]->core[core]->value[i]->data;
      val1 = *pval1;
      *pval = val1;
      if(sm == YES && data[ds]->holes[hole]->core[core]->value[i]->smooth_ok >= SMOK) {
        *psmval = data[ds]->holes[hole]->core[core]->value[i]->sm_data;
      }
      else {
        *psmval = *pval;
      }
      return 0;
    }
  }
  if(*parr == -1 && data[ds]->holes[hole]->core[core]->numvalues >= 2) {
    i = 0;
    j = 1;
    while(j < data[ds]->holes[hole]->core[core]->numvalues) {
      if(data[ds]->holes[hole]->core[core]->value[i]->quality != GOOD) { 
        ++i;
        if(i == j) {
          ++j;
        }
      }
      else if(data[ds]->holes[hole]->core[core]->value[j]->quality != GOOD) { 
        ++j;
      }
      else if(data[ds]->holes[hole]->core[core]->value[i]->sb_depth + 
         data[ds]->holes[hole]->core[core]->cum_dep_offset < depth    &&
         data[ds]->holes[hole]->core[core]->value[j]->sb_depth + 
         data[ds]->holes[hole]->core[core]->cum_dep_offset > depth) {
        *parr = j;
        *phow = INTERPOLATED;
        dep1 = data[ds]->holes[hole]->core[core]->value[i]->sb_depth +
               data[ds]->holes[hole]->core[core]->cum_dep_offset;
        dep2 = data[ds]->holes[hole]->core[core]->value[j]->sb_depth +
               data[ds]->holes[hole]->core[core]->cum_dep_offset;
        pval1 = data[ds]->holes[hole]->core[core]->value[i]->data;
        pval2 = data[ds]->holes[hole]->core[core]->value[j]->data;
        val1 = *pval1;
        val2 = *pval2;
        *pval = val1 + (val2 - val1) * (depth - dep1)/(dep2 - dep1);
        if(sm == YES && 
           data[ds]->holes[hole]->core[core]->value[i]->smooth_ok >= SMOK &&
           data[ds]->holes[hole]->core[core]->value[j]->smooth_ok >= SMOK) {
          val1 = data[ds]->holes[hole]->core[core]->value[i]->sm_data;
          val2 = data[ds]->holes[hole]->core[core]->value[j]->sm_data;
          *psmval = val1 + (val2 - val1) * (depth - dep1)/(dep2 - dep1);
        }
        else {
          *psmval = *pval;
        }
        return 0;
      }
      else {
        ++i;
        ++j;
      }
    }
  }

  return 1;
}

int StdDev(x, n, off, win, stddev, xmean)
int n, off, win;
float *x;
double *stddev, *xmean;
{
  int i;
  float sum, sumsq, nx;

  if(win < 1 || off + win > n) {
    return 1;
  }

  sum = 0.0;
  sumsq = 0.0;
 
  nx = 0.0;
  for(i=off; i<off+win; ++i) {
    sum = sum + x[i];
    sumsq = sumsq + x[i] * x[i];
    ++nx;
  }

  *xmean = sum/nx;

  if(nx < 2.0) {
    return 1;
  }
  else {
    *stddev = (nx * sumsq - sum * sum)/(nx * (nx - 1));
    if(*stddev < 0.0) {
      *stddev = 0.0;
    }
    else {
      *stddev = sqrt(*stddev);
    }
  }

  return 0;
}

int SiteAveDepth()
{
  int i, j, n, err;
  float avedep, sumavedep;

  n = 0;
  sumavedep = 0.0;
  for(i=0; i<data[dset]->numholes; ++i) {
    if(data[dset]->holes[i]->numcores < 1) {
    }
    else {
      for(j=0; j<data[dset]->holes[i]->numcores; ++j) {
        if(data[dset]->holes[i]->core[j]->numvalues < 1) {
        }
        else {

          if(err = FindAveDepth(i, j, &avedep) == 0) {
            sumavedep = sumavedep + avedep;
            ++n;
          }
        }
      }
    }
  }
  if(n > 0 && sumavedep > 0.0) {
    avedep = sumavedep/n;
    average_depth_step = avedep * 100;
  }
  else {
    average_depth_step = AVEDEPTHSTEP;
    (void)sprintf(buffer,"Warning: could not calculate the average depth step for this data set.");
    SpManageWarningBox(buffer);
  }
}

void MakeClipMask(dpy, gc, x, y, width, height)
Display *dpy;
GC gc;
short int x, y;
unsigned short int width, height;
{
  Region r;
  XRectangle rect;

  r = XCreateRegion();

  rect.x = x;
  rect.y = y;
  rect.width = width;
  rect.height = height;

  XUnionRectWithRegion(&rect, r, r);

  XSetRegion(dpy, gc, r);

  XDestroyRegion(r);
}

void FindClipRegion(who, win_width, win_height, start_hole)
int who, start_hole;
Dimension win_width, win_height;
{

  int i, tie, err, n, sm, x1, x2, x3, y1, y2, y3, h1, h2, h3, w1, w2, w3, t1, t2, point_clip;
  float sbd[MAXPERCORE], dat[MAXPERCORE], min1, min2, max1, max2;

  point_clip = 2;

  if(smooth.method == NONE) {
    sm = NO;
  }
  else if((smooth.method == GAUSSIAN || smooth.method == OTHER) &&
          (smooth.plot == UNSMOOTHED)){
    sm = NO;
  }
  else if((smooth.method == GAUSSIAN || smooth.method == OTHER) &&
           (smooth.plot == SMOOTHED || smooth.plot == SMOOTHEDBOTH)){
    sm = YES;
  }
  else {
    sm = NO;
  }

  if(who == EDIT) {
  
    if(reason_for_redraw == DRAW_TIES) {
    
      if(have_tie1 == DO && have_tie2 == DONT) {
        tie = tie1arraynum;
        err = CleanUpCore(dset, tie1holenum, tie1corenum, &n, sbd, dat, sm, &tie);
        y1 = (sbd[tie] - top_meter_edit)/depperpix + top_off_edit;
        if(y1 < POINTSIZE) {
          y1 = POINTSIZE;
        }
        clip_y = y1 - POINTSIZE;
        clip_height = POINTSIZE * point_clip;
        x1 = (dat[tie] - minvar)/varperpix+
              OFF + SPACE + (tie1holenum - start_hole) * (varaxislen + SPACE);
        if(x1 < POINTSIZE) {
          x1 = POINTSIZE;
        }
        clip_x = x1 - POINTSIZE;
        clip_width = POINTSIZE * point_clip; 

      }
      else if(have_tie1 == DONT && have_tie2 == DO) {
        tie = tie2arraynum;
        err = CleanUpCore(dset, tie2holenum, tie2corenum, &n, sbd, dat, sm, &tie); 
        y2 = (sbd[tie] - top_meter_edit)/depperpix + top_off_edit;
        if(y2 < POINTSIZE) { 
          y2 = POINTSIZE; 
        } 
        clip_y = y2 - POINTSIZE;
        clip_height = POINTSIZE * point_clip;
        x2 = (dat[tie] - minvar)/varperpix+ 
              OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);  
        if(x2 < POINTSIZE) { 
          x2 = POINTSIZE; 
        }
        clip_x = x2 - POINTSIZE;   
        clip_width = POINTSIZE * point_clip;
      }
      else if(have_tie1 == DO && have_tie2 == DO) {

        sm = NO;
        tie = tie1arraynum;
        err = CleanUpCore(dset, tie1holenum, tie1corenum, &n, sbd, dat, sm, &tie); 
        FindMinMaxOneCore(dat, n, &min1, &max1);
        x1 = (min1 - minvar)/varperpix + OFF + SPACE + (tie1holenum - start_hole) * (varaxislen + SPACE);
        w1 = (max1 - minvar)/varperpix + OFF + SPACE + (tie1holenum - start_hole) * (varaxislen + SPACE);

        tie = tie2arraynum;
        err = CleanUpCore(dset, tie2holenum, tie2corenum, &n, sbd, dat, sm, &tie);  
        FindMinMaxOneCore(dat, n, &min2, &max2);
        t2 = (sbd[tie] - top_meter_edit)/depperpix + top_off_edit;
        y3 = (sbd[0] - top_meter_edit + tiedepoffset)/depperpix + top_off_edit;
        h3 = (sbd[n-1] - top_meter_edit + tiedepoffset)/depperpix + top_off_edit;
        x2 = (min2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);
        w2 = (max2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);
        x3 = (min2 - minvar)/varperpix + OFF + SPACE + (tie1holenum - start_hole) * (varaxislen + SPACE); 
        w3 = (max2 - minvar)/varperpix + OFF + SPACE + (tie1holenum - start_hole) * (varaxislen + SPACE);

        if(y3 <= t2) {
          y1 = y3;
        }
        else if(y3 > t2) {
          y1 = t2;
        }
        if(y1 < 0) {
          clip_y = 0;
        }
        else {
          clip_y = y1;
        }

        if(h3 <= t2) {
          h1 = t2;
        }
        else if(h3 > t2) {
          h1 = h3;
        }
        if(h1 < 0) {
          h1 = 0;
        }
        clip_height = h1 - clip_y;

        if(x2 < x1) {
          x1 = x2;
        }
        if(x3 < x1) {
          x1 = x3;
        }
        if(x1 < 0) {
          clip_x = 0;
        }
        else {
          clip_x = x1;
        }

        if(w2 > w1) {   
          w1 = w2; 
        }
        if(w3 > w1) {
          w1 = w3;  
        }
        if(w1 < 0) {
          w1 = 0;
        }
        clip_width = w1 - clip_x;
      }
    }

    else if(reason_for_redraw == DRAW_DEPTHSHIFT || reason_for_redraw == DRAW_DEPTHSHIFTUNDO) {

      sm = NO;
      tie = tie2arraynum;
      err = CleanUpCore(dset, tie2holenum, tie2corenum, &n, sbd, dat, sm, &tie);

      if(reason_for_redraw == DRAW_DEPTHSHIFT) {
        if(lastdepoffset >= 0.0) {
          y2 = (sbd[0] - top_meter_edit - lastdepoffset)/depperpix + top_off_edit; 
        }
        else if(lastdepoffset < 0.0) {
          y2 = (sbd[0] - top_meter_edit)/depperpix + top_off_edit;
        }
      }
      else if(reason_for_redraw == DRAW_DEPTHSHIFTUNDO) {
        if(lastdepoffset >= 0.0) { 
          y2 = (sbd[0] - top_meter_edit)/depperpix + top_off_edit; 
        }  
        else if(lastdepoffset < 0.0) {
          y2 = (sbd[0] - top_meter_edit - lastdepoffset)/depperpix + top_off_edit; 
        }
      }
      if(y2 < 0) {
        clip_y = 0;
      }
      else {
        clip_y = y2;
      }
      
      if(lastshiftwho == ONECORE) {
        if(reason_for_redraw == DRAW_DEPTHSHIFT) { 
          if(lastdepoffset >= 0.0) { 
            h2 = (sbd[n-1] - top_meter_edit)/depperpix + top_off_edit; 
          }  
          else if(lastdepoffset < 0.0) {
            h2 = (sbd[n-1] - top_meter_edit + lastdepoffset)/depperpix + top_off_edit; 
          }  
        } 
        else if(reason_for_redraw == DRAW_DEPTHSHIFTUNDO) { 
          if(lastdepoffset >= 0.0) {  
            h2 = (sbd[n-1] - top_meter_edit + lastdepoffset)/depperpix + top_off_edit;  
          }   
          else if(lastdepoffset < 0.0) { 
            h2 = (sbd[n-1] - top_meter_edit)/depperpix + top_off_edit;  
          }
        }
      }
      else if(lastshiftwho == ALLCORES) {
        h2 = (int)win_height;
      }
      if(h2 < 0) {
        h2 = 0;
      }
      clip_height = h2 - clip_y;
  
      if(lastshiftwho == ONECORE || tie2corenum == data[dset]->holes[tie2holenum]->numcores - 1) {
        FindMinMaxOneCore(dat, n, &min2, &max2);
        x2 = (min2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);
        w2 = (max2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);
      }  
      else if(lastshiftwho == ALLCORES && tie2corenum < data[dset]->holes[tie2holenum]->numcores - 1) {
        FindMinMaxOneCore(dat, n, &min2, &max2); 
        x2 = (min2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE); 
        w2 = (max2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);
        i = tie2corenum + 1;
        while(i < data[dset]->holes[tie2holenum]->numcores) {
          tie = 0;
          err = CleanUpCore(dset, tie2holenum, i, &n, sbd, dat, sm, &tie);  
          if(((sbd[0] - top_meter_edit - lastdepoffset)/depperpix + top_off_edit) > (int)win_height) {
            break;
          }
          else {
            FindMinMaxOneCore(dat, n, &min2, &max2); 
            x3 = (min2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);  
            w3 = (max2 - minvar)/varperpix + OFF + SPACE + (tie2holenum - start_hole) * (varaxislen + SPACE);
            if(x3 < x2) {
              x2 = x3;
            }
            if(w3 > w2) {
              w2 = w3;
            }
            ++i;
          }
        }
      }
      if(x2 < 0) {
        clip_x = 0;
      }
      else {
        clip_x = x2;
      }
      if(w2 < 0) {
        w2 = 0;
      }
      clip_width = w2 - clip_x;
    }

    else {
      clip_x = 0;
      clip_y = 0;
      clip_width = (int)win_width;
      clip_height = (int)win_height;
    }

  }

  else if(who == VIEW) {

    if(reason_for_redraw == DRAW_TIES) { 
 
    } 
 
    else if(reason_for_redraw == DRAW_COREGRABBED) { 

      sm = NO;
      tie = splicearraynum;
      err = CleanUpCore(dset, spliceholenum, splicecorenum, &n, sbd, dat, sm, &tie);
      y1 = (sbd[0] - top_meter_view)/depperpix + top_off_view;
      if(y1 < 0) {
        clip_y = 0;
      }
      else {
        clip_y = y1;
      }
      h2 = (sbd[n-1] - top_meter_view)/depperpix + top_off_view;
      clip_height = h2 - clip_y;

      FindMinMaxOneCore(dat, n, &min1, &max1);
      x1 = (min1 - minvar)/varperpix + OFF + SPACE + varaxislen;
      w1 = (max1 - minvar)/varperpix + OFF + SPACE + varaxislen;
      if(x1 < 0) {
        clip_x = 0;
      }  
      else {
        clip_x = x1;
      }  
      if(w1 < 0) {
        w2 = 0;
      }  
      clip_width = w1 - clip_x;
    } 
 
    else if(reason_for_redraw == DRAW_CORECLEARED) {

    }

    else if(reason_for_redraw == DRAW_SPLICED) {

    }

    else if(reason_for_redraw == DRAW_APPEND) {

    }

    else if(reason_for_redraw == DRAW_UNDONE) {

    }

    else {
      clip_x = 0;
      clip_y = 0;
      clip_width = (int)win_width;
      clip_height = (int)win_height;
    }

  }

  else {
    clip_x = 0;
    clip_y = 0;
    clip_width = (int)win_width;
    clip_height = (int)win_height;
  }
}

int FindMinMaxOneCore(pdat, n, pmin, pmax)
int n;
float *pdat, *pmin, *pmax;
{
  int i;

  *pmin = 99999.0;
  *pmax = -99999.0;
  for(i=0; i<n; ++i) {
    if(*pmin > pdat[i]) {
      *pmin = pdat[i];
    }
    if(*pmax < pdat[i]) {
      *pmax = pdat[i];
    }
  }
  if(*pmin == 99999.0 || *pmax == -99999.0) {
    return 1;
  }
  else {
    return 0;
  }
} 

void ReadColorList(dpy)
Display *dpy;
{
  int start, i;
  char line[1000], rgbcolor[51], value[51], *color_path, *filename, *getenv();
  FILE *fp;
  XmString xmstring;
  Pixel sampPixel;

  start = 0;
  if((color_path=(char*)calloc(1000, CHAR_SIZE))==NULL)
                 SpBadMemAlloc("ReadColorList");
  (void)strcpy(color_path,(char*)getenv("SPLICER_COLOR_PATH"));
  if((filename=(char*)calloc((int)strlen(color_path) + 50, CHAR_SIZE))==NULL)
                 SpBadMemAlloc("ReadColorList");
  (void)sprintf(filename, "%s/color-name-list", color_path);
  free(color_path);

  if((fp = fopen(filename, "r")) != NULL) {
    strcpy(line, "");
    while(fgets(line, 1000, fp) != NULL) {

      for(i=50; i>=0; --i) {
        strcpy(&rgbcolor[i], "");
        strcpy(&value[i], "");
      }
      strcpy(rgbcolor, "");
      strcpy(value, "");

      (void)strncpy(value, &line[13], (int)strlen(line) - 12);
      
      sscanf(value, "%s", rgbcolor);

      xmstring = XmStringCreateSimple(rgbcolor);
      XmListAddItemUnselected(listColor, xmstring, 0);
      XmStringFree(xmstring); 
      if(start == 0) {

        /* let the first color in the list be the selected
           and displayed sample color
        */
        GetColorPixelValue(dpy, rgbcolor, &sampPixel);
        XtVaSetValues(drawingAreaColorSelect, XmNbackground, sampPixel, NULL);
        XmListSelectPos(listColor, 1, NULL);
        start = 1;
      }  
      strcpy(line, "");
    }
    fclose(fp);
  }
  else {
    (void)sprintf(buffer,"Warning: Could not open splicer's color-name-list.");
    SpManageWarningBox(buffer);
  }

  free(filename);

  (void)sprintf(line, "");
  (void)sprintf(rgbcolor, "");
  (void)sprintf(value, "");
}

int GetColorPixelValue(dpy, rgbc, pixel)
Display *dpy;
char rgbc[51];
Pixel *pixel;
{
  int test;
  XColor return_color, unused;
 
  if(!(test=XAllocNamedColor(dpy, cmap, rgbc, &return_color, &unused))) {
    (void)printf("can not allocate named color:  %s. reason %d\n", rgbc, test);
    *pixel = BlackPixelOfScreen(XtScreen(drawingAreaColorSelect));
  }
  else {
    *pixel = return_color.pixel;
  }    
}

void SetCustomeColorWidgetBGColors(bgP)
Pixel bgP;
{

  /* set the row-column background color
  */
  XtVaSetValues(rowColumnColorCompositeAndSplice, XmNbackground, bgP, NULL);
  XtVaSetValues(rowColumnColorCorrelation, XmNbackground, bgP, NULL);
  XtVaSetValues(rowColumnColorDepthOffset, XmNbackground, bgP, NULL);
  XtVaSetValues(rowColumnColorDrawingAreas, XmNbackground, bgP, NULL);
  XtVaSetValues(rowColumnColorAgeDepth, XmNbackground, bgP, NULL);
  XtVaSetValues(rowColumnColorSpliceToAge, XmNbackground, bgP, NULL);
 
  /* set the label background color
  */
  XtVaSetValues(labelDrawingAreaColorBG, XmNbackground, bgP, NULL);
  XtVaSetValues(labelDrawingAreaColorLabels, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorCoreRelated, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorCorembsf, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorCoremcd, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorSmooth, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorSplice, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorSpliceLocation, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorTieRelated, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorTiePtFixed, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorTiePtShift, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorTieLine, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorOverlayInCorr, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorOverlayOutCorr, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorStrat, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorPaleomag, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDiatom, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorRad, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorForam, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorNanno, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorCorrCoef, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorBestCorr, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetLine, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole1, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole2, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole3, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole4, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole5, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole6, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole7, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole8, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole9, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole10, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole11, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorAgeDepthHandPick, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorAgeDepthLine, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorSedRate, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorTimeSeries, XmNbackground, bgP, NULL);
  XtVaSetValues(labelColorDatumLocation, XmNbackground, bgP, NULL);
}

void SetCustomeColorWidgetFGColors(fgP)
Pixel fgP;
{

  /* set the row-column label colors
  */
  XtVaSetValues(labelDrawingAreaColorBG, XmNforeground, fgP, NULL);
  XtVaSetValues(labelDrawingAreaColorLabels, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorCoreRelated, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorCorembsf, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorCoremcd, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorSmooth, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorSplice, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorSpliceLocation, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorTieRelated, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorTiePtFixed, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorTiePtShift, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorTieLine, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorOverlayInCorr, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorOverlayOutCorr, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorStrat, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorPaleomag, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDiatom, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorRad, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorForam, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorNanno, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorCorrCoef, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorBestCorr, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetLine, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole1, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole2, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole3, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole4, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole5, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole6, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole7, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole8, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole9, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole10, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorDepthOffsetHole11, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorAgeDepthHandPick, XmNforeground, fgP, NULL);
  XtVaSetValues(labelColorAgeDepthLine, XmNforeground, fgP, NULL);
}

void SetCustomeColorButtonColors(bgP, buttP, buttColorName)
Pixel bgP, buttP[NCUSTOMECOLORBUTT];
char buttColorName[NCUSTOMECOLORBUTT][50];
{

  int i;
  XmString xmstring;

  XtVaSetValues(pushButtonDrawingAreaColorBG, XmNbackground, bgP, NULL); 
  xmstring = XmStringCreateSimple(buttColorName[BG_COLOR]); 
  XtVaSetValues(pushButtonDrawingAreaColorBG, XmNlabelString, xmstring, NULL); 
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonDrawingAreaColorLabels, XmNbackground, buttP[LABEL_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[LABEL_COLOR]);  
  XtVaSetValues(pushButtonDrawingAreaColorLabels, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCorembsf, XmNbackground, buttP[MBSF_COLOR], NULL);
  xmstring = XmStringCreateSimple(buttColorName[MBSF_COLOR]);
  XtVaSetValues(pushButtonColorCorembsf, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCoremcd, XmNbackground, buttP[MCD_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[MCD_COLOR]);  
  XtVaSetValues(pushButtonColorCoremcd, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);
  
  XtVaSetValues(pushButtonColorSmooth, XmNbackground, buttP[SMOOTH_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[SMOOTH_COLOR]);  
  XtVaSetValues(pushButtonColorSmooth, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorSplice, XmNbackground, buttP[SPLICE_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[SPLICE_COLOR]);  
  XtVaSetValues(pushButtonColorSplice, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorSpliceLocation, XmNbackground, buttP[SPLICELOCATION_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[SPLICELOCATION_COLOR]);  
  XtVaSetValues(pushButtonColorSpliceLocation, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTiePtFixed, XmNbackground, buttP[TIEPTFIXED_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[TIEPTFIXED_COLOR]);  
  XtVaSetValues(pushButtonColorTiePtFixed, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTiePtShift, XmNbackground, buttP[TIEPTSHIFT_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[TIEPTSHIFT_COLOR]);  
  XtVaSetValues(pushButtonColorTiePtShift, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTieLine, XmNbackground, buttP[TIELINE_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[TIELINE_COLOR]);  
  XtVaSetValues(pushButtonColorTieLine, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorOverlayInCorr, XmNbackground, buttP[OVERLAYINCORR_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[OVERLAYINCORR_COLOR]);  
  XtVaSetValues(pushButtonColorOverlayInCorr, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorOverlayOutCorr, XmNbackground, buttP[OVERLAYOUTCORR_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[OVERLAYOUTCORR_COLOR]);  
  XtVaSetValues(pushButtonColorOverlayOutCorr, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorPaleomag, XmNbackground, buttP[PALEOMAG_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[PALEOMAG_COLOR]);  
  XtVaSetValues(pushButtonColorPaleomag, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDiatom, XmNbackground, buttP[DIATOM_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DIATOM_COLOR]);  
  XtVaSetValues(pushButtonColorDiatom, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorRad, XmNbackground, buttP[RAD_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[RAD_COLOR]);  
  XtVaSetValues(pushButtonColorRad, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorForam, XmNbackground, buttP[FORAM_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[FORAM_COLOR]);  
  XtVaSetValues(pushButtonColorForam, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorNanno, XmNbackground, buttP[NANNO_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[NANNO_COLOR]);  
  XtVaSetValues(pushButtonColorNanno, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCorrCoef, XmNbackground, buttP[CORRCOEF_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[CORRCOEF_COLOR]);  
  XtVaSetValues(pushButtonColorCorrCoef, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorBestCorr, XmNbackground, buttP[BESTCORR_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[BESTCORR_COLOR]);  
  XtVaSetValues(pushButtonColorBestCorr, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetLine, XmNbackground, buttP[DEPOFFLINE_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFLINE_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetLine, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole1, XmNbackground, buttP[DEPOFFHOLE1_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE1_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole1, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole2, XmNbackground, buttP[DEPOFFHOLE2_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE2_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole2, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole3, XmNbackground, buttP[DEPOFFHOLE3_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE3_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole3, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole4, XmNbackground, buttP[DEPOFFHOLE4_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE4_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole4, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole5, XmNbackground, buttP[DEPOFFHOLE5_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE5_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole5, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole6, XmNbackground, buttP[DEPOFFHOLE6_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE6_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole6, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole7, XmNbackground, buttP[DEPOFFHOLE7_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE7_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole7, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole8, XmNbackground, buttP[DEPOFFHOLE8_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE8_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole8, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole9, XmNbackground, buttP[DEPOFFHOLE9_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE9_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole9, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole10, XmNbackground, buttP[DEPOFFHOLE10_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE10_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole10, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorDepthOffsetHole11, XmNbackground, buttP[DEPOFFHOLE11_COLOR], NULL);  
  xmstring = XmStringCreateSimple(buttColorName[DEPOFFHOLE11_COLOR]);  
  XtVaSetValues(pushButtonColorDepthOffsetHole11, XmNlabelString, xmstring, NULL);  
  XmStringFree(xmstring);

  xmstring = XmStringCreateSimple(buttColorName[AGEDEPHANDPICK_COLOR]);
  XtVaSetValues(pushButtonColorAgeDepthHandPick, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  xmstring = XmStringCreateSimple(buttColorName[AGEDEPLINE_COLOR]);
  XtVaSetValues(pushButtonColorAgeDepthLine, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);
}

void HardwireAxis(max, pmaxunit, pannot, pticinc, ppixperunit, pticpixlen, punitperpix, axispixlen, zoomfact)
int *pannot, *ppixperunit, *pticpixlen, axispixlen, zoomfact;
float max, *pmaxunit, *pticinc, *punitperpix;
{
  double check, fract, ip;

  if(max <= 50.0){
    *pmaxunit = 50.0;
    *pannot = 2;
    *pticinc = 5.0;
    *ppixperunit = 12;
    *pticpixlen = 60;
    *punitperpix = 0.0833;
  } 
  else if(max <= 75.0){
    *pmaxunit = 75.0;
    *pannot = 5;
    *pticinc = 5.0;
    *ppixperunit = 8;
    *pticpixlen = 40;
    *punitperpix = 0.125;
  }
  else if(max <= 100.0){
    *pmaxunit = 100.0;
    *pannot = 2;
    *pticinc = 10.0;
    *ppixperunit = 6;
    *pticpixlen = 60;
    *punitperpix = 0.1666;
  }
  else if(max <= 120.0){
    *pmaxunit = 120.0;
    *pannot = 2;
    *pticinc = 10.0;
    *ppixperunit = 5;
    *pticpixlen = 50;
    *punitperpix = 0.2000;
  }
  else if(max <= 150.0){
    *pmaxunit = 150.0;
    *pannot = 2;
    *pticinc = 25.0;
    *ppixperunit = 4;
    *pticpixlen = 100;
    *punitperpix = 0.2500;
  }
  else if(max <= 200.0){
    *pmaxunit = 200.0;
    *pannot = 2;
    *pticinc = 25.0;
    *ppixperunit = 3;
    *pticpixlen = 75;
    *punitperpix = 0.3333;
  }
  else if(max <= 300.0){
    *pmaxunit = 300.0;
    *pannot = 2;
    *pticinc = 50.0;
    *ppixperunit = 2;
    *pticpixlen = 100;
    *punitperpix = 0.5000;
  }
  else if(max <= 600.0){
    *pmaxunit = 600.0;
    *pannot = 1;
    *pticinc = 100;
    *ppixperunit = 1;
    *pticpixlen = 100;
    *punitperpix = 1.000;
  }
  else {
    *pmaxunit = max;
    *pannot = 1;
    *pticinc = 100.0;
    check = *pmaxunit/(*pticinc);
    fract = modf(check, &ip);
    if(fract == 0.0){
    }
    else {
      *pmaxunit = (ip * (*pticinc)) + (*pticinc);
    }
    check = axispixlen/(*pmaxunit);
    fract = modf(check, &ip);
    *ppixperunit = ip;
 
    *pticpixlen = *ppixperunit * (*pticinc);
    check = *ppixperunit;
    *punitperpix = 1.0/check;
  }
}

void PlaceDialog(w, where)
Widget w;
int where;
{
  Dimension wwidth, wheight;
  Position x, y;

  XtVaGetValues(w, XmNwidth, &wwidth, XmNheight, &wheight, NULL);

  if(where == TOPLEFT) {
    x = 20;
    y = 20;
  }
  else if(where == BOTLEFT) {
    x = 10;
    y = (int)HeightOfScreen(XtScreen(w)) - (int)wheight - 20;
  }
  else if(where == TOPRIGHT) {
    y = 20;
    x = (int)WidthOfScreen(XtScreen(w)) - (int)wwidth - 10;
  }
  else if(where == BOTRIGHT) {
    x = (int)WidthOfScreen(XtScreen(w)) - (int)wwidth - 10;
    y = (int)HeightOfScreen(XtScreen(w)) - (int)wheight - 10;
  }
  else {
    x = 20;
    y = 20;
  }
 
  XtVaSetValues(w, XmNx, x, XmNy, y, NULL);
}

void MapStratToAffine()
{
  int i, j, k, l, m;
  char holename[2];

  /* find if the datum is in the affine table
  */
  for( i=0; i<strat_file_cnt; ++i) {
    for(j=0; j<strat[i]->data_cnt; ++j) {
      strat[i]->data[j].hole_is_in_dataset = NO;
      strat[i]->data[j].top.in_affine = NO;
      strat[i]->data[j].bot.in_affine = NO;
      strat[i]->data[j].top.aff_map_hole = -1;
      strat[i]->data[j].top.aff_map_core = -1;
      strat[i]->data[j].bot.aff_map_hole = -1;
      strat[i]->data[j].bot.aff_map_core = -1;
      for(k=0; k<affinetable.numhole; ++k) {
        (void)sprintf(holename,"%c", strat[i]->data[j].top.hole);
        if(strcmp(holename, affinetable.hole[k].name) == 0) {
          strat[i]->data[j].top.aff_map_hole = k;
          strat[i]->data[j].bot.aff_map_hole = k;
          for(m=0; m<data[dset]->numholes; ++m) {
            if(strat[i]->data[j].top.hole == data[dset]->holes[m]->name) {
              strat[i]->data[j].hole_is_in_dataset = YES;
            }        
          }
          for(l=0; l<affinetable.hole[k].numcore; ++l) {
            if(strat[i]->data[j].top.core == affinetable.hole[k].core[l].name) {
              strat[i]->data[j].top.in_affine = YES;
              strat[i]->data[j].top.aff_map_core = l;
            }
            if(strat[i]->data[j].bot.core == affinetable.hole[k].core[l].name) {
              strat[i]->data[j].bot.in_affine = YES;
              strat[i]->data[j].bot.aff_map_core = l;
            }
          }
        }
      }
    }
  }

  (void)sprintf(holename, "");
}

void FindStratDepthOffset()
{
  int i, j;

  /* set the strat cum depth offset
     
     use the following rules for whether to use strat:

     if the affine table does not contain the hole of datum; 
           dont'-can't use datum
     if the affine table does not have the core(s) for both the top and bot of datum;
           ?
     if the affine table has the core for the top of datum but not the bot;
           use the top offset for bot;
     if the affine table has the core for the bot of datum but not the top;
           use the bot offset for top;
  */

  for( i=0; i<strat_file_cnt; ++i) {
    for(j=0; j<strat[i]->data_cnt; ++j) {
      if(strat[i]->data[j].top.in_affine == YES && strat[i]->data[j].bot.in_affine == YES) {
        strat[i]->data[j].top.offset = affinetable.hole[strat[i]->data[j].top.aff_map_hole].core[strat[i]->data[j].top.aff_map_core].cum_depth_offset;
        strat[i]->data[j].bot.offset = affinetable.hole[strat[i]->data[j].bot.aff_map_hole].core[strat[i]->data[j].bot.aff_map_core].cum_depth_offset;
      }
      else if(strat[i]->data[j].top.in_affine == YES && strat[i]->data[j].bot.in_affine == NO) {
        strat[i]->data[j].top.offset = affinetable.hole[strat[i]->data[j].top.aff_map_hole].core[strat[i]->data[j].top.aff_map_core].cum_depth_offset;
        strat[i]->data[j].bot.offset = strat[i]->data[j].top.offset;
      }
      else if(strat[i]->data[j].top.in_affine == NO && strat[i]->data[j].bot.in_affine == YES) {
        strat[i]->data[j].bot.offset = affinetable.hole[strat[i]->data[j].bot.aff_map_hole].core[strat[i]->data[j].bot.aff_map_core].cum_depth_offset;
        strat[i]->data[j].top.offset = strat[i]->data[j].bot.offset;
      }
      else {
        strat[i]->data[j].top.offset = 0.0;
        strat[i]->data[j].bot.offset = 0.0;
      }

      strat[i]->data[j].aveage = (strat[i]->data[j].bot_age + strat[i]->data[j].top_age)/2.0;
      strat[i]->data[j].avembsf = (strat[i]->data[j].bot.sb_depth + strat[i]->data[j].top.sb_depth)/2.0;
      strat[i]->data[j].avemcd = (strat[i]->data[j].bot.sb_depth + strat[i]->data[j].bot.offset + 
                                  strat[i]->data[j].top.sb_depth + strat[i]->data[j].top.offset)/2.0;
    }
  }
}

void AgeDepthMinMax()
{
  int i, j, scalemax;

  if(have_strat == DO) {
    maxagedepdepth = 0.0;
    maxagedepage = 0.0;
    for(i=0; i<strat_file_cnt; ++i) {
      for(j=0; j<strat[i]->data_cnt; ++j) {
        if(strat[i]->data[j].top.in_affine == YES || strat[i]->data[j].bot.in_affine == YES) {
          if(strat[i]->data[j].bot.sb_depth > maxagedepdepth) {
            maxagedepdepth = strat[i]->data[j].bot.sb_depth;
          }
          if(strat[i]->data[j].bot.sb_depth + strat[i]->data[j].bot.offset > maxagedepdepth) {
            maxagedepdepth = strat[i]->data[j].bot.sb_depth + strat[i]->data[j].bot.offset;
          }
          if(strat[i]->data[j].bot_age > maxagedepage) {
            maxagedepage = strat[i]->data[j].bot_age;
          }
        }
      }
    }

    /* set the scale bars max
    
    scalemax = maxagedepdepth + 1;
    maxagedepdepth = scalemax;
    XtVaSetValues(scaleDrawingAreaAgeDepthDepth, XmNmaximum, scalemax, NULL);
    scalemax = maxagedepage + 1;
    maxagedepage = scalemax;
    XtVaSetValues(scaleDrawingAreaAgeDepthAge, XmNmaximum, scalemax, NULL);
*/
  }
}

void AgeDepthPlotValues(winlen, pmaxvalue, startvalue, pfirsttic, topoffset, botoffset, pleft, pticpixlen, ticlen, ppixperunit)
int winlen, topoffset, botoffset, *pticpixlen, *ppixperunit, *pleft;
float *pmaxvalue, startvalue, *pfirsttic, ticlen;
{
  int axispixlen;
  double check, fract, ip;

  /* is the length of axis evenly divisiable by tic
     if not increase axis length so it is
  */
  check = *pmaxvalue/ticlen;
  fract = modf(check, &ip);
  if(fract == 0.0) {
  }
  else {
    *pmaxvalue = (ip * ticlen) + ticlen;
  }

  /* is the top value divisable by tic or is there a remainder
  */
  check = startvalue/ticlen;
  fract = modf(check, &ip);

  /*if no remainder than axis starts at a tic
    and if there is a remainder axis does not start at a tic
    and the first tic is the next one down
  */
  if(fract == 0.0) {
    *pfirsttic = startvalue;
  }
  else {
    *pfirsttic = ticlen * ip + ticlen;
  }

  axispixlen = winlen - topoffset - botoffset;

  /* calculate how many pixels in a unit; truncate the result so mult.
     units are equal to a pixel value that is a whole number
  */
  check = axispixlen/(*pmaxvalue);
  fract = modf(check, &ip);
  *ppixperunit = ip;

  *pticpixlen = *ppixperunit * ticlen;

  /*if axis does not start at a tic calculate the distance
    in pixels from top of axis to first tic
  */
  if(*pfirsttic == startvalue) {
    *pleft = 0;
  }
  else {
    *pleft = (*pfirsttic - startvalue) * *ppixperunit;
  }
  
}

int CalcAge()
{
  int i, j, k;

  /* calculate the age of the splice using age model
  */

  /* need at least two datums in age model
     because can't calc. sed rate with just one
  */
  if(agemodel_cnt <=1) {
    return YES;
  }

  /* calc the rates of change ddep/dage
  */
  agemodel_avesedrate = 0.0;
  for(i=0; i<agemodel_cnt-1; ++i) {
    agemodel[i].sedrate = (agemodel[i+1].avemcd - agemodel[i].avemcd)/(agemodel[i+1].aveage - agemodel[i].aveage);
    agemodel_avesedrate = agemodel_avesedrate + agemodel[i].sedrate;
  }
  agemodel[agemodel_cnt - 1].sedrate = agemodel[agemodel_cnt -2].sedrate;
  agemodel_avesedrate = agemodel_avesedrate/agemodel_cnt;

  for(j=0; j<spcomp.numcores; ++j) {
    for(k=0; k<spcomp.numpercore[j]; ++k) {
      if(spcomp.sb_depth[j][k] <= agemodel[0].avemcd) {
        spcomp.age[j][k] = agemodel[0].aveage - (agemodel[0].avemcd - spcomp.sb_depth[j][k])/agemodel[0].sedrate;
        spcomp.sedrate[j][k] = agemodel[0].sedrate;
      }
      else if(spcomp.sb_depth[j][k] >= agemodel[agemodel_cnt-1].avemcd) {
        spcomp.age[j][k] = agemodel[agemodel_cnt-1].aveage - 
                           (agemodel[agemodel_cnt-1].avemcd - spcomp.sb_depth[j][k])/agemodel[agemodel_cnt-1].sedrate;
        spcomp.sedrate[j][k] = agemodel[agemodel_cnt-1].sedrate;
      }
      else {
        for(i=0; i<agemodel_cnt-1; ++i) {
          if(spcomp.sb_depth[j][k] >= agemodel[i].avemcd && spcomp.sb_depth[j][k] <= agemodel[i+1].avemcd) {
            spcomp.age[j][k] = agemodel[i].aveage - (agemodel[i].avemcd - spcomp.sb_depth[j][k])/agemodel[i].sedrate;
            spcomp.sedrate[j][k] = agemodel[i].sedrate;
          }
        }
      }
    }
  }

  return NO;
}

int GetColorSet()
{
  int i;

  if(colorset == EARTH_COLORSET) {
    (void)strcpy(color[BG_COLOR],"NavajoWhite");
    (void)strcpy(color[LABEL_COLOR],"brown");
    (void)strcpy(color[MBSF_COLOR],"SlateGray");
    (void)strcpy(color[MCD_COLOR],"DarkOliveGreen");
    (void)strcpy(color[SMOOTH_COLOR],"gray");
    (void)strcpy(color[SPLICE_COLOR],"SkyBlue");
    (void)strcpy(color[SPLICELOCATION_COLOR],"sienna");
    (void)strcpy(color[TIEPTFIXED_COLOR],"red");
    (void)strcpy(color[TIEPTSHIFT_COLOR],"green");
    (void)strcpy(color[TIELINE_COLOR],"tomato");
    (void)strcpy(color[OVERLAYINCORR_COLOR],"red");
    (void)strcpy(color[OVERLAYOUTCORR_COLOR],"pink");
    (void)strcpy(color[PALEOMAG_COLOR],"blue");
    (void)strcpy(color[DIATOM_COLOR],"SpringGreen");
    (void)strcpy(color[RAD_COLOR],"white");
    (void)strcpy(color[FORAM_COLOR],"HotPink");
    (void)strcpy(color[NANNO_COLOR],"brown");
    (void)strcpy(color[CORRCOEF_COLOR],"ForestGreen");
    (void)strcpy(color[BESTCORR_COLOR],"yellow");
    (void)strcpy(color[DEPOFFLINE_COLOR],"black");
    (void)strcpy(color[DEPOFFHOLE1_COLOR],"white");
    (void)strcpy(color[DEPOFFHOLE2_COLOR],"green");
    (void)strcpy(color[DEPOFFHOLE3_COLOR],"blue");
    (void)strcpy(color[DEPOFFHOLE4_COLOR],"red");
    (void)strcpy(color[DEPOFFHOLE5_COLOR],"orange");
    (void)strcpy(color[DEPOFFHOLE6_COLOR],"brown");
    (void)strcpy(color[DEPOFFHOLE7_COLOR],"violet");
    (void)strcpy(color[DEPOFFHOLE8_COLOR],"pink");
    (void)strcpy(color[DEPOFFHOLE9_COLOR],"DarkGreen");
    (void)strcpy(color[DEPOFFHOLE10_COLOR],"MidnightBlue");
    (void)strcpy(color[DEPOFFHOLE11_COLOR],"PowderBlue");
    (void)strcpy(color[AGEDEPHANDPICK_COLOR], "orchid");
    (void)strcpy(color[AGEDEPLINE_COLOR], "black");
    (void)strcpy(color[SEDRATE_COLOR], "green");
    (void)strcpy(color[DATUMLOC_COLOR], "burlywood");
    (void)strcpy(color[TIMESERIES_COLOR], "salmon");
  }
  else if(colorset == CORPORATE_COLORSET) {
    (void)strcpy(color[BG_COLOR],"gainsboro");
    (void)strcpy(color[LABEL_COLOR],"black");
    (void)strcpy(color[MBSF_COLOR],"ForestGreen");
    (void)strcpy(color[MCD_COLOR],"blue");
    (void)strcpy(color[SMOOTH_COLOR],"peru");
    (void)strcpy(color[SPLICE_COLOR],"black");
    (void)strcpy(color[SPLICELOCATION_COLOR],"yellow");
    (void)strcpy(color[TIEPTFIXED_COLOR],"red");
    (void)strcpy(color[TIEPTSHIFT_COLOR],"green");
    (void)strcpy(color[TIELINE_COLOR],"purple");
    (void)strcpy(color[OVERLAYINCORR_COLOR],"red");
    (void)strcpy(color[OVERLAYOUTCORR_COLOR],"LightPink");
    (void)strcpy(color[PALEOMAG_COLOR],"red");
    (void)strcpy(color[DIATOM_COLOR],"white");
    (void)strcpy(color[RAD_COLOR],"DarkSeaGreen");
    (void)strcpy(color[FORAM_COLOR],"DeepPink");
    (void)strcpy(color[NANNO_COLOR],"DarkSlateBlue");
    (void)strcpy(color[CORRCOEF_COLOR],"red");
    (void)strcpy(color[BESTCORR_COLOR],"yellow");
    (void)strcpy(color[DEPOFFLINE_COLOR],"black");
    (void)strcpy(color[DEPOFFHOLE1_COLOR],"blue");
    (void)strcpy(color[DEPOFFHOLE2_COLOR],"green");
    (void)strcpy(color[DEPOFFHOLE3_COLOR],"yellow");
    (void)strcpy(color[DEPOFFHOLE4_COLOR],"red");
    (void)strcpy(color[DEPOFFHOLE5_COLOR],"orange");
    (void)strcpy(color[DEPOFFHOLE6_COLOR],"purple");
    (void)strcpy(color[DEPOFFHOLE7_COLOR],"brown");
    (void)strcpy(color[DEPOFFHOLE8_COLOR],"gold");
    (void)strcpy(color[DEPOFFHOLE9_COLOR],"violet");
    (void)strcpy(color[DEPOFFHOLE10_COLOR],"darkgreen");
    (void)strcpy(color[DEPOFFHOLE11_COLOR],"DarkKhaki");
    (void)strcpy(color[AGEDEPHANDPICK_COLOR], "purple");
    (void)strcpy(color[AGEDEPLINE_COLOR], "brown");
    (void)strcpy(color[SEDRATE_COLOR], "tomato");
    (void)strcpy(color[DATUMLOC_COLOR], "burlywood");
    (void)strcpy(color[TIMESERIES_COLOR], "ForestGreen");
  }
  else if(colorset == MARITIME_COLORSET) {
    (void)strcpy(color[BG_COLOR],"black");
    (void)strcpy(color[LABEL_COLOR],"white");
    (void)strcpy(color[MBSF_COLOR],"yellow");
    (void)strcpy(color[MCD_COLOR],"green");
    (void)strcpy(color[SMOOTH_COLOR],"pink");
    (void)strcpy(color[SPLICE_COLOR],"turquoise");
    (void)strcpy(color[SPLICELOCATION_COLOR],"white");
    (void)strcpy(color[TIEPTFIXED_COLOR],"red");
    (void)strcpy(color[TIEPTSHIFT_COLOR],"green");
    (void)strcpy(color[TIELINE_COLOR],"orange");
    (void)strcpy(color[OVERLAYINCORR_COLOR],"turquoise");
    (void)strcpy(color[OVERLAYOUTCORR_COLOR],"green");
    (void)strcpy(color[PALEOMAG_COLOR],"red");
    (void)strcpy(color[DIATOM_COLOR],"limegreen");
    (void)strcpy(color[RAD_COLOR],"white");
    (void)strcpy(color[FORAM_COLOR],"pink");
    (void)strcpy(color[NANNO_COLOR],"lightblue");
    (void)strcpy(color[CORRCOEF_COLOR],"lightblue");
    (void)strcpy(color[BESTCORR_COLOR],"yellow");
    (void)strcpy(color[DEPOFFLINE_COLOR],"white");
    (void)strcpy(color[DEPOFFHOLE1_COLOR],"pink");
    (void)strcpy(color[DEPOFFHOLE2_COLOR],"green");
    (void)strcpy(color[DEPOFFHOLE3_COLOR],"yellow");
    (void)strcpy(color[DEPOFFHOLE4_COLOR],"blue");
    (void)strcpy(color[DEPOFFHOLE5_COLOR],"orange");
    (void)strcpy(color[DEPOFFHOLE6_COLOR],"violet");
    (void)strcpy(color[DEPOFFHOLE7_COLOR],"red");
    (void)strcpy(color[DEPOFFHOLE8_COLOR],"brown");
    (void)strcpy(color[DEPOFFHOLE9_COLOR],"turquoise");
    (void)strcpy(color[DEPOFFHOLE10_COLOR],"darkgreen");
    (void)strcpy(color[DEPOFFHOLE11_COLOR],"lightblue");
    (void)strcpy(color[AGEDEPHANDPICK_COLOR],"yellow");
    (void)strcpy(color[AGEDEPLINE_COLOR], "red");
    (void)strcpy(color[SEDRATE_COLOR], "green");
    (void)strcpy(color[DATUMLOC_COLOR], "yellow");
    (void)strcpy(color[TIMESERIES_COLOR], "red");
  }
  else if(colorset == ODP_COLORSET) {
    (void)strcpy(color[BG_COLOR],"black");
    (void)strcpy(color[LABEL_COLOR],"white");
    (void)strcpy(color[MBSF_COLOR],"gold");
    (void)strcpy(color[MCD_COLOR],"DodgerBlue");
    (void)strcpy(color[SMOOTH_COLOR],"khaki");
    (void)strcpy(color[SPLICE_COLOR],"DodgerBlue");
    (void)strcpy(color[SPLICELOCATION_COLOR],"aquamarine");
    (void)strcpy(color[TIEPTFIXED_COLOR],"red");
    (void)strcpy(color[TIEPTSHIFT_COLOR],"green");
    (void)strcpy(color[TIELINE_COLOR],"DarkOrange");
    (void)strcpy(color[OVERLAYINCORR_COLOR],"LemonChiffon");
    (void)strcpy(color[OVERLAYOUTCORR_COLOR],"coral");
    (void)strcpy(color[PALEOMAG_COLOR],"red");
    (void)strcpy(color[DIATOM_COLOR],"GreenYellow");
    (void)strcpy(color[RAD_COLOR],"white");
    (void)strcpy(color[FORAM_COLOR],"DarkOrange");
    (void)strcpy(color[NANNO_COLOR],"turquoise");
    (void)strcpy(color[CORRCOEF_COLOR],"LightSkyBlue");
    (void)strcpy(color[BESTCORR_COLOR],"yellow");
    (void)strcpy(color[DEPOFFLINE_COLOR],"white");
    (void)strcpy(color[DEPOFFHOLE1_COLOR],"pink");
    (void)strcpy(color[DEPOFFHOLE2_COLOR],"green");
    (void)strcpy(color[DEPOFFHOLE3_COLOR],"yellow");
    (void)strcpy(color[DEPOFFHOLE4_COLOR],"blue");
    (void)strcpy(color[DEPOFFHOLE5_COLOR],"orange");
    (void)strcpy(color[DEPOFFHOLE6_COLOR],"violet");
    (void)strcpy(color[DEPOFFHOLE7_COLOR],"red");
    (void)strcpy(color[DEPOFFHOLE8_COLOR],"brown");
    (void)strcpy(color[DEPOFFHOLE9_COLOR],"turquoise");
    (void)strcpy(color[DEPOFFHOLE10_COLOR],"DarkGreen");
    (void)strcpy(color[DEPOFFHOLE11_COLOR],"lightBlue");
    (void)strcpy(color[AGEDEPHANDPICK_COLOR], "yellow");
    (void)strcpy(color[AGEDEPLINE_COLOR], "red");
    (void)strcpy(color[SEDRATE_COLOR], "green");
    (void)strcpy(color[DATUMLOC_COLOR], "yellow");
    (void)strcpy(color[TIMESERIES_COLOR], "DarkOrange");
  }
  else if(colorset == SANTAFE_COLORSET) {
    (void)strcpy(color[BG_COLOR],"IndianRed");
    (void)strcpy(color[LABEL_COLOR],"black");
    (void)strcpy(color[MBSF_COLOR],"DarkGreen");
    (void)strcpy(color[MCD_COLOR],"SteelBlue");
    (void)strcpy(color[SMOOTH_COLOR],"MistyRose");
    (void)strcpy(color[SPLICE_COLOR],"HotPink");
    (void)strcpy(color[SPLICELOCATION_COLOR],"yellow");
    (void)strcpy(color[TIEPTFIXED_COLOR],"red");
    (void)strcpy(color[TIEPTSHIFT_COLOR],"green");
    (void)strcpy(color[TIELINE_COLOR],"purple");
    (void)strcpy(color[OVERLAYINCORR_COLOR],"red");
    (void)strcpy(color[OVERLAYOUTCORR_COLOR],"LightPink");
    (void)strcpy(color[PALEOMAG_COLOR],"red");
    (void)strcpy(color[DIATOM_COLOR],"white");
    (void)strcpy(color[RAD_COLOR],"DarkSeaGreen");
    (void)strcpy(color[FORAM_COLOR],"DeepPink");
    (void)strcpy(color[NANNO_COLOR],"CornflowerBlue");
    (void)strcpy(color[CORRCOEF_COLOR],"blue");
    (void)strcpy(color[BESTCORR_COLOR],"yellow");
    (void)strcpy(color[DEPOFFLINE_COLOR],"black");
    (void)strcpy(color[DEPOFFHOLE1_COLOR],"DarkTurquoise");
    (void)strcpy(color[DEPOFFHOLE2_COLOR],"LimeGreen");
    (void)strcpy(color[DEPOFFHOLE3_COLOR],"yellow");
    (void)strcpy(color[DEPOFFHOLE4_COLOR],"blue");
    (void)strcpy(color[DEPOFFHOLE5_COLOR],"orange");
    (void)strcpy(color[DEPOFFHOLE6_COLOR],"violet");
    (void)strcpy(color[DEPOFFHOLE7_COLOR],"red");
    (void)strcpy(color[DEPOFFHOLE8_COLOR],"brown");
    (void)strcpy(color[DEPOFFHOLE9_COLOR],"purple");
    (void)strcpy(color[DEPOFFHOLE10_COLOR],"darkgreen");
    (void)strcpy(color[DEPOFFHOLE11_COLOR],"DarkKhaki");
    (void)strcpy(color[AGEDEPHANDPICK_COLOR], "yellow");
    (void)strcpy(color[AGEDEPLINE_COLOR], "black");
    (void)strcpy(color[SEDRATE_COLOR], "MediumSeaGreen");
    (void)strcpy(color[DATUMLOC_COLOR], "gold");
    (void)strcpy(color[TIMESERIES_COLOR], "turquoise");
  }
  else if(colorset == CUSTOME_COLORSET) {
    for(i=0; i<NCOLOR; ++i) {
      (void)sprintf(color[i], "");
      (void)strcpy(color[i], cust_color[i]);
    }
  }
  else {

  }
}

void SetColorSetBGandFG()
{
Pixel fgP, bgP;

  /* get the custom color dialog's foreground and background colors
  */
  XtVaGetValues(formSetColor, XmNbackground, &bgP, NULL);
  XtVaGetValues(formSetColor, XmNforeground, &fgP, NULL);

  /* set all the color set buttons to the parents background and
     foreground colors
  */
  XtVaSetValues(pushButtonColorSetEarth, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetCorporate, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetMaritime, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetSantaFe, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetODP, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetCustome, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetEarth, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetCorporate, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetMaritime, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetSantaFe, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetODP, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetCustome, XmNforeground, fgP, NULL);

  /* now set the background color of button of current colorset using 
     to the drawingarea background color abd the button label colors
     to the general label color
  */
  if(colorset == EARTH_COLORSET) {
    XtVaSetValues(pushButtonColorSetEarth, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetEarth, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  }
  else if(colorset == CORPORATE_COLORSET) {
    XtVaSetValues(pushButtonColorSetCorporate, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetCorporate, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  }
  else if(colorset == MARITIME_COLORSET) {
    XtVaSetValues(pushButtonColorSetMaritime, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetMaritime, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  }
  else if(colorset == SANTAFE_COLORSET) {
    XtVaSetValues(pushButtonColorSetSantaFe, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetSantaFe, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  }
  else if(colorset == ODP_COLORSET) {
    XtVaSetValues(pushButtonColorSetODP, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetODP, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  }
  else if(colorset == CUSTOME_COLORSET) {
    XtVaSetValues(pushButtonColorSetCustome, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetCustome, XmNforeground, fgPixel[LABEL_COLOR], NULL);
  }
}

int FindSpliceAveAge(pdt)
float *pdt;
{
  int i, j, n;
  float sumaveage;

  n = 0;
  sumaveage = 0.0;
  for(i=0; i<spcomp.numcores; ++i) {
    for(j=0; j<spcomp.numpercore[i]-1; ++j) {
      sumaveage = sumaveage + spcomp.age[i][j+1] - spcomp.age[i][j];
      ++n;
    }
  }
  if(n > 0 && sumaveage > 0.0) {
    *pdt = sumaveage/n;
  }
  else {
    (void)sprintf(buffer,"Warning: could not calculate the average time step for this data set.");
    SpManageWarningBox(buffer);
  }
  return 0;
}  

int InterpolateTiePtValue(n, depth, value, targetdep, intval, place)
int n, *place;
float *depth, *value, targetdep, *intval;
{
  int i;

  /* depth type not important
  */

  if(targetdep < depth[0] || targetdep > depth[n-1]) {
  }
  else {
    *place = -1;
    if(n > 1) {
      for(i=0; i<n-1; ++i) {
        if(targetdep >= depth[i] && targetdep <= depth[i+1]) {
          *intval = value[i] + (value[i+1] - value[i])/(depth[i+1] - depth[i]) * (targetdep - depth[i]);
          *place = i;
          break;
        }
      }
    }
    if(*place != -1) {
      return 0;
    }
  }
  return 1;
}

int XAxisTimeCorrSetup(lead, dt, len, tic, ntic, perpix, max)
int    lead;
float  dt;
int    *len;
float  *tic;
int    *ntic;
float  *perpix;
float  *max;
{
  float  leadlagmyrs;
  double fract, check, ip;
  String str;

  str= XmTextGetString(textFieldSpliceToAgeLeadLag);
  leadlagmyrs = atof(str);
  XtFree(str);

  check = *len;
  if(leadlagmyrs  <= 0.01){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=0.002;
    *ntic=10;
    *perpix=0.01/(*len);
    *max=0.01;
  }
  else if(leadlagmyrs <= 0.02){
    fract = modf((check/4.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 4.0;
    }
    else {
      *len = (ip * 4.0) + 4.0;
    }
    *tic=0.005;
    *ntic=8;
    *perpix=0.02/(*len);
    *max=0.02;
  }
  else if(leadlagmyrs <= 0.03){
    fract = modf((check/6.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 6.0;
    }
    else {
      *len = (ip * 6.0) + 6.0;
    }
    *tic=0.005;
    *ntic=12;
    *perpix=0.03/(*len);
    *max=0.03;
  }
  else if(leadlagmyrs <= 0.04){
    fract = modf((check/4.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 4.0;
    }
    else {
      *len = (ip * 4.0) + 4.0;
    }
    *tic=0.01;
    *ntic=8;
    *perpix=0.04/(*len);
    *max=0.04;
  }
  else if(leadlagmyrs <= 0.05){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=0.01;
    *ntic=10;
    *perpix=0.05/(*len);
    *max=0.05;
  }
  else if(leadlagmyrs <= 0.06){
    fract = modf((check/3.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 3.0;
    }
    else {
      *len = (ip * 3.0) + 3.0;
    }
    *tic=0.02;
    *ntic=6;
    *perpix=0.05/(*len);
    *max=0.05;
  }
/*
  else if(leadlagmyrs <= 0.07){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
  else if(leadlagmyrs <= 0.08){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
  else if(leadlagmyrs <= 0.09){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
  else if(leadlagmyrs <= 0.1){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
  else if(leadlagmyrs > 0.1 && leadlagmyrs <= 0.25){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
  else if(leadlagmyrs > 0.25 && leadlagmyrs <= 0.5){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
  else if(leadlagmyrs <= 1.0){
    fract = modf((check/5.0), &ip);
    if(fract == 0.0){
    }
    else if(fract < 0.5){
      *len = ip * 5.0;
    }
    else {
      *len = (ip * 5.0) + 5.0;
    }
    *tic=1.0;
    *ntic=10;
    *perpix=5.0/(*len);
    *max=5.0;
  }
*/
  else {
    return 1;
  }

  return 0;
}
