/*
	splicer_functions.c
*/
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <malloc.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/List.h>
#include "splicer-creation-c.h"
#include "splicer_vars.h"
#include "EquationMenu.h"
#include <X11/cursorfont.h>

#define NUM_OF_ARGS	(3)

void SpManageMessage(info)
MessageInfo	info;
{
        XmString        xmstring; 
	XmFontList	fontlist;
 
	XtManageChild(XmMessageBoxGetChild(messageBoxInfo,XmDIALOG_CANCEL_BUTTON));
        xmstring=XmCvtCTToXmString(info.label); 
        XtVaGetValues(messageBoxInfo,XmNlabelFontList,&fontlist,NULL);
        XtVaSetValues(messageBoxInfo,XmNmessageString,xmstring, 
                XmNdialogType,info.type,XmNdefaultButton,info.default_button,
		XmNwidth,XmStringWidth(fontlist,xmstring)+75,NULL); 
        XtUnmanageChild(XmMessageBoxGetChild(messageBoxInfo,XmDIALOG_HELP_BUTTON));
        if(info.type==XmDIALOG_WARNING || info.type==XmDIALOG_ERROR)
                XtUnmanageChild(XmMessageBoxGetChild(messageBoxInfo,XmDIALOG_CANCEL_BUTTON));
	XmStringFree(xmstring);
	XtManageChild(messageBoxInfo);
	XtPopup(XtParent(messageBoxInfo),XtGrabNone);
}

void SpExit()
{
	FILE	*defaults_ptr;

/* write defaults file */
	if((defaults_ptr=fopen(defaults_filename,"w"))==NULL)
		(void)fprintf(stderr,"splicer: Warning: cannot open defaults file %s for writing.\n", defaults_filename);
	else
	{
		(void)fprintf(stderr,"splicer: set defaults written to %s.\n",defaults_filename);
		Spwrite_defaults(defaults_ptr);	/* write defaults file */
		(void)fclose(defaults_ptr);
	}
	
/* clean up */
	SpCleanUp(EXIT);
}
void SpCleanUp(cflag)
int	cflag;
{
	int	i;
	extern	Widget	pushButtonOpenStrat;
        time_t  tp;

        if(cflag == CANCEL) {
          return;
        }

	if(cflag==EXIT)
	{
		if(defaults_filename!=NULL) free(defaults_filename);
		if(current_path!=NULL) free(current_path);
		if(report.ptr!=NULL) fclose(report.ptr);
                if(preview_input_path!=NULL) free(preview_input_path);
		for(i=0;i<strat_file_cnt;i++)
		{
			if(strat[i] && (int)strlen((char*)strat[i])>0)
				XtFree((char *)strat[i]);
		}
		strat_file_cnt=0;
                XtFree(open_data_directory);
		XtFree(outdata_filename);
		XtFree(outdata_dirname);
		XtFree(outspdata_filename);
		XtFree(outspdata_dirname);
		XtFree(cull.filename);
		XtFree(cull.dirname);
		XtFree(affine.filename);
		XtFree(affine.dirname);
		XtFree(outstrat.filename);
		XtFree(outstrat.dirname);
		XtFree(splicertable.filename);
		XtFree(splicertable.dirname);
                if(report_filename) 
                {
                  XtFree(report_filename);
                }
                if(report_dirname)
                {
                  XtFree(report_dirname);
                }
	}
	if(cflag==ALL || cflag==INPUTDATA)
	{
                if(report_filename) 
                {
                  XtFree(report_filename);
                  report_filename = NULL;
                }
                if(report_dirname)
                {
                  XtFree(report_dirname);
                  report_dirname = NULL;
                }
		done_reading=done_cull=done_smooth=done_decimate=done_affine=False;
		datafileopen=False;
                for(i=0; i<dataset_cnt; ++i) {
		  SpFreeData(data[i]);
                  if(data[i])
                  {
                    free(data[i]);
                    data[i]=NULL;
                  }
                }
                if(data)
                {
                  free(data);
                  data=NULL;
                }
                dset = 0;
                dataset_cnt = 0;
                XtUnmanageChild(optionMenuDataSet);
                XtUnmanageChild(pushButtonDataSet1);
                XtUnmanageChild(pushButtonDataSet2);
                XtUnmanageChild(pushButtonDataSet3);
                XtUnmanageChild(pushButtonDataSet4);
                XtUnmanageChild(pushButtonDataSet5);
                XtUnmanageChild(pushButtonDataSet6);
                XtUnmanageChild(pushButtonDataSet7);
                XtUnmanageChild(pushButtonDataSet8);
                XtUnmanageChild(pushButtonDataSet9);
		have_data=DONT;
                have_affine = DONT;
		have_tie=DONT;
		have_shift=DONT;
		have_corr=DONT;
                have_splice=DONT;
		have_spcorr=DONT;
                did_affine = NO;
                saved_affine = NO;
                did_agemodel = NO;
                saved_agemodel = NO;
                agemodel_cnt = 0;
                lastaffinehole = -1;
                lastaffinecore = -1;
                XmListDeleteAllItems(listConstructAgeModel);
              /*  XtSetSensitive(pushButtonDataBase,True); */
                XtSetSensitive(pushButtonOpenData,True);
                XtSetSensitive(pushButtonOpenStrat,False);
                XtSetSensitive(pushButtonOpenAffine,True);
                if(XtIsManaged(XtParent(drawingAreaEdit))) {
                  reason_for_redraw = DRAW_CLEAR;
                  DrawDrawingAreaEdit(drawingAreaEdit, (XtPointer)NULL, (XtPointer)NULL);
                }
		XmListDeleteAllItems(listOpenSelected);
		if(report.saveflag)
		{
			report.saveflag=False;
			fclose(report.ptr);
		}
		if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL)
			SpBadMemAlloc("SpCleanUp 1");
        	(void)time(&tp);
        	(void)sprintf(charptr,"Start of Session: \n%s",ctime(&tp));
		XmTextReplace(textReport,0,XmTextGetLastPosition(textReport),charptr);
		free(charptr);
                XtSetSensitive(cascadeButtonSave,FALSE);
                XtSetSensitive(pushButtonSaveCull,FALSE);
                XtSetSensitive(pushButtonSaveAffine,FALSE);
                XtSetSensitive(pushButtonSaveSplicerTable,FALSE);
                XtSetSensitive(pushButtonSaveStrat,FALSE);
                XtSetSensitive(pushButtonSaveData,FALSE);
                XtSetSensitive(pushButtonSaveSplicerData,FALSE);
                XtSetSensitive(cascadeButtonClear,FALSE);
                XtSetSensitive(pushButtonClearAll,FALSE);
                XtSetSensitive(pushButtonClearComposite,FALSE);
                XtSetSensitive(pushButtonClearSplice,FALSE);
                XtSetSensitive(pushButtonClearStrat,FALSE);
                XtSetSensitive(pushButtonComposite,FALSE);
                XtSetSensitive(cascadeButtonSplice,FALSE);
             /*   XtSetSensitive(pushButtonDisplay,FALSE); */
                XtSetSensitive(pushButtonViewOffsets,FALSE);
                XtSetSensitive(pushButtonViewAgeDepth,FALSE);
                XmToggleButtonSetState(toggleButtonPlotUnsmooth, True, NULL);
                XmToggleButtonSetState(toggleButtonPlotSmooth, False, NULL);
                XmToggleButtonSetState(toggleButtonPlotBoth, False, NULL);
                XtSetSensitive(toggleButtonPlotSmooth,FALSE);
                XtSetSensitive(toggleButtonPlotUnsmooth,FALSE);
                XtSetSensitive(toggleButtonPlotBoth,FALSE);
                XtSetSensitive(cascadeButtonDataManip, False);

                if(are_agemodelling == YES) {
                  /* unmanage the construct age model form
                  */
                  are_agemodelling = NO;
                  have_splicetoage = DONT;
                  if(XtIsManaged(XtParent(drawingAreaSpliceToAge))) {
                    XtUnmanageChild(formSpliceToAge);
                  }
                  XtUnmanageChild(formConstructAgeModel);
                  XtVaSetValues(XtParent(formAgeDepth), XmNwidth, 600, NULL);
                  XtSetSensitive(formAgeDepthControls, False);
                }
	}
	if(cflag==ALL || cflag==INPUTSTRAT)
	{
		stratfileopen=False;
		if(strat_file_cnt>0 && strat[strat_file_cnt-1])
		{
                   for(i=0; i<strat_file_cnt; ++i) {
			if(strat[i]->data)
			{
				free(strat[i]->data);
				strat[i]->data=NULL;
			}
			free(strat[i]);
			strat[i]=NULL;
                   }
		}
                strat_file_cnt = 0;
		have_strat=DONT;
	}
	if(cflag==ALL || cflag==INPUTSPLICERTABLE)
	{
		splicer_read_done=splicer_table_done=False;
		sptable_cnt=0;
		if(splicertable.data)
		{
			free(splicertable.data);
			splicertable.data=NULL;
		}
		splicertable.data_cnt= 0;
                splicertable.alloc_cnt=0;
		have_splice=DONT;
		have_splice_tie=DONT;
		have_splice_shift=DONT;
		have_core_to_splice=DONT;
                did_splicing = NO;
                saved_splice = NO;
                if(XtIsManaged(XtParent(drawingAreaView))) {
                  reason_for_redraw = DRAW_CLEAR;
                  DrawDrawingAreaView(drawingAreaView, (XtPointer)NULL, (XtPointer)NULL);
                }
                XtSetSensitive(pushButtonSaveSplicerTable,False);
                XtSetSensitive(pushButtonSaveSplicerData,False);
                XtSetSensitive(pushButtonClearSplice,FALSE);
                if(cflag == INPUTSPLICERTABLE) {
                  XtSetSensitive(pushButtonOpenSplicerTable,True);
                }
                else if(cflag == ALL) {
                  XtSetSensitive(pushButtonOpenSplicerTable, False);
                }

                if(are_agemodelling == YES) {
                  if(XtIsManaged(XtParent(drawingAreaSpliceToAge))) {
                    XClearWindow(XtDisplay(drawingAreaSpliceToAge), XtWindow(drawingAreaSpliceToAge));
                    XtUnmanageChild(formSpliceToAge);
                  }
                  XtSetSensitive(pushButtonPlotSpliceVsAge, False);
                  XtSetSensitive(pushButtonSaveSpliceToAge, False);
                  have_splicetoage = DONT;
                }
	}
        if(cflag == ALL || cflag == TIMESERIES)
        {
          have_time_series = DONT;
          have_timeseries_tie = DONT;
          have_splicetoage_tie = DONT;
          last_splicetoage_tie = NONE;
          free(timeseries.age);
          free(timeseries.val);
          timeseries.age = NULL;
          timeseries.val = NULL;
        }
}

void SpGetEquationValues(equ)
Equation	*equ;
{
	Widget	*tmp_widget;
	int	SpGetSign();
/* get text values */
	charptr=XmTextGetString(textFieldCullValue1);
	equ->value1=(float)atof(charptr);
	XtFree(charptr);
	charptr=XmTextGetString(textFieldCullValue2);
	equ->value2=(float)atof(charptr);
	XtFree(charptr);
/* get signs */
	equ->sign1=SpGetSign(equationMenuCull1);
	equ->sign2=SpGetSign(equationMenuCull2);
/* get join */
	XtVaGetValues(optionMenuCullJoin,XmNmenuHistory,&tmp_widget,NULL);
	if(*tmp_widget==pushButtonCullOnly)
		equ->join=ONLY;
	else
		equ->join=OR;
}

int	SpGetSign(equ_widget)
EquationMenuData	equ_widget;
{
	Widget	tmp_widget;
	int	value;

	XtVaGetValues(equ_widget.pulldownMenuEquation,XmNmenuHistory,&tmp_widget,NULL);
	if(tmp_widget==equ_widget.pushButtonLessThan)
		value=LESS_THAN;
	else if(tmp_widget==equ_widget.pushButtonLessThanEqual)
		value=LESS_THAN_OR_EQUAL_TO;
	else if(tmp_widget==equ_widget.pushButtonGreaterThan)
		value=GREATER_THAN;
	else if(tmp_widget==equ_widget.pushButtonGreaterThanEqual)
		value=GREATER_THAN_OR_EQUAL_TO;
	else
		value=EQUAL_TO;
	return(value);
}
void SpInitialize(argc,argv)
int	argc;
char	**argv;
{
	char	*tmpfile;
	FILE	*fptmp;
	int	error=FALSE,i,path_len;
	void	exit();

/* initialize values */
/*	data[0]->numfiles=0;
*/
	report.lineno=2;
	affine.usetable=FALSE;
	if((defaults_filename= (char *)calloc(25,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpInitialize 1");
	(void)strcpy(defaults_filename,".splicerdefaults");
/* get current path */
	tmpfile=NULL;
	tmpfile=tmpnam(tmpfile);
	if((charptr=(char*)calloc((int)strlen(tmpfile)*2+50,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpInitialize 2");
	(void)sprintf(charptr,"pwd|wc -c>%s;pwd>>%s",tmpfile,tmpfile);
	(void)system(charptr);
	free(charptr);
	fptmp=fopen(tmpfile,"r");
	(void)fscanf(fptmp,"%d",&path_len);
	if((current_path = (char*)calloc(path_len+5,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpInitialize 3");
	(void)fscanf(fptmp,"%s",current_path);
	fclose(fptmp);
        (void)remove(tmpfile);
/* make preview input path large, it is going to be used in such a way
   that calloc/recalloc will be impractable and its size could vary greatly
*/
        if((preview_input_path = (char*)calloc(1000,CHAR_SIZE))==NULL)
                SpBadMemAlloc("SpInitialize 3a");
        (void)sprintf(preview_input_path, "%s", current_path);

/* loop through arguments */
	if(argc>1)
	{
		for(i=1;i<argc && !error;i++)
		{
			if(!strcmp(argv[i],"-f"))	/* defaults file */
			{
				if((charptr=(char*)realloc((char*)defaults_filename,((int)strlen(argv[++i])+1)*CHAR_SIZE))==NULL)
					SpBadMemAlloc("SpInitialize 4");
				else
					defaults_filename=charptr;
				(void)strcpy(defaults_filename,argv[i]);
			}
			else
				error=True;
				
		}
	}
/* read defaults file */
	if(!Spread_defaults(defaults_filename))
	{
		(void)fprintf(stderr,"splicer: Warning: cannot read defaults file %s.\n", defaults_filename);
		(void)fprintf(stderr,"\t\tUsing program defaults.\n");
	}
	else
		(void)fprintf(stderr,"splicer: Using defaults file %s.\n",defaults_filename);

  /* check args for foreground and background color
     save the color names for the hsplicer program
  */
  (void)sprintf(prgfgcolor, "black");
  (void)sprintf(prgbgcolor, "white");
  prgfg = NO;
  prgbg = NO;
  if(argc >= 3) {
    for(i=0; i<argc; ++i) {
      if(strcmp(argv[i], "-fg") == 0) {
        if(i < argc-1) {
          (void)sprintf(prgfgcolor, "");
          (void)strcpy(prgfgcolor, argv[i+1]);
          prgfg = YES;
        }
      }
      if(strcmp(argv[i], "-bg") == 0) {
        if(i < argc-1) {
          (void)sprintf(prgbgcolor, "");
          (void)strcpy(prgbgcolor, argv[i+1]);
          prgbg = YES;
        }
      }
    }
  }

}
	

void SpManageWarningBox(string)
char	*string;
{
	message.fatal=False;
	message.error=True;
	message.caller=SPMANAGEWARNINGBOX;
	message.type=XmDIALOG_WARNING;
	message.default_button=XmDIALOG_OK_BUTTON;
	if((message.label=(char*)calloc((int)strlen(string)+2,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpManageWarningBox 1");
	(void)strcat(message.label,string);
	SpManageMessage(message);

}

void	SpBadMemAlloc(string)
char	*string;
{
	(void)fprintf(stderr,"ERROR: Memory allocation failed at %s! Exit & restart program!!",string);
	message.fatal=True;
	message.error=True;
	message.caller=BADMEMALLOC;
	message.type=XmDIALOG_ERROR;
	message.default_button=XmDIALOG_OK_BUTTON;
	message.label=(char*)calloc(200+(int)strlen(string),CHAR_SIZE);
	(void)sprintf(message.label,"ERROR: Memory allocation failed at %s! Exit & restart program!!",string);
	SpManageMessage(message);
}

void SpSetSign(equ_widget,sign)
EquationMenuData	equ_widget;
int	sign;
{
	Widget	*tmp_widget;

	if(sign==LESS_THAN)
		tmp_widget=&equ_widget.pushButtonLessThan;
	else if(sign==LESS_THAN_OR_EQUAL_TO)
		tmp_widget=&equ_widget.pushButtonLessThanEqual;
	else if(sign==GREATER_THAN)
		tmp_widget=&equ_widget.pushButtonGreaterThan;
	else if(sign==GREATER_THAN_OR_EQUAL_TO)
		tmp_widget=&equ_widget.pushButtonGreaterThanEqual;
	else
		tmp_widget=&equ_widget.pushButtonEqual;
	XtVaSetValues(equ_widget.EquationMenu,XmNmenuHistory,*tmp_widget,NULL);
}

void SpSetEquationValues(equ)
Equation	equ;
{
	Widget	*tmp_widget;

/* set text values */
	if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL)
		SpBadMemAlloc("SpSetEquationValues 1");
	(void)sprintf(charptr,"%.3f",equ.value1);
	XmTextSetString(textFieldCullValue1,charptr);
	(void)sprintf(charptr,"%.3f",equ.value2);
	XmTextSetString(textFieldCullValue2,charptr);
	free(charptr);
	
/* set signs */
	SpSetSign(equationMenuCull1,equ.sign1);
	SpSetSign(equationMenuCull2,equ.sign2);
/* set join */
	if(equ.join==ONLY)
	{
		tmp_widget=&pushButtonCullOnly;
		XtSetSensitive(equationMenuCull2.EquationMenu,False);
		XtSetSensitive(textFieldCullValue2,False);
	}
	else
	{
		tmp_widget=&pushButtonCullOr;
		XtSetSensitive(equationMenuCull2.EquationMenu,True);
		XtSetSensitive(textFieldCullValue2,True);
	}
	XtVaSetValues(optionMenuCullJoin,XmNmenuHistory,*tmp_widget,NULL);
}

void SpUpdateReport(text_mes)
char	*text_mes;
{
	XmTextPosition  last_pos;

	last_pos=XmTextGetLastPosition(textReport);
	XmTextInsert(textReport,last_pos,text_mes);
	last_pos=last_pos+(XmTextPosition)(int)strlen(text_mes);
	XmTextShowPosition(textReport,last_pos);
	if(report.saveflag)
	{
		fputs("\n",report.ptr);
		fputs(text_mes,report.ptr);
	}
}

#define filesearch_string "ls -lAd1 %s|awk '{ if($1 ~ /^-/) { num=$NF; type=\"FILE\" }else if($1 ~ /^l/) { num=$(NF-2); type=\"LINK\" }else if($1 ~ /^d/) { num=$NF; type=\"DIR\" } nw=split(num,word,\"/\"); print type,word[nw] }'>%s\n"
#define dirsearch_string "ls -lA1 %s|awk '{ if($1 ~ /^-/) { num=$NF; type=\"FILE\" }else if($1 ~ /^l/) { num=$(NF-2); type=\"LINK\" }else if($1 ~ /^d/) { num=$NF; type=\"DIR\" } nw=split(num,word,\"/\"); print type,word[nw] }'>%s\n"


void SpUpdateOpen(widget_type)
int	widget_type;	
{
        char    	*tmpfile=NULL, filetype[13], *filename;
        FILE    	*fptr;
        int     	numfiles=0,numdirs=0,alloc_file,alloc_dir,i;
        XmString        *filelist,*dirlist,*selected_dir;
	char		*textstring;

	tmpfile=tmpnam(tmpfile);
	if(widget_type==FILE_FILTER) /* file filter was updated */
	{
		textstring = XmTextGetString(textOpenFilter);
		if((int)strlen(textstring)==0)	/* no filename */
		{
			if((filename=(char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 1");
			(void)sprintf(filename,"%s/*",current_path);
		}
		else if(textstring[0]=='/') /* full path used */
		{
			if((filename=(char*)calloc((int)strlen(textstring)+2,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 2");
			(void)strcpy(filename,textstring);
			*strrchr(textstring,'/')= '\0';
			if((charptr=(char*)realloc(current_path,((int)strlen(textstring)+2)*CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 3");
			else
				current_path=charptr;
			(void)strcpy(current_path,textstring);
			/* set current path */
		}
		else if (!strchr(textstring,'/'))	/* only filename */
		{
			if((filename=(char*)calloc((int)strlen(current_path)+(int)strlen(textstring)+5,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 4");
			(void)sprintf(filename,"%s/%s",current_path,textstring);
		}
		else				/* relative path and filename */
		{
			if((filename=(char*)calloc((int)strlen(current_path)+(int)strlen(textstring)+5,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 5");
			(void)sprintf(filename,"%s/%s",current_path,textstring);
			*strrchr(textstring,'/')= '\0';
			if((charptr=(char*)realloc(current_path,((int)strlen(textstring)+2)*CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 6");
			else
				current_path=charptr;
			(void)strcpy(current_path,textstring);
		}
		i=(int)strlen(filesearch_string)+(int)strlen(filename)+(int)strlen(tmpfile)+100;
		if((charptr=(char*)calloc(i,CHAR_SIZE))==NULL)
			SpBadMemAlloc("SpUpdateOpen 7");
		else
			(void)sprintf(charptr,filesearch_string,filename,tmpfile);
		XtFree(textstring);
	}
	else /* directories was updates */
	{
		XtVaGetValues(listOpenDirectory,XmNselectedItems,&selected_dir,XmNselectedItemCount,&numdirs,NULL);
		if(numdirs == 1)
		{
			if(!XmStringGetLtoR(selected_dir[0],XmFONTLIST_DEFAULT_TAG,&textstring))
  			{
        			message.error=True;
        			message.fatal=False;
                                message.caller=NONE;
                                message.type=XmDIALOG_WARNING;
                                message.default_button=XmDIALOG_OK_BUTTON;
        			if((message.label=(char*)calloc(200,CHAR_SIZE))==NULL)
                			SpBadMemAlloc("SpUpdateOpen 7a");
        			else
                			(void)sprintf(message.label,"Unable to convert selected_dir[0]");
        			SpManageMessage(message);
  			}
                        if(strcmp(textstring,"..") == 0 && strcmp(current_path, "/") == 0) 
                        {
                        }
			else if(!strcmp(textstring,".."))	/* move back a directory */
                        {
				*strrchr(current_path,'/')='\0';
                                if(strcmp(current_path, "") == 0)
                                {
                                  (void)sprintf(current_path, "/");
                                }
                        }
			else  if(strcmp(textstring,"."))	/* new directory */
			{
				if((charptr=(char*)realloc(current_path,((int)strlen(current_path)+(int)strlen(textstring)+2)*CHAR_SIZE))==NULL)
                                	SpBadMemAlloc("SpUpdateOpen 8");
                        	else
                                	current_path=charptr;
                                if(strcmp(current_path, "/") == 0)
                                {
			  	  (void)sprintf(current_path,"/%s",textstring);
                                }
                                else
                                {
                                  (void)sprintf(current_path,"%s/%s",current_path, textstring);
                                }
			}
			XtFree(textstring);

			if((charptr=(char*)calloc((int)strlen(dirsearch_string)+(int)strlen(current_path)+(int)strlen(tmpfile)+100,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 9");
			(void)sprintf(charptr,dirsearch_string,current_path,tmpfile);

			/* update filter field */
			if((filename=(char*)calloc((int)strlen(current_path)+5,CHAR_SIZE))==NULL)
				SpBadMemAlloc("SpUpdateOpen 10");
                        if(strcmp(current_path, "/") == 0)
                        {
                          (void)sprintf(filename,"/*");
                        }
                        else
                        {
			  (void)sprintf(filename,"%s/*",current_path);
                        }
			XmTextSetString(textOpenFilter,filename);
			XmListDeselectAllItems(listOpenDirectory);
		}
		else
                {
			SpManageWarningBox("Error opening new directory!");
                }
	}
        system(charptr);
	free(charptr);

	/* get file and directory names  */
	numdirs=0;
	if((filelist=(XmString*)calloc((alloc_file=1000),sizeof(XmString**)))==NULL)
			SpBadMemAlloc("SpUpdateOpen 10b");
	if((dirlist=(XmString*)calloc((alloc_dir=1000),sizeof(XmString**)))==NULL)
			SpBadMemAlloc("SpUpdateOpen 10c");
        dirlist[numdirs++]=XmStringCreateLocalized(".");
        dirlist[numdirs++]=XmStringCreateLocalized("..");
        if((fptr=fopen(tmpfile,"r"))!=NULL)
        {
		if((charptr=(char*)realloc(filename,1000*CHAR_SIZE))==NULL)
              		SpBadMemAlloc("SpUpdateOpen 11");
        	else
              		filename=charptr;
                while(fscanf(fptr,"%s %s",filetype,filename)!=EOF)
                {
                        if(!strcmp(filetype,"DIR")) 		/* directory names */
			{
				if(numdirs>=alloc_dir)
				{
					if((charptr=(char*)realloc((char*)dirlist,(alloc_dir+=1000)*sizeof(XmString*)))==NULL)
							SpBadMemAlloc("SpUpdateOpen 11b");
					else
						dirlist=(XmString*)charptr;
				}
                                dirlist[numdirs++]=XmStringCreateLocalized(filename);
			}
                        else if(!strcmp(filetype,"FILE"))	/* file names */
			{
				if(numfiles>=alloc_file)
				{
					if((charptr=(char*)realloc((char*)filelist,(alloc_file+=1000)*sizeof(XmString*)))==NULL)
							SpBadMemAlloc("SpUpdateOpen 11c");
					else
						filelist=(XmString*)charptr;
				}
                                filelist[numfiles++]=XmStringCreateLocalized(filename);
			}
			else if(!strcmp(filetype,"LINK"))	/*  symbolic link name */
			{
				if((charptr=(char*)realloc((char*)filename,((int)strlen(filename)+25)*sizeof(XmString*)))==NULL)
					SpBadMemAlloc("SpUpdateOpen 11d");
				else
					filename=charptr;
				(void)strcat(filename," (sym-link)");
				if(numfiles>=alloc_file)
				{
					if((charptr=(char*)realloc((char*)filelist,(alloc_file+=1000)*sizeof(XmString*)))==NULL)
							SpBadMemAlloc("SpUpdateOpen 11e");
					else
						filelist=(XmString*)charptr;
				}
				filelist[numfiles++]=XmStringCreateLocalized(filename);
			}
                }
		free(filename);
        }

	/* invalid directory */
	if(numfiles <=0 && numdirs<=2)
	{
		if((charptr=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
			SpBadMemAlloc("SpUpdateOpen 12");
		(void)sprintf(charptr,"Invalid or empty filter: %s !",filename);
		SpManageWarningBox(charptr);
		free(charptr);
	}
        /* if files found - put them in file list */
        else
	{
		if(numfiles>0)
                	XtVaSetValues(listOpenFiles,XmNitemCount,numfiles,XmNvisibleItemCount,numfiles
						,XmNitems,filelist,NULL);
        	else    /* no files found  - clear list */
			XmListDeleteAllItems(listOpenFiles);

        	/* put directories in dir list */
        	XtVaSetValues(listOpenDirectory,XmNitemCount,numdirs,XmNvisibleItemCount,numdirs
					,XmNitems,dirlist,NULL);
       		 /* clean up memory used and remove temporary file */
        	while(numdirs>0) XmStringFree(dirlist[--numdirs]);
        	while(numfiles>0) XmStringFree(filelist[--numfiles]);
	}
	free(dirlist);
	free(filelist);
        (void)remove(tmpfile);
}

void CheckAffineTableOrder(affineptr)
AffineTable *affineptr;
{
  int i, j, k, l, m, foundit;
  float dep;
  AffineHole tempaffinehole;
  AffineCore  tempaffinecore;
  void AffineTestPrint();

  /* is the affinetable in order?
  */
  /* by hole
  */
  doholeagain:
  if(affineptr->numhole > 1) {
    for(i=0; i<affineptr->numhole-1; ++i) {
      if(strcmp(affineptr->hole[i].name, affineptr->hole[i+1].name) > 0) {
        tempaffinehole = affineptr->hole[i];
        affineptr->hole[i] = affineptr->hole[i+1];
        affineptr->hole[i+1] = tempaffinehole;
        goto doholeagain;
      }
    }
  }

  /* by core
  */
  docoreagain:
  for(i=0; i<affineptr->numhole-1; ++i) {
    if(affineptr->hole[i].numcore > 1) {
      for(j=0; j<affineptr->hole[i].numcore-1; ++j) {
        if(affineptr->hole[i].core[j].name > affineptr->hole[i].core[j+1].name) {
          tempaffinecore = affineptr->hole[i].core[j];
          affineptr->hole[i].core[j] = affineptr->hole[i].core[j+1];
          affineptr->hole[i].core[j+1] = tempaffinecore;
          goto docoreagain;
        }
      }
    }
  }
}

void CheckAffineTableMissingHole(affineptr, ds)
AffineTable *affineptr;
int ds;
{
  int i, j, k, foundit;
  float dep;
 

  /* are there missing holes in affinetable?
  */
  for(i=0; i<data[ds]->numholes; ++i) {
    foundit = NO;
    for(j=0; j<affineptr->numhole; ++j) {
      if(strcmp(affineptr->hole[j].name, &data[ds]->holes[i]->name) == 0) {
        foundit = YES;
        break;
      }
    }
    if(foundit == NO) {
      j = 0;
      while(strcmp(affineptr->hole[j].name, &data[ds]->holes[i]->name) <= 0 && j < affineptr->numhole) {
        ++j;
      }
      ++affineptr->numhole;
      for(k=affineptr->numhole-1; k > j; --k) {
        affineptr->hole[k] = affineptr->hole[k-1];
      }
      strncpy(affineptr->hole[j].name, &data[ds]->holes[i]->name, 1);
      affineptr->hole[j].numcore = data[ds]->holes[i]->numcores;
      for(k=0; k<data[ds]->holes[i]->numcores; ++k) {
        affineptr->hole[j].core[k].leg = data[ds]->leg;
        affineptr->hole[j].core[k].site = data[ds]->site;
        affineptr->hole[j].core[k].name = data[ds]->holes[i]->core[k]->num;
        strncpy(affineptr->hole[j].core[k].type, &data[ds]->holes[i]->core[k]->value[0]->type, 1);
        /*
          dep = data[ds]->holes[i]->core[k]->value[0]->top_int + ((atoi(data[ds]->holes[i]->core[k]->value[0]->section) - 1) * 1.5);
          affineptr->hole[j].core[k].mbsf = data[ds]->holes[i]->core[k]->value[0]->sb_depth - dep/100.0;
        */
        affineptr->hole[j].core[k].cum_depth_offset = 0.0;
        affineptr->hole[j].core[k].did_offset = NO;
      }
    }
  }
}


void CheckAffineTableMissingCore(affineptr, ds)
AffineTable *affineptr;
int ds;
{
  int i, j, k, m, nh;
  float dep;

  /* within a hole are there missing cores in affinetable?
  */ 
  for(i=0; i<affineptr->numhole; ++i) {
    k = 0;
    j = 0;
    nh = affineptr->hole[i].data_map_to_hole[ds];
    if(nh >= 0 && nh < data[ds]->numholes) {
      while(k < data[ds]->holes[nh]->numcores && nh >= 0) {
        if(data[ds]->holes[nh]->core[k]->num == affineptr->hole[i].core[j].name) {
          if(j+1 < affineptr->hole[i].numcore) {
            ++j;
          }
          ++k;
        }
        else if(data[ds]->holes[nh]->core[k]->num > affineptr->hole[i].core[affineptr->hole[i].numcore-1].name) {
          /*add to end*/
          ++affineptr->hole[i].numcore;
          j = affineptr->hole[i].numcore - 1;
          affineptr->hole[i].core[j].leg = data[ds]->leg;
          affineptr->hole[i].core[j].site = data[ds]->site;
          affineptr->hole[i].core[j].name = data[ds]->holes[nh]->core[k]->num; 
          strncpy(affineptr->hole[i].core[j].type, &data[ds]->holes[nh]->core[k]->value[0]->type, 1); 
          /*
            dep = data[ds]->holes[nh]->core[k]->value[0]->top_int + ((atoi(data[ds]->holes[nh]->core[k]->value[0]->section) - 1) * 1.5);
            affineptr->hole[i].core[j].mbsf = data[ds]->holes[nh]->core[k]->value[0]->sb_depth - dep/100.0; 
          */
          if(j > 0) { 
            affineptr->hole[i].core[j].cum_depth_offset = affineptr->hole[i].core[j-1].cum_depth_offset; 
          } 
          else { 
            affineptr->hole[i].core[j].cum_depth_offset = 0.0;  
          } 
          affineptr->hole[i].core[j].did_offset = NO;
          ++k;
        }
        else if(data[ds]->holes[nh]->core[k]->num > affineptr->hole[i].core[j].name) {
          if(j+1 < affineptr->hole[i].numcore) {
            ++j;
          }
        }
        else if(data[ds]->holes[nh]->core[k]->num < affineptr->hole[i].core[j].name) {
          /*insert new core into table*/
          ++affineptr->hole[i].numcore;
          for(m=affineptr->hole[i].numcore-1; m > j; --m) {
            affineptr->hole[i].core[m] = affineptr->hole[i].core[m-1];
          }
          affineptr->hole[i].core[j].leg = data[ds]->leg;
          affineptr->hole[i].core[j].site = data[ds]->site;
          affineptr->hole[i].core[j].name = data[ds]->holes[nh]->core[k]->num;
          strncpy(affineptr->hole[i].core[j].type, &data[ds]->holes[nh]->core[k]->value[0]->type, 1);
          /*
            dep = data[ds]->holes[nh]->core[k]->value[0]->top_int + ((atoi(data[ds]->holes[nh]->core[k]->value[0]->section) - 1) * 1.5);
            affineptr->hole[i].core[j].mbsf = data[ds]->holes[nh]->core[k]->value[0]->sb_depth - dep/100.0;
          */
          if(j > 0) {
            affineptr->hole[i].core[j].cum_depth_offset = affineptr->hole[i].core[j-1].cum_depth_offset;
          }
          else {
            affineptr->hole[i].core[j].cum_depth_offset = 0.0;
          }
          affineptr->hole[i].core[j].did_offset = NO;
          ++k;
          if(j+1 < affineptr->hole[i].numcore) {
            ++j;
          }
        }
      }
    }
    else {
    }
  }
}

void AffineTestPrint()
{
  int i, j;
  
  for(i=0; i<affinetable.numhole; ++i) {
    for(j=0; j<affinetable.hole[i].numcore; ++j) {
      printf("%d    %d   %s   %d   %s   %6.2f   %d\n",
       affinetable.hole[i].core[j].leg, affinetable.hole[i].core[j].site, affinetable.hole[i].name, affinetable.hole[i].core[j].name,
       affinetable.hole[i].core[j].type,  
       affinetable.hole[i].core[j].cum_depth_offset, affinetable.hole[i].core[j].did_offset);
    }
  }
  printf("\n\n");
}

void MakeNewAffineTable(affineptr)
AffineTable *affineptr;
{
  int i, j;
  float top_dep;

  affineptr->numhole = data[dset]->numholes;

  for(i=0; i<data[dset]->numholes; ++i) {
    strncpy(affineptr->hole[i].name, &data[dset]->holes[i]->name, 1);
    affineptr->hole[i].numcore = data[dset]->holes[i]->numcores;
    for(j=0; j<data[dset]->holes[i]->numcores; ++j) {
      affineptr->hole[i].core[j].leg = data[dset]->leg;
      affineptr->hole[i].core[j].site = data[dset]->site;
      affineptr->hole[i].core[j].name = data[dset]->holes[i]->core[j]->num;
      strncpy(affineptr->hole[i].core[j].type, &data[dset]->holes[i]->core[j]->value[0]->type, 1);
      affineptr->hole[i].core[j].did_offset = NO;
      affineptr->hole[i].core[j].cum_depth_offset = 0.0;
      /*
        top_dep = data[dset]->holes[i]->core[j]->value[0]->top_int + ((atoi(data[dset]->holes[i]->core[j]->value[0]->section) - 1) * 1.5);
        affineptr->hole[i].core[j].mbsf = data[dset]->holes[i]->core[j]->value[0]->sb_depth - top_dep/100.0;
      */
    }
  }
}

void MapHoleToAffineTable(affineptr, ds)
AffineTable *affineptr;
int ds;
{
  int i, k;

  for(i=0; i<data[ds]->numholes; ++i) {
    data[ds]->holes[i]->affine_map_to_hole = -1;
  }
  for(k=0; k<affineptr->numhole; ++k) {
    affineptr->hole[k].data_map_to_hole[ds] = -1;
  }

  for(i=0; i<data[ds]->numholes; ++i) {
    for(k=0; k<affineptr->numhole; ++k) {
      if(strncmp(affineptr->hole[k].name, &data[ds]->holes[i]->name, 1) == 0) {
        data[ds]->holes[i]->affine_map_to_hole = k;
        affineptr->hole[k].data_map_to_hole[ds] = i;
        break;
      }
    }
  }
}

void MapCoreToAffineTable(affineptr, ds)
AffineTable *affineptr;
int ds;
{
  int i, j, k, nh;

  for(i=0; i<data[ds]->numholes; ++i) {
    for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
      data[ds]->holes[i]->core[j]->affine_map_to_core = -1;
      data[ds]->holes[i]->core[j]->cum_dep_offset = 0.0;
      data[ds]->holes[i]->core[j]->did_offset = NO;
    }
  }
  for(i=0; i<affineptr->numhole; ++i) {
    for(k=0; k<affineptr->hole[i].numcore; ++k) {
      affineptr->hole[i].core[k].data_map_to_core[ds] = -1;
    }
  }

  for(i=0; i<data[ds]->numholes; ++i) {
    nh = data[ds]->holes[i]->affine_map_to_hole; 
    if(nh >= 0) {
      for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
        for(k=0; k<affineptr->hole[nh].numcore; ++k) {
          if(data[ds]->holes[i]->core[j]->num == affineptr->hole[nh].core[k].name) {
            data[ds]->holes[i]->core[j]->affine_map_to_core = k;
            affineptr->hole[nh].core[k].data_map_to_core[ds] = j;
            data[ds]->holes[i]->core[j]->cum_dep_offset = affineptr->hole[nh].core[k].cum_depth_offset;
            data[ds]->holes[i]->core[j]->did_offset = affineptr->hole[nh].core[k].did_offset;
            break;
          }
        }
      }
    }
  }
}

void SpliceUndoWarning(reason, cnt)
int reason, cnt;
{

  char *warn;

  if((warn=(char*)calloc(MAXBUF,CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpliceUndoWarning");
  if(reason == SPL_UNDO_MISSING_CORE) {
    sprintf(warn, "Warning; missing %d core(s) above the core you want to remove.\n", cnt);
    strcat(warn, "if you remove this core the missing core(s) will be removed from the splice table.\n");
  }
  else if(reason == SPL_UNDO_TAILING_CORE) {
    sprintf(warn, "Warning; trailing %d core(s) below the core you want to remove.\n", cnt);
    strcat(warn, "if you remove this core the trailing core(s) will be removed from the splice table.\n");
  }
  strcat(warn, "do you still want to remove this core?");
  XmTextSetString(textSpliceUndo, warn);
  free(warn);
}

void CheckSpliceTableOffsets()
{
  int i, warn;

  warn = NO;
  for(i=0; i<spcomp.numcores; ++i) {
    if(fabs(spcomp.Depthoffset[i] - data[dset]->holes[spcomp.hole[i]]->core[spcomp.core[i]]->cum_dep_offset) >= 0.01) {
      warn = YES;
    }
  }

  if(warn == YES) {
    (void)sprintf(buffer,"Warning: the affine table and splice table depth offsets differ.");
    SpManageWarningBox(buffer);
  }
}

int CheckCoreAndDepthOrder(d)
int d;
{
  int i, j, k, k1, k2;

  /* check that, for each hole in current dataset, cores are in
     desending order. 
  */
  for(i=0; i<data[d]->numholes; ++i) {
    if(data[d]->holes[i]->numcores > 1) {
      for(j=0; j<data[d]->holes[i]->numcores-1; ++j) {
        if(data[d]->holes[i]->core[j]->num > data[d]->holes[i]->core[j+1]->num) {
          (void)sprintf(buffer,"Error:  core %d in hole %c is not in descending order.", 
                                  data[d]->holes[i]->core[j]->num, data[d]->holes[i]->name);
          SpManageWarningBox(buffer);
          return ERR;
        }
      }
    }
  }
 
  /* and within the core depths are in order.
  */
  for(i=0; i<data[d]->numholes; ++i) {
    for(j=0; j<data[d]->holes[i]->numcores; ++j) {
      if(data[d]->holes[i]->core[j]->numvalues > 1) {
        k1 = 0;
        k2 = 1;
        while(k2 < data[d]->holes[i]->core[j]->numvalues) {
          if(data[d]->holes[i]->core[j]->value[k1]->quality != GOOD) {
            ++k1;
            k2 = k1 + 1;
          }
          else if(data[d]->holes[i]->core[j]->value[k2]->quality != GOOD) {
            ++k2;
          }
          else {
            if(data[d]->holes[i]->core[j]->value[k1]->sb_depth > data[d]->holes[i]->core[j]->value[k2]->sb_depth) {
             (void)sprintf(buffer,"Error: the depths in core %d, hole %c are not in descending order at\nsect. %s  %.1f(cm)  %.2f(mbsf)", 
                                     data[d]->holes[i]->core[j]->num,data[d]->holes[i]->name,
                                     data[d]->holes[i]->core[j]->value[k2]->section, data[d]->holes[i]->core[j]->value[k2]->top_int,
                                     data[d]->holes[i]->core[j]->value[k2]->sb_depth);
              SpManageWarningBox(buffer);
              return ERR;
            }
            ++k1;
            ++k2;
          }
        }
      }
    }
  }

  /* section interval depth; bot not less than top
  */
  if(data[d]->in_format != ODPOTHER4 && data[d]->in_format != ODPOTHER5) {
    for(i=0; i<data[d]->numholes; ++i) {
      for(j=0; j<data[d]->holes[i]->numcores; ++j) {
        for(k1=0; k1<data[d]->holes[i]->core[j]->numvalues; ++k1) {
          if(data[d]->holes[i]->core[j]->value[k1]->quality != GOOD) {
          }
          else {
            if((data[d]->holes[i]->core[j]->value[k1]->bot_int - data[d]->holes[i]->core[j]->value[k1]->top_int) < -0.05) {
              (void)sprintf(buffer,"Error: the depths in core %d, hole %c are not in descending order at\nsect. %s  %.1f(cm)  %.1f(cm)  %.2f(mbsf)",
                                     data[d]->holes[i]->core[j]->num,data[d]->holes[i]->name,
                                     data[d]->holes[i]->core[j]->value[k1]->section, data[d]->holes[i]->core[j]->value[k1]->top_int,
                                     data[d]->holes[i]->core[j]->value[k1]->bot_int, data[d]->holes[i]->core[j]->value[k1]->sb_depth);
              SpManageWarningBox(buffer);
              return ERR;
            }
          }
        }
      }
    }
  }
  return GOOD;
}


int MakeSplice(ds, sp)
int        ds;
SpliceComp *sp;
{
  int i, j, k, sptable_cnt, sm, dum1, dum2, warn;
  Core    *coreptr;
  Value   *valueptr;
  int FindValueInCoreToSplice();

  sptable_cnt = 0;
  sp->numcores = 0;
  warn = False;

  while(sptable_cnt < splicertable.data_cnt) {

    /* fine which hole
    */
    for(i=0;i<data[ds]->numholes && splicertable.data[sptable_cnt].hole!=data[ds]->holes[i]->name;i++);

    if(i<data[ds]->numholes)
    {

      /* find correct core 
      */
      for(j=0;j<data[ds]->holes[i]->numcores && splicertable.data[sptable_cnt].core!=data[ds]->holes[i]->core[j]->num;j++);
      if(j<data[ds]->holes[i]->numcores)
      {
        /* find first value for this core
        */
        coreptr=data[ds]->holes[i]->core[j];
        for(k=0;k<coreptr->numvalues && coreptr->value[k]->sb_depth < splicertable.data[sptable_cnt].mbsf; k++);

        /* get "good" values until bottom of tied core
        */
        if(k<coreptr->numvalues)
        {
          sp->hole[sp->numcores]=i;
          sp->core[sp->numcores]=j;
          sp->Depthoffset[sp->numcores]=splicertable.data[sptable_cnt].mcd-splicertable.data[sptable_cnt].mbsf;
          sp->numpercore[sp->numcores]=0;
          sp->map_to_table[sp->numcores] = sptable_cnt;
          if(sp->numcores > 0) {
            if(strcmp(splicertable.data[sptable_cnt].type_of_splice, "tie") == 0) {
              sp->splice_how[sp->numcores] = REAL;
            }
            else if(strcmp(splicertable.data[sptable_cnt].type_of_splice, "interp") == 0) {
              sp->splice_how[sp->numcores] = INTERPOLATED;
              sp->interpolated_spl_depth[sp->numcores] = splicertable.data[sptable_cnt].mcd;

              /* note that if find real value at 'depth' then splicearraynum comes back
                 with indicy of real point. but if interpolated a point then splicearraynum
                 is the indicy of next real point.
              */
              if(smooth.method == GAUSSIAN || smooth.method == OTHER) {
                sm == YES;
              }
              else {
                sm = NO;
              }
              (void)FindValueInCoreToSplice(ds, sm, sp->interpolated_spl_depth[sp->numcores],
                                          sp->hole[sp->numcores], sp->core[sp->numcores],
                                          &dum1, &dum2,
                                          &sp->interpolated_value[sp->numcores], &sp->interpolated_sm_value[sp->numcores]);
            }
            else if(strcmp(splicertable.data[sptable_cnt].type_of_splice, "append") == 0) {
              sp->splice_how[sp->numcores] = APPEND;
            }
            else {
              sp->splice_how[sp->numcores] = NONE;
            }
          }
          else {
            sp->splice_how[sp->numcores] = NONE;
          }
          for(;k<coreptr->numvalues && coreptr->value[k]->sb_depth <= splicertable.data[sptable_cnt+1].mbsf; k++)
          {
            valueptr=coreptr->value[k];
            if(valueptr->quality == GOOD)
            {
              sp->MapToOrig[sp->numcores][sp->numpercore[sp->numcores]] = k;
              sp->sb_depth[sp->numcores][sp->numpercore[sp->numcores]] = valueptr->sb_depth+sp->Depthoffset[sp->numcores];
              sp->var[sp->numcores][sp->numpercore[sp->numcores]] = *valueptr->data;
              sp->numpercore[sp->numcores]++;
            }
          }
          ++sp->numcores;
        }
        else {
          warn=SPL_NO_CORE_VALUES;
        }
      }
      else {
        warn=SPL_MISSING_CORE;
      }

      sptable_cnt+=2;
    }
    else
    {
      warn=SPL_MISSING_HOLE;
      sptable_cnt+=2;
    }
  }
}

void CullData(ds)
int ds;
{
  int i, j, k, hashflag, err;
  XmString xmstring;
  int FindMinMax(), CheckHowManyCulled();
  void SpCull(), SmoothData(), SetMinMax();

  for(i=0; i<data[ds]->numholes; ++i) {

    for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
      for(k=0; k<data[ds]->holes[i]->core[j]->numvalues; ++k) {
        data[ds]->holes[i]->core[j]->value[k]->quality = GOOD;
        if(fabs(data[ds]->holes[i]->core[j]->value[k]->sb_depth - BAD_CODE) <= ROUNDCHECK) {
          data[ds]->holes[i]->core[j]->value[k]->quality =BAD_SB_DEPTH;
        }
      }
    }

    if(cull.method==CULL_TABLE || cull.method == CULL_PARAMETER_AND_TABLE)
    {
           if(i==0 && hashflag!=CREATE_HASH)
           {
                   hashflag=CREATE_HASH;
           }
           else if(i+1==data[dset]->numholes)
                   hashflag=DESTROY_HASH;
           else
                   hashflag=0;
    }
  }
  SpCull(data[ds], data[ds]->type,cull,hashflag);

  /* if error culling restore data set by unculling
  */
  if((err = CheckHowManyCulled(ds)) > 0) {
    for(i=0; i<data[ds]->numholes; ++i) {
      for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
        for(k=0; k<data[ds]->holes[i]->core[j]->numvalues; ++k) {
          data[ds]->holes[i]->core[j]->value[k]->quality = GOOD;
          if(fabs(data[ds]->holes[i]->core[j]->value[k]->sb_depth - BAD_CODE) <= ROUNDCHECK) {
            data[ds]->holes[i]->core[j]->value[k]->quality =BAD_SB_DEPTH;
          }
        }
      }
    }
  }


  if((err = FindMinMax(dset)) > 0) {
    SpManageWarningBox("Warning; Could not find the min and max values of this data set. Using defaults.");
    if(data[ds]->type == GRAPE) {
      data[ds]->min = GRAPEMIN;
      data[ds]->max = GRAPEMAX;
    }
    else if(data[ds]->type == PWAVE) {
      data[ds]->min = PWAVEMIN;
      data[ds]->max = PWAVEMAX;
    }
    else if(data[ds]->type == SUSCEPTIBILITY) {
      data[ds]->min = SUSCMIN;
      data[ds]->max = SUSCMAX;
    }
    else if(data[ds]->type == NATURALGAMMA) {
      data[ds]->min = NGAMMAMIN;
      data[ds]->max = NGAMMAMAX;
    }
    else if(data[ds]->type == REFLECTANCEMST) {
      data[ds]->min = REFLECTMIN;
      data[ds]->max = REFLECTMAX;
    }
    else if(data[ds]->type == OTHERTYPE) {
      data[ds]->min = OTHERMIN;
      data[ds]->max = OTHERMAX;
    }
    else {
    } 
  }
  else {
    data[ds]->min = minvar;
    data[ds]->max = maxvar;
  }
  SetMinMax(ds);

  if(smooth.method!=NONE) {
    SmoothData(ds);
  }
}

void SmoothData(ds)
int ds;
{
  int i;
  XmString xmstring;
  void SpSmooth();

  xmstring = XmStringCreateSimple("Smoothing:");
  XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring,NULL);
  XmStringFree(xmstring);

  for(i=0; i<data[ds]->numholes; ++i) {
    if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SmoothData 1");
    (void)sprintf(charptr,"\nData : Smoothing data hole %c.",data[ds]->holes[i]->name);
    SpUpdateReport(charptr);
    free(charptr);

    if(i == 0) {
      if(smooth.width_units == DEPTH && smooth.width < MINSMOOTHWIDTH * average_depth_step) {
        if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SmoothData 2");
        (void)sprintf(charptr, "The width of the filter is too small. Please create a filter as wide or wider than %dcm.", 
                                 MINSMOOTHWIDTH * average_depth_step);
        SpManageWarningBox(charptr);
        free(charptr);
        smooth.method = NONE;
      }
      else if(smooth.width_units == POINTS && smooth.width < MINSMOOTHWIDTH) {
        if((charptr=(char*)calloc(200,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SmoothData 3");
        (void)sprintf(charptr, "The width of the filter is too small. Please create a filter as wide or wider than %d pts.", 
                                 MINSMOOTHWIDTH);
        SpManageWarningBox(charptr);
        free(charptr);
        smooth.method = NONE;
      }
    }

    if(smooth.method!=NONE) {
      SpSmooth(data[ds]->holes[i]);
    }
  }
}

void DecimateData(ds, decimate)
int ds;
int decimate;
{
  int i;
  XmString xmstring;
  void SpDecimate();

  CullData(ds);

  for(i=0; i<data[ds]->numholes; ++i) {
    if((charptr=(char*)calloc(100,CHAR_SIZE))==NULL)
                       SpBadMemAlloc("DecimateData 1");
    (void)sprintf(charptr,"\nData : Decimating data hole %c.",data[ds]->holes[i]->name);
    SpUpdateReport(charptr);
    xmstring=XmStringCreateLocalized(&charptr[1]);
    XtVaSetValues(messageBoxWorking,XmNmessageString,xmstring, NULL);
    XmStringFree(xmstring);
    free(charptr);

    SpDecimate(data[ds]->holes[i],decimate);
    
  }
}

void DetrendData(ds, how)
int ds;
int how;
{
  int i, j, k;
  float mean, sum, sum1, sum2, cnt, tbar, denom, xalpha, xbeta, fi;

  /* calculate mean
  */
  sum=0.0;
  cnt = 0.0;
  for(i=0; i<data[ds]->numholes; ++i) {
    for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
      for(k=0; k<data[ds]->holes[i]->core[j]->numvalues; ++k) {
        sum = sum + *data[ds]->holes[i]->core[j]->value[k]->data;
        ++cnt;
      }
    }
  }
  mean = sum/cnt;


  /* mean detrend
  */

  if(how == MEAN_DETREND) {
/*
    xdetrend = x[i] - mean;
*/
  }

  /* linear detrend
  */

  else if(how == LINEAR_DETREND) {
 
/*
        sum1=0.0;
        sum2=0.0;
        tbar = (cnt-1)/2.0;
        denom = (cnt-1.0)*cnt*(cnt+1.0)/6.0;
        do 250 i=1,nw
          sum2=2*i-nw+1
          sum2=(x(i)-vmean)*sum2
  250     sum1=sum1+sum2
        xalpha = sum1/denom;
        xbeta = vmean-xalpha*tbar;
        do 260 i=1,nw
          fi = i-1;
  260     x(i)=x(i)-fi*xalpha-xbeta;
*/

  }
}

void SpUpdateFileSelection(how, who, ptrpath)
int     how;
int     who;
char    *ptrpath;
{
        char            *tmpfile=NULL, *textstring, filetype[13], *filename;
        int             numfiles=0,numdirs=0,alloc_file,alloc_dir,i;
        XmString        *filelist, *dirlist, *selected_dir;
        FILE            *fptr;
  
        if(how != FILE_FILTER && how != DIRECTORIES) {
          return;
        }

        tmpfile=tmpnam(tmpfile);
        if(how==FILE_FILTER) /* file filter was updated */
        {
                if(who == PREVIEWINPUT) {
                  textstring = XmTextGetString(textFileSelectionFilterPreviewInput);
                }
                else if(who == SAVEDATA) {
                  textstring = XmTextGetString(textFieldSaveDataFilter);
                }
                else {
                  textstring = XmTextGetString(textFileSelectionFilter);
                }
                if((int)strlen(textstring)==0)  /* no filename */
                {
                        if((filename=(char*)calloc((int)strlen(ptrpath)+5,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpUpdateFileSelction 1");
                        (void)sprintf(filename,"%s/*",ptrpath);
                }
                else if(textstring[0]=='/') /* full path used */
                {
                        if((filename=(char*)calloc((int)strlen(textstring)+2,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpUpdateFileSelction 2");
                        (void)strcpy(filename,textstring);
                        *strrchr(textstring,'/')= '\0';
                        (void)strcpy(ptrpath,textstring);
                        /* set current path */
                }
                else if (!strchr(textstring,'/'))       /* only filename */
                {
                        if((filename=(char*)calloc((int)strlen(ptrpath)+(int)strlen(textstring)+5,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpUpdateFileSelction 4");
                        (void)sprintf(filename,"%s/%s",ptrpath,textstring);
                }
                else                            /* relative path and filename */
                {
                        if((filename=(char*)calloc((int)strlen(ptrpath)+(int)strlen(textstring)+5,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpUpdateFileSelction 5");
                        (void)sprintf(filename,"%s/%s",ptrpath,textstring);
                        *strrchr(textstring,'/')= '\0';
                        (void)strcpy(ptrpath,textstring);
                }
                if(who == PREVIEWINPUT) {
                  XtVaSetValues(textFileSelectionFilterPreviewInput, XmNvalue, filename, NULL);
                }
                else {
                  XtVaSetValues(textFileSelectionFilter, XmNvalue, filename, NULL);
                }
                i=(int)strlen(filesearch_string)+(int)strlen(filename)+(int)strlen(tmpfile)+100;
                if((charptr=(char*)calloc(i,CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpUpdateFileSelction 7");
                else
                        (void)sprintf(charptr,filesearch_string,filename,tmpfile);

                XtFree(textstring);
        }
        else if(how == DIRECTORIES) /* directories were updated */
        {
                if(who == PREVIEWINPUT) {
                  XtVaGetValues(listFileSelectionDirPreviewInput,XmNselectedItems,&selected_dir,XmNselectedItemCount,&numdirs,NULL);
                }
                else if(who == SAVEDATA) {
                  XtVaGetValues(listSaveDataDirectory,XmNselectedItems,&selected_dir,XmNselectedItemCount,&numdirs,NULL);
                }
                else {
                  XtVaGetValues(listFileSelectionDirectories,XmNselectedItems,&selected_dir,XmNselectedItemCount,&numdirs,NULL);
                }
                if(numdirs == 1)
                {
                        if(!XmStringGetLtoR(selected_dir[0],XmFONTLIST_DEFAULT_TAG,&textstring))
                        {
                                message.error=True;
                                message.fatal=False;
                                message.caller=NONE;
                                message.type=XmDIALOG_WARNING;
                                message.default_button=XmDIALOG_OK_BUTTON;
                                if((message.label=(char*)calloc(200,CHAR_SIZE))==NULL)
                                        SpBadMemAlloc("SpUpdateFileSelction 7a");
                                else
                                        (void)sprintf(message.label,"Unable to convert selected_dir[0]");
                                SpManageMessage(message);
                        }
                        if(strcmp(textstring,"..") == 0 && strcmp(ptrpath, "/") == 0)
                        {
                        }
                        else if(!strcmp(textstring,".."))       /* move back a directory */
                        {
                                *strrchr(ptrpath,'/')='\0';
                                if(strcmp(ptrpath, "") == 0)
                                {
                                  (void)sprintf(ptrpath, "/");
                                }
                        }
                        else  if(strcmp(textstring,"."))        /* new directory */
                        {
                                if(strcmp(ptrpath, "/") == 0)
                                {
                                  (void)sprintf(ptrpath,"/%s",textstring);
                                }
                                else
                                {
                                  (void)sprintf(ptrpath,"%s/%s",ptrpath, textstring);
                                }
                        }
                        XtFree(textstring);
                        if((charptr=(char*)calloc((int)strlen(dirsearch_string)+(int)strlen(ptrpath)+(int)strlen(tmpfile)+100,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpUpdateFileSelction 9");
                        (void)sprintf(charptr,dirsearch_string,ptrpath, tmpfile);

                        /* update filter field */
                        if((filename=(char*)calloc((int)strlen(ptrpath)+5,CHAR_SIZE))==NULL)
                                SpBadMemAlloc("SpUpdateFileSelction 10");
                        if(strcmp(ptrpath, "/") == 0)
                        {
                          (void)sprintf(filename,"/*");
                        }
                        else
                        {
                          (void)sprintf(filename,"%s/*",ptrpath);
                        }
                        if(who == PREVIEWINPUT) {
                          XmTextSetString(textFileSelectionFilterPreviewInput,filename);
                          XmListDeselectAllItems(listFileSelectionDirPreviewInput);
                        }
                        else if(who == SAVEDATA) {
                          XmTextSetString(textFieldSaveDataFilter,filename);
                          XmListDeselectAllItems(listSaveDataDirectory);
                        }
                        else {
                          XmTextSetString(textFileSelectionFilter,filename);
                          XmListDeselectAllItems(listFileSelectionDirectories);
                        }
                }
                else
                {
                        SpManageWarningBox("Error opening new directory!");
                }
        }
        system(charptr);
        free(charptr);

        /* get file and directory names for filter path */
        numdirs=0;
        if((filelist=(XmString*)calloc((alloc_file=1000),sizeof(XmString**)))==NULL)
                        SpBadMemAlloc("SpUpdateFileSelction 10b");
        if((dirlist=(XmString*)calloc((alloc_dir=1000),sizeof(XmString**)))==NULL)
                        SpBadMemAlloc("SpUpdateFileSelction 10c");
        dirlist[numdirs++]=XmStringCreateLocalized(".");
        dirlist[numdirs++]=XmStringCreateLocalized("..");
        if((fptr=fopen(tmpfile,"r"))!=NULL)
        {
                if((charptr=(char*)realloc(filename,1000*CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpUpdateFileSelction 11");
                else
                        filename=charptr;
                while(fscanf(fptr,"%s %s",filetype,filename)!=EOF)
                {
                        if(!strcmp(filetype,"DIR"))             /* directory names */
                        {
                                if(numdirs>=alloc_dir)
                                {
                                        if((charptr=(char*)realloc((char*)dirlist,(alloc_dir+=1000)*sizeof(XmString*)))==NULL)
                                                        SpBadMemAlloc("SpUpdateFileSelction 11b");
                                        else
                                                dirlist=(XmString*)charptr;
                                }
                                dirlist[numdirs++]=XmStringCreateLocalized(filename);
                        }
                        else if(!strcmp(filetype,"FILE"))       /* file names */
                        {
                                if(numfiles>=alloc_file)
                                {
                                        if((charptr=(char*)realloc((char*)filelist,(alloc_file+=1000)*sizeof(XmString*)))==NULL)
                                                        SpBadMemAlloc("SpUpdateFileSelction 11c");
                                        else
                                                filelist=(XmString*)charptr;
                                }
                                filelist[numfiles++]=XmStringCreateLocalized(filename);
                        }
                        else if(!strcmp(filetype,"LINK"))       /*  symbolic link name */
                        {
                                if((charptr=(char*)realloc((char*)filename,((int)strlen(filename)+25)*sizeof(XmString*)))==NULL)
                                        SpBadMemAlloc("SpUpdateFileSelction 11d");
                                else
                                        filename=charptr;
                                (void)strcat(filename," (sym-link)");
                                if(numfiles>=alloc_file)
                                {
                                        if((charptr=(char*)realloc((char*)filelist,(alloc_file+=1000)*sizeof(XmString*)))==NULL)
                                                        SpBadMemAlloc("SpUpdateFileSelction 11e");
                                        else
                                                filelist=(XmString*)charptr;
                                }
                                filelist[numfiles++]=XmStringCreateLocalized(filename);
                        }
                }
                free(filename);
        }

        /* invalid directory */
        if(who == SAVEDATA <=0 && numdirs<=2)
        {
                if((charptr=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpUpdateFileSelction 12");
                (void)sprintf(charptr,"Unable to do directory search.");
                SpManageWarningBox(charptr);
                free(charptr);
        }
        else if(numfiles <=0 && numdirs<=2)
        {
                if((charptr=(char*)calloc((int)strlen(filename)+50,CHAR_SIZE))==NULL)
                        SpBadMemAlloc("SpUpdateFileSelction 12");
                (void)sprintf(charptr,"Invalid or empty filter: %s !",filename);
                SpManageWarningBox(charptr);
                free(charptr);
        }

        /* if files found - put them in file list */
        if(who == PREVIEWINPUT) {
          if(numfiles>0)
            XtVaSetValues(listFileSelectionFilesPreviewInput,XmNitemCount,numfiles,XmNvisibleItemCount,numfiles
                                            ,XmNitems,filelist,NULL);
          else    /* no files found  - clear list */
            XmListDeleteAllItems(listFileSelectionFilesPreviewInput);

          /* put directories in dir list */
          XtVaSetValues(listFileSelectionDirPreviewInput,XmNitemCount,numdirs,XmNvisibleItemCount,numdirs
                                        ,XmNitems,dirlist,NULL);
        }
        else if(who == SAVEDATA) {
          /* put directories in dir list */
          XtVaSetValues(listSaveDataDirectory,XmNitemCount,numdirs,XmNvisibleItemCount,numdirs
                                        ,XmNitems,dirlist,NULL);
        }
        else {
          if(numfiles>0)
            XtVaSetValues(listFileSelectionFiles,XmNitemCount,numfiles,XmNvisibleItemCount,numfiles
                                            ,XmNitems,filelist,NULL);
          else    /* no files found  - clear list */
            XmListDeleteAllItems(listFileSelectionFiles);

          /* put directories in dir list */
          XtVaSetValues(listFileSelectionDirectories,XmNitemCount,numdirs,XmNvisibleItemCount,numdirs
                                        ,XmNitems,dirlist,NULL);
        }

        /* clean up memory used and remove temporary file */
        while(numdirs>0) XmStringFree(dirlist[--numdirs]);
        while(numfiles>0) XmStringFree(filelist[--numfiles]);
       
        free(dirlist);
        free(filelist);
        (void)remove(tmpfile);
}

void RecalcDatumAges()
{
  int i, j, k, n, f, d, done;
  float sedrate[MAXAGE], tempmcd[MAXAGE], tempage[MAXAGE], newage, diffage;

  /* make a temp array for all dataums that are tuned
  */
  n=0;
  for(i=0; i<agemodel_cnt; ++i) {
    if(agemodel[i].type == TIME) {
      tempage[n] = agemodel[i].aveage;
      tempmcd[n] = agemodel[i].avemcd;
      ++n;
    } 
  }

  /* if no tuned datums then return original values to strat datums
  */
  if(n == 0) {
    for(i=0; i<agemodel_cnt; ++i) {
      if(agemodel[i].type != HANDPICK) {
        f = agemodel[i].agemodel_maptostratfile;
        d = agemodel[i].agemodel_maptodatum;
        if(f >= 0 && d >= 0) {
          agemodel[i].aveage = strat[f]->data[d].aveage;
        }
      }
      else if(agemodel[i].type == HANDPICK) {
     
      }
    }
  }

  else if(agemodel_cnt == 1) {
    return;
  }

  /* calculate new strat ages
  */
  else {
    /* calculate the sed rate using only the tuned datums
    */
    if(n > 1) {
      for(i=1; i<n; ++i) {
        sedrate[i-1] = (tempmcd[i] - tempmcd[i-1])/(tempage[i] - tempage[i-1]);
      }
      sedrate[n-1] = sedrate[n-2];
    }
    else {
      sedrate[0] = agemodel_avesedrate;
    }

    i = 0;
    done = NO;
    while(i<agemodel_cnt && done == NO) {
      /* if the current datum is a strat datum
      */
      if(agemodel[i].type != TIME) {

        /* if the strat datum's mcd falls above first tuned datum or below last
        */
        if(agemodel[i].avemcd < tempmcd[0]) {
          if(agemodel[i].type != HANDPICK) {
            f = agemodel[i].agemodel_maptostratfile;
            d = agemodel[i].agemodel_maptodatum;
            if(f >= 0 && d >= 0) {
              agemodel[i].aveage = strat[f]->data[d].aveage;
            }
            else {

            }
          }
          else if(agemodel[i].type == HANDPICK) {

          }
          if(agemodel[i].aveage > tempage[0]) {
            agemodel[i].aveage = tempage[0] - (tempmcd[0] - agemodel[i].avemcd)/sedrate[0];
            for(j=i; j>0; --j) {
              if(agemodel[j-1].aveage > agemodel[j].aveage) {
                agemodel[j-1].aveage = tempage[0] - (tempmcd[0] - agemodel[j-1].avemcd)/sedrate[0];
              }
            }
          }
        }
        else if(agemodel[i].avemcd > tempmcd[n-1]) {
          if(agemodel[i].type != HANDPICK) {
            f = agemodel[i].agemodel_maptostratfile;
            d = agemodel[i].agemodel_maptodatum;
            if(f >= 0 && d >= 0) {
              agemodel[i].aveage = strat[f]->data[d].aveage;
            }
            else {

            }
          }
          else if(agemodel[i].type == HANDPICK) {

          }
          if(agemodel[i].aveage < tempage[n-1]) {
            newage = tempage[n-1] + (agemodel[i].avemcd - tempmcd[n-1])/sedrate[n-1];
            diffage = newage - agemodel[i].aveage;
            agemodel[i].aveage = newage;
          }
          for(j=i; j<agemodel_cnt-1; ++j) {
            if(agemodel[j+1].aveage < agemodel[j].aveage) {
              agemodel[j+1].aveage = agemodel[j+1].aveage + diffage;
            }
            else {
              if(agemodel[j+1].type != HANDPICK) {
                f = agemodel[j+1].agemodel_maptostratfile;
                d = agemodel[j+1].agemodel_maptodatum;
                if(f >= 0 && d >= 0) {
                  agemodel[j+1].aveage = strat[f]->data[d].aveage;
                }
              }
              else if(agemodel[j+1].type == HANDPICK) {
              }
            }
          }
          done = YES;
        }

        /* otherwise calculate(interpolate) a new tuned age for strat datum using tuned dates
           from above and below
        */
        else {
          for(j=0; j<n-1; ++j) {
            if(agemodel[i].avemcd >= tempmcd[j] && agemodel[i].avemcd < tempmcd[j+1]) {
              agemodel[i].aveage = tempage[j] + (agemodel[i].avemcd - tempmcd[j])/sedrate[j];
            }
          }
        }
      }
      ++i;
    }
  }
}

int VerifyFileReadable(file, kind, who)
char *file;
int kind;
int who;
{
  int len;
  char *checkfile, *tmpfile=NULL, *tmpinfo;
  FILE *fptr;

  /* check that file can be openned
  */
  if(who != SAVEDATA) {
    if(kind == OPEN) {
      if((fptr=fopen(file, "r")) == NULL) {
        return NO;
      }
      fclose(fptr);
    }
    else if(kind == SAVE) {
      if((fptr=fopen(file, "w")) == NULL) {
        return NO;
      }
      fclose(fptr);
    }
    else {
      return NO;
    }
  }

  /* check that file is of a readable type
  */
  tmpfile=tmpnam(tmpfile);
  if((tmpinfo=(char*)calloc((int)strlen(file)+(int)strlen(tmpfile)+50,CHAR_SIZE))==NULL) {
                        SpBadMemAlloc("VerifyFileReadable1");
  }
  else {
    (void)sprintf(tmpinfo,"ls -dF %s > %s", file, tmpfile);
  }
  system(tmpinfo);
  XtFree(tmpinfo);
  if(tmpinfo) {
    tmpinfo = NULL;
  }
  
  if((fptr=fopen(tmpfile,"r"))!=NULL) {
    if((checkfile=(char*)calloc((int)strlen(file)+100,CHAR_SIZE))==NULL) {
                        SpBadMemAlloc("VerifyFileReadable2");
    }
    (void)fscanf(fptr, "%s", checkfile);
    fclose(fptr);
    (void)remove(tmpfile);
    len=strlen(checkfile);
    if(len<1) {
      XtFree(checkfile);
      if(checkfile) {
        checkfile = NULL;
      }
      return NO;
    }
    /* '/' indicates the file is a directory, '*' an executable and '@ a symbolic link
    */
    else if(who == OPENCULLTABLE &&
            (strcmp(&checkfile[len-1], "/") == 0 || strcmp(&checkfile[len-1], "@") == 0)) {
      XtFree(checkfile);
      if(checkfile) {
        checkfile = NULL;
      }
      return NO;
    }
    else if(who != OPENCULLTABLE && who != SAVEDATA &&
            (strcmp(&checkfile[len-1], "/") == 0 || strcmp(&checkfile[len-1], "*") == 0 || strcmp(&checkfile[len-1], "@") == 0)) {
      XtFree(checkfile);
      if(checkfile) {
        checkfile = NULL;
      }
      return NO;
    }
    else if(who == SAVEDATA && (strcmp(&checkfile[len-1], "/") != 0)) {
      XtFree(checkfile);
      if(checkfile) {
        checkfile = NULL;
      }
      return NO;
    }
    else {
      XtFree(checkfile);
      if(checkfile) {
        checkfile = NULL;
      }
      return YES;
    }
  }
  else {
    (void)remove(tmpfile);
    return NO;
  }
}

int CheckHowManyCulled(ds)
int ds;
{
  int i, j, k;
  float  cullcnt, count, percent;

  for(i=0; i<data[ds]->numholes; ++i) {
    for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
      for(k=0; k<data[ds]->holes[i]->core[j]->numvalues; ++k) {
        if(data[ds]->holes[i]->core[j]->value[k]->quality != GOOD) {
          ++cullcnt;
          ++count;
        }
        else {
          ++count;
        }
      }
    }
  }

  percent = (cullcnt/count)*100.0;
  if(percent > WARNCULL) {
    if(percent < TOOMANYCULLED) {
      (void)sprintf(buffer,"Warning: %.1f percent of the data has been culled.", percent);
      SpManageWarningBox(buffer);
      message.error = False;
      return 0;
    }
    else {
      (void)sprintf(buffer,"Error: %.1f percent of the data has been culled. Restoring to unculled values.", percent);
      SpManageWarningBox(buffer);
      message.error = True;
      return 1;
    }
  }
  return 0;
}

void WaitCursor(what)
int what;
{

  if(what == DEFINEWAITCURSOR) {
    io_wait_cursor = XCreateFontCursor(XtDisplay(formSplicer), XC_watch);
    if(io_wait_cursor != BadAlloc && io_wait_cursor != BadFont && io_wait_cursor != BadValue) {
      XDefineCursor(XtDisplay(formSplicer), XtWindow(formSplicer), io_wait_cursor);
      XFreeCursor(XtDisplay(formSplicer), io_wait_cursor);
    }
/*
      XDefineCursor(XtDisplay(formTie), XtWindow(formTie), io_wait_cursor);
      XDefineCursor(XtDisplay(formSplicing), XtWindow(formSplicing), io_wait_cursor);
      XDefineCursor(XtDisplay(formSpliceToAge), XtWindow(formSpliceToAge), io_wait_cursor);
      XDefineCursor(XtDisplay(formAgeDepth), XtWindow(formAgeDepth), io_wait_cursor);
*/
  }
  else if(what == FREEWAITCURSOR) {
      XUndefineCursor(XtDisplay(formSplicer), XtWindow(formSplicer));
/*
      XUndefineCursor(XtDisplay(formTie), XtWindow(formTie));
      XUndefineCursor(XtDisplay(formSplicing), XtWindow(formSplicing));
      XUndefineCursor(XtDisplay(formSpliceToAge), XtWindow(formSpliceToAge));
      XUndefineCursor(XtDisplay(formAgeDepth), XtWindow(formAgeDepth));
*/
  }
}

int CheckDepthInDescendingOrder(ds)
int ds;
{
  int i, j, k, ndep, out, alloc, *map, howmany;
  char *text, *line;
  float    *pdep;
  XmString xmstring;
  XmTextPosition  pos;

  alloc = TOOMANYOUTOFORDER + 5;
  if((text=(char*)calloc(300*alloc, CHAR_SIZE))==NULL)
                SpBadMemAlloc("CheckDepthInDescendingOrder");
  if((line=(char*)calloc(300, CHAR_SIZE))==NULL)
                SpBadMemAlloc("CheckDepthInDescendingOrder");

  out = NO;
  howmany = 0;
  for(i=0; i<data[ds]->numholes; ++i) {
    for(j=0; j<data[ds]->holes[i]->numcores; ++j) {
      if(data[ds]->holes[i]->core[j]->numvalues < 2) {
      }
      else if(data[ds]->holes[i]->core[j]->numvalues == 2) {

      }
      else {
        if((pdep=(float*)calloc(data[ds]->holes[i]->core[j]->numvalues,sizeof(float))) == NULL)
                        SpBadMemAlloc("CheckDepthInDescendingOrder");
        if((map=(int*)calloc(data[ds]->holes[i]->core[j]->numvalues,sizeof(int))) == NULL)
                        SpBadMemAlloc("CheckDepthInDescendingOrder");
        ndep = 0;
        for(k=0; k<data[ds]->holes[i]->core[j]->numvalues; ++k) {
          if(data[ds]->holes[i]->core[j]->value[k]->quality & BAD_SB_DEPTH) {
          }
          else {
            pdep[ndep] = data[ds]->holes[i]->core[j]->value[k]->sb_depth;
            map[ndep] = k;
            ++ndep;
          }
        }

        if(ndep >= 3) {
          for(k=1; k<ndep-1; ++k) {
            if(pdep[k] <= pdep[k+1] && pdep[k] >= pdep[k-1]) {
            }
            else {
              ++howmany;
              if(out == NO) {
                out = YES;
                (void)sprintf(text,"");
                (void)sprintf(text,"\n");
                (void)strcat(text, "The following depths are out of order\n\n");
              }
              if(howmany >= TOOMANYOUTOFORDER) {
                (void)sprintf(line, "There may be more; stopped checking after %d were found.\n",
                              TOOMANYOUTOFORDER);
                (void)strcat(text, line);
                (void)sprintf(line, "Could there be a data type or format mismatch?\n");
                (void)strcat(text, line);
                break;
              }
              (void)sprintf(line,"site %d  hole %c  core %d  sect. %s top sect. depth  %.2f(cm)   %.2f(mbsf)\n",
                                  data[ds]->site, data[ds]->holes[i]->name, data[ds]->holes[i]->core[j]->num,
                                  data[ds]->holes[i]->core[j]->value[map[k]]->section,
                                  data[ds]->holes[i]->core[j]->value[map[k]]->top_int,
                                  data[ds]->holes[i]->core[j]->value[map[k]]->sb_depth);
              (void)strncat(text, line, (int)strlen(line));
            }
          }
        }
        free(pdep);
        pdep = NULL;
        free(map);
        map = NULL;
        if(howmany >= TOOMANYOUTOFORDER) {
          break;
        }
      }
    }
    if(howmany >= TOOMANYOUTOFORDER) {
      break;
    }
  }

  if(out == YES) {
    pos=XmTextGetLastPosition(textGeneric);
    XmTextInsert(textGeneric,pos,text);
    XmTextShowPosition(textGeneric,0);
    XtManageChild(formGenericText);
    XtPopup(XtParent(formGenericText),XtGrabNone);
    xmstring=XmCvtCTToXmString("Out Of Order Core Depths");
    XtVaSetValues(formGenericText,XmNdialogTitle,xmstring,NULL);
    XmStringFree(xmstring);
  }

  free(text);
  text = NULL;
  free(line);
  line = NULL;

  return out;
}
